Package: BEACH
Type: Package
Title: Biometric Exploratory Analysis Creation House
Version: 1.3.2
Authors@R: c(person("Danni", "Yu", email = "danni.yu@gmail.com", role = c("aut", "cre")), person("Michael", "Man", role = "aut"), person("ChenChen", "Yu", role = "ctb"))
Description: A platform for interactive data analysis designed to simplify development, deployment, interaction, and exploration (TEDDIE). The package enables users to create customized analyses and deploy them to end users, who can perform interactive analyses and export results to RTF or HTML files. It allows developers to focus on R code for analysis rather than managing HTML or Shiny application code.
Depends: R (>= 3.1.0)
Imports: shiny, DT, haven, xtable, plyr, WriteXLS
License: MIT + file LICENSE
Encoding: UTF-8
URL: https://pharmasug.org/proceedings/2018/AD/PharmaSUG-2018-AD05.pdf,
        https://higherlogicdownload.s3.amazonaws.com/AMSTAT/fa4dd52c-8429-41d0-abdf-0011047bfa19/UploadedImages/Webinars/2017/2017-09_Yu.pdf
RoxygenNote: 7.3.3
NeedsCompilation: no
Packaged: 2026-05-05 06:38:22 UTC; dyu
Author: Danni Yu [aut, cre],
  Michael Man [aut],
  ChenChen Yu [ctb]
Maintainer: Danni Yu <danni.yu@gmail.com>
Repository: CRAN
Date/Publication: 2026-05-05 07:00:02 UTC
Built: R 4.6.0; ; 2026-05-05 07:08:51 UTC; unix

Package: BEACH
Type: Package
Title: Biometric Exploratory Analysis Creation House
Version: 1.3.2
Authors@R: c(person("Danni", "Yu", email = "danni.yu@gmail.com", role = c("aut", "cre")), person("Michael", "Man", role = "aut"), person("ChenChen", "Yu", role = "ctb"))
Description: A platform for interactive data analysis designed to simplify development, deployment, interaction, and exploration (TEDDIE). The package enables users to create customized analyses and deploy them to end users, who can perform interactive analyses and export results to RTF or HTML files. It allows developers to focus on R code for analysis rather than managing HTML or Shiny application code.
Depends: R (>= 3.1.0)
Imports: shiny, DT, haven, xtable, plyr, WriteXLS
License: MIT + file LICENSE
Encoding: UTF-8
URL: https://pharmasug.org/proceedings/2018/AD/PharmaSUG-2018-AD05.pdf,
        https://higherlogicdownload.s3.amazonaws.com/AMSTAT/fa4dd52c-8429-41d0-abdf-0011047bfa19/UploadedImages/Webinars/2017/2017-09_Yu.pdf
RoxygenNote: 7.3.3
NeedsCompilation: no
Packaged: 2026-05-05 06:38:22 UTC; dyu
Author: Danni Yu [aut, cre],
  Michael Man [aut],
  ChenChen Yu [ctb]
Maintainer: Danni Yu <danni.yu@gmail.com>
Repository: CRAN
Date/Publication: 2026-05-05 07:00:02 UTC

# BEACH

<!-- badges: start -->
<!-- badges: end -->

Biometric Exploratory Analysis Creation House (BEACH) is a shiny app that provides automation platform for users.


## Installation

You can install and load some packages before running BEACH like so:

``` r
dep.packages <- c("shiny", "DT", "haven", "xtable", "plyr", "sas7bdat", "WriteXLS");
na.packages <- dep.packages[!dep.packages %in% installed.packages()];
if (length(na.packages)>0) install.packages(na.packages);

devtools::install_github('DanniYuGithub/RTF2', force=TRUE);
if(!"sas7bdat.parso" %in% installed.packages()) devtools::install_github('BioStatMatt/sas7bdat.parso', force=TRUE);

if (!require("BiocManager", quietly = TRUE)) install.packages("BiocManager");
BiocManager::install("Heatplus");
BiocManager::install("multtest");

  library(animation)

  library(beanplot)

  library(corrplot)  #create heatmap for correlation matrix#

  library(DT) #for render table

  library(grid)
  library(gridExtra)

  library(haven) #for loading SAS datasets
  library(Heatplus)  #creating customized heatmaps with covariate profile#
  library(Hmisc)

  library(lattice)
  library(latticeExtra)
  library(lmtest)

  library(multtest)

  library(plotrix)   #use 2D-heatmap#
  library(plyr)

  library(sas7bdat.parso)
  library(shiny)
  library(sp)
  library(survival)  #time to event analysis#

  library(vioplot)
  
  library(xtable)
  library(readxl)

  library(WriteXLS)

```

## Example

This is a basic example which shows you how to solve a common problem:

``` r
library(BEACH)
## basic example code
run_app()
```

Biometric Exploratory Analysis Creation House (BEACH) is a shiny app that provides automation platform for users.

Before running BEACH, please make sure your computer is connected to internet and the following packages are installed.

dep.packages <- c("shiny", "DT", "haven", "xtable", "rtf", "plyr", "sas7bdat", "WriteXLS", "rJava");
na.packages <- dep.packages[!dep.packages %in% installed.packages()]
if (length(na.packages)>0) install.packages(na.packages);

if(!"sas7bdat.parso" %in% installed.packages()) devtools::install_github('BioStatMatt/sas7bdat.parso', force=TRUE)



Please set up your default internet browser as google chrome
Then, in your R console, please run the following code to run BEACH locally.

library(shiny);
runGitHub("BEACH", "DanniYuGithub");


To install the package from R cran, please check the link https://cran.r-project.org/web/packages/BEACH/index.html
library(shiny); library(DT); library(BEACH); runBEACH()


Implementation: BEACH is written mainly in R/Shiny combined with some HTML & CSS code. Using this package, users can create customized analyses and make them available to end users who can perform interactive analyses and save analyses in the format of RTF, PDF or HTML. It allows developers to focus on R code for analysis, instead of dealing with html or shiny code. The available analysis modules in this package are DataQC, TrialDesign, SEM-BMK, visual_SDTM-LB, and LightON. 

############################################
##Author @ Danni Yu
##Date   @ 2016-05-31
############################################

CleanEnvir <<- function(pattern = "tmp") {
  objs <- ls(pos = ".GlobalEnv")
  #print(objs)
  rm(list = objs[grep("tmp", objs)], pos = ".GlobalEnv")
}
#print('global')
CleanEnvir()

  inGithub <- FALSE
 folder  <-'BEACH'
 htmlPath <- ''


#---------Configuration File---------------#
options(stringsAsFactors=FALSE)
  local.path0 <- file.path('.','functions')
  local.path1 <- file.path('.','functions')
  local.path2 <- tempdir()
  local.path3 <- file.path(local.path2, 'www')  
  if(!'www'%in%dir(local.path2)) {dir.create(local.path3)}
  
  #assign a static url to 'images' 
  addResourcePath('images',local.path3)

  htmltem <- file.path('.', 'html_template')
  npath3<-nchar(local.path3)+2

#define the maximum number of widgets
max.n1<-c(check=100, radio=100, dropdown=100, slide=100, 
  date=100, dateR=100, num=100, text=100, textbox=100)

#global variables defintion
#the value can be changed under 'expert' textInput

#indicate whether all sources files are output or only R script names
allSourceIn1<<-FALSE 

#create a global variable for dynamic render plot
dynamicCode<<-paste0("plot(0~0, col='white',axes=F, xlab='', ylab='',xlim=c(-3,3));",
  " text(x=0, y=0, labels=\'dynamicData is not defiend yet.\')")
dynamicData<<-NULL
dynamicData.xvar<<-NULL
dynamicData.yvar<<-NULL


#to check whether there is any CD
cdpool<<-dir(local.path1)
cdpool<<-cdpool[grepl('configuration', cdpool) & grepl('.csv', cdpool)]
cdpool<<-c(' ', cdpool)
cdpool2<<-gsub('_configuration_', '', cdpool)
cdpool2<<-gsub('configuration_', '', cdpool2) 
cdpool2<<-gsub('_configuration', '', cdpool2)
cdpool2<<-gsub('configuration', '', cdpool2)

#define the split string for multi-level header
muliHead.split <<- ";"


#define colors
RGBColors <- col2rgb(colors()[1:length(colors())])
HEXColors <- rgb(RGBColors[1,]/255, RGBColors[2,]/255, RGBColors[3,]/255)
names(HEXColors) <- colors()

#define global variables
if(TRUE){
  fL<<-'https://www.fda.gov/drugs/informationondrugs/approveddrugs/ucm279174.htm'
  FDA.Link <<- fL
}



#Begin 0. ---------------------------------------------------------------------#
if(TRUE){
  #function: get the estimate of p=Pr(CDA+|CDx+), the TRUE positive rate, or sensitivity
  #output: p_hat and Var_p_hat
  TPR <<- function(
    m1,  #number of enrolled patients who are CTA+ and randomly assigned to treatment or control
    m,   #the total number of screened patients with valid CTA results (eligible for bridging study)
    n11, #number of CTA+ and CDx+ out of n1
    n1,  #number of CTA+ patients enrolled in bridging (concordance) study
    n01, #number of CTA- and CDx+ out of n0
    n0   #number of CTA- patients enrolled in bridging (concordance) study
  ){
    if(FALSE){
      phi_hat    =0.09  #Pr(CTA+)
      psi_hat_11 =0.95  #Pr(CDx+|CTA+), sensitivity
      psi_hat_10 =0.95  #Pr(CDx+|CTA-), 1-specificity
    }
    if(m1>m)   {print('Error: m1 > m. So m1 is set to be m.'); m1 <- m}
    if(n1>m1)   {print('Error: n1 > m1. So n1 is set to be m1'); n1 <- m1}
    if(n11>n1) {print('Error: n11 > n1. So n11 is set to be n1.'); n11 <- n1}
    if(n0>(m-n1)) {print('Error: n0 > m-n1. So n0 is set to be m-n1.'); n0 <- m-n1}
    if(n01>n0) {print('Error: n01 > n0. So n01 is set to be n0.'); n01 <- n0}
    
    phi_hat     <- m1/m
    var_phi_hat <- phi_hat * (1-phi_hat) / m
    psi_hat_11     <- n11/n1
    var_psi_hat_11 <- psi_hat_11 * (1-psi_hat_11) / n1
    psi_hat_10     <- n01/n0
    var_psi_hat_10 <- psi_hat_10 * (1-psi_hat_10) / n0
    
    p_hat <- (phi_hat*psi_hat_11)/(phi_hat*psi_hat_11+(1-phi_hat)*psi_hat_10)
    var_p_hat <- (p_hat*(1-p_hat))^2 *
      (  var_phi_hat/((phi_hat*(1-phi_hat))^2) +
           var_psi_hat_11/(psi_hat_11^2) + 
           var_psi_hat_10/(psi_hat_10^2)   )
    se_p_hat <- sqrt(var_p_hat)
    
    return(data.frame(phat=p_hat, var_phat=var_p_hat, 
                      phat_95CI_low=max(0, p_hat-1.96*se_p_hat),
                      phat_95CI_high=min(1, p_hat+1.96*se_p_hat) ))
  } #end of TPR
  
  #function: get estimate of efficacy of briding study
  EFF <<- function(
    delta1_hat=0.5,  #efficacy in subgroup CDA+ and CDx+
    var_delta1_hat,  
    c = 1, #proportion of delta2/delta1, where delta2 is efficacy in CDA- and CDx+
    p_hat,    #p=Pr(CDA+|CDx+)   
    var_p_hat # obtain from the function of PPV   
  ){
    
    #a vector of bridging efficacy given different c
    delta_CDx_pos_hat <- ((1-c)*p_hat+c)*delta1_hat
    var_delta_CDx_pos_hat <- (2*p_hat^2-2*p_hat+1)*var_delta1_hat +
      ( ((1-c)^2)*(delta1_hat^2) + 2*var_delta1_hat ) * var_p_hat
    se_delta_CDx_pos_hat <- sqrt(var_delta_CDx_pos_hat)
    
    return(data.frame(dhat=delta_CDx_pos_hat,
                      var_dhat=var_delta_CDx_pos_hat,
                      dhat_95CI_low=delta_CDx_pos_hat-1.96*se_delta_CDx_pos_hat,
                      dhat_95CI_high=delta_CDx_pos_hat+1.96*se_delta_CDx_pos_hat))
  }#end of EFF
  
  #calculate the variance
  get_var_delta1_hat <<- function(
    orr,  #single-arm objective response rate in subgroup CDA+ and CDx+
    n11,  #number of CTA+ and CDx+ out of n1
    hr,   #two-arm hazard ratio (treatmentHazardRatio/controlHazardRatio)
    nExpectEvt=round(n11*c(0.4, 0.4)), #expected number of events (i.e. death) in 
    #treatment and control
    method='ORR' #or 'logHR'
  ){
    if(method=='ORR'){
      delta1_hat <- orr
      var1 <- delta1_hat*(1-delta1_hat)/n11
      return(data.frame(est=delta1_hat, estVar=var1))
    }else if (method=='logHR'){
      #assume proportional hazards: the hr is consistent over time and
      #any differences are due to random sampling.
      #assume the distribution of the time-to-event measure has an
      #exponential distribution
      #logrank approach: as part of the KM calculation, compute the number
      #of observed events in each group(Oa and Ob), and the number of 
      #expected events assuming a null hypothesis of no difference in 
      #survival (Ea and Eb)
      #http://aac.asm.org/content/48/8/2787.full
      if(sum(nExpectEvt)>n11){
        r1 <- nExpectEvt[1] /sum(Control)
        nr1 <- round(r1*n11)
        nr2 <- n11-nr1
        nExpectEvt <- c(nr1, nr2)
      }
      var_loghr <-sum(1/nExpectEvt)
      return(data.frame(est=log(hr), estVar=var_loghr))
    }else{
      print('Currently only two methods (ORR or logHR) are avaible.')
      var1 <- NA
      return(data.frame(est=NA, estVar=NA))
    }
    
  } #end of ge_var_delta1_hat
  
  #estimate dhat and phat if the efficacy is ORR
  est_ORR <<- function(
    m1=60, m=round(60/0.10), n11=29, n1=30, n01=1, n0=10,
    orr=0.4, c=0.5
  ){    
    tpr1 <- TPR(m1=m1, m=m, n11=n11, n1=n1, n01=n01, n0=n0)
    var_d1 <- get_var_delta1_hat(orr=orr, n11=n11, method='ORR')
    eff1 <- EFF(delta1_hat=var_d1$est[1], var_delta1_hat=var_d1$estVar, c=c, 
                p_hat=tpr1$phat, var_p_hat=tpr1$var_phat)
    eff1$dhat_95CI_low <- max(0, eff1$dhat_95CI_low)
    eff1$dhat_95CI_high <- min(1, eff1$dhat_95CI_high)
    
    return(list(tpr1=tpr1, eff1=eff1))
  }#end of estimate dhat and phat
  
  
  #plot
  plot_dp <<- function(
    tpr0,     #the output for TPR
    eff0,     #the otuput EFF
    xlim0=c(0,1), #range of X-axis
    ylim0=NULL,   #range of Y-axis
    xlab0= 'Concordance Pr(CTA+|CDx+)', 
    ylab0= 'ORR in CDx+ patients',
    add=FALSE #add the est bars to current plot if TRUE
  ){
    if(is.null(ylim0)){
      ylim0 <- range(as.vector(eff0[, c('dhat_95CI_low', 'dhat_95CI_high')]))
    }
    if(is.character(ylim0) & grepl(',', ylim0)){
      y12<-strsplit(ylim0, split=',', fixed=TRUE)[[1]]
      ylim0<-c(as.numeric(y12))
    }
    if(!add){
      plot(eff0$dhat~tpr0$phat, type='b', col='black', pch=16, 
           xlab=xlab0, ylab=ylab0, xlim=xlim0, ylim=ylim0)
    }else{
      points(eff0$dhat~tpr0$phat, type='b', col='black', pch=16,
             xlab=xlab0, ylab=ylab0, xlim=xlim0, ylim=ylim0)
    }
    #add 95%CI for phat
    arrows(x0=tpr0$phat_95CI_low,   y0=eff0$dhat, 
           x1=tpr0$phat_95CI_high, y1=eff0$dhat, 
           code=3, angle=90, length=0.15)
    #add 95%CI for dhat
    arrows(y0=eff0$dhat_95CI_low,   x0=tpr0$phat, 
           y1=eff0$dhat_95CI_high, x1=tpr0$phat, 
           code=3, angle=90, length=0.15)
    
  }#end of plot_dp
  
}#End 0. ---------------------------------------------------------------------#



#Begin 1. ---------------------------------------------------------------------#
if(TRUE){
  #Optimal basket design phase 1a/b study
  #Clinical Benifit and Biological Response are {0, 1} for {no or yes}. 
  #Output@: ranked table {dose, Disease, baselineBiomarker, expectedUtility}
  #Output@: tree plot
  DT_frame <- function(
    blBMK=c('B0','B1'),          #Baseline Biomarkers, required input
    tumorType=c('T0','T1','T2'), #Types of tumors, required input
    dose=c(20, 100),             #numeric values of dose levels, required input
    #parameters
    prior_ti=c(0.1, 0.2,  0.2, 0.3, 0.05, 0.15),#PrioInfo Tumor Incidence: 
    #length is length(blBMK)*length(tumorType)
    #values obtained from prior knowledge
    prior_prop=c(0.1, 0.9),      #proportion of patients in the subgroup of dose 
    #and bmk length is either length(dose) or
    #length(dose)*length(blBMK)*length(tumorType)
    #values obtained from prior knowledge
    prob_stop0 = c(0.75, 0.05),  #Prob(not stop|dose) matching to the levels in 
    #dose length is length(dose), the 
    #proportions obtained from early phase trials
    prob_BR1   = c(0.1, 0.75),   #Prob(BioResp=1|stop=0, dose, tumor, bmk), 
    #length is either length(dose) or 
    #length(dose)*length(blBMK)*length(tumorType)
    #values obtained from early phase trials  
    prob_CB1_BR = c(0.8, 0.1),   #Prob(ClinBenefit=1|BioResp=1) and 
    #Prob(CB=1|BR=0). The lengh is either 2, or
    #2*length(dose)*length(blBMK)*length(tumorType)
    showTree   = TRUE,           #if FASLE only return the tree table
    showProb   = TRUE,           #if TRUE show the probablities on the tree and 
    #return the probability table
    showBar    = TRUE,           #show the barplot of expected U(dose|{T,B})
    #other args for plotting
    th.arrow        = 0.8,       #horizontal space between an arrow and target
    th.utDB    = 1,              #vertical space between dose sign and utility
    topRatio   = 0.2,            #the top ratio of joint p-values (or utilities) 
    #that need to be colored
    topCol     = 'red',          #the color for the top joint p-values  
    payoff     = c(100, -100)    #payoff value for CB=1 and CB=0
  ){
    #an internal function trunc values to 0, 1
    trunc01 <- function(val){
      val[val>1]<-1
      val[val<-0]<-0
      return(val)
    }
    
    #cleanup the payoff values
    if(is.character(payoff)){
      payoff <- as.numeric(strsplit(payoff, split=',', fixed=TRUE)[[1]])
      if(length(payoff)==1){
        payoff<-c(max(0, payoff), min(0, payoff))
      }else{payoff <- payoff[1:2]}
    }
    
    #cleanup the top ratio
    if(is.null(topRatio)) topRatio <- 0.2
    topRatio <- trunc01( as.numeric(topRatio) )
    
    #cleanup the input
    if(length(blBMK)==1){
      blBMK<-strsplit(as.character(blBMK), split=',', fixed=T)[[1]]
    }
    if(length(tumorType)==1){
      tumorType<-strsplit(as.character(tumorType), split=',', fixed=T)[[1]]
    }
    if(length(dose)==1){
      dose<-strsplit(as.character(dose), split=',', fixed=T)[[1]]
    }
    if(length(prior_ti)==1){
      prior_ti<-as.numeric(strsplit(as.character(prior_ti), split=',', fixed=T)[[1]])
    }
    if(length(prior_prop)==1){
      prior_prop<-as.numeric(strsplit(as.character(prior_prop), split=',', fixed=T)[[1]])
    }
    if(length(prob_stop0)==1){
      prob_stop0<-as.numeric(strsplit(as.character(prob_stop0), split=',', fixed=T)[[1]])
    }
    if(length(prob_BR1)==1){
      prob_BR1<-as.numeric(strsplit(as.character(prob_BR1), split=',', fixed=T)[[1]])
    }
    if(length(prob_CB1_BR)==1){
      prob_CB1_BR<-as.numeric(strsplit(as.character(prob_CB1_BR), split=',', fixed=T)[[1]])
    }
    
    #check wether the probablities are matching to the actions
    if(showProb){
      con1 <- length(prior_ti) == length(blBMK)*length(tumorType)
      con2 <- length(prior_prop) == length(dose) | 
        length(prior_prop)==length(dose)*length(blBMK)*length(tumorType)
      con3 <- length(prob_stop0)==length(dose) | 
        length(prob_stop0)==length(dose)*length(blBMK)*length(tumorType)
      con4 <- length(prob_BR1) == length(dose) | 
        length(prob_BR1)==length(dose)*length(blBMK)*length(tumorType)
      con5 <- (length(prob_CB1_BR)==2)| (
        length(prob_CB1_BR)==2*length(dose)*length(blBMK)*length(tumorType)
      )
      if(!all(c(con1, con2, con3, con4, con5))){showProb<-FALSE}
    }
    
    #construct the output matrix
    if(TRUE){
      numL.ClinBenif<- 2
      numL.BioResp  <- 2
      numL.stop      <- 2
      numL.dose     <- length(dose)
      numL.tumorType<- length(tumorType)
      numL.blBMK    <- length(blBMK)
      
      ClinBenif <- rep(c('yes', 'no'), 
                       times=numL.BioResp*numL.stop*numL.dose*numL.tumorType*numL.blBMK)  
      BioResp   <- rep(rep(c('yes', 'no'), each=numL.ClinBenif),
                       times=numL.stop*numL.dose*numL.tumorType*numL.blBMK)
      stop0       <- rep(rep(c('yes', 'no'), each=numL.ClinBenif*numL.BioResp),
                         times=numL.dose*numL.tumorType*numL.blBMK)
      dose.in   <- rep(rep(dose, each=numL.ClinBenif*numL.BioResp*numL.stop),
                       times=numL.tumorType*numL.blBMK)
      BMK.in    <- rep(rep(blBMK, each=numL.ClinBenif*numL.BioResp*numL.stop*numL.dose), 
                       times=numL.tumorType)  
      tumor.in  <- rep(rep(tumorType),
                       each=numL.ClinBenif*numL.BioResp*numL.stop*numL.dose*numL.blBMK)
      numRow <- length(BMK.in)
      if(any(c(length(ClinBenif), length(BioResp), length(stop0), length(dose.in),
               length(tumor.in))!=numRow)){
        stop('Error in level definition: check input value for blBMK, tumorType, dose')
      }
      mat <- cbind(tumorType=tumor.in, blBMK=BMK.in, 
                   dose=dose.in, stop0=stop0, 
                   BioResp=BioResp, ClinBenif=ClinBenif)
      fun1<-function(x, lastCol=NULL){
        if(length(x)<=1) return(x)
        sel <- c(FALSE, x[2:length(x)]==x[1:(length(x)-1)])
        if(!is.null(lastCol)) sel <- sel & (lastCol=="")
        x[sel] <- ""
        return(x)
      }
      
      mat.tab <- mat[mat[,"stop0"]=='no', ]
      m11 <- matrix(fun1(mat.tab[,1]), ncol=1)
      for(i in 2:ncol(mat.tab)){
        m11 <- cbind(m11, fun1(mat.tab[,i], m11[,ncol(m11)]))
      }
      dimnames(m11) <- dimnames(mat.tab)
      mat.tab <- m11
      
      if(is.matrix(mat.tab)) {
        mat.tab[which(mat.tab[,'dose']!=''), 'stop0'] <- 'no'
      }
    }
    
    
    #build arrows' coordinates
    if(showTree){
      
      tot.col <- ncol(mat.tab)
      tot.row <- nrow(mat.tab)
      tot.col2<- tot.col+(tot.col-3)+2 #to enable the fitting lines longer
      text.size1 <- 3/log(tot.row)
      
      th <- th.arrow/log(tot.row)
      
      y.tt <- which(mat.tab[,1]!='')
      pnt <- data.frame(x=c(0, rep(1, length(y.tt))), y=c(1, y.tt), 
                        pch=rep(22,length(y.tt)+1), cex=rep(3,length(y.tt)+1))
      arr <- data.frame(x0=rep(0, length(y.tt))+th*0.8, 
                        y0=rep(1, length(y.tt)), 
                        x1=rep(1, length(y.tt))-th*0.8, 
                        y1=y.tt-th, 
                        lty=rep(1, length(y.tt)),
                        lwd=rep(1, length(y.tt)), 
                        col=rep('gray80', length(y.tt)))  
      y.tt0 <-y.tt;
      dum1 <- 1
      for(i in 2:tot.col){
        y.tt <- which(mat.tab[,i]!='')
        lty1 <- 1;  lwd1 <- 1; col1='gray80';
        if (i>=4) {col1 <- 'black'}
        if (i==5) {lty1<-4; }
        
        if(i <= 3){
          pnt <- rbind(pnt, 
                       data.frame(x=rep(i, length(y.tt)), 
                                  y=y.tt, pch=22, cex=3) )
          
          arr <- rbind(arr, 
                       data.frame(x0=rep(i-1, length(y.tt))+th*0.8, 
                                  y0=rep(which(mat.tab[,i-1]!=''), each=length(y.tt)/length(y.tt0)),
                                  x1=rep(i, length(y.tt))-th*0.8,
                                  y1=y.tt, 
                                  lty=rep(lty1, length(y.tt)),
                                  lwd=rep(lwd1, length(y.tt)),
                                  col=rep(col1, length(y.tt))))
        }else{
          arr <- rbind(arr, 
                       data.frame(x0=rep(i+dum1-2, length(y.tt))+th , 
                                  y0=rep(which(mat.tab[,i-1]!=''), each=length(y.tt)/length(y.tt0)),
                                  x1=rep(i+dum1, length(y.tt))-th,
                                  y1=y.tt, 
                                  lty=rep(lty1, length(y.tt)),
                                  lwd=rep(lwd1, length(y.tt)),
                                  col=rep(col1, length(y.tt))))
          dum1 <- dum1+1
        }
        y.tt0 <-y.tt
      }
      
      
      par(mar=c(0.2, 0.2, 0.2, 0.2), mfrow=c(1,1))
      plot(0~0, col='white', ylim=c(0, tot.row+3), xlim=c(0, tot.col2+ 0.5),
           axes=F, ylab='', xlab='')
      dum2 <- 0;   pos.col<-NULL; 
      th.p <- 0.5; #threshold for probability X-axis position
      #joint probability for Pr(br=1,...), Pr(br=0, ...), Pr(br=1,...), Pr(br=0, ...), etc.
      num.mat.L <- nrow(mat.tab)/2
      #print(num.mat.L)
      j.prob <- rep(1, num.mat.L) 
      for(i in 1:tot.col){
        if(i>3) { dum2 <- dum2+1; th.p <- 1;}
        text(x=i+dum2, y=1:tot.row, labels=mat.tab[,i], cex=text.size1)
        pos.col <- c(pos.col, i+dum2)
        
        if(showProb){
          # add probabilities to the tree and the the expected Utility for each action
          if(i==2){
            text(x=i+dum2-th.p, y=which(mat.tab[,i]!=''), labels=prior_ti, cex=text.size1, col='gray')
            #print(prior_ti)
            j.prob <- j.prob * rep(prior_ti, each=num.mat.L/length(prior_ti))
            #print(j.prob)
          }else if(i==3){
            if(length(prior_prop)==length(dose)) 
              prior_prop <- rep(prior_prop, numL.blBMK*numL.tumorType)
            text(x=i+dum2-th.p, y=which(mat.tab[,i]!=''), labels=prior_prop, cex=text.size1, col='gray')
            j.prob <- j.prob * rep(prior_prop, each=num.mat.L/length(prior_prop))
            #print(j.prob)
          }else if (i==4){
            if(length(prob_stop0)==length(dose))
              prob_stop0 <- rep(prob_stop0, numL.blBMK*numL.tumorType) 
            text(x=i+dum2-th.p, y=which(mat.tab[,i]!=''), labels=prob_stop0, cex=text.size1, col='gray')
            j.prob <- j.prob * rep(prob_stop0, each=num.mat.L/length(prob_stop0))
            #print(j.prob)
          }else if (i==5){
            if(length(prob_BR1)==numL.dose && numL.dose<numL.blBMK*numL.tumorType)
              prob_BR1 <- rep(prob_BR1, numL.blBMK*numL.tumorType)
            text(x=i+dum2-th.p, y=which(mat.tab[,i]=='yes'), labels=prob_BR1, cex=text.size1, col='gray') 
            #the prob are Pr(br=1|...), Pr(br=0|...), Pr(br=1|...), Pr(br=0|...), etc.
            prob_BR <- as.vector(rbind(prob_BR1, 1-prob_BR1))
            j.prob <- j.prob * prob_BR
            #print(j.prob)
          }else if (i==6){
            if(length(prob_CB1_BR)==2)
              prob_CB1_BR <- rep(prob_CB1_BR, numL.blBMK*numL.tumorType)
            #Pr(CB=1|BR=1,...), Pr(CB=1|BR=0,...), Pr(CB=1|BR=1,...), Pr(CB=1|BR=0,...), etc.
            text(x=i+dum2-th.p, y=which(mat.tab[,i]=='yes'), labels=prob_CB1_BR, cex=text.size1, col='gray')          
            #for U(CB=0|....)
            #Pr(CB=0,BR=1|...), Pr(CB=0,BR=0|...),Pr(CB=0,BR=1|...), Pr(CB=0,BR=0|...), etc.
            j.prob0 <- round(payoff[2]*j.prob * trunc01(1-prob_CB1_BR), 3)          
            #for U(CB=1|....)
            #Pr(CB=1,BR=1|...), Pr(CB=1,BR=0|...),Pr(CB=1,BR=1|...), Pr(CB=1,BR=0|...), etc.
            j.prob <- round(payoff[1]*j.prob * prob_CB1_BR, 3)
            
            
            
            #color the top 10%
            num.col <- round(length(j.prob)*topRatio)
            sub.u <- j.prob+j.prob0
            top.p   <- sort(sub.u, decreasing=TRUE)[1:num.col]
            col.p   <- rep('gray', length(j.prob))
            col.p[sub.u%in%top.p] <- topCol
            #print(j.prob)
            text(x=i+dum2+1, y=which(mat.tab[,i]=='yes'), labels=j.prob, 
                 cex=text.size1, col=col.p) 
            text(x=i+dum2+2.5, y=which(mat.tab[,i]=='yes'), labels=j.prob0, 
                 cex=text.size1, col='gray')           
            
            #add the utility into the treat leave
            mat.tab <- cbind(mat.tab, 
                             U=rep("", nrow(mat.tab)),
                             U0=rep("", nrow(mat.tab)),
                             topColor=rep("", nrow(mat.tab)))
            
            #print(prob_CB1_BR)
            #print(j.prob)
            #print(mat.tab)
            
            mat.tab[mat.tab[, i]=='yes', 'U']<-j.prob
            mat.tab[mat.tab[, i]=='yes', 'U0']<-j.prob0
            mat.tab[mat.tab[, i]=='yes', 'topColor']<-col.p
            #get the index for top p values in output table
            wh.top.p<- which(mat.tab[,'topColor']==topCol)
            
          }
          
        }
      }
      points(x=pnt$x, y=pnt$y, pch=pnt$pch, cex=pnt$cex, col='gray80')
      
      arr$col <- as.character(arr$col)
      arrows(x0=arr$x0, y0=arr$y0, x1=arr$x1, y1=arr$y1, length=0.1, lty=arr$lty, lwd=arr$lwd, 
             col=arr$col)
      
      nms <- c('Tumor\nType (T)', 'Baseline\nBiomarker (B)', '\nDose', 
               'Stop due\nto toxicity', 'Biological\nResponse', 
               'Clinical\nBenefit')
      mtext(text=nms, side=3, at=pos.col, padj=1.1)
      
      #It is alway true: P(BR|stop=1)=0
      note1 <- c('P(stop=0|dose)', 'P(BR=1|stop=0, dose, TI)', 'P(CB=1|BR)') 
      text(x=pos.col[-(1:3)]-1, y=tot.row, labels=note1, col='darkgreen', cex=text.size1)
      
      #Assume {dose, stop} is independent from the tumor incident of a biomarker in the tumor type.
      #TI is independent from dose, so P({T,B}|dose)=P({T,B})
      note2 <- c('PriorInfo\nTumorIncidence(TI)', 'Proportion\nDoseLevel')
      text(x=c(pos.col[1]-0.5, pos.col[2]+0.5), y=tot.row, labels=note2, col='blue', cex=text.size1)
      
      if(showProb){
        note3 <- c(paste0('U=', payoff[1], '*Prob(CB=1, BR,\nstop=0, dose, {T,B})'),
                   paste0('U=', payoff[2], '*Prob(CB=0, BR,\nstop=0, dose, {T,B})'))
        pos.note3 <- tot.col2 + c(-1, 0.5)
        text(labels=note3, x=pos.note3, y=rep(tot.row+1, 2), 
             cex=text.size1*0.7, col=c('red', 'magenta'))
        
        #add the expected utility
        mat.tab <- cbind(mat.tab, 
                         U_dTB=rep("", nrow(mat.tab)),
                         U_dTB_color=rep("", nrow(mat.tab)),
                         U_dTB_topColor=rep("", nrow(mat.tab)))
        dum.u <- 0; dum.col <- ''
        for(r in nrow(mat.tab):1){
          if(mat.tab[r,'dose']=="" & mat.tab[r,'U']!=''){
            payoff.pos <-as.numeric(mat.tab[r, 'U'])
            payoff.neg <-as.numeric(mat.tab[r, 'U0'])
            dum.u <- dum.u+ payoff.pos + payoff.neg
            if(mat.tab[r,'topColor']!='') 
              dum.col<-mat.tab[r,'topColor']
          }else if (mat.tab[r,'U']!=''){
            payoff.pos <-as.numeric(mat.tab[r, 'U'])
            payoff.neg <-as.numeric(mat.tab[r, 'U0'])
            dum.u <- dum.u+ payoff.pos + payoff.neg
            mat.tab[r, 'U_dTB'] <- dum.u
            dum.u <- 0
            if(mat.tab[r,'topColor']!='') {
              dum.col<-mat.tab[r,'topColor']
              mat.tab[r, 'U_dTB_color']<-dum.col
            }
          }
        }      
        top.U_dTB <- sort(as.numeric(mat.tab[,"U_dTB"]), decreasing=T)
        top.U_dTB <- top.U_dTB[1:ceiling(length(top.U_dTB)*topRatio)]
        
        u.tDB <- mat.tab[,'U_dTB']; 
        wh.utDB <- which(u.tDB!='')
        mat.tab[wh.utDB, 'U_dTB_topColor']<-'black'
        mat.tab[wh.utDB&u.tDB%in%as.character(top.U_dTB), 'U_dTB_topColor']<-'red'
        u.tDB <- u.tDB[wh.utDB];
        #u.tDB.col<-mat.tab[wh.utDB, 'U_dTB_color']
        u.tDB.col<-mat.tab[wh.utDB, 'U_dTB_topColor']
        note4 <- paste0('U(d,T,B)= ', u.tDB)
        
        if(showBar){
          for(k in 1:length(u.tDB)){
            lines(x=0+c(0, as.numeric(u.tDB[k])), y=rep(wh.utDB[k]-th.utDB, 2), lwd=8, 
                  col=rgb(0, 0, 255, alpha=80, maxColorValue=255) )
          }
          lines(x=c(0,0), y=c(0,nrow(mat.tab)), 
                col=rgb(0, 0, 255, alpha=80, maxColorValue=255))
        }
        
        #u.tDB.col[u.tDB.col=='gray'] <- 'black'
        text(labels=note4, x=3, y=wh.utDB-th.utDB, 
             cex=text.size1, col=u.tDB.col)
        
        
      }
      
    }
    
    
    return(mat.tab)
    
  }
  
  #Obtain combination annotation
  anno_tt_bmk <- function(bmk, tt, other.note=''){
    bmk <- strsplit(as.character(bmk), split=',', fixed=TRUE)[[1]]
    tt <- strsplit(as.character(tt), split=',', fixed=TRUE)[[1]]
    ot <- paste(rep(tt, each=length(bmk)), rep(bmk, length(tt)), sep='_')
    ot <- paste(ot, collapse=',')
    ot <- paste(other.note, ot)
    return(ot)
  }
}
#End 1. -----------------------------------------------------------------------#



#Begin 2. ---------------------------------------------------------------------#
#1. Extension to have the CSF analysis
#2. Generalized to user-defined variables
#3. For discrete variables
if(TRUE){
  #expected loss function for discrete X variables
  #L(theta,a)=0 if x in the range else abs(lev-a)*abs(theta-th)
  #f(theta|data) is a binomial distriubtion
  #Users can define their own expected loss function however the input must
  #be [th, n, p_pos] and the output must be a vector of expected loss under
  #each Bayes decision levels
  my.eLoss <<- function(
    th,             #the vector of thresholds (delta) of decision rule
    n,              #the number of patients in a cohort
    p_pos,          #the posterior probability of responding to drug
    #is the value update by data and affect decsion loss
    #d.fun=pbinom    #probability function (lower.tail=T)
    d.fun=dbinom
  ){
    #defin the distribution as binomial
    #d.fun=pbinom   #the density function of p_pos
    #user can re-define the loss function from here to the end....
    
    th <- sort(as.numeric(th))
    len_a <- length(th)
    
    #~~~data construction~~~#
    #the number of decision levels is the number thresholds plus 1
    xs <- 0:n              #get all numbers in the binomial distribution
    xs_lev <- rep(1, n)    #get decision levels for each number
    for(i in 1:len_a) xs_lev[xs>th[i]]<-i+1
    
    #~~~get the expected loss for each action~~~#
    #a is the action level from 0 to len_a according to theta
    e_loss <- rep(0, len_a+1)
    
    #construct loss elements based on the higher bound for the lowest level
    i<-1
    #els.h<-abs(xs_lev - i)*abs(xs-th[i])*(1-d.fun(xs, size=n, prob=p_pos))
    els.h<-(xs<=th[i])*(xs-th[i])*(d.fun(xs, size=n, prob=p_pos))
    e_loss[i]<-sum(els.h)
    tot.dist <- sum(sapply(n, function(x){
        sum((xs<=x)*abs(xs-x)*(d.fun(xs, size=n, prob=p_pos)))
       }))
    
    #expected loss from level 2 to lev_a
    if(len_a>1){
      for(i in 2:len_a){#if taking the action as level i
        # els.h<-abs(xs_lev - i)*abs(xs-th[i])*(1-d.fun(xs, size=n, prob=p_pos))
        # els.l<-abs(xs_lev - i)*abs(xs-th[i-1])*(1-d.fun(xs, size=n, prob=p_pos))
        els.h<-abs(xs_lev - i)*abs(xs-th[i])*(d.fun(xs, size=n, prob=p_pos))
        els.l<-abs(xs_lev - i)*abs(xs-th[i-1])*(d.fun(xs, size=n, prob=p_pos))
        e_loss[i] <- sum(els.h[xs_lev>i]) + sum(els.l[xs_lev<i])
      }
    } 
    
    #for highest level
    #construct loss elements based on the lower bound
    i <- len_a
    # els.l<-(xs>th[i])*abs(xs-th[i])*(1-d.fun(xs, size=n, prob=p_pos))
    els.l<-(xs>th[i])*abs(xs-th[i])*(d.fun(xs, size=n, prob=p_pos))
    e_loss[i+1]<-sum(els.l)
    tot.dist2 <- sum(sapply(0, function(x){
        #sum((xs>x)*abs(xs-x)*(1-d.fun(xs, size=n, prob=p_pos)))
        sum((xs>x)*abs(xs-x)*(d.fun(xs, size=n, prob=p_pos)))
       }))
    
    #return(e_loss/c(tot.dist, tot.dist2))
    return(e_loss/n)
  }
  
  
  #improved function for Baysian decision theory with Critical Success Factor
  #available to add or remove variables
  #available to specify the Bayse loss function
  #available to select utility bar and the loss bar
  #Clinical Benifit and Biological Response are {0, 1} for {no or yes}. 
  #Output@: ranked table {dose, Disease, baselineBiomarker, expectedUtility}
  #Output@: tree plot
  #function name: Bayesian Decision Theory Utility and Loss
  #fixing the expected utility and make loss function flexible
  BDT_UaL <- function(
    levVars="B1::T1::coh1::BR1,B1::T1::coh2::BR1,B1::T2::coh3::BR2",       
    #variables and levels separated by "::"
    dr_lev="nogo::go,nogo::go,nogo::go",  #order does matter.
    #decision rule labels
    incidence="0.3,0.3,0.1",      #Biomarker incidence in the tumor type 
    #values obtained from prior knowledge
    pBprior=NULL,                 #the hyper parameters "alph, beta"
    #if NULL, then alpha=1+incidence
    #beta=2-incidence
    #if not NULL, the value should be like
    #"1.3 1.7,1.3 1.7, 1.1 1.9," 
    n_ij="10, 10, 10",            #sample sizes for each cohort
    #values obtained from decision makers
    dr_th="0.1,0.5,0.6",          #decision rule threshold (delta)
    #if 3 levels of decision rule such as 
    #dr_lev="go::moreData::nogo," then
    #dr_th="0.9::0.3,"
    drFunc=my.eLoss,              #user-defined Bayes decision loss function
    #input: [th, n, p_pos]
    #output: a vector of Bayes decision loss
    showBar=TRUE,                 #show the barplot of utility & loss
    th.arrow= 0.8,                #horizontal space between an arrow and target
    payoff= c(10, -1)            #payoff value for utility, only two values
    #gain vs lost
  ){
    #an internal function truncates values to 0, 1
    trunc01 <- function(val){
      val[val>1]<-1
      val[val<-0]<-0
      return(val)
    }
    
    #an internal function gets the hierarchical variables
    my.split1 <- function(mylab="", s1=",", s2="::"){
      if(length(mylab)==1 & is.character(mylab)){
        L1 <- strsplit(mylab, split=s1)[[1]]
      }else{L1 <- mylab}
      if(length(L1)==0) return('L1 in my.split1 is missing.')
      if(is.null(s2)) return(L1)
      if(all(is.character(L1))){
        L2 <- strsplit(L1, split=s2)
      }else{
        L2 <- mylab
      }
      return(L2)
      #mat1<-t(matrix(unlist(L2), ncol=length(L2)))
    }
    
    
    #cleanup the input parameters
    if(TRUE){
      #sample size proportions
      if(is.null(n_ij) || all(n_ij=='')|all(incidence=='')|
         all(dr_th=='')) return(NULL)
      n_1 <- as.numeric(unlist(my.split1(n_ij)))
      n_rt<- n_1/sum(n_1)
      #incidences
      if(is.null(incidence)) return(NULL)
      incd<- as.numeric(unlist(my.split1(incidence)))
      
      p.0<-list()
      for(o in 1:length(incd)){
        #p.0[[o]]<-c(1+incd[o], 2-incd[o])
        p.0[[o]]<-c(1, 2)
      }
      
      if(!is.null(pBprior) && pBprior!="~" && 
         gsub(" ", "", pBprior)!=""){
        p.0p<-my.split1(pBprior, s2=" ")
        p.0p<-lapply(p.0p, function(x){x[x!=""]})
        for(o in 1:length(p.0)){
          p.0[[o]] <- p.0[[o]]+as.numeric(p.0p[[o]])*incd[o]
        }
        #note the length p.0 == the leve of plans
      }
      num.p0 <- length(p.0)
      
      #if using default threshold
      if(dr_th=="~"){
        th1 <- list()
        for(o in 1:length(p.0))
          th1[[o]] <- p.0[[o]][1]/sum(p.0[[o]])
      }else{
        th1 <- lapply(my.split1(dr_th),as.numeric)
      }
      #print(th1)
      
      #cleanup the payoff values
      if(is.character(payoff)){
        payoff <- as.numeric(strsplit(payoff, split=',', fixed=TRUE)[[1]])
        if(length(payoff)==1){
          payoff<-c(payoff, 0)
        }else{
          payoff <- payoff[1:2]
        }
      }
    }
    
    #construct the decision tree with user-defined variables
    if(TRUE){
      
      if(is.null(levVars)) return(NULL)
      
      LV0 <- LV <- my.split1(levVars)
      num.var <- length(LV[[1]])
      drLV  <- my.split1(dr_lev)
      num.dr  <- length(drLV[[1]])
      
      if(length(LV)!=length(drLV) | length(LV)!=num.p0){
        #print('Error: lengths of decision rule and layers do not match!')
        return(NULL)
      }
      
      iLV <- E.L <- U <- p.1 <- list()
      for(o in 1:length(LV)){
        th2<-round(th1[[o]]*n_1[o])
        p.1[[o]] <- p.0[[o]][1]/sum(p.0[[o]])
        eL <- drFunc(th=th2,
                     n=n_1[o],
                     p_pos=p.1[[o]] )
        E.L[[o]]<-eL  #expected loss
        
        U[[o]] <- incd[o]*n_rt[o]*p.1[[o]]*payoff[1]+
          incd[o]*n_rt[o]*(1-p.1[[o]])*payoff[2]
        #expected utility
        
        if(o>1){
          o.wh <- which(LV0[[o]]!=LV0[[o-1]])[1]
          if(length(o.wh)==0) o.wh<-1
          no.wh <- which(LV0[[o]]==LV0[[o-1]])
          LV[[o]][ no.wh[no.wh<o.wh] ]<-''
        }
        
        iLV[[o]] <- c(LV[[o]][1:(num.var-1)],
                      paste0(LV[[o]][num.var], ", n=", n_1[o],
                             "\nI=", incd[o],
                             ", U=", round(U[[o]],3),
                             ", p=", round(p.1[[o]],3)  ), 
                      paste0(drLV[[o]][1],": go if r>", th2[1],
                             ", E(L)=", round(eL[1],3)))
        if(num.dr==1) next
        for(h in 2:num.dr){
          if(h==num.dr){
            iLV[[o]] <- c(iLV[[o]], rep('', num.var), 
                          paste0(drLV[[o]][h], ": stop if r<=",th2[h-1],
                                 ", E(L)=", round(eL[h],3))  )
          }else{
            iLV[[o]] <- c(iLV[[o]], rep('', num.var), 
                          paste0(drLV[[o]][h], ": ",th2[h-1],
                                 "<= r <",th2[h],
                                 ", E(L)=", round(eL[h],3))  )
          }
        }
      }
      varMat <- t(matrix(unlist(iLV), nrow=num.var+1))
      #E.L[[o]]: expected Bayes decision loss
      #U[[o]]: utility of plan
    }
    
    #build arrows and coordinates to show the decision tree
    if(TRUE){
      tot.col   <- ncol(varMat)
      max.nchar <- apply(varMat, 2, function(x){max(nchar(x))})
      cex.1char<- 0.1
      tot.row <- nrow(varMat)
      tot.col2<- tot.col+2 #to enable the fitting lines longer
      text.size1 <- 3/log(tot.row)
      th.a <- th.arrow/log(tot.row) #about arrow locaiton
      
      #for Layer 1
      lty1 <- 1;  lwd1 <- 1; col1='gray80';
      y.tt <- which(varMat[,1]!='')
      pnt <- data.frame(x=c(0, rep(1, length(y.tt))), y=c(1, y.tt), 
                        lab=c('', varMat[y.tt,1]),
                        pch=rep(22,length(y.tt)+1), cex=rep(3,length(y.tt)+1))
      arr <- data.frame(x0=rep(0, length(y.tt)), 
                        y0=rep(1, length(y.tt)), 
                        x1=rep(1, length(y.tt)), 
                        y1=y.tt, 
                        lty=rep(1, length(y.tt)),
                        lwd=rep(1, length(y.tt)), 
                        col=rep(col1, length(y.tt)))  
      shf <- sum(max.nchar[1])*cex.1char
      y.tt0 <- y.tt
      for(i in 2:tot.col){
        y.tt <- which(varMat[,i]!='')
        pnt <- rbind(pnt, data.frame(x=rep(i+shf, length(y.tt)), 
                                     y=y.tt, lab=varMat[y.tt,i],
                                     pch=22, cex=3) )
        wh.a1<-which(!y.tt%in%y.tt0)
        y.tt0a <- y.tt
        for(a in wh.a1){
          y.tt0a[a] <- y.tt0a[a-1]
        }
        arr <- rbind(arr,
                     data.frame(x0=rep(i-1+shf, length(y.tt)), 
                                y0=y.tt0a,
                                x1=rep(i+shf, length(y.tt)),
                                y1=y.tt, 
                                lty=rep(lty1, length(y.tt)),
                                lwd=rep(lwd1, length(y.tt)),
                                col=rep(col1, length(y.tt))))
        shf <- sum(max.nchar[1:i])*cex.1char
        y.tt0 <- y.tt
      }
      
      
      par(mar=c(0.2, 0.2, 0.2, 0.2), mfrow=c(1,1))
      plot(y~x, data=pnt, col='gray80', pch=pnt$pch,
           ylim=c(0, tot.row), xlim=c(0, tot.col2+shf+0.5),
           axes=F, ylab='', xlab='')
      text(x=pnt$x, y=pnt$y, labels=pnt$lab, adj=-0.07)
      arrows(x0=arr$x0, y0=arr$y0, x1=arr$x1, y1=arr$y1, 
             length=0.1, lty=arr$lty, lwd=arr$lwd, 
             col=arr$col)
    }
    
    #add barplot of utility and loss
    if(showBar){
      u.x0<-rep(0, length(LV))
      u.y0<-which(varMat[,ncol(varMat)-1]!='')
      u.x1<-unlist(U)
      col.bar1 <- rgb(0, 0, 255, alpha=80, maxColorValue=255)
      abline(v=0, col=col.bar1)
      for(i in 1:length(u.y0)){
        lines(x=c(u.x0[i], u.x1[i]), y=c(u.y0[i], u.y0[i]),
              lwd=8, 
              col=col.bar1)
      }
      
      l.x0<-rep(tot.col2+shf, nrow(varMat))
      l.y0<-1:nrow(varMat)
      l.x1<-l.x0-unlist(E.L)
      col.bar2 <- rgb(255, 0, 0, alpha=80, maxColorValue=255)
      abline(v=tot.col2+shf, col=col.bar2)
      for(i in 1:length(l.y0)){
        lines(x=c(l.x0[i], l.x1[i]), y=c(l.y0[i], l.y0[i]),
              lwd=8, 
              col=col.bar2)
      }
    }
    
    return(list(dat=varMat, BayesLoss=E.L, U=U, p=p.1))
    
  }
  
}

#define global variables for FDA_log analysis
if(TRUE){
  #get a subset
  key.words <<- c('all', 'NSCLC|lung', 
                  'urothelial', 
                  'gastrointestinal', 
                  'msi', 'breast', 'head', 'hcc',
                  'other')
  mySelect<-function(vec1, sp=NULL,
                     ctype='all',
                     fdaLink=FALSE, 
                     allkeys=key.words  ){
    
    if(!is.null(fdaLink)&&as.logical(fdaLink)){
      vec1 <- readLines(fL)
      #vec1 <- vec1[grepl('<li>', vec1)]
      vec1 <- vec1[grepl('approv', vec1)]
      if(length(vec1)==1){
        vec1<-vec1[grepl('href=\"#updates\"', vec1, fixed=T)]
        vec1<-strsplit(split='<li>', vec1, fixed=TRUE)[[1]]
        vec1<-gsub('\t|  ','', vec1)
        vec1 <- vec1[grepl('approv', vec1)]
      }
      if(length(vec1)==0){
        return(data.frame(FDA_log='Fail to reach the link.'))
      }
    }
    if(is.null(sp) || is.null(ctype)){
      return(data.frame(FDA_log='no data'))
    }
    if(!ctype%in%c('all')){
      if(ctype=='other'){
        ctype <- paste(allkeys[!allkeys%in%c('all','other')], collapse='|')
        vec1<-vec1[!grepl(ctype, vec1, ignore.case=T)]
      }else{
        vec1<-vec1[grepl(ctype, vec1, ignore.case=T)]
      }
      if(length(vec1)==0){
        return(data.frame(FDA_log='The disease is not found.'))
      }
    }
    if(sp==''|sp=='~'){
      if(is.data.frame(vec1)){
        dat1 <- data.frame(FDA_log=vec1[,1])
      }else if (is.vector(vec1)){
        dat1<- data.frame(FDA_log=vec1)
      }else{
        dat1<-data.frame(FDA_log='no data')
      }
      return(dat1)
    }
    vec2<- vec1[grepl(
      paste(paste0("(?=.*",strsplit(as.character(sp), split='&')[[1]], ")"), 
            collapse=""), vec1, perl=T, ignore.case=T)]
    dat1<-data.frame(FDA_log=vec2)
    return(dat1)
  }
}
#End 2. -----------------------------------------------------------------------#



#Begin 3. ---------------------------------------------------------------------#
#1.add continuous variables
#2.add benchmark reference
if(TRUE){
  
  #A function for P(y.trt-y.ref<x) given the equal length samples of y.trt, y.ref
  prob.diff <- function(x, y.diff=NULL, y.trt=NULL, y.ref=NULL){
    if(!is.null(y.diff)){
      dif1 <- y.diff[is.finite(y.diff)]
      return( mean(dif1<x, na.rm=T) )
    }else if(!is.null(y.trt) & !is.null(y.ref) & length(y.trt)==length(y.ref)){
      dif1 <- (y.trt-y.ref)
      dif1 <- dif1[is.finite(dif1)]
      return( mean(dif1<x, na.rm=T) )
    }else{return(0)}
  }
  #functions getting the random samples from given distribution
  #rbinom with n and pi
  #rlnorm with meanlog and sdlog
  
  
  #expected loss function for either discrete or continues X variables
  #L(theta,a)=0 if x in the range else abs(lev-a)*abs(theta-th)
  #f(theta|data) is a binomial distriubtion
  #Users can define their own expected loss function however the input must
  #be [th, n, p_pos] and the output must be a vector of expected loss under
  #each Bayes decision levels
  eLoss.diff <<- function(
    th=NULL,              #the vector of thresholds (delta) of decision rule
    sample1,             #a vector of samples under treatment assumption
    sample2,             #a vector of samples under control assumption
    sample1.prob,        #a vector of samples prob under treatment assumption
    sample2.prob,        #a vector of samples prob under control assumption
    len_cutoffs=NULL #the number of cutoffs or thresholds of a decision rule
  ){
    prob.1g2<-NULL
    #create the matrix of difference and the probablity
    if(!is.vector(sample1) | !is.vector(sample1.prob) |
       length(sample1)!=length(sample1.prob)){
      stop('Sample1 input is wrong for eLoss.diff')
    }else if(!is.vector(sample2) | !is.vector(sample2.prob) |
             length(sample2)!=length(sample2.prob)){
      stop('Sample2 input is wrong for eLoss.diff')
    }else{
      n.r <- length(sample1)
      n.c <- length(sample2)
      sam1.mat<-matrix(sample1, nrow=n.r, ncol=n.c)
      sam1prob.mat<-matrix(sample1.prob, nrow=n.r, ncol=n.c)
      sam2.mat<-t(matrix(sample2, nrow=n.c, ncol=n.r))
      sam2prob.mat<-t(matrix(sample2.prob, nrow=n.c, ncol=n.r))
      prob.mat <- sam1prob.mat*sam2prob.mat
      diff.mat <- sam1.mat - sam2.mat
      y2sampleD <- as.vector(diff.mat)
      ord <- order(y2sampleD)
      y2sampleD <- y2sampleD[ord]
      y2sampleD.prob <- as.vector(prob.mat)[ord]
      prob.1g2 <- sum(y2sampleD.prob[y2sampleD>0])
    }
    
    
    #Recomend threshold maximizing the loss difference
    if(is.null(th)||th%in%c("", "~", "-")){
      if(is.null(len_cutoffs)){len_cutoffs <- 1}
      th.prob <- seq(0,1, by=1/(len_cutoffs+1))
      th.prob <- th.prob[c(-1, -length(th.prob))]
      th <- quantile(y2sampleD, th.prob)
      recom.th <- TRUE
    }else{recom.th<-FALSE}
    
    
    #order the thereshold for a decision rule
    th <- sort(as.numeric(th))
    len_a<- length(th)
    n  <- length(y2sampleD)
    
    #~~~data construction~~~#
    #the number of decision levels is the number thresholds plus 1
    xs <- y2sampleD  #get the distribution consits of samples
    xs_lev <- rep(1, n)    #get decision levels for each sample
    for(i in 1:len_a) {
      xs_lev[xs>th[i]]<-i+1
    }
    
    #~~~get the expected loss for each action~~~#
    #a is the action level from 0 to len_a according to theta
    e_loss <- rep(0, len_a+1)
    
    #construct loss elements based on the higher bound for the lowest level
    #i<-1
    els.h<-abs(xs-th[1])*y2sampleD.prob
    e_loss[1]<-sum(els.h[xs_lev==1])
    
    #expected loss from level 2 to lev_a
    i<-2
    while(i>=2 & i<=len_a){#if taking the action as level i
      els.h<-abs(xs-th[i])*y2sampleD.prob
      els.l<-abs(xs-th[i-1])*y2sampleD.prob
      els <- els.h+els.h
      e_loss[i] <- sum(els[xs_lev>=i-1 & xs_lev<i])
      i<-i+1
    }
    
    #for highest level
    #construct loss elements based on the lower bound
    els.l<-abs(xs-th[len_a])*y2sampleD.prob
    e_loss[len_a+1]<-sum(els.l[xs_lev>len_a])
    
    if(recom.th){
      return(list(e_loss=e_loss, th=th, p.1g2=prob.1g2))
    }else{
      return(list(e_loss=e_loss, p.1g2=prob.1g2))  
    }
    
  }
  
  #A revised function of generating random variable from a lognormal distb
  rlnorm2 <- function(B=1000000, m, s){
    location <- log(m^2 / sqrt(s^2 + m^2))
    shape <- sqrt(log(1 + (s^2 / m^2)))
    smp <- rlnorm(n=B, location, shape)
    return(smp)
  }
  
  #improved function for Baysian decision theory with Critical Success Factor
  #take the difference between treatment variable and the benchmark control
  #available to add or remove variables
  #available to specify the Bayse loss function
  #available to select utility bar and the loss bar
  #Clinical Benifit and Biological Response are {0, 1} for {no or yes}. 
  #Output@: ranked table {dose, Disease, baselineBiomarker, expectedUtility}
  #Output@: tree plot
  #function name: Bayesian Decision Theory Utility and Loss
  #fixing the expected utility and make loss function flexible
  BDT_UaL.diff <- function(
    levVars="B1::T1::coh1::BR1,B1::T1::coh2::BR1,B1::T2::coh3::BR2",       
    #variables and levels separated by "::"
    dr_lev="No Go::Go,No Go::Go,No Go::Go",  #order does matter.
    #decision rule labels
    incidence="0.3,0.3,0.1",      #Biomarker incidence in the tumor type 
    #values obtained from prior knowledge
    numRsp=NULL,                 #the hyper parameters "alph, 2-alpha"
    #if NULL, then alpha=1+incidence and beta=2-incidence, 
    #and only trt ORR is onsidered without the benchmark control ORR
    #if not NULL, the value should be like
    #"1.3vs1.3,1.3vs1.2, 1.1vs1" matches "TRT_ORRvsCTR_ORR"
    muTTE=NULL,
    sdTTE=NULL,           #the mean and sd of TTE variables
    #if not NULL, e.g. "5vs5, 9vs2, 10vs8" and "1vs1, 1vs1, 1vs1"
    #matches "TRTvsCTR"
    n_ij="10, 10, 10",            #sample sizes for each cohort
    #or "10vs20,10vs80,10vs10" for "TRTvsCTR"
    #values obtained from decision makers
    dr_th="0.1,0.5,0.6",          #decision rule threshold for ORR
    #if 3 levels of decision rule such as 
    #dr_lev="go::moreData::nogo," then
    #dr_th="0.9::0.3,"
    #input: [th, n, p_pos]
    #output: a vector of Bayes decision loss
    showPlot=TRUE,  showBar=TRUE,      #show the barplot of utility & loss
    onebar=TRUE,                 #only show integrated bar at left
    th.arrow= 0.8,               #horizontal space between an arrow and target
    payoff= c(10, -1),            #payoff value for utility, only two values
    #gain vs lost
    bar.wid=8,          #the width of the horizontal bar
    Bsample=10000        #number of bootstrapping samples
  ){
    set.seed(1234567)
    #a list of difference in ORR between trt and ctr
    RT.diff <- list()
    #a list of difference in tte between trt and ctr
    tte.diff<- list()
    #by default, the difference variable between trt and ctr is not used.
    #it will be TRUE if 'vs' shows in the string of numRsp
    useRspDiff<-FALSE
    #it will be TRUE if 'vs's shows in the string muTTE
    useTteDiff<-FALSE
    
    #an internal function gets the hierarchical variables 
    #seperated by "::" for different levels of a variable
    #seperated by "," for different subgroups
    #seperated by "vs" for treatment vs control
    my.split1 <- function(mylab="", s1=",", s2="::"){
      if(length(mylab)==1 & is.character(mylab)){
        #the input is a string
        L1 <- strsplit(mylab, split=s1)[[1]]
      }else{ #when the input is already a vector
        L1 <- mylab
      }
      if(length(L1)==0) return('L1 in my.split1 is missing.')
      if(is.null(s2)) return(L1)
      if(all(is.character(L1))){
        L2 <- strsplit(L1, split=s2)
      }else{
        L2 <- mylab
      }
      return(L2)
    }
    
    
    #cleanup the input parameters
    if(TRUE){
      #Cleanup sample size parameters
      if(is.null(n_ij) || all(n_ij=='')|all(incidence=='')) return(NULL)
      if(grepl('vs',n_ij)){
        nL <- my.split1(n_ij, s2='vs')
        n_1.trt<- as.numeric(as.vector(sapply(nL,function(x){x[1]})))
        n_1.ctr<- as.numeric(as.vector(sapply(nL,function(x){x[2]})))
        n_1 <- n_1.trt #n_1 alwasy has values for treatment sizes
        if(length(n_1.trt)!=length(n_1.ctr)) return(NULL)
      } else {
        n_1 <- as.numeric(unlist(my.split1(n_ij)))
        n_1.trt <- n_1.ctr <- n_1
      }
      n_rt<- n_1/sum(n_1)
      
      #incidences
      if(is.null(incidence)) return(NULL)
      incd<- as.numeric(unlist(my.split1(incidence)))
      
      #for treatment prior parameters of Beta Variable pi based on incidences
      p.0<-list()
      for(o in 1:length(incd)){
        #p.0[[o]]<-c(1+incd[o], 2-incd[o])
        p.0[[o]]<-c(1, 2)
      }
      
      #posterior parameters of Beta Variable pi updated by trt ORR
      #and get RT.diff
      if(!is.null(numRsp) && numRsp!="~" && gsub(" ", "", numRsp)!=""){
        if(!(grepl("vs", numRsp)) && !is.null(n_1)){
          #when no sample sizes for control or benchmark
          #only the Beta posterrior parameters are updated
          p.0p<-as.numeric(my.split1(numRsp, s2=NULL))
          if(length(incd)!=length(p.0p)) return(NULL)
          if(length(p.0p)!=length(n_1)){
            #use the probability only without the sample sizes
            #if(any(p.0p>1|p.0p<0)) return(NULL)
            for(o in 1:length(p.0)){
              if(p.0p[o]>1){
                p.0[[o]]<-p.0[[o]]+c(p.0p[o]*incd[o], n_1[o]-p.0p[o]*incd[o])
              }else{
                p.0[[o]]<-p.0[[o]]+c(p.0p[o]*incd[o], 1-p.0p[o]*incd[o])
              }
            }
          } else {
            for(o in 1:length(p.0)){
              if(p.0p[o]>1){
                p.0[[o]]<-p.0[[o]]+c(p.0p[o]*incd[o], n_1[o]-p.0p[o]*incd[o])
              }else{
                p.0[[o]]<-p.0[[o]]+c(p.0p[o]*incd[o], 1-p.0p[o]*incd[o])
              }
            }
          }
          #note: p.0 is a listing object. Each element is a vector of
          #the two Beta parameters. The total number of elements matches
          #the number of incidences or cohorts/arms.
        }else{
          #when number of responders in control are inserted in numRsp
          #then the difference between trt and ref is given
          p.0p <- my.split1(numRsp, s2='vs')
          p.0p.trt<-as.numeric(sapply(p.0p, function(x){x[1]}))
          p.0p.ctr<-as.numeric(sapply(p.0p, function(x){x[2]}))
          if(is.null(n_1.ctr)) n_1.ctr <- n_1.trt
          if(!is.null(n_1.ctr) & length(p.0p)==length(n_1.ctr)){
            for(o in 1:length(p.0p)){
              if(p.0p.trt[o]>1){#if the new alpha>1
                p.0[[o]] <- p.0[[o]]+c(p.0p.trt[o]*incd[o], n_1[o]-p.0p.trt[o]*incd[o])
              }else{
                p.0[[o]] <- p.0[[o]]+n_1[o]*c(p.0p.trt[o]*incd[o], 1-p.0p.trt[o]*incd[o])
                #p.0p.trt[o] <- round(p.0p.trt[o], n_1[o])
                p.0p.trt[o] <- p.0p.trt[o]
              }
              if(p.0p.ctr[o]>1){
                prob.ctr<-p.0p.ctr[o]/n_1.ctr[o]
              }else{
                prob.ctr<-p.0p.ctr[o];
                p.0p.ctr[o]<-p.0p.ctr[o]*n_1.ctr[o]
              }
              sam.trt <- sam.ctr <- 0:n_1.trt[o]
              use1 <- 1
              if(use1==1){ #######2020-10-29   use emprical binomial
                sam.trt.prob<-dbinom(sam.trt, size=n_1.trt[o], 
                                   prob=p.0[[o]][1]/sum(p.0[[o]]) )
                sam.ctr.prob<-dbinom(sam.ctr, size=n_1.ctr[o], 
                                   prob=prob.ctr )
              }else if (use1==2){ #use preditive distribution for both trt and cntr
                sam.trt.prob<-dbbinom(sam.trt, size=n_1.trt[o], 
                                  alpha=1+p.0p.trt[o], beta=2-p.0p.trt[o] )
                sam.ctr.prob<-dbbinom(sam.ctr, size=n_1.ctr[o], 
                                  alpha=1+prob.ctr, beta=2-prob.ctr)
              }else{
                sam.trt.prob<-dbeta(sam.trt/n_1[o],  
                                   1+p.0p.trt[o], 2-p.0p.trt[o] )
                sam.ctr.prob<-dbeta(sam.ctr/n_1[o],  
                                   1+prob.ctr, 2-prob.ctr)
              }
              RT.diff[[o]] <- list()
              RT.diff[[o]]$sample1 <- sam.trt
              RT.diff[[o]]$sample2 <- sam.ctr
              RT.diff[[o]]$sample1.prob <- sam.trt.prob
              RT.diff[[o]]$sample2.prob <- sam.ctr.prob
              #print(paste('sum(sam.trt.prob)', sum(sam.trt.prob))); 
              #print(paste(p.0[[o]][1]/sum(p.0[[o]]), ',', prob.ctr))
              #print(quantile(sam.trt.prob))
              #print(quantile(sam.trt))
              #print(quantile(sam.ctr))
              #print(paste('sum(sam.ctr.prob)', sum(sam.ctr.prob)))
            }
            useRspDiff<-TRUE
          }else{return(NULL)}
        }
        #note: RT.diff[[o]] is a listing object for the o_th cohorts/arms. 
        #Four objects are saved in the listting RT.diff[[o]]: 
        #sample1, sample1.prob for treatment and  
        #sample2, sample2.prob for control
      }
      
      #Note:the length p.0 == the level of plans or #cohorts
      num.p0 <- length(p.0)
      
      #When using the default threshold
      if(!is.null(dr_th) && dr_th%in%c("~", "")){
        th1 <- list()
        #use prevalence for the thresholds
        for(o in 1:length(p.0))
          th1[[o]] <- p.0[[o]][1]/sum(p.0[[o]])
      }else{
        #when the thresholds are defined in a string such as "3::5,4::6"
        #then 3 and 4 are the lower cutoff for cohort 1 and 2, 
        #5 and 6 are the higher cutoff for cohort 1 and 2. 
        th1 <- lapply(my.split1(dr_th),as.numeric)
      }
      #note: th1 is a listing object. Each element is a vector of ORR 
      #cutoffs. The number of elements matches the number of incidences.
      
      #cleanup the two parameters for lognormal variables, such as TTE
      #Note: The benchmark control reference must be provided for the analysis
      tte.mu <- tte.sd <- list()
      if(!is.null(muTTE) & !is.null(sdTTE) & 
         grepl('vs', muTTE) & grepl('vs', sdTTE)){
        #a listing object of lognormal means. each element is the two means
        #of trt vs cntr
        tte.mu<-lapply(my.split1(muTTE, s2='vs'), as.numeric)
        tte.sd<-lapply(my.split1(sdTTE, s2='vs'), as.numeric)
        if(length(tte.mu)==length(tte.sd) & 
           all(sapply(tte.mu, length)==2) & 
           all(sapply(tte.sd, length)==2) &
           length(tte.mu)==length(incd)
        ){
          for(o in 1:length(incd)){
            cy.trt <- rlnorm2(B=Bsample, m=tte.mu[[o]][1], s=tte.sd[[o]][1])
            cy.ctr <- rlnorm2(B=Bsample, m=tte.mu[[o]][2], s=tte.sd[[o]][2])
            tte.diff[[o]] <- cy.trt-cy.ctr
            tte.diff[[o]] <- tte.diff[[o]][is.finite(tte.diff[[o]]) & 
                                             !is.na(tte.diff[[o]])]
          }
          useTteDiff<-TRUE
        }
      }
      
      #cleanup the payoff values
      if(is.character(payoff)){
        payoff <- as.numeric(strsplit(payoff, split=',', fixed=TRUE)[[1]])
        if(length(payoff)==1){
          payoff<-c(payoff, 0)
        }else{
          payoff <- payoff[1:2]
        }
      }
    }
    
    #construct the decision tree with user-defined variables
    #calculate Utility and Loss
    if(TRUE){
      
      #A listing object of plans. 
      #Each element is a vector of critical variables.
      if(is.null(levVars)) return(NULL)
      LV0 <- LV <- my.split1(levVars)
      num.var <- length(LV[[1]]) #number of variables
      
      #A listing object of decision rules. 
      #Each element is a vector of decision thresholds
      drLV  <- my.split1(dr_lev) 
      num.dr  <- length(drLV[[1]])
      
      if(length(LV)!=length(drLV) | length(LV)!=num.p0){
        #print('Error: lengths of decision rule and layers do not match!')
        return(NULL)
      }
      
      #lost, utility, response probability pi. 
      #p.2 is the posterior prob for benefit.
      iLV <- E.L <- U <- Utte <- p.1 <-p.2 <- list()
      for(o in 1:length(LV)){
        #convert the ORR_trt decision thresholds into numRsp_trt
        th2.lab<-th2<-round(th1[[o]]*n_1[o])
        
        #eLoss.diff(th, y2sampleD)
        if(useRspDiff){
          #if benchmark ref is available then the threshold th2 change to be
          #the difference. 
          th2 <- round((th1[[o]]-p.0p.ctr[o]/n_1.ctr[o])*n_1[o])
          #print(th2); print(paste("length(RT.diff[[o]])", length(RT.diff[[o]])));
          
          eL <- eLoss.diff(th=th2, 
                           sample1=RT.diff[[o]]$sample1,
                           sample2=RT.diff[[o]]$sample2,
                           sample1.prob=RT.diff[[o]]$sample1.prob,
                           sample2.prob=RT.diff[[o]]$sample2.prob)
          #normalize the loss
          #print('sum(eL$e_loss)'); print(sum(eL$e_loss))
          eL$e_loss <- eL$e_loss/sum(eL$e_loss)
          #probability of the difference pi_trt-pi_ctr>0
          #print(paste0('p.1[[',o,']]=', p.1[[o]] <- eL$p.1g2))
          p.1[[o]] <- eL$p.1g2
          eL <- eL$e_loss
        }else{
          #expected response probability pi_trt
          p.1[[o]] <- p.0[[o]][1]/sum(p.0[[o]])
          eL <- my.eLoss(th=th2, n=n_1[o], p_pos=p.1[[o]] )
          #normalized the loss
          #eL <- eL/sum(eL)
          #convert the expected distance to success in the scale of response rate
          #eL <- eL/n_1[o]
        }
        E.L[[o]]<-eL  #expected loss
        
        #expected utility based on ORR
        # U[[o]] <- incd[o]*n_rt[o]*p.1[[o]]*payoff[1]+
        #   incd[o]*n_rt[o]*(1-p.1[[o]])*payoff[2]
        U[[o]] <- incd[o]*p.1[[o]]*payoff[1] + incd[o]*(1-p.1[[o]])*payoff[2]
        
        #expected utility based on TTE
        if(useTteDiff){
          #P(mu_trt-mu_ctr>0|...)
          p.2[[o]] <- mean(tte.diff[[o]]>0)
          # Utte[[o]] <- incd[o]*n_rt[o]*p.2[[o]]*payoff[1]+
          #   incd[o]*n_rt[o]*(1-p.2[[o]])*payoff[2]
          Utte[[o]] <- incd[o]*p.2[[o]]*payoff[1]+
            incd[o]*(1-p.2[[o]])*payoff[2]
        }
        
        if(o>1){
          o.wh <- which(LV0[[o]]!=LV0[[o-1]])[1]
          if(length(o.wh)==0) o.wh<-1
          no.wh <- which(LV0[[o]]==LV0[[o-1]])
          LV[[o]][ no.wh[no.wh<o.wh] ]<-''
        }
        
        iLV[[o]] <- c(LV[[o]][1:(num.var-1)],
                      paste0(LV[[o]][num.var], ", n=", n_1[o],
                             "\nI=", incd[o],
                             ", U_orr=", round(U[[o]],3),
                             ifelse(useRspDiff,
                                    ", p(trt>ref)=", 
                                    ", p="), round(p.1[[o]],3),
                             ifelse(useTteDiff, 
                                    paste0("\nU_tte=",round(Utte[[o]],3),
                                           ", m_trt=", tte.mu[[o]][1],
                                           ", m_ref=", tte.mu[[o]][2],
                                           ", s_trt=", tte.sd[[o]][1],
                                           ", s_ref=", tte.sd[[o]][2]), 
                                    "")), 
                      paste0(drLV[[o]][1],
                             ifelse(useRspDiff, " if d_r<=", " if r<="),
                             th2.lab[1],
                             ", E(L)=", round(eL[1],3)))
        if(num.dr==1) next
        for(h in 2:num.dr){
          if(h==num.dr){
            iLV[[o]] <- c(iLV[[o]], rep('', num.var), 
                          paste0(drLV[[o]][h], 
                                 ifelse(useRspDiff," if d_r>", " if r>"),
                                 th2.lab[h-1],
                                 ", E(L)=", round(eL[h],3))  )
          }else{
            iLV[[o]] <- c(iLV[[o]], rep('', num.var), 
                          paste0(drLV[[o]][h], ": ",th2.lab[h-1],
                                 ifelse(useRspDiff,"<= d_r <" , "<= r <"),
                                 th2.lab[h],
                                 ", E(L)=", round(eL[h],3))  )
          }
        }
      }
      varMat <- t(matrix(unlist(iLV), nrow=num.var+1))
      #E.L[[o]]: expected Bayes decision loss
      #U[[o]]: utility of plan based on ORR
      #Utte[[o]]: utility based on tte
    }
    
    #build arrows and coordinates to show the decision tree
    if(TRUE){
      tot.col   <- ncol(varMat)
      max.nchar <- apply(varMat, 2, function(x){max(nchar(x))})
      cex.1char<- 0.05 #affect distance between text and arrow
      tot.row <- nrow(varMat)
      tot.col2<- tot.col+2 #to enable the fitting lines longer
      text.size1 <- 3/log(tot.row)
      th.a <- th.arrow/log(tot.row) #about arrow locaiton
      
      #for Layer 1
      lty1 <- 1;  lwd1 <- 1; col1='gray80';
      y.tt <- which(varMat[,1]!='')
      pnt <- data.frame(x=c(0, rep(1, length(y.tt))), y=c(1, y.tt), 
                        lab=c('', varMat[y.tt,1]),
                        pch=rep(22,length(y.tt)+1), cex=rep(3,length(y.tt)+1))
      arr <- data.frame(x0=rep(0, length(y.tt)), 
                        y0=rep(1, length(y.tt)), 
                        x1=rep(1, length(y.tt)), 
                        y1=y.tt, 
                        lty=rep(1, length(y.tt)),
                        lwd=rep(1, length(y.tt)), 
                        col=rep(col1, length(y.tt)))  
      shf <- sum(max.nchar[1])*cex.1char
      y.tt0 <- y.tt
      for(i in 2:tot.col){
        y.tt <- which(varMat[,i]!='')
        pnt <- rbind(pnt, data.frame(x=rep(i+shf, length(y.tt)), 
                                     y=y.tt, lab=varMat[y.tt,i],
                                     pch=22, cex=3) )
        wh.a1<-which(!y.tt%in%y.tt0)
        y.tt0a <- y.tt
        for(a in wh.a1){
          y.tt0a[a] <- y.tt0a[a-1]
        }
        arr <- rbind(arr,
                     data.frame(x0=rep(i-0.5+shf, length(y.tt)), 
                                y0=y.tt0a,
                                x1=rep(i+shf, length(y.tt)),
                                y1=y.tt, 
                                lty=rep(lty1, length(y.tt)),
                                lwd=rep(lwd1, length(y.tt)),
                                col=rep(col1, length(y.tt))))
        shf <- sum(max.nchar[1:i])*cex.1char
        y.tt0 <- y.tt
      }
      
      if(showPlot){
        par(mar=c(0.2, 0.2, 0.2, 0.2), mfrow=c(1,1))
        plot(y~x, data=pnt, col='gray80', pch=pnt$pch,
             ylim=c(0, tot.row+0.5), xlim=c(0, tot.col2+shf+0.5),
             axes=F, ylab='', xlab='')
        text(x=pnt$x, y=pnt$y, labels=pnt$lab, adj=-0.07)
        arrows(x0=arr$x0, y0=arr$y0, x1=arr$x1, y1=arr$y1, 
               length=0.1, lty=arr$lty, lwd=arr$lwd, 
               col=arr$col)
        text(x=0, y=tot.row+0.5, labels='Utility', col='blue')
        text(x=tot.col2+shf, y=tot.row+0.5, labels='Risk', col='red')
      }
    }
    
    #add barplot of utility and loss
    if(showBar&showPlot){
      #      bar.wid <- 8
      u.x0<-rep(0, length(LV))
      u.y0<-which(varMat[,ncol(varMat)-1]!='')
      u.x1<-unlist(U)
      if(useTteDiff){utte.x1<-unlist(Utte)}else{utte.x1<-NULL}
      col.bar1 <- rgb(0, 0, 255, alpha=80, maxColorValue=255) #blue
      col.bar1tte <- rgb(0, 100, 0, alpha=80, maxColorValue=255)  #darkgreen
      abline(v=0, col=col.bar1)
      for(i in 1:length(u.y0)){
        if(onebar & useTteDiff){
          uInt.x1<-u.x1[i]*utte.x1[i]
          lines(x=c(u.x0[i], uInt.x1), 
                y=c(u.y0[i], u.y0[i]),
                lwd=bar.wid, col=col.bar1)
          text(x=u.x0[i], y=u.y0[i], labels=round(uInt.x1, 3))
        }else{
          lines(x=c(u.x0[i], u.x1[i]), y=c(u.y0[i], u.y0[i]),
                lwd=bar.wid, 
                col=col.bar1)
          if(useTteDiff){
            lines(x=c(u.x0[i], utte.x1[i]), y=c(u.y0[i], u.y0[i])+0.1,
                  lwd=bar.wid, 
                  col=col.bar1tte)
          }
        }
      }
      
      l.x0<-rep(tot.col2+shf, nrow(varMat))
      l.y0<-1:nrow(varMat)
      l.x1<-l.x0-unlist(E.L)
      col.bar2 <- rgb(255, 0, 0, alpha=80, maxColorValue=255)
      abline(v=tot.col2+shf, col=col.bar2)
      for(i in 1:length(l.y0)){
        lines(x=c(l.x0[i], l.x1[i]), y=c(l.y0[i], l.y0[i]),
              lwd=bar.wid, 
              col=col.bar2)
      }
    }
    
    return(list(dat=varMat, BayesLoss=E.L, U=U, Utte=Utte, p=p.1))
    
  }
  
  
}
#End 3. -----------------------------------------------------------------------#


#Begin 3.1 ---------------------------------------------------------------------#
#1.dynamic CSF with iBDT
if(TRUE){
  library(extraDistr)
  
  ###--- convert color to rgb format---###
  c2r<-function(cc='red', a=0.5){
    rc<-col2rgb(cc)
    rgb(rc[1,1], rc[2,1], rc[3,1], a*255, maxColorValue=255)
  } 
  #c2r('yellow', 0.3) 
  
  

  if(F){
    #the chance of having 2 or 3 or.. events in the first 15
    SimOrd<-function(B=1000, n1=15, n2=150, p=0.3, a=0.3, b=0.7){
      bsim<-bbsim<-NULL
      for(ss in 1:B){
        #sampling from binomial
        bsim <- c(bsim, sum(rbern(n2, p)[1:n1]))
        #sampling from beta binomial
        bbsim <- c(bbsim, sum(rbern(n2, rbeta(1, a, b))[1:n1]) )
      }
      freq.b <- table(bsim)/B; freq.bb <- table(bbsim)/B
      col2<-c(rep(paste0('Bernoulli(', p,')'), length(freq.b)), 
              rep(paste0('BetaBernoulli(', a,', ', b,')'),length(freq.bb)))
      dd <- data.frame(y=c(freq.b, freq.bb), col=col2,
                       x=as.numeric(c(names(freq.b), names(freq.bb))) )
      barplot(y~col+x, data=dd, col=c('black','purple'), beside=TRUE, 
              ylab='prob', xlab='', legend=TRUE)
    }
    par(mfrow=c(2,2))
    SimOrd(n1=15, n2=150)
    SimOrd(n1=15, n2=150, a=0.3*10, b=10*(1-0.3))
  }


  #integrated BDT values
  iBDT_CSF<-function(
    levInt=paste(c("Cervical::2L_PD-L1_CPS>1%",  "NSCLC::1L_IIIB/IV_PD-L1>5%",
                   "NSCLC::2L_IIIB/IV_PD-L1>5%", "NSCLC::3L_IIIB/IV_PD-L1>5%",
                   "NSCLC::1Lplatinum_IIIB/IV"),collapse=','), 
    #set cohort lables to compare, '::' defines levels
    n1c='40',  #fixed a samples for other parameter change
    orr0="0.146, 0.22, 0.19, 0.18, 0.137", #ORRs of controls match to lev1
    delta.r='0.10',  #fixed an improved ORR effect size
    delta.t='4', #fixed TTE effect size month
    mt0='2.1, 5.4, 2.8, 2.8, 2.7', #tte values of control or benchmarks
    cv='0.8', #coefficient variation for tte
    cutoff='0.4', #decision threshold over ORR or delta ORR
    nsel="20, 40, 60, 80, 100, 120, 140, 160",#simulate different samples
    dorr="0.05, 0.1, 0.15, 0.2", #simulate different ORR effect size
    dtte="1, 2, 3, 4, 5, 6, 7", #simulate different TTE effect size
    dr1r='0.10,0.15,0.20,0.25,0.30,0.35,0.40,0.45,0.50,0.55,0.60,0.65,0.70', 
    #simulate decision threshold
    yellowC="0.25, 0.4||0.5", #yellow range for ORR decision thresholds||transparency
    showAll=TRUE #if F, only show the iBDT risk vs threshold
  ){
    #set up basic parameters
    if(TRUE){
      #levInt<-paste(lev1, collapse = ',')
      lev1<- unlist(strsplit(levInt, split=',', fixed=T)[[1]])
      ngrp <- length(lev1)
      c2n<-function(x, s=NULL){
        if(is.numeric(x)) return(x)
        if(is.null(s))
          x<-as.numeric(unlist(strsplit(as.character(x), split=',')[[1]]))
        else
          x<-as.numeric(unlist(strsplit(as.character(x), split=',')[[1]]))[s]
        return(x)
      }#covert character to vector

      n1c<-c2n(n1c,1); orr0<-c2n(orr0); delta.r<-c2n(delta.r,1);
      if(gsub(' ', '', dr1r, fixed=T)==''){
        dr1r<- paste((2:(n1c-1))/n1c, collapse=',')
      }
      delta.t<-c2n(delta.t,1); mt0<-c2n(mt0); cv<-c2n(cv,1); 
      cutoff<-c2n(cutoff,1); nsel<-c2n(nsel); dorr<-c2n(dorr);
      dtte<-c2n(dtte);  dr1r<-c2n(dr1r);
      yellowC<-unlist(strsplit(yellowC, split='||', fixed=T))
      if(length(yellowC)>1){ctra<-c2n(yellowC[2])}else{ctra<-0.85}
      yellowC<-c2n(yellowC[1],1:2)
      
      dr_1Int<-paste0(rep('stop::go', len=ngrp), collapse=',')
      #bmk prevalence internal setup
      ic_1Int<-paste0(rep(1, len=ngrp), collapse=',') 
      n1Int  <- paste(rep(n1c, len=ngrp),collapse=',')
      
      #set up ORR trt vs ctrl labels
      orrV<-paste(min(orr0+delta.r,1), orr0, sep='vs')
      orr1Int<-paste(orrV,collapse=', ')
      #orr1Int <- paste(orr0+delta.r, collapse=', ')
      
      #set up TTE trt vs ctrl lables      
      mt1V<-paste(mt0+delta.t, mt0, sep='vs')
      mt1Int <- paste(mt1V,collapse=', ')
      sd0 <- mt0*cv #standard deviation of TTE
      sd1Int <- paste(paste(sd0, sd0, sep='vs'),collapse=',')
      
      #decision rule threshold for ORR
      dr1Int <- paste(rep(cutoff, len=ngrp), collapse=',')
      poInt  <-c(1,0) #convert utility to success rate
    }
    
    p1<-function(nsel.p1=nsel, ngrp.p=ngrp, dlt.r=delta.r, dlt.t=delta.t,
                 lev2=levInt, dr_1=dr_1Int, ic_1=ic_1Int, orr1=orr1Int,
                 mt1=mt1Int, sd1=sd1Int, po=poInt, dr1=dr1Int,
                 lev1p=lev1, orr0p=orr0, mt0p=mt0 ){ #change n
      u1<-u2<-r1<-matrix(NA, nrow=ngrp.p, ncol=length(nsel.p1))
      for(i in 1:length(nsel.p1)){#start looping
        n1  <- paste(rep(nsel.p1[i], len=ngrp.p),collapse=',')
        ibdt1<-BDT_UaL.diff( levVars=lev2, dr_lev=dr_1, incidence=ic_1, 
                             numRsp=orr1, muTTE=mt1,  sdTTE=sd1,  
                             n_ij=n1, dr_th=dr1, showPlot=F, payoff=po)
        u1[,i]<-unlist(ibdt1$U)
        u2[,i]<-unlist(ibdt1$Utte)
        r1[,i]<-sapply(ibdt1$BayesLoss, function(x){x[2]})
      }
      u <- sqrt(u1*u2)
      colnames(u)<-colnames(r1)<-nsel.p1 #start plotting
      plot(u[1,]~nsel.p1, ylim=range(u)+c(-0.3,0),  type='o', 
           ylab='iBDT Utility',  xlab='n',
           main=paste0('delta_ORR=', 100*dlt.r, '%, delta_TTE=', dlt.t,'mon'))
      j<-2; while(j>=2 & j<=nrow(u)){
        points(u[j,]~nsel.p1, type='o', col=j)
        j<-j+1
      }
      col1<-1:nrow(u)
      legend('bottomright', 
             legend=paste0(lev1p,'orr_ctrl',orr0p, ' mPFS', mt0p), 
             text.col=col1, bty='n', lty=1, col=col1)
    }
    
    
    p2<-function(dorr.p2=dorr,n.1=n1c, ngrp.p=ngrp, dlt.r=delta.r, dlt.t=delta.t,
                 lev2=levInt, dr_1=dr_1Int, ic_1=ic_1Int,  n1=n1Int,
                 mt1=mt1Int, sd1=sd1Int, po=poInt, dr1=dr1Int, #orr1=orr1Int,
                 lev1p=lev1, orr0p=orr0, mt0p=mt0){ #change delata
      u1<-u2<-r1<-matrix(NA, nrow=ngrp.p, ncol=length(dorr.p2))
      for(i in 1:length(dorr.p2)){#start looping
        orr1<-paste(paste(min(orr0p+dorr.p2[i],1), orr0p, sep='vs'), collapse=', ')
        ibdt1<-BDT_UaL.diff( levVars=lev2, dr_lev=dr_1, incidence=ic_1, 
                             numRsp=orr1, muTTE=mt1,  sdTTE=sd1,  n_ij=n1, 
                             dr_th=dr1, showPlot=F, payoff=po)
        u1[,i]<-unlist(ibdt1$U)
        u2[,i]<-unlist(ibdt1$Utte)
        r1[,i]<-sapply(ibdt1$BayesLoss, function(x){x[2]})
      }
      u <- sqrt(u1*u2)
      colnames(u)<-colnames(r1)<-dorr.p2
      plot(u[1,]~dorr.p2, ylim=range(u)+c(-0.3,0),  type='o', ylab='iBDT Utility', 
           xlab='ORR effect size', 
           main=paste0('n=',n.1,', delta_TTE=', dlt.t, 'mon'))
      j<-2; while(j>=2 & j<=nrow(u)){
        points(u[j,]~dorr.p2, type='o', col=j)
        j<-j+1
      }
      col1<-1:nrow(u)
      legend('bottomright', 
             legend=paste0(lev1p,'orr_ctrl',orr0p, ' mPFS', mt0p), 
             text.col=col1, bty='n', lty=1, col=col1)
    }
    
    p3<-function(dtte.p3=dtte,n.1=n1c, ngrp.p=ngrp, dlt.r=delta.r, dlt.t=delta.t,
                 lev2=levInt, dr_1=dr_1Int, ic_1=ic_1Int,  n1=n1Int,
                 sd1=sd1Int, po=poInt, dr1=dr1Int, orr1=orr1Int, #mt1=mt1Int, 
                 lev1p=lev1, orr0p=orr0, mt0p=mt0 ){ #change delata TTE
      u1<-u2<-r1<-matrix(NA, nrow=ngrp.p, ncol=length(dtte.p3))
      for(i in 1:length(dtte.p3)){#start looping
        mt1 <- paste(paste(mt0p+dtte.p3[i], mt0p, sep='vs'),collapse=', ')
        ibdt1<-BDT_UaL.diff( levVars=lev2, dr_lev=dr_1, incidence=ic_1, 
                             numRsp=orr1, muTTE=mt1,  sdTTE=sd1,  n_ij=n1, 
                             dr_th=dr1, showPlot=F, payoff=po)
        u1[,i]<-unlist(ibdt1$U)
        u2[,i]<-unlist(ibdt1$Utte)
        r1[,i]<-sapply(ibdt1$BayesLoss, function(x){x[2]})
      }
      u <- sqrt(u1*u2)
      colnames(u)<-colnames(r1)<-dtte.p3
      plot(u[1,]~dtte.p3, ylim=range(u, na.rm=T)+c(-0.3,0),  type='o', 
           ylab='iBDT Utility', xlab='TTE effect size', 
           main=paste0('n=',n.1, ', delta_ORR=,', dlt.r*100, '%'))
      j<-2; while(j>=2 & j<=nrow(u)){
        points(u[j,]~dtte.p3, type='o', col=j)
        j<-j+1
      }
    }
    
    p4<-function(dr1r.p4=dr1r, n.1=n1c, ngrp.p=ngrp, dlt.r=delta.r, dlt.t=delta.t,
                 lev2=levInt, dr_1=dr_1Int, ic_1=ic_1Int,  n1=n1Int,
                 sd1=sd1Int, po=poInt, dr1=dr1Int, orr1=orr1Int, mt1=mt1Int, 
                 lev1p=lev1, orr0p=orr0, mt0p=mt0,
                 dc_rg=yellowC){#change CSF with different rate
      u1<-u2<-r1<-matrix(NA, nrow=ngrp.p, ncol=length(dr1r.p4))
      for(i in 1:length(dr1r.p4)){#start looping
        dr1 <- paste(rep(dr1r.p4[i], ngrp.p), collapse=',')
        #print('dr1');print(dr1); print(dr_1); print(ic_1); print(orr1);
        ibdt1<-BDT_UaL.diff( levVars=lev2, dr_lev=dr_1, incidence=ic_1, 
                             numRsp=orr1, muTTE=mt1,  sdTTE=sd1,  n_ij=n1, 
                             dr_th=dr1, showPlot=F, payoff=po)
        u1[,i]<-unlist(ibdt1$U)
        u2[,i]<-unlist(ibdt1$Utte)
        r1[,i]<-sapply(ibdt1$BayesLoss, function(x){x[2]})
        #print('BayL'); print(ibdt1$BayesLoss)
      }
      u <- sqrt(u1*u2)
      colnames(u)<-colnames(r1)<-dr1r.p4
      plot(0~min(dr1r.p4), ylim=range(r1),  type='o', 
           ylab='iBDT risk = expected distance to success', 
           col='white', xlim=range(dr1r.p4), xlab='ORR decision threshold', 
           main=paste0('n=',n.1,', delta_ORR=', dlt.r*100, '%'))
      abline(h=c(0.1,0.5, 0.9), lty=2)
      #ctra<-0.3
      polygon(x=c(min(dr1r.p4), dc_rg[1], dc_rg[1], min(dr1r.p4)), 
              y=rep(range(r1), each=2), col=c2r('red',ctra), border=c2r('red',ctra))
      polygon(x=c(dc_rg[1], dc_rg[2], dc_rg[2], dc_rg[1]), 
              y=rep(range(r1), each=2), col=c2r('yellow',ctra), border=c2r('yellow',ctra))
      polygon(x=c(dc_rg[2], max(dr1r.p4), max(dr1r.p4), dc_rg[2]),
              y=rep(range(r1), each=2), col=c2r('green', ctra), border=c2r('green', ctra))
      j<-1; while(j>=1 & j<=nrow(u)){
        points(r1[j,]~dr1r.p4, type='o', col=j)
        j<-j+1
      }
      #print('r1:'); print(r1)
      col1<-1:nrow(u)
      # legend('topright', legend=paste0(lev1,', orr_ctrl',orr0, ', mPFS', mt0), 
      # 			 text.col=col1, bty='n', lty=1, col=col1)
    }
    
    if(showAll){
      par(mfrow=c(1,2))
      #p1();  p4(); 
      p2(); p3();
    }else{
      par(mfrow=c(1,2))
      p1(); p4();

    }
  }
  if(F){#BEACH code
    input<-NULL
    
    input$text<-"Cervical::2L_PD-L1_CPS>1%,NSCLC::1L_IIIB/IV_PD-L1>5%,NSCLC::2L_IIIB/IV_PD-L1>5%,NSCLC::3L_IIIB/IV_PD-L1>5%,NSCLC::1Lplatinum_IIIB/IV"
    
    input$text2<-'40'
    input$text3<-"0.146, 0.22, 0.19, 0.18, 0.137"
    input$text4<-'0.10'
    input$text5<-'4'
    input$text6<-'2.1, 5.4, 2.8, 2.8, 2.7'
    input$text7<-'0.8'
    input$text8<-'0.4'
    input$text9<-"20, 40, 60, 80, 100, 120, 140, 160"
    input$text10<-"0.05, 0.1, 0.15, 0.2"
    input$text11<-"1, 2, 3, 4, 5, 6, 7"
    input$text12<-'0.10,0.15,0.20,0.25,0.30,0.35,0.40,0.45,0.50,0.55,0.60,0.65,0.70'
    input$text13<-"0.25, 0.4"
    
    iBDT_CSF(
      levInt=input$text, #set cohort lables to compare, '::' defines levels
      n1c=input$text2,  #fixed a samples for other parameter change
      orr0=input$text3, #ORRs of controls match to lev1
      delta.r=input$text4,  #fixed an improved ORR effect size
      delta.t=input$text5, #fixed TTE effect size month
      mt0=input$text6, #tte values of control or benchmarks
      cv=input$text7, #coefficient variation for tte
      cutoff=input$text8, #decision threshold over ORR or delta ORR
      nsel=input$text9,#simulate different samples
      dorr=input$text10, #simulate different ORR effect size
      dtte=input$text11, #simulate different TTE effect size
      dr1r=input$text12, #simulate decision threshold
      yellowC=input$text13, #yellow range for ORR decision thresholds\
      showAll=F
    )
  }
}
#End 3.1 -----------------------------------------------------------------------#


#Begin 3.2 ---------------------------------------------------------------------#
if(T){ #######2020-10-29
  library(extraDistr)

  #convert a text to num
  c2n<<-function(x, rm.c=c('c','(',')'), sp=',', sp2=';'){
    x<-as.character(x)
    for(jj in rm.c)
      x <- gsub(jj, '', x, fixed=T)
    if(grepl(sp2, x)){
      x3 <- unlist(strsplit(x, split=sp2, fixed=T))
      x2 <- lapply(x3, function(m){
              as.numeric(unlist(strsplit(m, split=sp, fixed=T)))})
    }else{
      x2 <- as.numeric(unlist(strsplit(x, split=sp, fixed=T)))
    }
    return(x2)
  }
  
  #generate a futility table for no go decision
  futTb <<- function(
       n=c(6, 8, 9), #sample sizes
       nr=c(0, 1, 2, 4), #number of observed responders
       trt.orr=c(0.1, 0.2), #target ORRs
       dlt.orr=c(0.05, 0.05), #ORR effect size
       show.type=1, #1=both posterior prob and iBDT risk; 2=iBDT only; 3=post prob
       beta.parm=c(0.2, 1.8), #hyper prior only used in Bayesian Posterior only
       num.dig=3, #number of digits to keep
       direc='1. P(X>r|data)' #for success probability, or'2. P(X<=r|data)' for futility
      ){
     if(is.character(show.type)){show.type<-as.numeric(substring(show.type,1,1))}
     #setup number of responders, sample sizes
     trt.orr <- sort(unique(trt.orr[trt.orr>=0]))
     n <- sort(unique(n[n>0]))
     trt.orrs <- rep(trt.orr, each=length(n))
     trt.id <- rep(1:length(trt.orr), each=length(n))
     dlt.orrs <- rep(dlt.orr, each=length(n))
     ns <- rep(n, times=length(trt.orr))
     if(is.list(beta.parm)){beta.L <- beta.parm}else{beta.L<-NULL}

     #set up rsp labels and fut table
     nr <- sort(unique(nr))
     lab.rsp<-paste0('#rsp=', nr)
     fut<-matrix(NA, nrow=length(n)*length(trt.orr), ncol=length(lab.rsp)) 
     colnames(fut)<-lab.rsp

     show.type<-as.character(show.type)
     for(i in 1:nrow(fut)){
       if(!is.null(beta.L)){beta.parm<-beta.L[[trt.id[i]]]}
       irsk<-NULL #get iBDT risk
       for(j in 1:length(nr)){
         #expected similarity between observed data and target data
         rsk<-BDT_UaL.diff(levVars='my.tst', dr_lev="stop::go", incidence="1", 
              numRsp=paste0(trt.orrs[i],'vs', trt.orrs[i]-dlt.orrs[i]), 
              muTTE=3, sdTTE=0.8, # not useful for rsk result
              n_ij=ns[i], dr_th=nr[j]/ns[i], showPlot=F, payoff=c(1,0))
         irsk <- c(irsk, 1-rsk$BayesLoss[[1]][2])
       }#Similarity to target success?wwith number of responders (m) improved by treatment
       #posterior parameter expectation
       p2 <- 1- pbeta(trt.orrs[i], beta.parm[1]+nr, beta.parm[2]+ns[i]-nr)#Posterior Prob to success
       p4 <- 1- pbbinom(nr, ns[i], 1+trt.orrs[i], 2-trt.orrs[i]) #Predictive Prob to success
       p5 <- pbinom(nr, ns[i], trt.orrs[i])        #false negative P(Y<=nr|targetORR)
       p6 <- 1-pbinom(nr, ns[i], trt.orrs[i]-dlt.orrs[i]) #false positive P(Y>nr|controlORR)
       if(substring(direc, 1,1)!='1'){
          irsk <- 1-irsk
          p2 <- 1-p2 #Posterior Prob to failure
          p4 <- 1-p4 #Predictive Prob to failure
          p5 <- 1-p5 #true negative
          p6 <- 1-p6 #true positive
       }
       p2 <- round(p2, num.dig)
       p4 <- round(p4, num.dig)
       p5 <- round(p5, num.dig)
       p6 <- round(p6, num.dig)
       irsk<-round(irsk, num.dig)
       if(show.type==4){ #FN
         fut[i,] <- p5
       }else if (show.type==5){ #FP
         fut[i,] <- p6
       }else if(show.type==100) {#iBDT posterior for number of responders
         fut[i,] <- paste(p2, 'vs', p4)
         lst.row<-'Posterior Prob Beta vs BetaBinomial'
       }else if(show.type==101) {#iBDT posterior for number of responders
         fut[i,] <- p4
         lst.row<-'Posterior Prob BetaBinomial'
       }else if(show.type==2){ #both table
         fut[i,] <- paste(p2,'vs', irsk)
         lst.row<-'P(ORR>target_orr)  vs  iBDT risk for the expected distance to success. Effect size=0.05'
       }else if(show.type==1){ #iBDT risk
         fut[i,] <- irsk
         lst.row<-'iBDT risk for the expected distance to success. Effect size=0.05'
       }else { #posterior for response rate  #show.type==3
         fut[i,] <- p2
         lst.row<-'P(ORR>target_orr)'
       }
     }
     ot <- data.frame(targetORR=trt.orrs, sampleSize=ns, fut)
     ot[ot==0]<-paste0('<0.', paste(rep('0', num.dig-1), collapse=''), '1')
     colnames(ot)[-(1:2)] <- lab.rsp
     if(show.type%in%c(1,5)){ot <- cbind(controlORR=trt.orrs-dlt.orrs, ot)}
     #ot <- rbind(ot, c('', '', lst.row, rep('', ncol(ot)-3)))
     return(ot)
  }

  #test result
  if(F){

    source('functions/users/DT_frame2.r')

    input<-NULL
    input$text <- '6, 9, 12'
    input$text2 <- '0, 1, 2, 4'
    input$text3 <- '0.1, 0.15'
    input$text4 <- '0.05, 0.05'
    input$text5 <- '0.2, 1.8; 0.3, 1.7;0.4, 16'
#    input$radio <- '0. FN'
    input$radio <- '4. FP'
    input$dropdown<-'3'
    input$radio2<- '1.'

    futTb(n=c2n(input$text), #sample sizes
       nr=c2n(input$text2), #number of observed responders
       trt.orr=c2n(input$text3), #target ORRs
       dlt.orr=c2n(input$text4), #ORR effect size
       show.type=input$radio, #1=both posterior prob and iBDT risk; 2=iBDT only; 3=post prob
       beta.parm=c2n(input$text5), # Hyper parameter in Beta distribution
       num.dig=c2n(input$dropdown),
       direc=input$radio2 )

  }
}
#End 3.2 -----------------------------------------------------------------------#




#Begin 4. ---------------------------------------------------------------------#
#power analysis
if(TRUE){
  #X ~ w*N(muA, sgmS) + (1-w)*N(muB, sgmS)
  #mu = w*muA + (1-w)*muB where muA>=muB
  #sgmS = sqrt(sgm^2 - ee)
  #ee = w*muA^2 + (1-w)*muB^2 - mu^2
  #theta = muA - muB
  BEACH_PowerPlot<<-function(
    n.rg='10~200',
    n.vl=20, #a fixed vertical line in power vs n plot
    theta.rg='0~200',
    theta.vl=50, #a fixed vertical line in power vs theat
    sgm.rg='10~200', 
    sgm.vl=100, #a fixed vertical line in power vs observed standardization
    muA=15, #a default assumption of the lower group mean
    prev='0.15~0.65', #prevalence rate for group A
    alpha=0.05,  #significance level
    simSize=100, #simulation size
    m1=1,           #number of group pairs
    r1=ifelse(as.numeric(m1)<2,  NA,
              paste(rep(1,round(as.numeric(m1))-1),collapse=',') )
    #proportions in the groups with higher means
  ){
    require(pwr)
    xx2<-function(rg1, ss=simSize){
      return(seq(rg1[1], rg1[2], len=ss))
    }
    add1<-function(xL='sample size', LL, v1=n.vl, v1c='n', 
                   LG1=NULL, LG1.pos='topright', 
                   LG2=NULL, LG2.pos='bottomright'){
      plot(y~x, data=LL[[1]], ylab='power', xlab=xL, type='l', lty=2,
           ylim=c(0,1), xlim=range(LL[[1]]$x))
      if(length(LL)>1){
        for(i in 2:length(LL)) lines(y~x, data=LL[[i]], lty=i+1)
      }
      abline(v=v1, col='red')
      mtext(text=paste0(v1c,'=', v1), at=v1, col='red')
      if(!is.null(LG1)){
        legend(LG1.pos,legend=LG1, text.col='red', bty='n')
      }
      if(!is.null(LG2)){
        legend(LG2.pos,legend=LG2, bty='n')
      }
    }
    #convert number of group paris into integer
    m1<-round(as.numeric(m1))
    #get the sample size ratios of other group to group a
    r1<-as.numeric(strsplit(r1, split=',', fixed=T)[[1]])
    if(!is.na(r1)){
      l_r1 <- m1 - length(r1)
      if(l_r1>0){
        r1<-c(r1, rep(1, l_r1)) #set default ratio as 1 if missing
      }
      r1<-r1[1:m1]
      r1<-r1/sum(r1)
      alpha<-round(1-(1-alpha)^(1/m1),3)#set type I error for each test
    }
    
    n.rg<-spF(n.rg); #set total sample size range
    theta.rg<-spF(theta.rg); #set effect size range
    sgm.rg<-spF(sgm.rg); #set standard deviation range
    prev<-spF(prev, s='~|,', noClean=TRUE); 
    prev<-prev[prev>0&prev<1];#set the prevalences of the lowest group mean
    if(alpha>1|alpha<0){alpha<-0.05}; #set default significance level
    
    cv.vl<-sgm.vl/theta.vl; #set coefficient variation selected value
    cv.rg<-c(min(cv.vl,0.01), max(cv.vl+1, 2)); #set range for cv
    d1t<-abs(theta.vl)/sgm.vl; #set the selected effect size
    
    #get the point value
    y1<-nA1<-nB1<-NULL; #note B1 could have >1 values if m>1
    for(i in 1:length(prev)){
      nA1t<-round(n.vl*prev[i]); nB1t<-n.vl-nA1t
      if(is.na(r1)){
        y1t<-pwr.t2n.test(n1=nA1t, n2=nB1t, d=d1t, sig.level=alpha)$power
      }else{
        nB1t1<- round(nB1t*r1)
        nB1t1<-nB1t1[nB1t1>1]
        y1t <- pwr.t2n.test(n1=nA1t, n2=nB1t1, d=d1t, sig.level=alpha)$power
        y1t <- 1-prod(1-y1t)
      }
      y1<-c(y1, y1t)
      nA1<-c(nA1, nA1t)
      nB1<-c(nB1, nB1t) 
    }
    leg1<-paste0(paste0('rA=',prev), paste0(', pwr=',round(y1,2)))
    leg1<-leg1[order(y1, decreasing=T)]
    
    par(mfrow=c(2,2))
    #power vs n
    x<-round(xx2(n.rg, ss=simSize)); pnL<-list(); 
    for(i in 1:length(prev)){
      nAs<-pmax(2, round(x*prev[i])); nBs<-pmax(2, x-nAs); 
      if(is.na(r1)){
        y<-pwr.t2n.test(n1=nAs, n2=nBs, d=d1t, sig.level=alpha)$power
      }else{
        yt<-rep(1, length(x))
        for(r_m in 1:length(r1)){
          nBs1<-round(r1[r_m]*nBs)
          s0<-nBs1>1
          if(all(!s0)){next}
          yt[s0]<-yt[s0]*(1-pwr.t2n.test(n1=nAs[s0], n2=nBs1[s0], d=d1t, 
                                         sig.level=alpha)$power)
        }
        y<-1-yt
      }
      pnL[[i]]<-data.frame(x=x, y=y)
    }
    leg2<-paste0('meanA=',muA, ', diff=',theta.vl,
                 ', sd=', sgm.vl, ', sig.level=', alpha)
    add1(xL='sample size', LL=pnL, v1=n.vl, v1c='n', LG1=leg1,LG2=leg2)
    
    ##power vs cv
    x<-xx2(cv.rg, ss=simSize); pcL<-list(); 
    for(i in 1:length(prev)){
      if(is.na(r1)){
        y<-pwr.t2n.test(n1=nA1[i], n2=nB1[i], d=1/x, sig.level=alpha)$power
      }else{
        yt<-rep(1, length(x))
        for(r_m in 1:length(r1)){
          nBs1<-round(r1[r_m]*nB1[i])
          if(nBs1<2) next
          yt<-yt*(1-pwr.t2n.test(n1=nA1[i], n2=nBs1, d=1/x, sig.level=alpha)$power)
        }
        y<-1-yt
      }
      pcL[[i]]<-data.frame(x=x, y=y)
    }
    leg2<-paste0('meanA=',muA, ', n=',n.vl, ', sig.level=', alpha)
    add1(xL='coefficient of variation (sd/mean)', LL=pcL, v1=round(cv.vl,2), 
         v1c='cv', LG2=leg2, LG2.pos='topright')
    
    #power vs sd
    x<-xx2(sgm.rg, ss=simSize); psL<-list(); 
    muB<-muA+theta.vl
    for(i in 1:length(prev)){
      mmt<-prev[i]*muA^2+(1-prev[i])*muB^2-(prev[i]*muA+(1-prev[i])*muB)^2
      xS<-sqrt(x^2-mmt)
      if(is.na(r1)){
        y<-pwr.t2n.test(n1=nA1[i], n2=nB1[i], 
                        d=abs(theta.vl)/xS, sig.level=alpha)$power
      }else{
        yt<-rep(1, length(x))
        for(r_m in 1:length(r1)){
          nBs1<-round(r1[r_m]*nB1[i])
          if(nBs1<2) next
          yt<-yt*(1-pwr.t2n.test(n1=nA1[i], n2=nBs1, 
                                 d=abs(theta.vl)/xS, sig.level=alpha)$power)
        }
        y<-1-yt
      }
      psL[[i]]<-data.frame(x=x, y=y)
    }
    leg2<-paste0('meanA=',muA, ', diff=',theta.vl,
                 ', n=', n.vl, ', sig.level=', alpha)
    add1(xL='total standard deviation', LL=psL, v1=sgm.vl, v1c='sd', LG2=leg2, 
         LG2.pos='topright')
    
    #power vs diff
    x<-xx2(theta.rg, ss=simSize); pdL<-list(); 
    for(i in 1:length(prev)){
      if(is.na(r1)){
        y<-pwr.t2n.test(n1=nA1[i], n2=nB1[i], 
                        d=abs(x)/sgm.vl, sig.level=alpha)$power
      }else{
        yt<-rep(1, length(x))
        for(r_m in 1:length(r1)){
          nBs1<-round(r1[r_m]*nB1[i])
          if(nBs1<2) next
          yt<-yt*(1-pwr.t2n.test(n1=nA1[i], n2=nBs1, 
                                 d=abs(x)/sgm.vl, sig.level=alpha)$power)
        }
        y<-1-yt
      }
      pdL[[i]]<-data.frame(x=x, y=y)
    }
    leg2<-paste0('meanA=',muA, ', sd=',sgm.vl,
                 ', n=', n.vl, ', sig.level=', alpha)
    add1(xL='absolute difference', LL=pdL, v1=theta.vl, 
         v1c='meanB - meanA', LG2=leg2)
    
    #density plot
    if(F){
      dsL<-list(); mu.rg<-c(muA-3*sgm.vl, muA+theta.vl+3*sgm.vl);
      x<-xx2(mu.rg); yrg<-NULL;
      muB<-muA+theta.vl; 
      sgmS<-NULL
      for(i in 1:length(prev)){
        mmt<-prev[i]*muA^2+(1-prev[i])*muB^2-(prev[i]*muA+(1-prev[i])*muB)^2
        sgmSt<-sqrt(sgm.vl^2-mmt)
        ya<-prev[i]*dnorm(x, mean=muA, sd=sgmSt)
        yb<-(1-prev[i])*dnorm(x, mean=muB, sd=sgmSt)
        sgmS<-c(sgmS, sgmSt)
        dsL[[i]]<-data.frame(x=x, ya=ya, yb=yb)
        yrg<-range(c(yrg, range(ya), range(yb)))
      }
      yrg<-c(0,max(yrg))
      plot(0~0, ylim=yrg, xlim=range(x), col='white', ylab='density', 
           xlab='means')
      for(i in 1:length(dsL)){
        lines(ya~x, data=dsL[[i]], lty=i+1, col='blue')
        lines(yb~x, data=dsL[[i]], lty=i+1, col='magenta')
      }
      abline(v=c(muA,muB), col=c('blue', 'magenta'))
      mtext(at=(muA+muB)/2, text=paste0('muB-muA=',theta.vl))
      #legend("topleft",legend=leg1, lty=(1:length(prev))+1, bty='n')
    }
  }
  #setup parameters
  spF<<-function(x, s="~", ss=simSize, noClean=FALSE){
    if(is.null(x)){
      rg1<-NULL
    }else if(all(grepl(s, x))){
      x<-as.numeric(strsplit(x, split=s)[[1]])
      rg1<-x[!is.na(x)]
    }else{rg1<-as.numeric(x)}
    if(noClean){return(rg1)}
    if(is.null(rg1)||length(rg1)==0){rg1<-c(0, ss)}#defult setup
    if(length(rg1)==1){rg1<-c(rg1, rg1+ss)}else{rg1<-rg1[1:2]}
    return(rg1)
  }
  
}
#End 4. -----------------------------------------------------------------------#


#Begian 5. --------------------------------------------------------------------#


#calculate the ratio of  over the expected absolute distance between threshold
#and experimental outcome. 
CompDist <- function(n=6, p=0.1, #target ORR
                     a=0.6, b=1.2, #Bayesian prior assumptions
                     th0=NULL ){
  require(extraDistr) #for beta binomial
  if(is.null(th0)){th0<-0:n}
  r0 <- c0 <-r1 <- c1 <- fn <- fp <- bay0<-bay2<-NULL
  for(th in th0){
    x1 <- 0:max(0, th)
    if(th<n){x2 <- (th+1):n}else{x2<-th+1}
    d1 <- sum(dbinom(x=x1, size=n, prob=p)*(th-x1))
    d2 <- sum(dbinom(x=x2, size=n, prob=p)*(x2-th))
    db1 <- sum(dbbinom(x=x1, size=n, alpha=a, beta=b)*(th-x1))
    db2 <- sum(dbbinom(x=x2, size=n, alpha=a, beta=b)*(x2-th))
    r0 <- c(r0, d1/(d1+d2))
    c0 <- c(c0, d1+d2)
    r1 <- c(r1, db1/(db1+db2))
    c1 <- c(c1, db1+db2)
    fn <- c(fn, ifelse(th<1, 0, pbinom(th-1, n, p, lower.tail=T)))
    fp <- c(fp, ifelse(th<1, 1, pbinom(th-1, n, p, lower.tail=F)))
    #fn <- c(fn, ifelse(th<1, 0, pbbinom(th-1, n, a+th, b+n-th, lower.tail=T)))
    #fp <- c(fp, ifelse(th<1, 1, pbbinom(th-1, n, a+th, b+n-th, lower.tail=F)))
    bay0 <- c(bay0, pbeta(p, a+th, b+n-th, lower.tail=F))
    bay2 <- c(bay2, dbbinom(th, n, a+th, b+n-th))
  }
  c00 <- c0 - min(c0); c00<-c00/max(c00)
  c11 <- c1 - min(c1); c11<-c11/max(c11)
  ob<-data.frame(th=th0, abs_dist=round(c0,4), abs_dist2=round(c00,4),
                 abs_bdist=round(c1,4), abs_bdist2=round(c11,4),
                 #up_dist=round((1-r0)*c0,4), lw_dis=round(r0*c0,4), 
                 post_beta=round(bay0,4), p_betabinom=round(bay2, 4),
                 fn=round(fn, 4), fp=round(fp,4), target_orr=p)
  #print(ob[ob$abs_dist2<=0.1,])
  return(ob)
}


# 2021-06-26 for JSM2021
Plot.CompDist<-function(n=10, p=0.4, a=0.4, b=0.6, href=c(0.1,0.2),
                        col0='lightblue', col2='yellow', show.plot=TRUE){
  ttt <- CompDist(n, p, a=a, b=b)
  if(!show.plot) return(ttt)
  plot(abs_dist2~th, data=ttt, type='o', ylab='Averge Distance', 
       xlab='threshold for go / nogo', axes=F)
  axis(1); axis(2); 
  if(!is.null(col2)){
    col.p2<-c2r(col2, 0.3)
    polygon(x=c(ttt$th, ttt$th[nrow(ttt)], ttt$th[1]), 
            y=c(ttt$fn,0,0), border=NA, col=col.p2 )
  }
  if(!is.null(col0)){
    col.p<-c2r(col0, 0.3); 
    axis(4, at=round(ttt$post_beta,2), col=col0, col.ticks=col0)
    text(x=ttt$th[nrow(ttt)]-0.5, y=min(ttt$post_beta), cex=0.8,
         labels='Posterior Probability To Success', adj=0, srt=90)
    points(x=ttt$th, y=ttt$post_beta, col=col0, type='h', lwd=0.1)
    polygon(x=c(ttt$th, ttt$th[nrow(ttt)], ttt$th[1]), 
            y=c(ttt$post_beta,0,0), border=NA, col=col.p )
  }
  points(abs_dist2~th, data=ttt, type='o', col='black')
  points(abs_bdist2~th, data=ttt, type='o', col='blue')
  legend("top", text.col=c('black','blue'), bty='n', 
         legend=c(paste0('Binomial p=', p), 
                  paste0('Bayesian a=', a,', b=', b)))
  if(!is.null(href)){abline(h=href, col='gray', lty=3)}
  ttt
} 

ADDt<-function(nn="15,14",      #sample size
               pp="0.3,0.2",     #expected ORR
               aa="0.3, 3",  #alpha in the Beta prior
               bb="0.7,7",  #beta in the Beta prior 
               show.result.in.table=FALSE, 
               hr.fn="0.1,0.2" #reference line for false neg probability
){
  if(is.null(nn)|| is.na(nn) || 
     is.null(pp)|| is.na(pp) || 
     is.null(aa)|| is.na(aa) || 
     is.null(bb)|| is.na(bb) ||
     is.null(hr.fn)|| is.na(hr.fn) ) return(NULL)
  ff0<-function(jj){
    if(!is.character(jj)){return(as.character(jj))}else{return(jj)} }
  nn<-ff0(nn); pp<-ff0(pp); aa<-ff0(aa); bb<-ff0(bb)
  nn<-round(as.numeric(unlist(strsplit(nn,split=','))))
  pp<-(as.numeric(unlist(strsplit(pp,split=',',fixed=T))))
  aa<-(as.numeric(unlist(strsplit(aa,split=',',fixed=T))))
  bb<-(as.numeric(unlist(strsplit(bb,split=',',fixed=T))))
  len.n<-min(c(length(nn), length(pp), length(aa), length(bb)))
  
  hr.fn<-(as.numeric(unlist(strsplit(hr.fn,split=',',fixed=T))))
  
  par(mfcol=c(2, len.n)); 
  cpm0<-list()
  for(i in 1:len.n){
    xx<-0:nn[i]
    y0<-dbinom(xx,nn[i], pp[i]);
    y2<-dbbinom(xx, nn[i], aa[i], bb[i])
    plot(y=y0, x=xx, type='h', lwd=5, ylim=c(0,max(y0,y2)),
         ylab='Prob(Y=y)', xlab='y')
    points(y=y2, x=xx+0.25, type='h', lwd=5, col=c2r('blue',0.6))
    legend('topright', text.col=c('black',c2r('blue',0.8)), bty='n',
           legend=c(paste0('Binomial(', nn[i], ', ', pp[i], ')'), 
                    paste0('BetaB(',nn[i], ', ', aa[i], ', ', bb[i],')')))
    cpm0[[i]]<-Plot.CompDist(nn[i], pp[i], aa[i], bb[i], href=hr.fn)
  }
  
  if(show.result.in.table){
    rst <- NULL
    for(i in 1:len.n){
      rst<-rbind(rst, data.frame(cpm0[[i]], 
                            p.a.b=paste(pp[i], aa[i], bb[i])))
    }
    return(rst)
  }
}


if(F){
  
  ADDt(nn="15,15", pp="0.3,0.3", aa="0.03, 0.3, 3",  bb="0.07, 0.7, 7")
  
}

#End 5. --------------------------------------------------------------------#

#----------UI Functions------------------#


#select color function
selectInput_color <- function(id='wpColor', 
                              label='Background color', 
                              choices=colors(), 
                              selected='azure3',
                              HEX=HEXColors){
  code <- paste0("<div class=\"form-group shiny-input-container\">\n",
                 "<label class=\"control-label\" for=\"",
                 id, "\">", label, ":</label>\n<div>\n",
                 "<select id=\"", id, "\"><option value=\"",
                 selected, "\" selected>", selected, "</option>\n")
  for(i in 1:length(choices)){
    code <- paste0(code, 
                   "<option value=\"",
                   choices[i], "\" style=\"background-color: ",
                   HEX[choices[i]], "\">", choices[i], "</option>\n")
  }
  code <- paste0(code, "</select>",
                 "<script type=\"application/json\" data-for=\"",
                 id, "\" data-nonempty=\"\">{}</script> \n</div>\n</div> ")
  
  return(code)
}










#Function to create Table with checkboxes

checkboxTableInput <- function(df,table.id="checktable",id.name, 
                               checked, check.name,labels=NULL, showSelectedOnly=FALSE
){
  table_head0<-capture.output(print(xtable(df[0,]), type="html", 
                                    include.rownames=F,include.colnames=T))
  table_head0[3]<-"<table border=1 class=\"table table-bordered\">"
  table_head <- paste(table_head0, collapse=" ")
  table_head <- gsub("</TABLE>", "", table_head)
  table_head <- gsub("</table>", "", table_head)
  table_head <- gsub("<table", paste0("<table id=\"",table.id,"\""), table_head)
  table_head<- gsub('<TR>','<tr>',table_head)
  table_head<- gsub('</TR>','</tr>',table_head)
  table_head <- gsub("<tr>", paste("<tr> <th> ", check.name, " </th>", sep=""), 
                     table_head)
  table_body <- paste(capture.output(print(xtable(df), type="html", 
                                           content.only=T, include.rownames=F, include.colnames=F)), collapse=" ")
  table_body<- gsub('<TR>','<tr>',table_body)
  table_body<- gsub('</TR>','</tr>',table_body)
  table_body<- gsub('<TD>','<td>',table_body)
  table_body<- gsub('</TD>','</td>',table_body)
  table_body<- gsub('</tr>','',table_body)
  table_body<- gsub('</table>','',table_body)
  which.tag <- regexpr("<tr>", table_body)[1]
  table_body <- substr(table_body, which.tag, nchar(table_body))
  table_body2 <- unlist(strsplit(table_body, "<tr>", fixed=T))
  # print(table_body2)
  table_body3 <- '' #table_body2[1]
  
  if(showSelectedOnly){
    for (i in 1:nrow(df)){
      if(checked[i]){
        check_tag <- paste("<tr>  <td align=left>", 
                           as.character(checkboxInput(paste0(id.name,'_',i), "", checked[i])),
                           " </td>", sep="")
        table_body3<-paste(table_body3, check_tag, table_body2[i+1], "</tr>",  sep="")
      }
    }
  }else{
    for (i in 1:nrow(df)){
      check_tag <- paste("<tr>  <TD align=left>", 
                         as.character(checkboxInput(paste0(id.name,'_',i), "", checked[i])),
                         " </td>", sep="")
      table_body3<-paste(table_body3, check_tag, table_body2[i+1], "</tr>", sep="")
    }
  }
  table_out <- paste(table_head, table_body3, "</table>", collapse=" ")
  if (!is.null(labels)){
    for (k in 1:length(labels)){
      table_out<-gsub(paste0('<th> ',colnames(df)[k],' </th>'),
                      paste0('<th> ',labels[k],' </th>'), table_out)
    }
  }
  # print(table_out)
  
  return(table_out)
}

#-------------Create Tabs-------------#
tabs<-function(tab.id,tab.label,tab.value){
  tabset<-unique(cbind(tab.label,tab.value))
  tabcode1<-paste0('<div class=\"tabbable tabs-above\">\n',
                   '<ul class=\"nav nav-tabs shiny-tab-input\" id=\"',
                   tab.id,'\">\n<li class=\"active\">\n')
  tabcode2<-paste0('<a href=\"#tab-',tab.id,'-',1:nrow(tabset),
                   '\" data-toggle=\"tab\" data-value=\"',
                   tabset[,1],"\">",tabset[,2],"</a>\n</li>\n<li>\n")
  tabcode2[length(tabcode2)]<-gsub('<li>','</ul>',tabcode2[length(tabcode2)])
  tabcode3<-"<div class=\"tab-content\">"
  tabcode4<-paste0('<div class=\"tab-pane active\" data-value=\"',
                   tabset[,1],'\" id=\"tab-',tab.id,'-',1:nrow(tabset),
                   '\"></div>\n',collapse=" ")
  tabcode5<-'</div>\n</div>'
  tabcode<-paste0(tabcode1,paste0(tabcode2,collapse=" "),
                  tabcode3,tabcode4,tabcode5,collapse=" ")  
  return(tabcode)
}

#-------------side panel data input-------------#
inlinetext<-function(text.id,text.label,text.value, note=NULL){
  if(is.null(note)){
    nt <- ""
  }else {
    nt <- paste0('<h6 style=\"width:50%\">', note, ' </h6>')
  }
  if(FALSE){ #using textInput widget
    code <- paste0(
      "<div class = \"form-group shiny-input-container\", style = \"width:100%\">",
      paste0("<label for=\"", text.id, "\">", text.label, "</label>"),
      paste0("<input id=\"", text.id, "\" type=\"text\" class=\"form-control\" value=\"", text.value, "\"/>"),
      "</div>",
      collapse='\n'
    )
  } else { #using traditional widget
    code<-paste0( '<div class=\"input-prepend\" style=\"width:100%\">',  
                  paste0('<span class=\"add-on\" >',text.label,'</span>'),
                  paste0('<input style=\"width:50%\" id=\"',text.id,
                         '\" class=\"form-control\" value=\"',text.value,'\" type=\"text\" />\n'),
                  nt,
                  '</div>',
                  collapse='\n')
  }
  return(code)
}

#-------------For output R code-------------#
runcode<-function(codelist, # merged dataset of loa and configuration file
                  datPath, # dataset path from input
                  outPath, # output path from input
                  libs,
                  params1,    #a vector of widgets name (require ordered)
                  paramLabs1, #a vector of widgets label(1:1 matched to params)
                  sourceCode, # source files from configuration file
                  subCode,
                  title0, # Main title with study id and tumor type
                  devpath,
                  outBcode=NULL
){
  
  #codelist<-codelist[!(!is.na(codelist[,paramLabs1[1]]) & is.na(codelist[,params1[1]])),]
  sourceCode<-unique(sourceCode[!is.na(sourceCode)])
  sourceCode<-sourceCode[!grepl("rcode.r",sourceCode)]
  head1<-sop_head  #paste0('#/*soh',paste0(rep('*',73),collapse=''))
  nParam<-length(params1)
  
  params1.od <- order(params1)
  params1    <- params1[params1.od]
  paramLabs1 <- paramLabs1[params1.od]
  
  if(FALSE){
    head2<-'if(FALSE){ # DESCRIPTION: Parameters for generating following results:'
    tmploa<-unique(codelist[,c('Request.Name',params1,paramLabs1)])
    tmploa2<-sapply(1:nrow(tmploa),function(y){
      paste0(tmploa$Request.Name[y],' ',
             ifelse(is.na(tmploa[y,paramLabs1[1]]),
                    '',
                    paste0('(',paste0(sapply(which(!is.na(tmploa[y,paramLabs1])),function(x){
                      paste0(tmploa[y,paramLabs1[x]],'=',
                             ifelse(is.na(tmploa[y,params1[x]]),
                                    'Parameters Needed',
                                    tmploa[y,params1[x]]))
                    }),collapse=';'),') \n')
             )
      )})
    tmploa2<-gsub(";", ";\n    #", tmploa2)
    head3<-paste0('  #',1:length(tmploa2),'. ',tmploa2)  
    
    head4<-paste0('\n}\n#', paste0(rep("-",90),collapse='')) #end of DESCRIPTION
  } else {
    head2<-''
    head3<-''
    head4<-''
  }
  head5<-''# paste0('  #', gsub('\n', '\n  #  ', libs))
  head6<-'\nif(TRUE){ #------Read in CSV Dataset------'
  head7<-paste0( '  indataset<-list() \n',
                 '  for(i in 1:length(inf)){ \n',
                 '    indataset[[i]]<-read.csv_sas(inf[i],stringsAsFactors=FALSE,header=TRUE, encoding=inf.enc[i], comment.char=\"\") \n',
                 '  } \n ',
                 '  names(indataset)<-inf  \n',
                 '  indataset.i<-indataset[[1]]  ')
  head8<-paste0('  ', subCode)
  head6.1<-'\n}\nif(TRUE){ #------Read in one RData------'
  head7.1<-paste0(
    'load(inf.R, indataR<-new.env())\n',
    'indataR<<-as.list(indataR)\n' )
  head9<-'\n}\n\nif (TRUE){ #------Source Packages and Function Files------'
  #connect default folder for reusable functions
  head10<-paste0(
    '  if(FALSE){ #Please firstly check whether all the required pacakges are installed.\n    ',
    '#install.packages(c(...))\n    ', 
    gsub('\n', '\n    ', libs),
    '\n  }',
    '\n  require(rtf) \n  require(haven) \n',
    '\n  read.csv_sas<<-function(file, header=TRUE, nrow=-1, comment.char="", ...){',
    '\n   is.sas<-grepl(\'.sas7bdat\', file, fixed=TRUE)',
    '\n   is.csv<-grepl(\'.csv\', file, fixed=TRUE)',
    '\n   if(is.sas){',
    '\n     ot<-haven::read_sas(file)',
    '\n     if(header & nrow==1){ot<-names(ot)}',
    '\n   }else if (is.csv){',
    '\n     tm<-try(ot<-read.csv(file=file, h=header, nrow=nrow, na=c(\'NA\', \'\', \'.\'), stringsAsFactors=FALSE, comment.char=comment.char, ...))',
    '\n     if(class(tm)==\'try-error\')',
    '\n     tm<-try(ot<-read.csv(file=file, h=header, nrow=nrow, na=c(\'NA\', \'\', \'.\'), stringsAsFactors=FALSE,fileEncoding=\"latin1\", comment.char=comment.char))',
    '\n     if(class(tm)==\'try-error\')',
    '\n     tm<-try(ot<-read.csv(file=file, h=header, nrow=nrow, na=c(\'NA\', \'\', \'.\'), stringsAsFactors=FALSE,fileEncoding=\"UTF-8\", comment.char=comment.char))',
    '\n     if(class(tm)==\'try-error\')',
    '\n     tm<-try(ot<-readLines(con=file))     ',
    '\n   }else{',
    '\n   ot<-NULL\n}',
    '\n   return(ot) \n  }',   
    "\n   try(source(SourceFile)) \n ",
    "\n  ", ifelse(is.null(eval(parse(text=outBcode))), " ", outBcode),
    "\n}")
  head11<-'\n\nif(OutputRTF){  #----- Generate RTF file ------'
  head12<-paste0('\n  pageW<-11 \n  pageH<-8.5 ',
                 '\n  figW<-9 #figure width in RTF file',
                 '\n  figH<-6 #figure height in RTF file\n',
                 '\n  rtf<-RTF(rtfFileName,width=pageW,height=pageH, font.size=8,omi=c(.5,.5,.5,.5))')
  r_out<-c(head1,head2,head3,head4,head5, head9,head10,head6,head7,head8,head6.1, head7.1, head11,head12)
  for (i in 1:nrow(codelist)){
    for(x in nParam:1){
      if(!is.na(codelist[i,params1[x]])){
        tmp0<-unlist(strsplit(as.character(codelist[i,params1[x]]),
                              ',',fixed=TRUE))
        tmp00 <- try( as.numeric(tmp0) )
        if( class(tmp00)[1]=='try-error' || any(is.na(as.numeric(tmp0))) )
          say1 <- TRUE
        else
          say1 <-FALSE
        tmp<-ifelse(say1,
                    paste0('c(\"',paste0(tmp0,collapse='\",\"'),'\")'),
                    paste0('c(',paste0(codelist[i,params1[x]],collapse=','),')'))
        codelist$Title[i]<- gsub(paste0('input$',params1[x]),
                                 tmp,codelist$Title[i],fixed=TRUE)
        codelist$PlotCode[i]<- gsub(paste0('input$',params1[x]),
                                    tmp,codelist$PlotCode[i],fixed=TRUE)
        codelist$FootCode[i]<- gsub(paste0('input$',params1[x]),
                                    tmp,codelist$FootCode[i],fixed=TRUE)
      }
    }
    
    #Add Header
    title<-codelist$Title[i]
    
    if(is.na(title) || length(title)<1) title <- " "
    if(grepl(title, 'paste', fixed=TRUE)) title<-eval(parse(text=title))
    addhead<-vector()
    addhead[1]<-paste0('\n\n  #------Add Header  ',codelist$order[i],' ------')
    addhead[2]<-paste0('  addHeader(rtf,title=\"',title0,'\",font.size=10)')
    addhead[3]<-paste0('  addHeader(rtf,title=\"',title,'\",font.size=10)')
    r_out<-c(r_out,addhead)
    
    #Add Plot
    if( (!is.na(codelist$Type.y[i]) & codelist$Type.y[i]=='Figure') || 
        (!is.na(codelist$Type.x[i]) & codelist$Type.x[i]=='Figure')  ){
      addplot<-vector()
      addplot[1]<-paste0('  #------Add Plot: ',codelist$Request.Name[i],' ------')
      addplot[2]<-paste0('  tmp<-',codelist$tmp[i])
      addplot[3]<-paste0('  pngtmp<-function(){',codelist$PlotCode[i],'}')
      addplot[4]<-paste0('  addPlot(rtf,pngtmp,width=figW', #codelist$width[i]/160,
                         ',height=figH'#,codelist$height[i]/160,')'
      )  
      r_out<-c(r_out,addplot)}
    
    #Add Table            
    if(  (!is.na(codelist$Type.y[i]) & codelist$Type.y[i]=='Table') || 
         (!is.na(codelist$Type.x[i]) & codelist$Type.x[i]=='Table')  ){
      addtab<-vector()
      addtab[1]<-paste0('  #------Add Table: ',codelist$Request.Name[i],' ------')
      addtab[2]<-paste0('  tmp<-',codelist$tmp[i])
      addtab[3]<-paste0('  outTable<-{',codelist$PlotCode[i],'}')
      addtab[4]<-paste0('  tWidth<-9\nnc<-nchar(as.character(outTable[,1]))\nc1W<-pmax(max(nc)*0.079/2, 20*0.079)\n',
                        '  caW<-nc*0.079\nlcW<-.711\nothW<-(tWidth-c1W-lcW)/(ncol(outTable)-2)\n',
                        '  centW<-rep(othW,ncol(outTable)-2)\ncWs<-c(c1W,centW,lcW)'
      )
      addtab[5]<-paste0( '  addTable(rtf,outTable,col.widths=cWs,col.justify=rep(\'L\',length(outTable)))'
      )
      r_out<-c(r_out,addtab)
    }
    
    #Add Footnote
    footnote<-codelist$FootCode[i]
    footnote<-gsub("\\\\n","\n",footnote)
    if(!is.na(footnote)&&gsub("", " ", footnote)!=''&&substr(footnote,1,5)=='paste')
      footnote<-eval(parse(text=footnote))
    addfoot<-vector()
    addfoot[1]<-'  addNewLine(rtf, n=2)'
    addfoot[2]<-paste0('  #------Add Footnote  ',codelist$order[i],' ------')
    addfoot[3]<-paste0('  addParagraph(rtf,\"',footnote,'\")')
    r_out<-c(r_out,addfoot)
    
    if(i!=nrow(codelist)){
      r_out<-c(r_out,'  addPageBreak(rtf,width=11,height=8.5,font.size=8,omi=c(.5,.5,.5,.5))')
    }else{
      r_out<-c(r_out,'\ndone(rtf)\n}  #------End of RTF------\n')
    }
  }
  return(paste0(r_out,collapse='\n'))
}

checkSource<-function(fnm, keyS1='source('){#fnm must be a file under inpath2
  rF1<-NULL
  r1<-readLines(con=fnm)
  r2<-toupper(gsub(" ", '', r1))
  falseKey<-FALSE
  for(j in 1:length(r1)){
    if(grepl('IF(FALSE)', r2[j], fixed=TRUE)|grepl('IF(F)', r2[j], fixed=TRUE)){
      falseKey<-TRUE
      b1<-0
    }
    if(falseKey){
      if(gsub("IF(FALSE)","", r2[j],fixed=TRUE)=="[{]"|substr(r2[j],1,1)=="[{]") b1<-b1+1
      if(b1==0 & grepl("[{]", r2[j]))
        falseKey<-FALSE
      if(grepl("}", r2[j])) {
        b1<-b1-1
        if(b1==0) falseKey<-FALSE
      }
    }else{
      if(grepl(toupper(keyS1), r2[j], fixed=TRUE)){
        f3<-strsplit(r1[j],split='local.path1,', fixed=TRUE)[[1]][2]
        f3<-gsub("users/","",f3, fixed=TRUE)
        f3<-gsub("'","",f3, fixed=TRUE)
        f3<-gsub('"','',f3, fixed=TRUE)
        f3<-gsub('\"','',f3, fixed=TRUE)
        f3<-gsub(')','',f3, fixed=TRUE)
        f3<-gsub('(','',f3, fixed=TRUE)
        f3<-gsub(' ','',f3, fixed=TRUE)
        if(grepl(".r", tolower(f3), fixed=TRUE)){
          rF1<-c(rF1, f3)
        }
      }
    }
  }
  return(rF1)
}




#-------------Creat Parameters-------------#
#use radiobutton, slidebar, checkbox, selectInput
if(newWay){
  widgets.code<-function(UInames, max.n){
    ind<-max.n!=0
    
    check.code<-lapply(max.n['check']:1,function(x){  
      ret<-'\n output$checkbox_xx<-renderUI({
    tmpN<-reactive(which(check.param()$Request.Name==input$analysis))
    if(length(tmpN())<1) return(NULL)
    try(tmp<-eval(parse(text=Vdic()$tmp[AnalyC()])))
    if(is.na(check.param()[tmpN(),\'check.label_xx\'])
    ||class(try(default<-eval(parse(text=check.param()[tmpN(),\'check.default_xx\']))))==\"try-error\"
    ||class(try(choice<-eval(parse(text=check.param()[tmpN(),\'check.choice_xx\']))))==\"try-error\")return(NULL)
    if (length(choice)==0)return(div(class=\"alert alert-error\",strong(\'checkbox Options Are Not Available\')))
    if (is.na(default))default<-choice
    checkboxGroupInput(inputId=\'check_xx\',label=strong(check.param()[tmpN(),\'check.label_xx\']),choices=choice,selected=default)})\n\n  '
      if (x==1){ret<-gsub('_xx','',ret,fixed=TRUE)}else{ret<-gsub('_xx',x,ret,fixed=TRUE)}
      ret
    })
    check.codes<-Reduce(function(x,y)paste0(x,y,collapse='\n'),check.code)
    
    radio.code<-lapply(max.n['radio']:1,function(x){
      ret<-'output$radiobutton_xx<-renderUI({
     tmpN<-reactive(which(radio.param()$Request.Name==input$analysis))
     if(length(tmpN())<1) return(NULL)
     try(tmp<-eval(parse(text=Vdic()$tmp[AnalyC()])))
     if(is.na(radio.param()[tmpN(),\'radio.label_xx\'])
     ||class(try(default<-eval(parse(text=radio.param()[tmpN(),\'radio.default_xx\']))))==\"try-error\"
     ||class(try(choice<-eval(parse(text=radio.param()[tmpN(),\'radio.choice_xx\']))))==\"try-error\")return(NULL)
     if (length(choice)==0)return(div(class=\"alert alert-error\",strong(\'radiobutton Options Are Not Available\')))
     if (is.na(default))default<-choice[1]
    radioButtons(\'radio_xx\',label=strong(radio.param()[tmpN(),\'radio.label_xx\']),choices=choice,selected=default)})\n\n  '
      if (x==1){ret<-gsub('_xx','',ret,fixed=TRUE)}else{ret<-gsub('_xx',x,ret,fixed=TRUE)}
      ret
    })
    radio.codes<-Reduce(function(x,y)paste0(x,y,collapse='\n'),radio.code)
    
    dropdown.code<-lapply(max.n['dropdown']:1,function(x){
      ret<-'output$dropdown_xx<-renderUI({   
    isolate({
      tmpN<-reactive(which(dropdown.param()$Request.Name==input$analysis))
      if(length(tmpN())<1) return(NULL)
      try(tmp<-eval(parse(text=Vdic()$tmp[AnalyC()])))   
    })
    if(is.null(dropdown.param()[tmpN(),\'dropdown.label_xx\'])) return(NULL)
    if (is.na(dropdown.param()[tmpN(),\'dropdown.label_xx\'])  
    ||class(try(default<-eval(parse(text=dropdown.param()[tmpN(),\'dropdown.default_xx\']))))==\"try-error\"
    ||class(try(default2<-eval(parse(text=dropdown.param()[tmpN(),\'dropdown.multiple_xx\']))))==\"try-error\"
    ||class(try(choice<-eval(parse(text=dropdown.param()[tmpN(),\'dropdown.choice_xx\']))))==\"try-error\")return(NULL)
    if (length(choice)==0)return(div(class=\"alert alert-error\",strong(\'dropdown Options Are Not Available\')))
    if (all(is.na(default)))default<-choice[1]
    if (all(is.na(default2)))default2<-TRUE
    selectInput(\'dropdown_xx\',label=strong(dropdown.param()[tmpN(),\'dropdown.label_xx\']),
      choices=choice,selected=default,multiple=default2,selectize=TRUE, width=\"100%\") }) \n\n  '
      if (x==1){ret<-gsub('_xx','',ret,fixed=TRUE)}else{ret<-gsub('_xx',x,ret,fixed=TRUE)}
      ret
    })
    dropdown.codes<-Reduce(function(x,y)paste0(x,y,collapse='\n'),dropdown.code)
    
    slide.code<<-lapply(max.n['slide']:1,function(x){
      ret<-'output$slider_xx<-renderUI({
    tmpN<-reactive(which(slide.param()$Request.Name==input$analysis))
    if(length(tmpN())<1) return(NULL)
    try(tmp<-eval(parse(text=Vdic()$tmp[AnalyC()])))
    if(is.null(slide.param()[tmpN(),\'slide.label_xx\'])) return(NULL)
    if (is.na(slide.param()[tmpN(),\'slide.label_xx\'])  
    ||class(try(min<-eval(parse(text=slide.param()[tmpN(),\'slide.min_xx\']))))[1]==\"try-error\"
    ||class(try(max<-eval(parse(text=slide.param()[tmpN(),\'slide.max_xx\']))))[1]==\"try-error\"
    ||class(try(default<-eval(parse(text=slide.param()[tmpN(),\'slide.value_xx\']))))[1]==\"try-error\"
    ||class(try(by<-eval(parse(text=slide.param()[tmpN(),\'slide.by_xx\']))))[1]==\"try-error\")return(NULL)
    if (length(c(min,max,default,by))<4)return(div(class=\"alert alert-error\",strong(\'slider Options Are Not Available\')))
    if (is.na(default))default<-mean(min,max)
    dw.max<<-max
    dw.min<<-min
    dw.by<<-by
    conditionalPanel(condition=\'true\',
      sliderInput(\'slide_xx\',label=strong(slide.param()[tmpN(),\'slide.label_xx\']),
                 min=min,max=max,value=default,step=by,animate = TRUE),
      downloadButton(\"getAnim_slide_xx\",label=\'gif\'),
      downloadButton(\"getPDF_slide_xx\",label=\'pdf\')
    )
  }) \n\n 
    output$getAnim_slide_xx<-downloadHandler(
    filename=function(){
      tt <- \'currentSliderAnimation.gif\'
      return(tt)
    },
    content=function(file){
      slideAnimFunc <- function(code1){
        seq1 <- seq(from=dw.min, to=dw.max, by=dw.by)
        for(sld1 in seq1){
          code2<- gsub(\'input$slide_xx\', sld1, code1)
          eval(parse(text=code2))
        }
      }
      
      codelist<<-Vdic()$PlotCode[AnalyN()[1]]
      #codelist$width <- codelist$width.x
      #codelist$height <- codelist$height.x
      #codelist$res <- codelist$res.x
      #animation::saveVideo(slideAnimFunc(codelist), video.name=file)  
      owd<-setwd(local.path2)
      seq1 <- seq(from=dw.min, to=dw.max, by=dw.by)
      fn.ani1<-dir(local.path2)
      fn.ani1<-fn.ani1[grepl(\".png\", fn.ani1)]
      file.remove(fn.ani1)
      fn.ani<-NULL
      for(sld1 in seq1){
        print(sld1)
        print( code2<<- gsub(\'input$slide_xx\', sld1, codelist, fixed=T) )
        fn.ani <- c(fn.ani, paste0(\'slideAnim\',sld1, \'.png\'))
        png(paste0(\'slideAnim\',sld1, \'.png\'))
          try0<-try(eval(parse(text=code2)))
          if(class(try0)[1]==\'try-error\'){
            plot(0~0, col=\'white\', axes=F, ylab=\'\', xlab=\'\')
          }
        dev.off()
      }
      im.convert(\'slideAnim*.png\', output=file)
      try(file.remove(fn.ani))
      setwd(owd)
    })
    \n\n
    
    output$getPDF_slide_xx<-downloadHandler(
    filename=function(){
      tt <- \'currentSlider.pdf\'
      return(tt)
    },
    content=function(file){
      slideAnimFunc <- function(code1){
        seq1 <- seq(from=dw.min, to=dw.max, by=dw.by)
        for(sld1 in seq1){
          code2<- gsub(\'input$slide_xx\', sld1, code1)
          eval(parse(text=code2))
        }
      }
      codelist<<-Vdic()$PlotCode[AnalyN()[1]]
      seq1 <- seq(from=dw.min, to=dw.max, by=dw.by)
      pdf(file, 
          title = paste(\"BEACH Output\", pdf.label), 
          height=tfl.h/tfl.r, 
          width=tfl.w/tfl.r,  
          pointsize = 1/tfl.r )
      for(sld1 in seq1){
        print(sld1)
        print( code2<<- gsub(\'input$slide_xx\', sld1, codelist, fixed=T) )
        try0<-try(eval(parse(text=code2)))
        if(class(try0)[1]==\'try-error\'){
          plot(0~0, col=\'white\', axes=F, ylab=\'\', xlab=\'\')
        }
      }
      dev.off()
    })
    \n\n'
      if (x==1){ret<-gsub('_xx','',ret,fixed=TRUE)}else{ret<-gsub('_xx',x,ret,fixed=TRUE)}
      ret
    })  
    slide.codes<-Reduce(function(x,y)paste0(x,y,collapse='\n'),slide.code)
    
    date.code<-lapply(max.n['date']:1,function(x){
      ret<-'output$date_xx<-renderUI({
    tmpN<-reactive(which(date.param()$Request.Name==input$analysis))
    if(length(tmpN())<1) return(NULL)
    try(tmp<-eval(parse(text=Vdic()$tmp[AnalyC()])))
    if (is.na(date.param()[tmpN(),\'date.label_xx\'])  
    ||class(try(default<-eval(parse(text="(date.param()[tmpN(),\'date.value_xx\'])"))))==\"try-error\")return(NULL)
    if (!is.null(default)&is.na(default)) return(div(class=\"alert alert-error\",strong(\'date Options Are Not Available\')))
    dateInput(\'date_xx\',label=strong(date.param()[tmpN(),\'date.label_xx\']),
      value=default, format = \"yyyy-mm-dd\")})\n\n'
      if (x==1){ret<-gsub('_xx','',ret,fixed=TRUE)}else{ret<-gsub('_xx',x,ret,fixed=TRUE)}
      ret
    })  
    date.codes<-Reduce(function(x,y)paste0(x,y,collapse='\n'),date.code)
    
    dateR.code<-lapply(max.n['dateR']:1,function(x){
      ret<-'output$dateR_xx<-renderUI({
    tmpN<-reactive(which(dateR.param()$Request.Name==input$analysis))
    if(length(tmpN())<1) return(NULL)
    try(tmp<-eval(parse(text=Vdic()$tmp[AnalyC()])))
    if (is.na(dateR.param()[tmpN(),\'dateR.label_xx\'])  
    ||class(try(min<-eval(parse(text="(dateR.param()[tmpN(),\'dateR.start_xx\'])"))))==\"try-error\"
    ||class(try(max<-eval(parse(text="(dateR.param()[tmpN(),\'dateR.end_xx\'])"))))==\"try-error\") return(NULL)
    if ((!is.null(min)&is.null(max))&(is.na(min)&is.na(max)))
      return(div(class=\"alert alert-error\",strong(\'data range Options Are Not Available\')))
    dateRangeInput(\'dateR_xx\',label=strong(dateR.param()[tmpN(),\'dateR.label_xx\']),
       start=min, end=max, format = \"yyyy-mm-dd\")})\n\n'
      if (x==1){ret<-gsub('_xx','',ret,fixed=TRUE)}else{ret<-gsub('_xx',x,ret,fixed=TRUE)}
      ret
    })  
    dateR.codes<-Reduce(function(x,y)paste0(x,y,collapse='\n'),dateR.code)
    
    num.code<-lapply(max.n['num']:1,function(x){
      ret<-'output$num_xx<-renderUI({
    tmpN<-reactive(which(num.param()$Request.Name==input$analysis))
    if(length(tmpN())<1) return(NULL)
    try(tmp<-eval(parse(text=Vdic()$tmp[AnalyC()])))
    if (is.na(num.param()[tmpN(),\'num.label_xx\'])  
    ||class(try(default<-eval(parse(text="num.param()[tmpN(),\'num.value_xx\']"))))==\"try-error\")return(NULL)
    if (is.na(default)) return(div(class=\"alert alert-error\",strong(\'numericInput Options Are Not Available\')))
    numericInput(\'num_xx\',label=strong(num.param()[tmpN(),\'num.label_xx\']),
      value=default)})\n\n'
      if (x==1){ret<-gsub('_xx','',ret,fixed=TRUE)}else{ret<-gsub('_xx',x,ret,fixed=TRUE)}
      ret
    })  
    num.codes<-Reduce(function(x,y)paste0(x,y,collapse='\n'),num.code)
    
    text.code<-lapply(max.n['text']:1,function(x){
      ret<-'output$text_xx<-renderUI({
    tmpN<-reactive(which(text.param()$Request.Name==input$analysis))
    if(length(tmpN())<1) return(NULL)
    try(tmp<-eval(parse(text=Vdic()$tmp[AnalyC()])))
    if (is.na(text.param()[tmpN(),\'text.label_xx\'])  
    ||class(try(default<-eval(parse(text=text.param()[tmpN(),\'text.value_xx\']))))==\"try-error\")return(NULL)
    if (is.na(default)) return(div(class=\"alert alert-error\",strong(\'textInput Options Are Not Available\')))
    textInput(\'text_xx\',label=strong(text.param()[tmpN(),\'text.label_xx\']),
      value=default)})\n\n'
      if (x==1){ret<-gsub('_xx','',ret,fixed=TRUE)}else{ret<-gsub('_xx',x,ret,fixed=TRUE)}
      ret
    })  
    text.codes<-Reduce(function(x,y)paste0(x,y,collapse='\n'),text.code)
    
    textbox.code<-lapply(max.n['textbox']:1,function(x){
      ret<-paste0('output$textbox_xx<-renderUI({
     tmpN<-reactive(which(textbox.param()$Request.Name==input$analysis))
     try(tmp<-eval(parse(text=Vdic()$tmp[AnalyC()])))
     if(is.na(textbox.param()[tmpN(),\'textbox.label_xx\']))return(NULL)
     cols<-eval(parse(text=textbox.param()[tmpN(),\'textbox.cols_xx\']))
     rows<-eval(parse(text=textbox.param()[tmpN(),\'textbox.rows_xx\']))
     default<-textbox.param()[tmpN(),\'textbox.default_xx\']
     label<-textbox.param()[tmpN(),\'textbox.label_xx\']
     if(is.na(cols)||is.null(cols))cols<-40
     if(is.na(rows)||is.null(rows))rows<-2
     texttmp<-paste0(\'<h6>\',label,\'</h6>\n<textarea name=\"\',textbox_xx,\'\" 
     rows=\"\',rows,\'\"  cols=\"\',cols,\'\">\',default,\'</textarea>\')
     return(shiny::HTML(texttmp))
     })\n\n')
      if (x==1){ret<-gsub('_xx','',ret,fixed=TRUE)}else{ret<-gsub('_xx',x,ret,fixed=TRUE)}
      ret
    })  
    textbox.codes<-Reduce(function(x,y)paste0(x,y,collapse='\n'),textbox.code)
    
    
    widgets.code<-paste0(c(check.codes,radio.codes,dropdown.codes,slide.codes,
                           date.codes, dateR.codes, num.codes, text.codes, textbox.codes)[ind],
                         collapse='\n\n')
    return(widgets.code)
  }
}

widgets.order<<-function(analysis, UIdic1, UInames, ncol.widg=NULL){
  #  print(UIdic1)
  #  print(UInames)
  #  print(analysis)
  
  if(is.null(ncol.widg)){ncol.widg<-1}
  input.names<-as.vector(t(UIdic1[UIdic1$Request.Name==analysis, UInames]))
  if(length(input.names)==0){
    widg.list=NULL
  }else{
    input.labs<-as.vector(t(UIdic1[UIdic1$Request.Name==analysis,
                                   gsub("uiInput", "uilab", UInames, fixed=TRUE)]))
    #names(input.names)<-1:length(input.names)
    s_1<-!is.na(input.names)
    input.names<-input.names[s_1]#unique(setdiff(as.vector(input.names),NA))
    input.labs<-input.labs[s_1]
    input.labs[is.na(input.labs)]<-""
    
    widg.list<-unlist(strsplit(input.names,'input$',fixed=TRUE))
    sel0<-widg.list!='' & !is.na(widg.list)
    input.names<-widg.list<-widg.list[sel0]
    #input.labs<-input.labs[sel0]
    
    widg.list<-gsub('check','checkbox',widg.list)
    widg.list<-gsub('radio','radiobutton',widg.list)
    widg.list<-gsub('dropdown','dropdown',widg.list)
    widg.list<-gsub('slide','slider',widg.list)
    # widg.list<-gsub('date','date',widg.list)
    # widg.list<-gsub('dateR','dateR',widg.list)
    # widg.list<-gsub('num','num',widg.list)
    # widg.list<-gsub('text','text',widg.list)
    # widg.list<-gsub('textbox','textbox',widg.list)
  }
  if(length(widg.list)==0){
    widg.code<-'return(NULL)';
    input.names<-input.labs<-NA
  }else{
    if(F){
      widg.code<-paste0('uiOutput(\'',widg.list,'\')',collapse=',')
      widg.code<-paste0('return(conditionalPanel(condition=\'true\', div(',
                        widg.code,')))',collapse='')
    }else{
      widg.code<-paste0('uiOutput(\'',widg.list,'\')') #,collapse=','
      w.widg<-floor(12/ncol.widg)    #upto 4, column width
      nrow.widg<-ceiling(length(widg.code)/ncol.widg)#number of rows
      widg.code2<-NULL
      for(i in 1:nrow.widg){
        widg.code3<-NULL
        for(j in 1:ncol.widg){
          ij<-(i-1)*ncol.widg+j  
          if(ij <= length(widg.code)){
            wij<-paste0("column(", w.widg,", ", widg.code[ij], 
                        ", offset=", 0, ")") #max(w.widg*(j-1)-2,0)
            widg.code3<-paste0(c(widg.code3, wij), collapse=",")
          }
        }
        widg.code2<-c(widg.code2, paste0("fluidRow(", widg.code3, ")"))
      }
      widg.code<-paste0(widg.code2, collapse=',')
      widg.code<-paste0('return(conditionalPanel(condition=\'true\', div(',
                        widg.code,')))',collapse='')
    }
  }
  out1<-data.frame(code=widg.code,names=input.names,labs=input.labs)
  
  return(out1)
}

widgets.param<-function(uidic, wid, max.n){
  if(!wid %in% names(max.n)){
    return(NA)
  }else{
    temp<-lapply(setdiff(unique(uidic$Request.Name),NA),function(x){
      row_sel<-uidic$Request.Name==x
      ret<-unique(uidic[which(row_sel), grepl(wid,colnames(uidic))])
      ret$Request.Name<-x
      #dfnames is the widget name which default values not specified in CD
      wid2<-wid[!wid%in%c("num","text")]
      if(length(wid2)>0){
        dfnames<-c(paste0(wid2,'.default',c(max.n[wid2]:2, '')))
        dfnames<-dfnames[!dfnames%in%colnames(uidic)] 
        if (length(dfnames)>0){
          dfs<-matrix(NA,nrow=nrow(ret),ncol=length(dfnames))
          colnames(dfs)<-dfnames
          ret2<-data.frame(ret,dfs,row.names=NULL)
        }else{ ret2<-data.frame(ret,row.names=NULL)}
      }else{ ret2<-data.frame(ret,row.names=NULL)}
      #dfnames3 is the dropdown widget name which multiple not specified in CD
      wid3<-wid2[grepl("dropdown",wid2)]
      if(length(wid3)>0){
        dfnames3<-c(paste0(wid3,'.multiple',c(max.n[wid3]:2, '')))
        dfnames3<-dfnames3[!dfnames3%in%colnames(uidic)]
        if (length(dfnames3)>0){
          dfs<-matrix(NA,nrow=nrow(ret2),ncol=length(dfnames3))
          colnames(dfs)<-dfnames3
          ret3<-data.frame(ret2,dfs, row.names=NULL)
        }else{ ret3<-data.frame(ret2,row.names=NULL) }
      }else{ ret3<-data.frame(ret2,row.names=NULL) }
      return(ret3)
    })
    #convert the list object to data.frame
    ret0<-Reduce(function(x,y){unique(rbind(x,y))},temp)
    return(ret0)
  }
}



#-------------Functions for RTF output setup-------------#
if(TRUE){
  col_width <- function(tb){  #Function to Generate rtf table column widths
    cws <- NULL
    for(i in 1:length(names(tb))) {
      ncName <- nchar(names(tb)[i])
      ncString <- max(nchar(tb[,i]))
      nc <- max(ncName, ncString)
      cw <- nc*0.89/10                 # assume 10 characters per an inch
      cws <- c(cws, cw)
    }
    return(cws)
  }
  
  
  #--- convert factor to character colname
  convert_fac_to_char <- function(dat) {
    for(i in 1:ncol(dat)) {
      if(class(dat[, i]) == "factor")
        dat[, i] <- as.character(dat[, i])
      
    }
    return(dat)
  }
  
  .convert <- function (x) 
  {
    x <- gsub("\\n", " \\\\line ", x)
    x <- gsub("<=", "\\\\u8804\\\\3", x)
    x <- gsub(">=", "\\\\u8805\\\\3", x)
    x <- gsub("&gt;", ">", x)
    x <- gsub("&lt;", "<", x)
    x <- gsub("&Alpha;", "\\\\u0913\\\\3", x)
    x <- gsub("&Beta;", "\\\\u0914\\\\3", x)
    x <- gsub("&Gamma;", "\\\\u0915\\\\3", x)
    x <- gsub("&Delta;", "\\\\u0916\\\\3", x)
    x <- gsub("&Epsilon;", "\\\\u0917\\\\3", x)
    x <- gsub("&Zeta;", "\\\\u0918\\\\3", x)
    x <- gsub("&Eta;", "\\\\u0919\\\\3", x)
    x <- gsub("&Theta;", "\\\\u0920\\\\3", x)
    x <- gsub("&Iota;", "\\\\u0921\\\\3", x)
    x <- gsub("&Kappa;", "\\\\u0922\\\\3", x)
    x <- gsub("&Lambda;", "\\\\u0923\\\\3", x)
    x <- gsub("&Mu;", "\\\\u0924\\\\3", x)
    x <- gsub("&Nu;", "\\\\u0925\\\\3", x)
    x <- gsub("&Xi;", "\\\\u0926\\\\3", x)
    x <- gsub("&Omicron;", "\\\\u0927\\\\3", x)
    x <- gsub("&Pi;", "\\\\u0928\\\\3", x)
    x <- gsub("&Rho;", "\\\\u0929\\\\3", x)
    x <- gsub("&Sigma;", "\\\\u0931\\\\3", x)
    x <- gsub("&Tau;", "\\\\u0932\\\\3", x)
    x <- gsub("&Upsilon;", "\\\\u0933\\\\3", x)
    x <- gsub("&Phi;", "\\\\u0934\\\\3", x)
    x <- gsub("&Chi;", "\\\\u0935\\\\3", x)
    x <- gsub("&Psi;", "\\\\u0936\\\\3", x)
    x <- gsub("&Omega;", "\\\\u0937\\\\3", x)
    x <- gsub("&alpha;", "\\\\u0945\\\\3", x)
    x <- gsub("&beta;", "\\\\u0946\\\\3", x)
    x <- gsub("&gamma;", "\\\\u0947\\\\3", x)
    x <- gsub("&delta;", "\\\\u0948\\\\3", x)
    x <- gsub("&epsilon;", "\\\\u0949\\\\3", x)
    x <- gsub("&zeta;", "\\\\u0950\\\\3", x)
    x <- gsub("&eta;", "\\\\u0951\\\\3", x)
    x <- gsub("&theta;", "\\\\u0952\\\\3", x)
    x <- gsub("&iota;", "\\\\u0953\\\\3", x)
    x <- gsub("&kappa;", "\\\\u0954\\\\3", x)
    x <- gsub("&lambda;", "\\\\u0955\\\\3", x)
    x <- gsub("&mu;", "\\\\u0956\\\\3", x)
    x <- gsub("&nu;", "\\\\u0957\\\\3", x)
    x <- gsub("&xi;", "\\\\u0958\\\\3", x)
    x <- gsub("&omicron;", "\\\\u0959\\\\3", x)
    x <- gsub("&pi;", "\\\\u0960\\\\3", x)
    x <- gsub("&rho;", "\\\\u0961\\\\3", x)
    x <- gsub("&sigmaf;", "\\\\u0962\\\\3", x)
    x <- gsub("&sigma;", "\\\\u0963\\\\3", x)
    x <- gsub("&tau;", "\\\\u0964\\\\3", x)
    x <- gsub("&upsilon;", "\\\\u0965\\\\3", x)
    x <- gsub("&phi;", "\\\\u0966\\\\3", x)
    x <- gsub("&chi;", "\\\\u0967\\\\3", x)
    x <- gsub("&psi;", "\\\\u0968\\\\3", x)
    x <- gsub("&omega;", "\\\\u0969\\\\3", x)
    x <- gsub("TRUE", "Yes", x)
    x <- gsub("FALSE", "No", x)
    x
  }
  
  
  .get.space.before.after <- function (space.before = NULL, space.after = NULL) 
  {
    ret <- ""
    if (!is.null(space.before)) {
      ret <- paste(ret, "\\sb", (space.before * 1440), sep = "")
    }
    if (!is.null(space.after)) {
      ret <- paste(ret, "\\sa", (space.after * 1440), sep = "")
    }
    ret
  }
  
  
  .add.table.row <- function (col.data = c("c1", "c2", "c3"), 
                              col.widths = c(1, 4.5, 1), 
                              col.justify = NULL, font.size = 10, last.row = FALSE, 
                              indent = 0, border.top = FALSE, border.bottom = FALSE, space.before = NULL, 
                              space.after = NULL) 
  {
    header <- paste("\\trowd\\trgaph100\\trleft", indent, sep = "")
    if (length(col.data) != length(col.widths)) {
      stop(paste("The number of data columns (", length(col.data), 
                 ") doesn't match the column widths (", length(col.widths), 
                 ")!  Input data: ", col.data, sep = ""))
    }
    justify <- vector()
    justify["L"] <- "\\ql"
    justify["R"] <- "\\qr"
    justify["C"] <- "\\qc"
    justify["J"] <- "\\qj"
    justify.v <- rep(justify["L"], length(col.data))
    numeric.cols <- which(!is.na(suppressWarnings(as.numeric(col.data))))
    if (length(numeric.cols) > 0) {
      justify.v[numeric.cols] <- justify["R"]
    }
    if (!is.null(col.justify)) {
      if (length(col.justify) == 1) {
        if (col.justify %in% names(justify)) {
          justify.v <- rep(justify[col.justify], length(col.data))
        }
        else {
          stop(paste("col.justify parameter not recognized: ", 
                     col.justify, " (should be L, R, C, or J)", 
                     sep = ""))
        }
      }
      else if (length(col.justify) == length(col.data)) {
        justify.v <- justify[col.justify]
      }
      else {
        stop(paste("The number of data columns (", length(col.data), 
                   ") doesn't match the col.justify (", length(col.justify), 
                   ") parameter!  Input data: ", paste(col.data, 
                                                       sep = "", collapse = ", "), sep = ""))
      }
    }
    btop <- ""
    bbottom <- ""
    if (any(border.top))  #  
      btop <- sapply(border.top, ifelse, "\\clbrdrt\\brdrs\\brdrw15",'') # make border.top as a vector option
    if (last.row == TRUE | any(border.bottom))  # 
      bbottom <- sapply(border.bottom, ifelse, "\\clbrdrb\\brdrs\\brdrw15",'') #make border.bottom as a vector option
    cols.prefix <- paste("\\clvertalt\\clshdrawnil\\clwWidth", 
                         round(col.widths * 1440, 0), "\\clftsWidth3\\clheight260\\clpadl100\\clpadr100\\gaph", 
                         btop, bbottom, "\\cellx", c(1:length(col.widths)), "\n", 
                         sep = "", collapse = "")
    cols <- paste("\\pard", justify.v, .get.space.before.after(space.before, 
                                                               space.after), "\\widctlpar\\intbl\\fi0\\f2\\fs", font.size * 
                    2, " ", .convert(col.data), "\\cell\n", sep = "", collapse = "")
    end.row <- "\\widctlpar\\intbl\\row\n"
    paste(header, cols.prefix, cols, end.row, sep = "")
  }
  
  # add width basing on duplication
  adj.width <- function(x, cw, space=1){
    ret <- array(0, dim=dim(x))
    x2 <- x
    #dup <- t(apply(x,1, function(x) duplicated(x)& x!='')) 
    dup <- t(apply(x,1, function(x) c(FALSE, x[-1]==x[-length(x)])))		
    for (i in 1:nrow(x)) {
      for (j in ncol(x):1) {
        if (i > 1 & j <= ncol(x)) if (!dup[i-1,j]) dup[i,j] <- FALSE
        if (dup[i,j]) {
          ret[i,j-1] <- ret[i,j]+space*cw[j]
          ret[i,j  ] <-         -space*cw[j]		
          x2[i,j] <- ''		
        }		
      }
      ret[i,] <- ret[i,]+cw
    }
    list(x=x2, cw=ret)		
  }
  
  
  ###--- This one is added/modified a little bit from the original rtf.tab that Michael Man developed
  # It expanded the width for header or footnote
  rtf.tab <- function(dat,cw=NULL,titles,col.just=NULL,var.ul,prd.status='QA',footns='',header=FALSE,footer=FALSE,
                      nline.body=40, addSpaceHeader=0, addSpaceFoot=0, page.disp=TRUE,...) { # almost automated w/ modified .add.table.row		
    st <- attributes(dat)$'start cell'[1]
    hd <- 1:(st-1)
    if(is.null(cw)) cw <- c(1.5,rep(.7,ncol(dat)-1))
    if(is.null(col.just)) col.just <- rep('R', nrow(dat)) 
    if(is.null(dim(col.just))) col.just <- matrix(rep(col.just,ncol(dat)), nrow=nrow(dat), byrow=FALSE)
    x <- dat
    cw2 <- matrix(rep(cw, nrow(x)), ncol=ncol(x), byrow=TRUE)
    if (st > 2) {
      #undebug(adj.width)
      y <- adj.width(x=dat[hd,],cw=cw, space=1)
      x[hd,] <- y$x
      cw2[hd,] <- y$cw		
    } 
    
    #expr=expression({
    rtf.add.row <- function(rows=1:nrow(x)){
      ret <- "{\\pard\n"
      for (i in rows) if (i <= nrow(x)){
        sel <- which(cw2[i,]>0)
        ret <- paste(ret, 
                     .add.table.row(
                       col.data =     x[i,sel], 
                       col.widths = cw2[i,sel], 
                       col.justify = col.just[i,sel],
                       font.size = fs,
                       border.top = i %in% c(1), 
                       border.bottom = if (i > st-2) i %in% c(st-1,nrow(x),max(rows)) else x[i,sel] %in% var.ul
                     ),
                     sep='') 	
        if (i < st) if (!all(cw2[i,] == cw2[i+1,])) ret <- paste(ret,'{\\pard\\par}','', sep='')
      }	
      ret <- paste(ret, "}\n\n", sep = "")
      rtf$.rtf <- paste(rtf$.rtf, ret, sep='')				
    }
    #})
    
    rtf <- RTF(...)
    fs <- rtf$.font.size
    rtf$.rtf <- gsub('Times New Roman', 'Courier New', rtf$.rtf)	# make "Courier New" as default
    rtf$.rtf <- gsub('field{\\fldinst{page}}', '', rtf$.rtf, fixed=TRUE)	# delete page number
    #nline.body <- 2
    npage <- ceiling((nrow(x)-st+1)/nline.body)
    #addHeader(rtf,title=titles[[1]],subtitle=titles[[2]])
    #systems <- c('Page \\chpgn  of {\\field{\\*\\fldinst  NUMPAGES }}', 
    systems <- c(ifelse(page.disp==TRUE, paste('Page \\chpgn  of ', npage, sep=''), ""), 
                 format(Sys.time(), "%H:%M %d%b%Y"),
                 prd.status)
    #systems <- c(paste('Page \\chpgn  of ', npage, sep=''), 
    #             format(Sys.time(), "%H:%M %d%b%Y"),
    #             prd.status)
    hd.m <- c(paste(titles,  collapse='\\line '), 
              paste(systems, collapse='\\line '))  # main header									
    tmp <- .add.table.row(
      col.data =  hd.m, 
      col.widths = c(sum(cw)-2+addSpaceHeader,2), 
      col.justify = c('L', 'R'),
      font.size = fs)
    tmp2 <- .add.table.row(
      col.data =  paste(footns, collapse='\\line '), 
      col.widths = sum(cw)+addSpaceFoot, 
      col.justify = 'L',
      font.size = fs)							
    if (FALSE) rtf$.rtf <- paste(rtf$.rtf, "{\\header\\pard", "\\fi0\\f2\\fs", fs*2, 
                                 "\\qr Page \\chpgn  of {\\field{\\*\\fldinst  NUMPAGES }}\\par}", sep='')
    for (i in 1:npage){						
      rtf$.rtf <- paste(rtf$.rtf, ifelse(i==1,'','\\page'), '{\\pard\\par}', 
                        ifelse(header,'{\\header',''), tmp, 
                        ifelse(header,'}',''), '{\\pard\\par}', sep='')					
      #startParagraph(rtf)
      #eval(expr)
      rtf.add.row(rows=c(1:(st-1), 1:nline.body-1+st+nline.body*(i-1)))
      #endParagraph(rtf)		
      rtf$.rtf <- paste(rtf$.rtf, '{\\pard\\par}', ifelse(footer,'\\footer',''), tmp2, sep='')
    }	
    done(rtf)		
    
  }#end rtf.tab
  
  
  #--- produce to rtf file that as SAS output. It can be used for single table or table with multiple pages
  rtf_table_out_as_sas <- function(rtf, tb, cw=NULL, 
                                   colFormat=c(rep("L", 1), rep("C",1), rep("R",1)),
                                   cell1=2, cell2=1, nheader=1,
                                   varName=NULL,
                                   var.ul='', prd.status=' ', #'QA',
                                   titles="", footns="", 
                                   header=FALSE, footer=FALSE,
                                   nline.body=30, height=8.5, width=11, omi=c(1,1,1,1),
                                   addSpaceHeader=0, addSpaceFoot=0, page.disp=TRUE,
                                   ...) {
    
    # rtf: RTF object that is just needed to be declared once before calling the function
    # tb: table out
    # cw: column width
    # colFormat: alignment (left, center, or right) for each column
    # varName: variable name that want to be repeated when go to the next page
    # var.ul: pre-specified cell values that indicate the bottom line in a table
    # nline.body: number of lines per page
    # addSpaceFoot, addSpaceHeader: expand the width of header or footnotes
    # page.disp: whether diplay page number
    
    #--- generate blank pape (break page) if the data is more than a page
    if(nrow(tb) > nline.body) {
      idx <- seq(1, nrow(tb), by = nline.body)
      idx.n <- c(seq(nline.body, nrow(tb), by = nline.body), nrow(tb))
    }else {
      idx <- 1
      idx.n <- nrow(tb)
    }
    
    npage <- length(idx)
    
    for(k in 1:length(idx)) {
      subTable <- tb[idx[k]:idx.n[k], ]
      if(is.null(nrow(subTable))){
        subTable <- data.frame(` `=subTable)
      }
      #--- if nrow < nline.body, need adding some spaces to move footnotes to bottom of the page
      if(nrow(subTable) < nline.body) {
        addData <- data.frame(matrix("",ncol=ncol(subTable), nrow=nline.body-nrow(subTable)-1))
        names(addData) <- names(subTable)
        subTable <- rbind(subTable, addData)  
      }
      
      #-- get values that will be in the 1st row of next page
      rownames(subTable) <- 1:nrow(subTable)
      
      #-- check if the last row of previous page with varName not matched the 1st row of next page
      if(k==1)
        string.val <- NULL
      if(k!=1 & !all(unique(subTable[1,varName]) %in% "") & !all(unique(subTable[1,varName]) %in% string.val))
        string.val <- unique(subTable[1,varName])
      
      if(k==1 & all(tb[nrow(subTable)+1, varName] %in% "")) {
        for(m in 1:nrow(subTable)) 
          if(all(!subTable[m,varName] %in% ""))
            string.val <- subTable[m, varName]
      } else if(!all(tb[nrow(subTable)+1, varName] %in% "")) {
        string.val <- NULL
      } else {   
        #-- add last row of previous page to 1st row of next page    
        if(!is.null(string.val))
          subTable[1, varName] <- string.val
        
        for(m in 1:nrow(subTable)) 
          if(all(!subTable[m,varName] %in% ""))
            string.val <- subTable[m, varName] 
      }
      
      hd <- sapply(colnames(subTable), function(x) strsplit(x, '; ')[[1]])
      ret <- rbind(hd, as.matrix(subTable))
      colnames(ret) <- 1:ncol(ret)            
      rownames(ret) <- 1:nrow(ret)
      
      ret2 <- ret
      
      colnames(ret2) <- 1:ncol(ret2)            
      rownames(ret2) <- 1:nrow(ret2)
      attributes(ret2) <- list(dim = dim(ret2), dimnames = dimnames(ret2), `start cell` = c(cell1, cell2))
      
      col.just <- matrix(c(rep(colFormat, nrow(ret2) + nheader)), ncol=ncol(ret2), byrow=TRUE)
      
      dat <- ret2
      st <- attributes(dat)$'start cell'[1]
      hd <- 1:(st-1)
      if(is.null(cw)) cw <- c(2.5, rep(1.5,ncol(dat)-1))
      x <- dat
      cw2 <- matrix(rep(cw, nrow(x)), ncol=ncol(x), byrow=TRUE)
      if (st > 2) {
        y <- adj.width(x=dat[hd,],cw=cw, space=1)
        x[hd,] <- y$x
        cw2[hd,] <- y$cw    
      } 
      
      rtf.add.row <- function(rows=1:nrow(x)){
        ret <- "{\\pard\n"
        for (i in rows) if (i <= nrow(x)){
          sel <- which(cw2[i,]>0)
          ret <- paste(ret, 
                       .add.table.row(
                         col.data =     x[i,sel], 
                         col.widths = cw2[i,sel], 
                         col.justify = col.just[i,sel],
                         font.size = fs,
                         border.top = i %in% c(1), 
                         border.bottom = if (i > st-2) i %in% c(st-1,nrow(x),max(rows)) else x[i,sel] %in% var.ul
                         #x is the subtable with header
                       ),  sep='') 
          if (i < st) if (!all(cw2[i,] == cw2[i+1,])) ret <- paste(ret,'{\\pard\\par}','', sep='')
        }
        ret <- paste(ret, "}\n\n", sep = "")
        rtf$.rtf <- paste(rtf$.rtf, ret, sep='')
      }
      
      rtf <- rtf
      fs <- rtf$.font.size
      rtf$.rtf <- gsub('Times New Roman', 'Courier New', rtf$.rtf)	# make "Courier New" as default
      rtf$.rtf <- gsub('field{\\fldinst{page}}', '', rtf$.rtf, fixed=TRUE)	# delete page number
      
      tmp2 <- .add.table.row(
        col.data =  paste(footns, collapse='\\line '), 
        col.widths = sum(cw)+addSpaceFoot, 
        col.justify = 'L',
        font.size = fs)	
      rtf.add.row(rows=c(1:(st-1), 1:nline.body-1+st))	
      rtf$.rtf <- paste(rtf$.rtf, '{\\pard\\par}', ifelse(footer,'\\footer',''), tmp2, sep='')
    } #end of the for loop	
    return(rtf)
  }#end rtf_table_out_as_sas  
  
  
}





#-------------Manually Convert R object into HTML code-------------#
df2html<-function( #convert a table into part of HTML code
  datF, #a data.frame for table output
  tabTit="",  #table title
  fnote=NULL,  #footnote
  ind=1
){
  datF<-as.data.frame(datF)
  dim1<-dim(datF)
  nr<-dim1[1]
  nc<-dim1[2]
  cnm<-colnames(datF)
  rnm<-rownames(datF) #currently the rownames would not be printed out.  
  out<-paste0('<a name=\"IDX',ind,'\"></a>')
  out<-c(out, '<div align=\"left\">')
  tabSum2<-paste0('<table class=\"Table\" cellspacing=\"1\" cellpadding=\"',
                  nc+2, '\" rules=\"groups\" frame=\"box\" border=\"1\" bordercolor=\"#000000\" ',
                  'summary=\"', tabTit, '\" >')  #style="table-layout: fixed; width: 100%"
  out<-c(out, tabSum2, '<colgroup>', rep('<col>',nc), '</colgroup>', '<thead>')
  #For table header
  tabHead<-c('<tr>', paste0('<td class="l NoteContent" colspan=\"', nc,
                            '\">', tabTit, '<br>', paste(rep("-",138),collapse=''), '</td>'), '</tr>', '<tr>')
  for(i in 1:nc){
    tabHead<-c(tabHead, paste0('<th class=\"c b Header\" scope=\"col\">',
                               cnm[i], '</th>'))
  }
  out<-c(out, tabHead, '</tr>', '</thead>', '<tbody>')
  #for table body
  tabBody<-NULL
  for(j in 1:nr){
    tabBody<-c(tabBody, '<tr>')
    for(i in 1:nc){
      tabBody<-c(tabBody, paste0('<td class=\"l Data\">', datF[j,i], '</td>'))
    }
    tabBody<-c(tabBody, '</tr>')
  }
  out<-c(out, tabBody, '</tbody>', '<tfoot>', '<tr>')
  out<-c(out, paste0('<td class=\"l NoteContent\" colspan=\"',nc,'\">',
                     paste(rep("-",138),collapse=''), '<br>', fnote, '</td>'), '</tr>', '</tfoot>')
  out<-c(out, '</table>', '</div>', 
         '<p style="page-break-after: always;"><br></p><hr size="3">')
  return(out)  
}

fig2html<-function( #convert a png figure into part of HTML code
  figNm='plot.png', # the png file name
  figTit="", #figure title
  figH="480", figW="640",
  fnote=NULL,  #footnote
  ind=1
){
  out<-paste0('<a name=\"IDX',ind,'\"></a>')
  figTit1<-c('<div align=\"left\">', 
             paste0('<table class=\"Table\" cellspacing=\"1\" cellpadding=\"1',
                    '\" rules=\"groups\" frame=\"box\" border=\"1\" bordercolor=\"#000000\" ',
                    'summary=\"', figTit, '\" >'), '<colgroup>','<col>', '</colgroup>',
             '<thead>', '<tr>' ) 
  out<-c(out, figTit1, paste0('<td class=\"l NoteContent\" colspan=\"1\">', 
                              figTit,  '</td>'), '</tr>', '</thead>', '<tbody>', '<tr>' )
  out<-c(out, '<td>', paste0('<img alt=\" \" src=\"', figNm,
                             '\" style=\" height: ', figH, 'px; width: ', figW, 
                             'px;\"  border=\"0\">'), '</td>', '</tr>', '</tbody>','<tfoot>','<tr>')
  out<-c(out, paste0('<td class=\"l NoteContent\" colspan=\"1\">',fnote,
                     '</td>'), '</tr>', '</tfoot>')
  out<-c(out, '</table>', '</div>',
         '<p style="page-break-after: always;"><br></p><hr size="3">')
  return(out)  
  
}

cLink<-function( #generate a link in content table
  tit="tmplink", ind=1
){
  out<-'<li class=\"ContentItem\">'
  out<-c(out, '<span><b>&#183;</b><a href=\"',
         paste0('body.htm#IDX', ind,'\" target=\"body\">',tit,'</a>'),
         '</span><br></li>')
  return(out)
}


#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
#revise a html table code
#make it into multi-level header
toMultH <- function(
  tbc, # a vector of html table code
  split1=";"                
){
  wh.h <- grep('<th>', tbc)
  if(length(wh.h)>1){return(tbc)}
  tbc.h <- tbc[1:(wh.h-1)]
  if(wh.h==length(tbc)){return(tbc)}
  tbc.b <- tbc[(wh.h+1):length(tbc)]
  hh <- tbc[wh.h]
  hh <- gsub("<th>", "", hh, fixed=TRUE)
  hh <- gsub("<tr>", "", hh, fixed=TRUE)
  hh <- gsub("</tr>", "", hh, fixed=TRUE)
  hh <- strsplit(hh, split="</th>")[[1]]
  hh <- hh[-length(hh)] #remove the last empty element
  hh <- strsplit(hh, split=split1, fixed=TRUE)
  
  hh.l <- sapply(hh, length)
  short <- hh.l<max(hh.l)
  hh[short] <- lapply(hh[short], function(x){
    c(x, rep(" ", max(hh.l)-length(x)))})
  
  hh3 <-matrix(unlist(hh), nrow=max(hh.l))
  hh3 <- apply(hh3, 1, function(x){
    r1 <- "<tr> <th colspan=\'"
    colspan <- 1
    if(length(x)>1){
      for(i in 1:(length(x)-1)){#requre ncol for the table is 2+
        if( gsub(" ", "", x[i])==gsub(" ", "", x[i+1])){
          colspan <- colspan + 1
        }else {
          r1 <- paste(r1, colspan, "\'>", x[i], "</th> <th colspan=\'")
          colspan <- 1
        }
      }
    }
    r1 <- paste(r1, colspan, "\'>", x[length(x)], "</th> </tr>'")
    return(r1)
    #<th colspan='2'>      
  })
  return(c(tbc.h, hh3, tbc.b))
  
}



#----------UI Functions------------------#


#select color function
selectInput_color <- function(id='wpColor', 
                              label='Background color', 
                              choices=colors(), 
                              selected='azure3',
                              HEX=HEXColors){
  code <- paste0("<div class=\"form-group shiny-input-container\">\n",
                 "<label class=\"control-label\" for=\"",
                 id, "\">", label, ":</label>\n<div>\n",
                 "<select id=\"", id, "\"><option value=\"",
                 selected, "\" selected>", selected, "</option>\n")
  for(i in 1:length(choices)){
    code <- paste0(code, 
                   "<option value=\"",
                   choices[i], "\" style=\"background-color: ",
                   HEX[choices[i]], "\">", choices[i], "</option>\n")
  }
  code <- paste0(code, "</select>",
                 "<script type=\"application/json\" data-for=\"",
                 id, "\" data-nonempty=\"\">{}</script> \n</div>\n</div> ")
  
  return(code)
}










#Function to create Table with checkboxes

checkboxTableInput <- function(df,table.id="checktable",id.name, 
                               checked, check.name,labels=NULL, showSelectedOnly=FALSE
){
  table_head0<-capture.output(print(xtable(df[0,]), type="html", 
                                    include.rownames=F,include.colnames=T))
  table_head0[3]<-"<table border=1 class=\"table table-bordered\">"
  table_head <- paste(table_head0, collapse=" ")
  table_head <- gsub("</TABLE>", "", table_head)
  table_head <- gsub("</table>", "", table_head)
  table_head <- gsub("<table", paste0("<table id=\"",table.id,"\""), table_head)
  table_head<- gsub('<TR>','<tr>',table_head)
  table_head<- gsub('</TR>','</tr>',table_head)
  table_head <- gsub("<tr>", paste("<tr> <th> ", check.name, " </th>", sep=""), 
                     table_head)
  table_body <- paste(capture.output(print(xtable(df), type="html", 
                                           content.only=T, include.rownames=F, include.colnames=F)), collapse=" ")
  table_body<- gsub('<TR>','<tr>',table_body)
  table_body<- gsub('</TR>','</tr>',table_body)
  table_body<- gsub('<TD>','<td>',table_body)
  table_body<- gsub('</TD>','</td>',table_body)
  table_body<- gsub('</tr>','',table_body)
  table_body<- gsub('</table>','',table_body)
  which.tag <- regexpr("<tr>", table_body)[1]
  table_body <- substr(table_body, which.tag, nchar(table_body))
  table_body2 <- unlist(strsplit(table_body, "<tr>", fixed=T))
  # print(table_body2)
  table_body3 <- '' #table_body2[1]
  
  if(showSelectedOnly){
    for (i in 1:nrow(df)){
      if(checked[i]){
        check_tag <- paste("<tr>  <td align=left>", 
                           as.character(checkboxInput(paste0(id.name,'_',i), "", checked[i])),
                           " </td>", sep="")
        table_body3<-paste(table_body3, check_tag, table_body2[i+1], "</tr>",  sep="")
      }
    }
  }else{
    for (i in 1:nrow(df)){
      check_tag <- paste("<tr>  <TD align=left>", 
                         as.character(checkboxInput(paste0(id.name,'_',i), "", checked[i])),
                         " </td>", sep="")
      table_body3<-paste(table_body3, check_tag, table_body2[i+1], "</tr>", sep="")
    }
  }
  table_out <- paste(table_head, table_body3, "</table>", collapse=" ")
  if (!is.null(labels)){
    for (k in 1:length(labels)){
      table_out<-gsub(paste0('<th> ',colnames(df)[k],' </th>'),
                      paste0('<th> ',labels[k],' </th>'), table_out)
    }
  }
  # print(table_out)
  
  return(table_out)
}

#-------------Create Tabs-------------#
tabs<-function(tab.id,tab.label,tab.value){
  tabset<-unique(cbind(tab.label,tab.value))
  tabcode1<-paste0('<div class=\"tabbable tabs-above\">\n',
                   '<ul class=\"nav nav-tabs shiny-tab-input\" id=\"',
                   tab.id,'\">\n<li class=\"active\">\n')
  tabcode2<-paste0('<a href=\"#tab-',tab.id,'-',1:nrow(tabset),
                   '\" data-toggle=\"tab\" data-value=\"',
                   tabset[,1],"\">",tabset[,2],"</a>\n</li>\n<li>\n")
  tabcode2[length(tabcode2)]<-gsub('<li>','</ul>',tabcode2[length(tabcode2)])
  tabcode3<-"<div class=\"tab-content\">"
  tabcode4<-paste0('<div class=\"tab-pane active\" data-value=\"',
                   tabset[,1],'\" id=\"tab-',tab.id,'-',1:nrow(tabset),
                   '\"></div>\n',collapse=" ")
  tabcode5<-'</div>\n</div>'
  tabcode<-paste0(tabcode1,paste0(tabcode2,collapse=" "),
                  tabcode3,tabcode4,tabcode5,collapse=" ")  
  return(tabcode)
}

#-------------side panel data input-------------#
inlinetext<-function(text.id,text.label,text.value, note=NULL){
  if(is.null(note)){
    nt <- ""
  }else {
    nt <- paste0('<h6 style=\"width:50%\">', note, ' </h6>')
  }
  if(FALSE){ #using textInput widget
    code <- paste0(
      "<div class = \"form-group shiny-input-container\", style = \"width:100%\">",
      paste0("<label for=\"", text.id, "\">", text.label, "</label>"),
      paste0("<input id=\"", text.id, "\" type=\"text\" class=\"form-control\" value=\"", text.value, "\"/>"),
      "</div>",
      collapse='\n'
    )
  } else { #using traditional widget
    code<-paste0( '<div class=\"input-prepend\" style=\"width:100%\">',  
                  paste0('<span class=\"add-on\" >',text.label,'</span>'),
                  paste0('<input style=\"width:50%\" id=\"',text.id,
                         '\" class=\"form-control\" value=\"',text.value,'\" type=\"text\" />\n'),
                  nt,
                  '</div>',
                  collapse='\n')
  }
  return(code)
}

#-------------For output R code-------------#
runcode<-function(codelist, # merged dataset of loa and configuration file
                  datPath, # dataset path from input
                  outPath, # output path from input
                  libs,
                  params1,    #a vector of widgets name (require ordered)
                  paramLabs1, #a vector of widgets label(1:1 matched to params)
                  sourceCode, # source files from configuration file
                  subCode,
                  title0, # Main title with study id and tumor type
                  devpath,
                  outBcode=NULL
){
  
  codelist<-codelist[!(!is.na(codelist[,paramLabs1[1]]) & is.na(codelist[,params1[1]])),]
  sourceCode<-unique(sourceCode[!is.na(sourceCode)])
  sourceCode<-sourceCode[!grepl("rcode.r",sourceCode)]
  head1<-sop_head  #paste0('#/*soh',paste0(rep('*',73),collapse=''))
  nParam<-length(params1)
  
  if(FALSE){
    head2<-'if(FALSE){ # DESCRIPTION: Parameters for generating following results:'
    tmploa<-unique(codelist[,c('Request.Name',params1,paramLabs1)])
    tmploa2<-sapply(1:nrow(tmploa),function(y){
      paste0(tmploa$Request.Name[y],' ',
             ifelse(is.na(tmploa[y,paramLabs1[1]]),
                    '',
                    paste0('(',paste0(sapply(which(!is.na(tmploa[y,paramLabs1])),function(x){
                      paste0(tmploa[y,paramLabs1[x]],'=',
                             ifelse(is.na(tmploa[y,params1[x]]),
                                    'Parameters Needed',
                                    tmploa[y,params1[x]]))
                    }),collapse=';'),') \n')
             )
      )})
    tmploa2<-gsub(";", ";\n    #", tmploa2)
    head3<-paste0('  #',1:length(tmploa2),'. ',tmploa2)  
    
    head4<-paste0('\n}\n#', paste0(rep("-",90),collapse='')) #end of DESCRIPTION
  } else {
    head2<-''
    head3<-''
    head4<-''
  }
  head5<-''# paste0('  #', gsub('\n', '\n  #  ', libs))
  head6<-'\nif(TRUE){ #------Read in CSV Dataset------'
  head7<-paste0( '  indataset<-list() \n',
                 '  for(i in 1:length(inf)){ \n',
                 '    indataset[[i]]<-read.csv_sas(inf[i],stringsAsFactors=FALSE,header=TRUE, encoding=inf.enc[i], comment.char=\"\") \n',
                 '  } \n ',
                 '  names(indataset)<-inf  \n',
                 '  indataset.i<-indataset[[1]]  ')
  head8<-paste0('  ', subCode)
  head6.1<-'\n}\nif(TRUE){ #------Read in one RData------'
  head7.1<-paste0(
    'load(inf.R, indataR<-new.env())\n',
    'indataR<<-as.list(indataR)\n' )
  head9<-'\n\n\nif (TRUE){ #------Source Packages and Function Files------'
  #connect default folder for reusable functions
  head10<-paste0(
    '  if(FALSE){ #Please firstly check whether all the required pacakges are installed.\n    ',
    '#install.packages(c(...))\n    ', 
    gsub('\n', '\n    ', libs),
    '\n  }',
    '\n  require(rtf) \n  require(haven) \n',
    '\n  read.csv_sas<<-function(file, header=TRUE, nrow=-1, comment.char="", ...){',
    '\n   is.sas<-grepl(\'.sas7bdat\', file, fixed=TRUE)',
    '\n   is.csv<-grepl(\'.csv\', file, fixed=TRUE)',
    '\n   if(is.sas){',
    '\n     ot<-haven::read_sas(file)',
    '\n     if(header & nrow==1){ot<-names(ot)}',
    '\n   }else if (is.csv){',
    '\n     tm<-try(ot<-read.csv(file=file, h=header, nrow=nrow, na=c(\'NA\', \'\', \'.\'), stringsAsFactors=FALSE, comment.char=comment.char, ...))',
    '\n     if(class(tm)==\'try-error\')',
    '\n     tm<-try(ot<-read.csv(file=file, h=header, nrow=nrow, na=c(\'NA\', \'\', \'.\'), stringsAsFactors=FALSE,fileEncoding=\"latin1\", comment.char=comment.char))',
    '\n     if(class(tm)==\'try-error\')',
    '\n     tm<-try(ot<-read.csv(file=file, h=header, nrow=nrow, na=c(\'NA\', \'\', \'.\'), stringsAsFactors=FALSE,fileEncoding=\"UTF-8\", comment.char=comment.char))',
    '\n     if(class(tm)==\'try-error\')',
    '\n     tm<-try(ot<-readLines(con=file))     ',
    '\n   }else{',
    '\n   ot<-NULL\n}',
    '\n   return(ot) \n  }',   
    "\n  ", ifelse(is.null(eval(parse(text=outBcode))), " ", outBcode),
    "\n}")
  head11<-'\n\ntry(source(SourceFile))\n\nif(OutputRTF){  #----- Generate RTF file ------'
  head12<-paste0('\n  pageW<-11 \n  pageH<-8.5 ',
                 '\n  figW<-9 #figure width in RTF file',
                 '\n  figH<-6 #figure height in RTF file\n',
                 '\n  rtf<-RTF(rtfFileName,width=pageW,height=pageH, font.size=8,omi=c(.5,.5,.5,.5))')
  r_out<-c(head1,head2,head3,head4,head5, head9,head10,head6,head7,head8,head6.1, head7.1, head11,head12)
  for (i in 1:nrow(codelist)){
    for(x in nParam:1){
      if(!is.na(codelist[i,params1[x]])){
        tmp0<-unlist(strsplit(as.character(codelist[i,params1[x]]),
                              ',',fixed=TRUE))
        tmp00 <- try( as.numeric(tmp0) )
        if( class(tmp00)[1]=='try-error' || any(is.na(as.numeric(tmp0))) )
          say1 <- TRUE
        else
          say1 <-FALSE
        tmp<-ifelse(say1,
                    paste0('c(\"',paste0(tmp0,collapse='\",\"'),'\")'),
                    paste0('c(',paste0(codelist[i,params1[x]],collapse=','),')'))
        codelist$Title[i]<- gsub(paste0('input$',params1[x]),
                                 tmp,codelist$Title[i],fixed=TRUE)
        codelist$PlotCode[i]<- gsub(paste0('input$',params1[x]),
                                    tmp,codelist$PlotCode[i],fixed=TRUE)
        codelist$FootCode[i]<- gsub(paste0('input$',params1[x]),
                                    tmp,codelist$FootCode[i],fixed=TRUE)
      }
    }
    
    #Add Header
    title<-codelist$Title[i]
    
    if(is.na(title) || length(title)<1) title <- " "
    if(grepl(title, 'paste', fixed=TRUE)) title<-eval(parse(text=title))
    addhead<-vector()
    addhead[1]<-paste0('\n\n  #------Add Header  ',codelist$order[i],' ------')
    addhead[2]<-paste0('  addHeader(rtf,title=\"',title0,'\",font.size=10)')
    addhead[3]<-paste0('  addHeader(rtf,title=\"',title,'\",font.size=10)')
    r_out<-c(r_out,addhead)
    
    #Add Plot
    if( (!is.na(codelist$Type.y[i]) & codelist$Type.y[i]=='Figure') || 
        (!is.na(codelist$Type.x[i]) & codelist$Type.x[i]=='Figure')  ){
      addplot<-vector()
      addplot[1]<-paste0('  #------Add Plot: ',codelist$Request.Name[i],' ------')
      addplot[2]<-paste0('  tmp<-',codelist$tmp[i])
      addplot[3]<-paste0('  pngtmp<-function(){',codelist$PlotCode[i],'}')
      addplot[4]<-paste0('  addPlot(rtf,pngtmp,width=figW', #codelist$width[i]/160,
                         'height=figH' #, codelist$height[i]/160,')'
      )  
      r_out<-c(r_out,addplot)}
    
    #Add Table            
    if(  (!is.na(codelist$Type.y[i]) & codelist$Type.y[i]=='Table') || 
         (!is.na(codelist$Type.x[i]) & codelist$Type.x[i]=='Table')  ){
      addtab<-vector()
      addtab[1]<-paste0('  #------Add Table: ',codelist$Request.Name[i],' ------')
      addtab[2]<-paste0('  tmp<-',codelist$tmp[i])
      addtab[3]<-paste0('  outTable<-{',codelist$PlotCode[i],'}')
      addtab[4]<-paste0('  tWidth<-9\nnc<-nchar(as.character(outTable[,1]))\nc1W<-pmax(max(nc)*0.079/2, 20*0.079)\n',
                        '  caW<-nc*0.079\nlcW<-.711\nothW<-(tWidth-c1W-lcW)/(ncol(outTable)-2)\n',
                        '  centW<-rep(othW,ncol(outTable)-2)\ncWs<-c(c1W,centW,lcW)'
      )
      addtab[5]<-paste0( '  addTable(rtf,outTable,col.widths=cWs,col.justify=rep(\'L\',length(outTable)))'
      )
      r_out<-c(r_out,addtab)
    }
    
    #Add Footnote
    footnote<-codelist$FootCode[i]
    footnote<-gsub("\\\\n","\n",footnote)
    if(!is.na(footnote)&&gsub("", " ", footnote)!=''&&substr(footnote,1,5)=='paste')
      footnote<-eval(parse(text=footnote))
    addfoot<-vector()
    addfoot[1]<-'  addNewLine(rtf, n=2)'
    addfoot[2]<-paste0('  #------Add Footnote  ',codelist$order[i],' ------')
    addfoot[3]<-paste0('  addParagraph(rtf,\"',footnote,'\")')
    r_out<-c(r_out,addfoot)
    
    if(i!=nrow(codelist)){
      r_out<-c(r_out,'  addPageBreak(rtf,width=11,height=8.5,font.size=8,omi=c(.5,.5,.5,.5))')
    }else{
      r_out<-c(r_out,'\ndone(rtf)\n}  #------End of RTF------\n')
    }
  }
  return(paste0(r_out,collapse='\n'))
}

checkSource<-function(fnm, keyS1='source('){#fnm must be a file under inpath2
  rF1<-NULL
  r1<-readLines(con=fnm)
  r2<-toupper(gsub(" ", '', r1))
  falseKey<-FALSE
  for(j in 1:length(r1)){
    if(grepl('IF(FALSE)', r2[j], fixed=TRUE)|grepl('IF(F)', r2[j], fixed=TRUE)){
      falseKey<-TRUE
      b1<-0
    }
    if(falseKey){
      if(gsub("IF(FALSE)","", r2[j],fixed=TRUE)=="[{]"|substr(r2[j],1,1)=="[{]") b1<-b1+1
      if(b1==0 & grepl("[{]", r2[j]))
        falseKey<-FALSE
      if(grepl("}", r2[j])) {
        b1<-b1-1
        if(b1==0) falseKey<-FALSE
      }
    }else{
      if(grepl(toupper(keyS1), r2[j], fixed=TRUE)){
        f3<-strsplit(r1[j],split='local.path1,', fixed=TRUE)[[1]][2]
        f3<-gsub("users/","",f3, fixed=TRUE)
        f3<-gsub("'","",f3, fixed=TRUE)
        f3<-gsub('"','',f3, fixed=TRUE)
        f3<-gsub('\"','',f3, fixed=TRUE)
        f3<-gsub(')','',f3, fixed=TRUE)
        f3<-gsub('(','',f3, fixed=TRUE)
        f3<-gsub(' ','',f3, fixed=TRUE)
        if(grepl(".r", tolower(f3), fixed=TRUE)){
          rF1<-c(rF1, f3)
        }
      }
    }
  }
  return(rF1)
}




#-------------Creat Parameters-------------#
#use radiobutton, slidebar, checkbox, selectInput
if(!newWay){
  widgets.code<-function(UInames, max.n){
    ind<-max.n!=0
    
    check.code<-lapply(max.n['check']:1,function(x){  
      ret<-'\n output$checkbox_xx<-renderUI({
    tmpN<-reactive(which(check.param()$Request.Name==input$analysis))
    if(length(tmpN())<1) return(NULL)
    try(tmp<-eval(parse(text=Vdic()$tmp[AnalyC()])))
    if(is.na(check.param()[tmpN(),\'check.label_xx\'])
    ||class(try(default<-eval(parse(text=check.param()[tmpN(),\'check.default_xx\']))))==\"try-error\"
    ||class(try(choice<-eval(parse(text=check.param()[tmpN(),\'check.choice_xx\']))))==\"try-error\")return(NULL)
    if (length(choice)==0)return(div(class=\"alert alert-error\",strong(\'checkbox Options Are Not Available\')))
    if (is.na(default))default<-choice
    checkboxGroupInput(inputId=\'check_xx\',label=strong(check.param()[tmpN(),\'check.label_xx\']),choices=choice,selected=default)})\n\n  '
      if (x==1){ret<-gsub('_xx','',ret,fixed=TRUE)}else{ret<-gsub('_xx',x,ret,fixed=TRUE)}
      ret
    })
    check.codes<-Reduce(function(x,y)paste0(x,y,collapse='\n'),check.code)
    
    radio.code<-lapply(max.n['radio']:1,function(x){
      ret<-'output$radiobutton_xx<-renderUI({
     tmpN<-reactive(which(radio.param()$Request.Name==input$analysis))
     if(length(tmpN())<1) return(NULL)
     try(tmp<-eval(parse(text=Vdic()$tmp[AnalyC()])))
     if(is.na(radio.param()[tmpN(),\'radio.label_xx\'])
     ||class(try(default<-eval(parse(text=radio.param()[tmpN(),\'radio.default_xx\']))))==\"try-error\"
     ||class(try(choice<-eval(parse(text=radio.param()[tmpN(),\'radio.choice_xx\']))))==\"try-error\")return(NULL)
     if (length(choice)==0)return(div(class=\"alert alert-error\",strong(\'radiobutton Options Are Not Available\')))
     if (is.na(default))default<-choice[1]
    radioButtons(\'radio_xx\',label=strong(radio.param()[tmpN(),\'radio.label_xx\']),choices=choice,selected=default)})\n\n  '
      if (x==1){ret<-gsub('_xx','',ret,fixed=TRUE)}else{ret<-gsub('_xx',x,ret,fixed=TRUE)}
      ret
    })
    radio.codes<-Reduce(function(x,y)paste0(x,y,collapse='\n'),radio.code)
    
    dropdown.code<-lapply(max.n['dropdown']:1,function(x){
      ret<-'output$dropdown_xx<-renderUI({   
    isolate({
      tmpN<-reactive(which(dropdown.param()$Request.Name==input$analysis))
      if(length(tmpN())<1) return(NULL)
      try(tmp<-eval(parse(text=Vdic()$tmp[AnalyC()])))   
    })
    if(is.null(dropdown.param()[tmpN(),\'dropdown.label_xx\'])) return(NULL)
    if (is.na(dropdown.param()[tmpN(),\'dropdown.label_xx\'])  
    ||class(try(default<-eval(parse(text=dropdown.param()[tmpN(),\'dropdown.default_xx\']))))==\"try-error\"
    ||class(try(default2<-eval(parse(text=dropdown.param()[tmpN(),\'dropdown.multiple_xx\']))))==\"try-error\"
    ||class(try(choice<-eval(parse(text=dropdown.param()[tmpN(),\'dropdown.choice_xx\']))))==\"try-error\")return(NULL)
    if (length(choice)==0)return(div(class=\"alert alert-error\",strong(\'dropdown Options Are Not Available\')))
    if (all(is.na(default)))default<-choice[1]
    if (all(is.na(default2)))default2<-TRUE
    selectInput(\'dropdown_xx\',label=strong(dropdown.param()[tmpN(),\'dropdown.label_xx\']),
      choices=choice,selected=default,multiple=default2,selectize=TRUE, width=\"100%\") }) \n\n  '
      if (x==1){ret<-gsub('_xx','',ret,fixed=TRUE)}else{ret<-gsub('_xx',x,ret,fixed=TRUE)}
      ret
    })
    dropdown.codes<-Reduce(function(x,y)paste0(x,y,collapse='\n'),dropdown.code)
    
    slide.code<-lapply(max.n['slide']:1,function(x){
      ret<-'output$slider_xx<-renderUI({
    tmpN<-reactive(which(slide.param()$Request.Name==input$analysis))
    if(length(tmpN())<1) return(NULL)
    try(tmp<-eval(parse(text=Vdic()$tmp[AnalyC()])))
    if(is.null(slide.param()[tmpN(),\'slide.label_xx\'])) return(NULL)
    if (is.na(slide.param()[tmpN(),\'slide.label_xx\'])  
    ||class(try(min<-eval(parse(text=slide.param()[tmpN(),\'slide.min_xx\']))))[1]==\"try-error\"
    ||class(try(max<-eval(parse(text=slide.param()[tmpN(),\'slide.max_xx\']))))[1]==\"try-error\"
    ||class(try(default<-eval(parse(text=slide.param()[tmpN(),\'slide.value_xx\']))))[1]==\"try-error\"
    ||class(try(by<-eval(parse(text=slide.param()[tmpN(),\'slide.by_xx\']))))[1]==\"try-error\")return(NULL)
    if (length(c(min,max,default,by))<4)return(div(class=\"alert alert-error\",strong(\'slider Options Are Not Available\')))
    if (is.na(default))default<-mean(min,max)
    sliderInput(\'slide_xx\',label=strong(slide.param()[tmpN(),\'slide.label_xx\']),min=min,max=max,value=default,step=by,animate = TRUE)})\n\n'
      if (x==1){ret<-gsub('_xx','',ret,fixed=TRUE)}else{ret<-gsub('_xx',x,ret,fixed=TRUE)}
      ret
    })  
    slide.codes<-Reduce(function(x,y)paste0(x,y,collapse='\n'),slide.code)
    
    date.code<-lapply(max.n['date']:1,function(x){
      ret<-'output$date_xx<-renderUI({
    tmpN<-reactive(which(date.param()$Request.Name==input$analysis))
    if(length(tmpN())<1) return(NULL)
    try(tmp<-eval(parse(text=Vdic()$tmp[AnalyC()])))
    if (is.na(date.param()[tmpN(),\'date.label_xx\'])  
    ||class(try(default<-eval(parse(text="(date.param()[tmpN(),\'date.value_xx\'])"))))==\"try-error\")return(NULL)
    if (!is.null(default)&is.na(default)) return(div(class=\"alert alert-error\",strong(\'date Options Are Not Available\')))
    dateInput(\'date_xx\',label=strong(date.param()[tmpN(),\'date.label_xx\']),
      value=default, format = \"yyyy-mm-dd\")})\n\n'
      if (x==1){ret<-gsub('_xx','',ret,fixed=TRUE)}else{ret<-gsub('_xx',x,ret,fixed=TRUE)}
      ret
    })  
    date.codes<-Reduce(function(x,y)paste0(x,y,collapse='\n'),date.code)
    
    dateR.code<-lapply(max.n['dateR']:1,function(x){
      ret<-'output$dateR_xx<-renderUI({
    tmpN<-reactive(which(dateR.param()$Request.Name==input$analysis))
    if(length(tmpN())<1) return(NULL)
    try(tmp<-eval(parse(text=Vdic()$tmp[AnalyC()])))
    if (is.na(dateR.param()[tmpN(),\'dateR.label_xx\'])  
    ||class(try(min<-eval(parse(text="(dateR.param()[tmpN(),\'dateR.start_xx\'])"))))==\"try-error\"
    ||class(try(max<-eval(parse(text="(dateR.param()[tmpN(),\'dateR.end_xx\'])"))))==\"try-error\") return(NULL)
    if ((!is.null(min)&is.null(max))&(is.na(min)&is.na(max)))
      return(div(class=\"alert alert-error\",strong(\'data range Options Are Not Available\')))
    dateRangeInput(\'dateR_xx\',label=strong(dateR.param()[tmpN(),\'dateR.label_xx\']),
       start=min, end=max, format = \"yyyy-mm-dd\")})\n\n'
      if (x==1){ret<-gsub('_xx','',ret,fixed=TRUE)}else{ret<-gsub('_xx',x,ret,fixed=TRUE)}
      ret
    })  
    dateR.codes<-Reduce(function(x,y)paste0(x,y,collapse='\n'),dateR.code)
    
    num.code<-lapply(max.n['num']:1,function(x){
      ret<-'output$num_xx<-renderUI({
    tmpN<-reactive(which(num.param()$Request.Name==input$analysis))
    if(length(tmpN())<1) return(NULL)
    try(tmp<-eval(parse(text=Vdic()$tmp[AnalyC()])))
    if (is.na(num.param()[tmpN(),\'num.label_xx\'])  
    ||class(try(default<-eval(parse(text="num.param()[tmpN(),\'num.value_xx\']"))))==\"try-error\")return(NULL)
    if (is.na(default)) return(div(class=\"alert alert-error\",strong(\'numericInput Options Are Not Available\')))
    numericInput(\'num_xx\',label=strong(num.param()[tmpN(),\'num.label_xx\']),
      value=default)})\n\n'
      if (x==1){ret<-gsub('_xx','',ret,fixed=TRUE)}else{ret<-gsub('_xx',x,ret,fixed=TRUE)}
      ret
    })  
    num.codes<-Reduce(function(x,y)paste0(x,y,collapse='\n'),num.code)
    
    text.code<-lapply(max.n['text']:1,function(x){
      ret<-'output$text_xx<-renderUI({
    tmpN<-reactive(which(text.param()$Request.Name==input$analysis))
    if(length(tmpN())<1) return(NULL)
    try(tmp<-eval(parse(text=Vdic()$tmp[AnalyC()])))
    if (is.na(text.param()[tmpN(),\'text.label_xx\'])  
    ||class(try(default<-eval(parse(text=text.param()[tmpN(),\'text.value_xx\']))))==\"try-error\")return(NULL)
    if (is.na(default)) return(div(class=\"alert alert-error\",strong(\'textInput Options Are Not Available\')))
    textInput(\'text_xx\',label=strong(text.param()[tmpN(),\'text.label_xx\']),
      value=default)})\n\n'
      if (x==1){ret<-gsub('_xx','',ret,fixed=TRUE)}else{ret<-gsub('_xx',x,ret,fixed=TRUE)}
      ret
    })  
    text.codes<-Reduce(function(x,y)paste0(x,y,collapse='\n'),text.code)
    
    textbox.code<-lapply(max.n['textbox']:1,function(x){
      ret<-paste0('output$textbox_xx<-renderUI({
     tmpN<-reactive(which(textbox.param()$Request.Name==input$analysis))
     try(tmp<-eval(parse(text=Vdic()$tmp[AnalyC()])))
     if(is.na(textbox.param()[tmpN(),\'textbox.label_xx\']))return(NULL)
     cols<-eval(parse(text=textbox.param()[tmpN(),\'textbox.cols_xx\']))
     rows<-eval(parse(text=textbox.param()[tmpN(),\'textbox.rows_xx\']))
     default<-textbox.param()[tmpN(),\'textbox.default_xx\']
     label<-textbox.param()[tmpN(),\'textbox.label_xx\']
     if(is.na(cols)||is.null(cols))cols<-40
     if(is.na(rows)||is.null(rows))rows<-2
     texttmp<-paste0(\'<h6>\',label,\'</h6>\n<textarea name=\"\',textbox_xx,\'\" 
     rows=\"\',rows,\'\"  cols=\"\',cols,\'\">\',default,\'</textarea>\')
     return(shiny::HTML(texttmp))
     })\n\n')
      if (x==1){ret<-gsub('_xx','',ret,fixed=TRUE)}else{ret<-gsub('_xx',x,ret,fixed=TRUE)}
      ret
    })  
    textbox.codes<-Reduce(function(x,y)paste0(x,y,collapse='\n'),textbox.code)
    
    
    widgets.code<-paste0(c(check.codes,radio.codes,dropdown.codes,slide.codes,
                           date.codes, dateR.codes, num.codes, text.codes, textbox.codes)[ind],
                         collapse='\n\n')
    return(widgets.code)
  }
}

widgets.order<<-function(analysis, UIdic1, UInames, ncol.widg=NULL){
  #  print(UIdic1)
  #  print(UInames)
  #  print(analysis)
  
  if(is.null(ncol.widg)){ncol.widg<-1}
  input.names<-as.vector(t(UIdic1[UIdic1$Request.Name==analysis, UInames]))
  if(length(input.names)==0){
    widg.list=NULL
  }else{
    input.labs<-as.vector(t(UIdic1[UIdic1$Request.Name==analysis,
                                   gsub("uiInput", "uilab", UInames, fixed=TRUE)]))
    #names(input.names)<-1:length(input.names)
    s_1<-!is.na(input.names)
    input.names<-input.names[s_1]#unique(setdiff(as.vector(input.names),NA))
    input.labs<-input.labs[s_1]
    input.labs[is.na(input.labs)]<-""
    
    widg.list<-unlist(strsplit(input.names,'input$',fixed=TRUE))
    sel0<-widg.list!='' & !is.na(widg.list)
    input.names<-widg.list<-widg.list[sel0]
    #input.labs<-input.labs[sel0]
    
    widg.list<-gsub('check','checkbox',widg.list)
    widg.list<-gsub('radio','radiobutton',widg.list)
    widg.list<-gsub('dropdown','dropdown',widg.list)
    widg.list<-gsub('slide','slider',widg.list)
    # widg.list<-gsub('date','date',widg.list)
    # widg.list<-gsub('dateR','dateR',widg.list)
    # widg.list<-gsub('num','num',widg.list)
    # widg.list<-gsub('text','text',widg.list)
    # widg.list<-gsub('textbox','textbox',widg.list)
  }
  if(length(widg.list)==0){
    widg.code<-'return(NULL)';
    input.names<-input.labs<-NA
  }else{
    if(F){
      widg.code<-paste0('uiOutput(\'',widg.list,'\')',collapse=',')
      widg.code<-paste0('return(conditionalPanel(condition=\'true\', div(',
                        widg.code,')))',collapse='')
    }else{
      widg.code<-paste0('uiOutput(\'',widg.list,'\')') #,collapse=','
      w.widg<-floor(12/ncol.widg)    #upto 4, column width
      nrow.widg<-ceiling(length(widg.code)/ncol.widg)#number of rows
      widg.code2<-NULL
      for(i in 1:nrow.widg){
        widg.code3<-NULL
        for(j in 1:ncol.widg){
          ij<-(i-1)*ncol.widg+j  
          if(ij <= length(widg.code)){
            wij<-paste0("column(", w.widg,", ", widg.code[ij], 
                        ", offset=", 0, ")") #max(w.widg*(j-1)-2,0)
            widg.code3<-paste0(c(widg.code3, wij), collapse=",")
          }
        }
        widg.code2<-c(widg.code2, paste0("fluidRow(", widg.code3, ")"))
      }
      widg.code<-paste0(widg.code2, collapse=',')
      widg.code<-paste0('return(conditionalPanel(condition=\'true\', div(',
                        widg.code,')))',collapse='')
    }
  }
  out1<-data.frame(code=widg.code,names=input.names,labs=input.labs)
  
  return(out1)
}

widgets.param<-function(uidic, wid, max.n){
  if(!wid %in% names(max.n)){
    return(NA)
  }else{
    temp<-lapply(setdiff(unique(uidic$Request.Name),NA),function(x){
      row_sel<-uidic$Request.Name==x
      ret<-unique(uidic[which(row_sel), grepl(wid,colnames(uidic))])
      ret$Request.Name<-x
      #dfnames is the widget name which default values not specified in CD
      wid2<-wid[!wid%in%c("num","text")]
      if(length(wid2)>0){
        dfnames<-c(paste0(wid2,'.default',c(max.n[wid2]:2, '')))
        dfnames<-dfnames[!dfnames%in%colnames(uidic)] 
        if (length(dfnames)>0){
          dfs<-matrix(NA,nrow=nrow(ret),ncol=length(dfnames))
          colnames(dfs)<-dfnames
          ret2<-data.frame(ret,dfs,row.names=NULL)
        }else{ ret2<-data.frame(ret,row.names=NULL)}
      }else{ ret2<-data.frame(ret,row.names=NULL)}
      #dfnames3 is the dropdown widget name which multiple not specified in CD
      wid3<-wid2[grepl("dropdown",wid2)]
      if(length(wid3)>0){
        dfnames3<-c(paste0(wid3,'.multiple',c(max.n[wid3]:2, '')))
        dfnames3<-dfnames3[!dfnames3%in%colnames(uidic)]
        if (length(dfnames3)>0){
          dfs<-matrix(NA,nrow=nrow(ret2),ncol=length(dfnames3))
          colnames(dfs)<-dfnames3
          ret3<-data.frame(ret2,dfs, row.names=NULL)
        }else{ ret3<-data.frame(ret2,row.names=NULL) }
      }else{ ret3<-data.frame(ret2,row.names=NULL) }
      return(ret3)
    })
    #convert the list object to data.frame
    ret0<-Reduce(function(x,y){unique(rbind(x,y))},temp)
    return(ret0)
  }
}



#-------------Functions for RTF output setup-------------#
if(TRUE){
  col_width <- function(tb){  #Function to Generate rtf table column widths
    cws <- NULL
    for(i in 1:length(names(tb))) {
      ncName <- nchar(names(tb)[i])
      ncString <- max(nchar(tb[,i]))
      nc <- max(ncName, ncString)
      cw <- nc*0.89/10                 # assume 10 characters per an inch
      cws <- c(cws, cw)
    }
    return(cws)
  }
  
  
  #--- convert factor to character colname
  convert_fac_to_char <- function(dat) {
    for(i in 1:ncol(dat)) {
      if(class(dat[, i]) == "factor")
        dat[, i] <- as.character(dat[, i])
      
    }
    return(dat)
  }
  
  .convert <- function (x) 
  {
    x <- gsub("\\n", " \\\\line ", x)
    x <- gsub("<=", "\\\\u8804\\\\3", x)
    x <- gsub(">=", "\\\\u8805\\\\3", x)
    x <- gsub("&gt;", ">", x)
    x <- gsub("&lt;", "<", x)
    x <- gsub("&Alpha;", "\\\\u0913\\\\3", x)
    x <- gsub("&Beta;", "\\\\u0914\\\\3", x)
    x <- gsub("&Gamma;", "\\\\u0915\\\\3", x)
    x <- gsub("&Delta;", "\\\\u0916\\\\3", x)
    x <- gsub("&Epsilon;", "\\\\u0917\\\\3", x)
    x <- gsub("&Zeta;", "\\\\u0918\\\\3", x)
    x <- gsub("&Eta;", "\\\\u0919\\\\3", x)
    x <- gsub("&Theta;", "\\\\u0920\\\\3", x)
    x <- gsub("&Iota;", "\\\\u0921\\\\3", x)
    x <- gsub("&Kappa;", "\\\\u0922\\\\3", x)
    x <- gsub("&Lambda;", "\\\\u0923\\\\3", x)
    x <- gsub("&Mu;", "\\\\u0924\\\\3", x)
    x <- gsub("&Nu;", "\\\\u0925\\\\3", x)
    x <- gsub("&Xi;", "\\\\u0926\\\\3", x)
    x <- gsub("&Omicron;", "\\\\u0927\\\\3", x)
    x <- gsub("&Pi;", "\\\\u0928\\\\3", x)
    x <- gsub("&Rho;", "\\\\u0929\\\\3", x)
    x <- gsub("&Sigma;", "\\\\u0931\\\\3", x)
    x <- gsub("&Tau;", "\\\\u0932\\\\3", x)
    x <- gsub("&Upsilon;", "\\\\u0933\\\\3", x)
    x <- gsub("&Phi;", "\\\\u0934\\\\3", x)
    x <- gsub("&Chi;", "\\\\u0935\\\\3", x)
    x <- gsub("&Psi;", "\\\\u0936\\\\3", x)
    x <- gsub("&Omega;", "\\\\u0937\\\\3", x)
    x <- gsub("&alpha;", "\\\\u0945\\\\3", x)
    x <- gsub("&beta;", "\\\\u0946\\\\3", x)
    x <- gsub("&gamma;", "\\\\u0947\\\\3", x)
    x <- gsub("&delta;", "\\\\u0948\\\\3", x)
    x <- gsub("&epsilon;", "\\\\u0949\\\\3", x)
    x <- gsub("&zeta;", "\\\\u0950\\\\3", x)
    x <- gsub("&eta;", "\\\\u0951\\\\3", x)
    x <- gsub("&theta;", "\\\\u0952\\\\3", x)
    x <- gsub("&iota;", "\\\\u0953\\\\3", x)
    x <- gsub("&kappa;", "\\\\u0954\\\\3", x)
    x <- gsub("&lambda;", "\\\\u0955\\\\3", x)
    x <- gsub("&mu;", "\\\\u0956\\\\3", x)
    x <- gsub("&nu;", "\\\\u0957\\\\3", x)
    x <- gsub("&xi;", "\\\\u0958\\\\3", x)
    x <- gsub("&omicron;", "\\\\u0959\\\\3", x)
    x <- gsub("&pi;", "\\\\u0960\\\\3", x)
    x <- gsub("&rho;", "\\\\u0961\\\\3", x)
    x <- gsub("&sigmaf;", "\\\\u0962\\\\3", x)
    x <- gsub("&sigma;", "\\\\u0963\\\\3", x)
    x <- gsub("&tau;", "\\\\u0964\\\\3", x)
    x <- gsub("&upsilon;", "\\\\u0965\\\\3", x)
    x <- gsub("&phi;", "\\\\u0966\\\\3", x)
    x <- gsub("&chi;", "\\\\u0967\\\\3", x)
    x <- gsub("&psi;", "\\\\u0968\\\\3", x)
    x <- gsub("&omega;", "\\\\u0969\\\\3", x)
    x <- gsub("TRUE", "Yes", x)
    x <- gsub("FALSE", "No", x)
    x
  }
  
  
  .get.space.before.after <- function (space.before = NULL, space.after = NULL) 
  {
    ret <- ""
    if (!is.null(space.before)) {
      ret <- paste(ret, "\\sb", (space.before * 1440), sep = "")
    }
    if (!is.null(space.after)) {
      ret <- paste(ret, "\\sa", (space.after * 1440), sep = "")
    }
    ret
  }
  
  
  .add.table.row <- function (col.data = c("c1", "c2", "c3"), 
                              col.widths = c(1, 4.5, 1), 
                              col.justify = NULL, font.size = 10, last.row = FALSE, 
                              indent = 0, border.top = FALSE, border.bottom = FALSE, space.before = NULL, 
                              space.after = NULL) 
  {
    header <- paste("\\trowd\\trgaph100\\trleft", indent, sep = "")
    if (length(col.data) != length(col.widths)) {
      stop(paste("The number of data columns (", length(col.data), 
                 ") doesn't match the column widths (", length(col.widths), 
                 ")!  Input data: ", col.data, sep = ""))
    }
    justify <- vector()
    justify["L"] <- "\\ql"
    justify["R"] <- "\\qr"
    justify["C"] <- "\\qc"
    justify["J"] <- "\\qj"
    justify.v <- rep(justify["L"], length(col.data))
    numeric.cols <- which(!is.na(suppressWarnings(as.numeric(col.data))))
    if (length(numeric.cols) > 0) {
      justify.v[numeric.cols] <- justify["R"]
    }
    if (!is.null(col.justify)) {
      if (length(col.justify) == 1) {
        if (col.justify %in% names(justify)) {
          justify.v <- rep(justify[col.justify], length(col.data))
        }
        else {
          stop(paste("col.justify parameter not recognized: ", 
                     col.justify, " (should be L, R, C, or J)", 
                     sep = ""))
        }
      }
      else if (length(col.justify) == length(col.data)) {
        justify.v <- justify[col.justify]
      }
      else {
        stop(paste("The number of data columns (", length(col.data), 
                   ") doesn't match the col.justify (", length(col.justify), 
                   ") parameter!  Input data: ", paste(col.data, 
                                                       sep = "", collapse = ", "), sep = ""))
      }
    }
    btop <- ""
    bbottom <- ""
    if (any(border.top))  #  
      btop <- sapply(border.top, ifelse, "\\clbrdrt\\brdrs\\brdrw15",'') # make border.top as a vector option
    if (last.row == TRUE | any(border.bottom))  # 
      bbottom <- sapply(border.bottom, ifelse, "\\clbrdrb\\brdrs\\brdrw15",'') #make border.bottom as a vector option
    cols.prefix <- paste("\\clvertalt\\clshdrawnil\\clwWidth", 
                         round(col.widths * 1440, 0), "\\clftsWidth3\\clheight260\\clpadl100\\clpadr100\\gaph", 
                         btop, bbottom, "\\cellx", c(1:length(col.widths)), "\n", 
                         sep = "", collapse = "")
    cols <- paste("\\pard", justify.v, .get.space.before.after(space.before, 
                                                               space.after), "\\widctlpar\\intbl\\fi0\\f2\\fs", font.size * 
                    2, " ", .convert(col.data), "\\cell\n", sep = "", collapse = "")
    end.row <- "\\widctlpar\\intbl\\row\n"
    paste(header, cols.prefix, cols, end.row, sep = "")
  }
  
  # add width basing on duplication
  adj.width <- function(x, cw, space=1){
    ret <- array(0, dim=dim(x))
    x2 <- x
    #dup <- t(apply(x,1, function(x) duplicated(x)& x!='')) 
    dup <- t(apply(x,1, function(x) c(FALSE, x[-1]==x[-length(x)])))		
    for (i in 1:nrow(x)) {
      for (j in ncol(x):1) {
        if (i > 1 & j <= ncol(x)) if (!dup[i-1,j]) dup[i,j] <- FALSE
        if (dup[i,j]) {
          ret[i,j-1] <- ret[i,j]+space*cw[j]
          ret[i,j  ] <-         -space*cw[j]		
          x2[i,j] <- ''		
        }		
      }
      ret[i,] <- ret[i,]+cw
    }
    list(x=x2, cw=ret)		
  }
  
  
  ###--- This one is added/modified a little bit from the original rtf.tab that Michael Man developed
  # It expanded the width for header or footnote
  rtf.tab <- function(dat,cw=NULL,titles,col.just=NULL,var.ul,prd.status='QA',footns='',header=FALSE,footer=FALSE,
                      nline.body=40, addSpaceHeader=0, addSpaceFoot=0, page.disp=TRUE,...) { # almost automated w/ modified .add.table.row		
    st <- attributes(dat)$'start cell'[1]
    hd <- 1:(st-1)
    if(is.null(cw)) cw <- c(1.5,rep(.7,ncol(dat)-1))
    if(is.null(col.just)) col.just <- rep('R', nrow(dat)) 
    if(is.null(dim(col.just))) col.just <- matrix(rep(col.just,ncol(dat)), nrow=nrow(dat), byrow=FALSE)
    x <- dat
    cw2 <- matrix(rep(cw, nrow(x)), ncol=ncol(x), byrow=TRUE)
    if (st > 2) {
      #undebug(adj.width)
      y <- adj.width(x=dat[hd,],cw=cw, space=1)
      x[hd,] <- y$x
      cw2[hd,] <- y$cw		
    } 
    
    #expr=expression({
    rtf.add.row <- function(rows=1:nrow(x)){
      ret <- "{\\pard\n"
      for (i in rows) if (i <= nrow(x)){
        sel <- which(cw2[i,]>0)
        ret <- paste(ret, 
                     .add.table.row(
                       col.data =     x[i,sel], 
                       col.widths = cw2[i,sel], 
                       col.justify = col.just[i,sel],
                       font.size = fs,
                       border.top = i %in% c(1), 
                       border.bottom = if (i > st-2) i %in% c(st-1,nrow(x),max(rows)) else x[i,sel] %in% var.ul
                     ),
                     sep='') 	
        if (i < st) if (!all(cw2[i,] == cw2[i+1,])) ret <- paste(ret,'{\\pard\\par}','', sep='')
      }	
      ret <- paste(ret, "}\n\n", sep = "")
      rtf$.rtf <- paste(rtf$.rtf, ret, sep='')				
    }
    #})
    
    rtf <- RTF(...)
    fs <- rtf$.font.size
    rtf$.rtf <- gsub('Times New Roman', 'Courier New', rtf$.rtf)	# make "Courier New" as default
    rtf$.rtf <- gsub('field{\\fldinst{page}}', '', rtf$.rtf, fixed=TRUE)	# delete page number
    #nline.body <- 2
    npage <- ceiling((nrow(x)-st+1)/nline.body)
    #addHeader(rtf,title=titles[[1]],subtitle=titles[[2]])
    #systems <- c('Page \\chpgn  of {\\field{\\*\\fldinst  NUMPAGES }}', 
    systems <- c(ifelse(page.disp==TRUE, paste('Page \\chpgn  of ', npage, sep=''), ""), 
                 format(Sys.time(), "%H:%M %d%b%Y"),
                 prd.status)
    #systems <- c(paste('Page \\chpgn  of ', npage, sep=''), 
    #             format(Sys.time(), "%H:%M %d%b%Y"),
    #             prd.status)
    hd.m <- c(paste(titles,  collapse='\\line '), 
              paste(systems, collapse='\\line '))  # main header									
    tmp <- .add.table.row(
      col.data =  hd.m, 
      col.widths = c(sum(cw)-2+addSpaceHeader,2), 
      col.justify = c('L', 'R'),
      font.size = fs)
    tmp2 <- .add.table.row(
      col.data =  paste(footns, collapse='\\line '), 
      col.widths = sum(cw)+addSpaceFoot, 
      col.justify = 'L',
      font.size = fs)							
    if (FALSE) rtf$.rtf <- paste(rtf$.rtf, "{\\header\\pard", "\\fi0\\f2\\fs", fs*2, 
                                 "\\qr Page \\chpgn  of {\\field{\\*\\fldinst  NUMPAGES }}\\par}", sep='')
    for (i in 1:npage){						
      rtf$.rtf <- paste(rtf$.rtf, ifelse(i==1,'','\\page'), '{\\pard\\par}', 
                        ifelse(header,'{\\header',''), tmp, 
                        ifelse(header,'}',''), '{\\pard\\par}', sep='')					
      #startParagraph(rtf)
      #eval(expr)
      rtf.add.row(rows=c(1:(st-1), 1:nline.body-1+st+nline.body*(i-1)))
      #endParagraph(rtf)		
      rtf$.rtf <- paste(rtf$.rtf, '{\\pard\\par}', ifelse(footer,'\\footer',''), tmp2, sep='')
    }	
    done(rtf)		
    
  }#end rtf.tab
  
  
  #--- produce to rtf file that as SAS output. It can be used for single table or table with multiple pages
  rtf_table_out_as_sas <- function(rtf, tb, cw=NULL, 
                                   colFormat=c(rep("L", 1), rep("C",1), rep("R",1)),
                                   cell1=2, cell2=1, nheader=1,
                                   varName=NULL,
                                   var.ul='', prd.status=' ', #'QA',
                                   titles="", footns="", 
                                   header=FALSE, footer=FALSE,
                                   nline.body=30, height=8.5, width=11, omi=c(1,1,1,1),
                                   addSpaceHeader=0, addSpaceFoot=0, page.disp=TRUE,
                                   ...) {
    
    # rtf: RTF object that is just needed to be declared once before calling the function
    # tb: table out
    # cw: column width
    # colFormat: alignment (left, center, or right) for each column
    # varName: variable name that want to be repeated when go to the next page
    # var.ul: pre-specified cell values that indicate the bottom line in a table
    # nline.body: number of lines per page
    # addSpaceFoot, addSpaceHeader: expand the width of header or footnotes
    # page.disp: whether diplay page number
    
    #--- generate blank pape (break page) if the data is more than a page
    if(nrow(tb) > nline.body) {
      idx <- seq(1, nrow(tb), by = nline.body)
      idx.n <- c(seq(nline.body, nrow(tb), by = nline.body), nrow(tb))
    }else {
      idx <- 1
      idx.n <- nrow(tb)
    }
    
    npage <- length(idx)
    
    for(k in 1:length(idx)) {
      subTable <- tb[idx[k]:idx.n[k], ]
      if(is.null(nrow(subTable))){
        subTable <- data.frame(` `=subTable)
      }
      #--- if nrow < nline.body, need adding some spaces to move footnotes to bottom of the page
      if(nrow(subTable) < nline.body) {
        addData <- data.frame(matrix("",ncol=ncol(subTable), nrow=nline.body-nrow(subTable)-1))
        names(addData) <- names(subTable)
        subTable <- rbind(subTable, addData)  
      }
      
      #-- get values that will be in the 1st row of next page
      rownames(subTable) <- 1:nrow(subTable)
      
      #-- check if the last row of previous page with varName not matched the 1st row of next page
      if(k==1)
        string.val <- NULL
      if(k!=1 & !all(unique(subTable[1,varName]) %in% "") & !all(unique(subTable[1,varName]) %in% string.val))
        string.val <- unique(subTable[1,varName])
      
      if(k==1 & all(tb[nrow(subTable)+1, varName] %in% "")) {
        for(m in 1:nrow(subTable)) 
          if(all(!subTable[m,varName] %in% ""))
            string.val <- subTable[m, varName]
      } else if(!all(tb[nrow(subTable)+1, varName] %in% "")) {
        string.val <- NULL
      } else {   
        #-- add last row of previous page to 1st row of next page    
        if(!is.null(string.val))
          subTable[1, varName] <- string.val
        
        for(m in 1:nrow(subTable)) 
          if(all(!subTable[m,varName] %in% ""))
            string.val <- subTable[m, varName] 
      }
      
      hd <- sapply(colnames(subTable), function(x) strsplit(x, '; ')[[1]])
      ret <- rbind(hd, as.matrix(subTable))
      colnames(ret) <- 1:ncol(ret)            
      rownames(ret) <- 1:nrow(ret)
      
      ret2 <- ret
      
      colnames(ret2) <- 1:ncol(ret2)            
      rownames(ret2) <- 1:nrow(ret2)
      attributes(ret2) <- list(dim = dim(ret2), dimnames = dimnames(ret2), `start cell` = c(cell1, cell2))
      
      col.just <- matrix(c(rep(colFormat, nrow(ret2) + nheader)), ncol=ncol(ret2), byrow=TRUE)
      
      dat <- ret2
      st <- attributes(dat)$'start cell'[1]
      hd <- 1:(st-1)
      if(is.null(cw)) cw <- c(2.5, rep(1.5,ncol(dat)-1))
      x <- dat
      cw2 <- matrix(rep(cw, nrow(x)), ncol=ncol(x), byrow=TRUE)
      if (st > 2) {
        y <- adj.width(x=dat[hd,],cw=cw, space=1)
        x[hd,] <- y$x
        cw2[hd,] <- y$cw    
      } 
      
      rtf.add.row <- function(rows=1:nrow(x)){
        ret <- "{\\pard\n"
        for (i in rows) if (i <= nrow(x)){
          sel <- which(cw2[i,]>0)
          ret <- paste(ret, 
                       .add.table.row(
                         col.data =     x[i,sel], 
                         col.widths = cw2[i,sel], 
                         col.justify = col.just[i,sel],
                         font.size = fs,
                         border.top = i %in% c(1), 
                         border.bottom = if (i > st-2) i %in% c(st-1,nrow(x),max(rows)) else x[i,sel] %in% var.ul
                         #x is the subtable with header
                       ),  sep='') 
          if (i < st) if (!all(cw2[i,] == cw2[i+1,])) ret <- paste(ret,'{\\pard\\par}','', sep='')
        }
        ret <- paste(ret, "}\n\n", sep = "")
        rtf$.rtf <- paste(rtf$.rtf, ret, sep='')
      }
      
      rtf <- rtf
      fs <- rtf$.font.size
      rtf$.rtf <- gsub('Times New Roman', 'Courier New', rtf$.rtf)	# make "Courier New" as default
      rtf$.rtf <- gsub('field{\\fldinst{page}}', '', rtf$.rtf, fixed=TRUE)	# delete page number
      
      tmp2 <- .add.table.row(
        col.data =  paste(footns, collapse='\\line '), 
        col.widths = sum(cw)+addSpaceFoot, 
        col.justify = 'L',
        font.size = fs)	
      rtf.add.row(rows=c(1:(st-1), 1:nline.body-1+st))	
      rtf$.rtf <- paste(rtf$.rtf, '{\\pard\\par}', ifelse(footer,'\\footer',''), tmp2, sep='')
    } #end of the for loop	
    return(rtf)
  }#end rtf_table_out_as_sas  
  
  
}





#-------------Manually Convert R object into HTML code-------------#
df2html<-function( #convert a table into part of HTML code
  datF, #a data.frame for table output
  tabTit="",  #table title
  fnote=NULL,  #footnote
  ind=1
){
  datF<-as.data.frame(datF)
  dim1<-dim(datF)
  nr<-dim1[1]
  nc<-dim1[2]
  cnm<-colnames(datF)
  rnm<-rownames(datF) #currently the rownames would not be printed out.  
  out<-paste0('<a name=\"IDX',ind,'\"></a>')
  out<-c(out, '<div align=\"left\">')
  tabSum2<-paste0('<table class=\"Table\" cellspacing=\"1\" cellpadding=\"',
                  nc+2, '\" rules=\"groups\" frame=\"box\" border=\"1\" bordercolor=\"#000000\" ',
                  'summary=\"', tabTit, '\" >')  #style="table-layout: fixed; width: 100%"
  out<-c(out, tabSum2, '<colgroup>', rep('<col>',nc), '</colgroup>', '<thead>')
  #For table header
  tabHead<-c('<tr>', paste0('<td class="l NoteContent" colspan=\"', nc,
                            '\">', tabTit, '<br>', paste(rep("-",138),collapse=''), '</td>'), '</tr>', '<tr>')
  for(i in 1:nc){
    tabHead<-c(tabHead, paste0('<th class=\"c b Header\" scope=\"col\">',
                               cnm[i], '</th>'))
  }
  out<-c(out, tabHead, '</tr>', '</thead>', '<tbody>')
  #for table body
  tabBody<-NULL
  for(j in 1:nr){
    tabBody<-c(tabBody, '<tr>')
    for(i in 1:nc){
      tabBody<-c(tabBody, paste0('<td class=\"l Data\">', datF[j,i], '</td>'))
    }
    tabBody<-c(tabBody, '</tr>')
  }
  out<-c(out, tabBody, '</tbody>', '<tfoot>', '<tr>')
  out<-c(out, paste0('<td class=\"l NoteContent\" colspan=\"',nc,'\">',
                     paste(rep("-",138),collapse=''), '<br>', fnote, '</td>'), '</tr>', '</tfoot>')
  out<-c(out, '</table>', '</div>', 
         '<p style="page-break-after: always;"><br></p><hr size="3">')
  return(out)  
}

fig2html<-function( #convert a png figure into part of HTML code
  figNm='plot.png', # the png file name
  figTit="", #figure title
  figH="480", figW="640",
  fnote=NULL,  #footnote
  ind=1
){
  out<-paste0('<a name=\"IDX',ind,'\"></a>')
  figTit1<-c('<div align=\"left\">', 
             paste0('<table class=\"Table\" cellspacing=\"1\" cellpadding=\"1',
                    '\" rules=\"groups\" frame=\"box\" border=\"1\" bordercolor=\"#000000\" ',
                    'summary=\"', figTit, '\" >'), '<colgroup>','<col>', '</colgroup>',
             '<thead>', '<tr>' ) 
  out<-c(out, figTit1, paste0('<td class=\"l NoteContent\" colspan=\"1\">', 
                              figTit,  '</td>'), '</tr>', '</thead>', '<tbody>', '<tr>' )
  out<-c(out, '<td>', paste0('<img alt=\" \" src=\"', figNm,
                             '\" style=\" height: ', figH, 'px; width: ', figW, 
                             'px;\"  border=\"0\">'), '</td>', '</tr>', '</tbody>','<tfoot>','<tr>')
  out<-c(out, paste0('<td class=\"l NoteContent\" colspan=\"1\">',fnote,
                     '</td>'), '</tr>', '</tfoot>')
  out<-c(out, '</table>', '</div>',
         '<p style="page-break-after: always;"><br></p><hr size="3">')
  return(out)  
  
}

cLink<-function( #generate a link in content table
  tit="tmplink", ind=1
){
  out<-'<li class=\"ContentItem\">'
  out<-c(out, '<span><b>&#183;</b><a href=\"',
         paste0('body.htm#IDX', ind,'\" target=\"body\">',tit,'</a>'),
         '</span><br></li>')
  return(out)
}


#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
#revise a html table code
#make it into multi-level header
toMultH <- function(
  tbc, # a vector of html table code
  split1=";"   #the string character spliting the header             
){
  wh.h <- grep('<th>', tbc)
  if(length(wh.h)>1){return(tbc)}
  tbc.h <- tbc[1:(wh.h-1)]
  if(wh.h==length(tbc)){return(tbc)}
  tbc.b <- tbc[(wh.h+1):length(tbc)]
  hh <- tbc[wh.h]
  hh <- gsub("<th>", "", hh, fixed=TRUE)
  hh <- gsub("<tr>", "", hh, fixed=TRUE)
  hh <- gsub("</tr>", "", hh, fixed=TRUE)
  hh <- strsplit(hh, split="</th>")[[1]]
  hh <- hh[-length(hh)] #remove the last empty element
  hh <- strsplit(hh, split=split1, fixed=TRUE)
  
  hh.l <- sapply(hh, length)
  short <- hh.l<max(hh.l)
  hh[short] <- lapply(hh[short], function(x){
    c(x, rep(" ", max(hh.l)-length(x)))})
  
  hh3 <-matrix(unlist(hh), nrow=max(hh.l))
  hh3 <- apply(hh3, 1, function(x){
    r1 <- "<tr> <th colspan=\'"
    colspan <- 1
    if(length(x)>1){
      for(i in 1:(length(x)-1)){#requre ncol for the table is 2+
        if( gsub(" ", "", x[i])==gsub(" ", "", x[i+1])){
          colspan <- colspan + 1
        }else {
          r1 <- paste(r1, colspan, "\'>", x[i], "</th> <th colspan=\'")
          colspan <- 1
        }
      }
    }
    r1 <- paste(r1, colspan, "\'>", x[length(x)], "</th> </tr>'")
    return(r1)
    #<th colspan='2'>      
  })
  return(c(tbc.h, hh3, tbc.b))
  
}

if(TRUE){#header
  #*****************************************************************************
  #Eli Lilly and Company - GLOBAL STATISTICAL SCIENCES - PROGRAM
  #CODE NAME (required)                : nzi_source.r
  #PROJECT NAME (required)             : Near-Zero-Informed Bayesian (NZIB)
  #STUDY NUMBER                        : 
  #DESCRIPTION (required)              : 
  #SPECIFICATIONS(optional)            : 
  #VALIDATION TYPE (required)          : 
  #INDEPENDENT REPLICATION (optional)  : 
  #ORIGINAL CODE (required)            : 
  #EXTERNAL CODE FILES THAT ARE NO 
  #RE-USEABLE CODE MODULES             : 
  #SOFTWARE/VERSION# (required)        : R Version 3.2.0
  #INFRASTRUCTURE                      : R studio server
  #DATA INPUT location                 : 
  #SDD: 
  #                                    
  #OUTPUT location: 
  #
  #
  #R SCRIPT location
  #
  #
  #-----------------------------------------------------------------------------
  #     #Author                 Code History Description             Date Change
  #---- ------------       ---------------------------------------  ---------
  #1.0  Danni Yu                Initial Code created                 01/21/2020
  #2.0  Danni Yu                Last Revision                        06/12/2020
  #3.0  Michelle Carlsen        Peer Review Validation               06/12/2020
  #*****************************************************************************
}
# rm(list=ls())

#program name, track_info
if(TRUE){
  progfile<-'nzi_source.r'
}

#soure functions for NZI Bayesians
if(TRUE){
  library(ggplot2)
  library(gridExtra)
  library(ggrepel)
  library(extraDistr)
  library(cowplot)
  
  #----------------------------------------------------------------------------#
  #### Recommend the maximum P_a is at least ... #####
  recPa <- function(n, dp=6){
    if(is.null(n)){return("0.2")}
    if(is.character(n)){n<-round(as.numeric(n))}
    if(is.na(n)){return("0.2")}
    # p0<-1/n
    # rp<-p0+sqrt(p0*(1-p0)/n)
    rp<-1/n
    for(i in 2:dp){
      rPa<-round(rp, i)
      if(rPa>0) break
    }
    if(i==dp & rPa==0){
      rPa<-as.numeric(paste0('0.',paste(rep(0,dp-1), collapse=''),'1'))
    }
    rPa<-min(rPa,1)
    return(rPa)
  }
  
  
  #----------------------------------------------------------------------------#
  #### Re-set the structure of output #####
  mytab<-function(ttb, ttb.th=0.99){
    colnames(ttb) <- NULL
    rownames(ttb) <- c("Number of Events", #x
                       "Event Rate",        #orr
                       "Superiority", #csr
                       "FPR (type I)", 
                       "FNR (type II)")
    if(all(!is.na(ttb[3,]))){
      return( ttb[,(ttb[3,]<=ttb.th)] )
    }else{return( ttb ) }
  }
  
  
  #----------------------------------------------------------------------------#
  # simulation to estimate the chance of >=1 occurance in N subjects
  # Bayesian approach: 
  nzi_Bayes_sim<-function(
    B=5000, #simulation size 
    N=45,    #sample size
    #p0=NULL,  #a referral rate
    p=0.02,  #a referral rate
    bet=1, a1=NULL #the parameters in Beta distribution
    #plot.p=T, xL=NULL, yL=NULL, bkn=10
  ){
    set.seed(1234567)
    
    if((is.null(p) & is.null(a1))|(is.null(bet))){return(NULL)}
    if(is.null(a1)&!is.null(p)&!is.na(bet)){a1<-p*bet/(1-p)}
    if(!is.null(a1)&is.null(p)&!is.na(bet)){p<-a1/(a1+bet)}

    #using excact probablities for risk estimates
    #upper tail probability in the beta-binomial distribution
    tot.m<-sapply(0:N, s.pbb, n=N, a=a1, b=bet)
    names(tot.m)<-paste0('P[Y>=', 0:N, ']')
    
    #simulate number of events
    if(!is.null(p)){
      tab <- sapply(1:N, function(x, n=N){
        orr <- round(x/n,3) #occurence rate
        csf <- round(1-pbeta(p, a1+x, bet+n-x),3)#under Beta distb only
        #--- Bayesian p-value type I: approx. Pr( X>= Obs_Incidence x |n, pp1)
        pp<-rbeta(B, a1+x, bet+n-x)#randomly generate true rates from Beta distb
        pp1<-pp[pp<=p]; 
        if(length(pp1)==0) {
          pp1<-NA #the true rates < or = bkgrd 
          prob.fp <- 0
        }else{ prob.fp <- round(mean(1-pbinom(x-1, n, pp1)), 3) }
        #--- type II: approx. Pr( X < Obs_Incidence x |n, pp2)
        # pp<-rbeta(B, a1, bet)#randomly generate true rates from Beta distb
        pp2<-pp[pp>p];  
        if(length(pp2)==0){
          pp2<-NA #the true rates > bkgrd
          prob.fn <- 1
        }else{ prob.fn <- round(mean(pbinom(x-1, n, pp2)), 3) }
        return(c(x,orr,csf,prob.fp,prob.fn))
      })
      mtt<-mytab(tab, 1.1) 
    }else{mtt<-NULL}
    
    return(list(risk=tot.m[-1], mytab=mtt))
  }

  
  #----------------------------------------------------------------------------#
  # simulation to estimate the chance of >=1 occurance in N
  # Frequentist approach: Binomial distribution
  binom_sim<-function( 
    N=45,     #sample size
    p0=NULL,  #a referral rate
    p=0.02,   #the higher alternative rate or maximumly acceptable rate
    getPlot=F, getPnt=F, getPnt.col='black', getPnt.lty=1,
    out='pp'  #or 'mytab'
  ){
    set.seed(1234567)
    
    if(is.null(p))return(NULL)
    
    o<-1:N #number of events
    
    #simulate number of events
    if(!is.null(p0)){
      tab <- sapply(o, function(x, n=N){
        orr <- round(x/n,3)
        csf <- NA
        prob.fp <- round(1-pbinom(x-1, n, p0), 3)
        prob.fn <- round(pbinom(x-1, n, p), 3) 
        return(c(x,orr,csf,prob.fp,prob.fn))
      })
      mtt<-mytab(tab) 
    }else{mtt<-NULL}
    
    #probability of observing at least #events: P(X>=x)
    if(!is.null(p0)&is.numeric(p0)){
      prob0<-pbinom(o-1, N, p0, lower.tail=F) #P(Y>=y)
      proba<-pbinom(o-1, N, p, lower.tail=F)
      pp<-rbind(prob0, proba)
      colnames(pp)<-o
      rownames(pp)<-paste0('p=', c(p0, p))
      if(getPlot){
        plot(prob0~o, type='l', xlim=c(0,9), ylim=c(0,0.6),
             ylab='Chance observing >= #events', 
             xlab='#events')
        points(proba~o, type='l', col=getPnt.col, lty=getPnt.lty)
        legend('topright', bty='n', legend=paste0(c('p0=','p='), c(p0, p)),
               lty=c(1,2), col=c('black', 'blue'), text.col=c('black', 'blue'))
      }
    }else{
      proba<-pbinom(o-1, N, p, lower.tail=F) #P(Y>=y)
      pp<-proba
      names(pp)<-o
      if(getPlot){
        plot(proba~o, type='l',  col='blue', lty=2)
      }
      if(getPnt){
        points(proba~o, type='l',  col='blue', lty=2)
      }
    }
    return(list(postP=pp, mytab=mtt))
  }
  
  
  #----------------------------------------------------------------------------#
  #check and plot NZI Beta distribution
  fbet<-function(bet, B=5000, p0=0.01, alp=NULL, xlim1=c(0,0.1),
                 ylim1=NULL, is.plot=F, ... ){
    if(is.null(alp)) alp<-p0*bet/(1-p0)
    ss<-rbeta(B, shape1=alp, shape2=bet) 
    if(is.plot){
      hist(ss, freq=F, ylim=ylim1, 
           xlim=xlim1, 
           main=paste0('p=', p0, ', beta=', bet), ...)
    }
    print(c(mean(ss), alp/(alp+bet)))
    oo<-density(ss, from=0, to=1)
    oo$y[oo$y<=0]<-min(oo$y[oo$y>0])
    return(oo)
  }
  #function to generate density values from the prior Beta distribution
  s.dbeta<-function(p,a,b){
    d<-dbeta(p,a,b)
    return(d)
  }
  #function to generate density values from the BetaBinomial distribution
  s.dbb<-function(x, n, a,b){
    d<- extraDistr::dbbinom(x, n, a, b)
    return(d)
  }
  #function to generate upper tail probability in the beta-binomial distribution
  s.pbb<-function(x, n, a,b){
    #P[X>=x]
    pp<- extraDistr::pbbinom(x, n, a, b, FALSE) +
      extraDistr::dbbinom(x, n, a, b)
    return(pp)
  }
  
  
  #----------------------------------------------------------------------------#
  #visualize the prior Beta distribution and the Beta-Binomial distribution
  bbin<-function(
    prior.a="0.5,1,", #parameters in p~Beta(a=, b=) prior distribution
    prior.b="0.5,1",  #parameters in p~Beta(a=, b=) prior distribution
    N11=30,         #planned sample size
    pa=0.2,         #expected average for event rate p
    p.xL='',        #xlim for beta distribution
    x.xL='',        #xlim for beta-binomial distribution
    showBinom=T,    #whether show Biomial distribution in the plot
    drawPlot=TRUE   #if F, only return the ggplot object for predictive distb
  ){
    #clean up paramters
    c2v<-function(ll){as.numeric(unlist(strsplit(ll, split=',', fixed=T)))}
    if(is.character(prior.a)){a<-c2v(prior.a)}else{a<-prior.a}
    if(is.character(prior.b)){b<-c2v(prior.b)}else{b<-prior.b}
    if(is.character(p.xL)){xL.p<-c2v(p.xL)}
    if(is.character(x.xL)){xL.x<-c2v(x.xL)}
    if(is.character(pa)){pa<-as.numeric(pa)}
    if(is.character(N11)){N11<-round(as.numeric(N11))}
    if(length(a)!=length(b)){
      num<-min(length(a), length(b))
      a<-a[1:num]; b<-b[1:num];
    }else{num<-length(a)}
    col2<-rep(c('red', 'purple','magenta','pink', 'brown','valet'),
              each=4)
    col3<-c('black','blue')
    lin2<-rep(3:6,len=length(col2))
    lin3<-1:2;
    
    #function to set x-axis limit
    xyL0<-function(pp, xl){
      if(is.numeric(xl) & length(xl)==2) pp<-pp+ xlim(xl)
      return(pp)
    }
    
    #generate prior distribution
    x1<-0:N11  #use exact probability instead of simulations
    u1<-x1/N11
    ppL<-list() 
    
    legLab1<-legLab2<-NULL #used for math expression in legend
    if(num>0){
      for(i in 1:num){
        #get density values
        ppL[[i]]<- data.frame(p=u1, x=x1,
                              d=s.dbeta(u1, a[i],  b[i]),
                              dx=s.dbb(x1, N11,a[i], b[i]),
                        model=paste0('Beta(a=',a[i],', b=',b[i],')'))
        legLab1<-c(legLab1, #to show math experriosn in legend
                   bquote(paste("Beta(", alpha, "=", .(a[i]),
                                ", ", beta, "=", .(b[i]),')')))
        legLab2<-c(legLab2, 
                   bquote(paste("BetaB(n=", .(N11), ", ", alpha, "=", .(a[i]),
                                ", ", beta, "=", .(b[i]),')')))
      }
      pp <- do.call(rbind, ppL)
    }else{pp<-NULL}
    col1<-rep(col2, len=num); lin1<-rep(lin2, len=num)
    
    #set NZI lable
    model.nzi1<-paste0("NZI Beta(mu=", pa,")")
    
    #combine 3 model data 
    if(is.numeric(pa) && !is.na(pa)){
      tm0<-data.frame(p=u1, x=x1,
                      d=s.dbeta(u1, pa/(1-pa), 1),
                      dx=s.dbb(x1, N11, pa/(1-pa), 1),
                      model=model.nzi1 )
      pp <- rbind(tm0, pp)
      legLab1<-c(bquote(paste("NZI Beta(", mu, "=", .(pa), ")")), legLab1)
      legLab2<-c(bquote(paste("NZIB(n=", .(N11),", ", mu,"=", .(pa), ")")),legLab2)
      col1<-c(col3[1], col1)
      lin1<-c(lin3[1], lin1)
      if(showBinom){
        tm<-data.frame(p=rep(pa,length(x1)), x=x1, d=rep(1, length(x1)),
                       dx=dbinom(x1, N11, pa),
                       model=paste('Binomial(n=',N11,', p=',pa, ')'))
        pp2<-rbind(pp, tm)
        legLab2<-c(legLab2, 
                   bquote(paste('Binomial(n=',.(N11),', p=', .(pa), ')')))
        col1<-c(col1, col3[2])
        lin1<-c(lin1, lin3[2])
      }else{pp2<-pp}
    }else{pp2<-pp}
    
    #generate beta-binomial distribution
    pp2$model<-gsub('NZI Beta(', paste0('NZIB(n=',N11, ', '), pp2$model, fixed=TRUE)
    pp2$model<-gsub('Beta(', paste0('BetaB(n=',N11, ', '), pp2$model, fixed=TRUE)
    pp2$model<-factor(pp2$model, levels=unique(pp2$model))
    pp$model<-factor(pp$model, levels=unique(pp$model))
    
    #clean data for predictive distribution
    pp2<-unique(pp2[,c('x','dx','model')])
  
    #generate distribution plot for prior Beta
    p1<-ggplot(pp, aes(x=p, y=d, group=model,color=model, linetype=model)) + 
      geom_line() + ylab('Density') + 
      theme_bw() + ggtitle('Prior distribution') +
      xlab('p') + 
      scale_color_manual(values=col1, labels=legLab1)+
      scale_linetype_manual(values=lin1, labels=legLab1)
    p1<-xyL0(p1, xL.p)
  
    if(drawPlot){
      #generate distribution plot for Beta-Binomial
      p2<-ggplot(pp2, aes(x=x, y=dx, group=model,color=model, linetype=model)) + 
        geom_line() + ylab('Probability') + 
        theme_bw() + ggtitle('Predictive distribution of events') +
        xlab('n: number of events') + 
        scale_color_manual(values=col1, labels=legLab2)+
        scale_linetype_manual(values=lin1, labels=legLab2)
      p2<-xyL0(p2, xL.x)
      grid.arrange(grobs=list(p1, p2), nrow=1, widths=c(1, 1.1))
    }else{
      #generate distribution plot for Beta-Binomial
      p2<-ggplot(pp2, aes(x=x, y=dx, group=model,color=model, linetype=model)) + 
        geom_line() + 
        theme_bw() + ggtitle('Predictive distribution') +
        scale_color_manual(values=col1, labels=legLab2)+
        scale_linetype_manual(values=lin1, labels=legLab2)
      p2<-xyL0(p2, xL.x) 
      
      return(list(data=pp2, plot=p2))
    }
  }
  
  #----------------------------------------------------------------------------#
  #All-in-one function for NIZB analysis
  nzib <- function( stopAt=NULL, #number of ADR for stopping rule
    N1=45,         #max number of samples
    maxIDR=0.0051, #max expected acceptable occurrence rate
    normIDR=NULL,  #normal occurrence rate, default maxIDR/2 
    plot.type=1,   #1. NZIB; 2. NZIB, Binomial; 3.NZIB, Bayesian; 4.all 3 lines
    bay.prior="c(alpha=0.05, beta=0.8)", #hyper parameter in beta-binomial
    col1=c("black",'red', 'blue'),     #line colors in graph
    rsk.xlim=NULL,    #x-axis range for risk plot
    rsk.ylim=NULL,    #y-axis range for risk plot
    errI.xlim=c(0,5), #x-axis range for type I error plot
    errI.ylim=NULL,   #y-axis range for type I error plot
    errII.xlim=NULL,  #x-axis range for type II error plot
    errII.ylim=NULL,  #y-axis range for type II error plot
    sup.xlim=NULL,    #x-axis range for superiority plot, default=errI.xlim
    sup.ylim=NULL,    #y-axis range for superiority plot
    B1=5000,           #number of simulations
    plot4=FALSE,       #show 4 plots
    goTh="0.05, 0.2", #go/no-go thresholds for type I and type II errors
    noplot=F           #don't create any plot if T
  ){
    #set prior according to plot type
    if(plot.type%in%c(1,2)){bay.prior<-NULL}
    if(plot.type%in%c(2,4)){showbm<-T}else{showbm<-F}
    
    #clean up parameters
    if(is.null(goTh)){
      goTh<-c(0.05, 0.2)
    }else{
      goTh<-as.numeric(strsplit(as.character(goTh), split=',', fixed=T)[[1]])
    }
    if(length(goTh[!is.na(goTh)])<2){goTh<-c(0.05, 0.2)}
    
    if(is.character(B1)){B1<-max(1000, round(as.numeric(B1)))}
    if(is.null(B1)|is.na(B1)){B1<-5000}
    if(is.character(N1)){N1<-max(3, round(as.numeric(N1)))}
    if(!is.null(stopAt) & !is.numeric(stopAt)){
      stopAt<-gsub(' ', '', stopAt, fixed=T)
      if(stopAt!=''){
        stopAt<-unlist(strsplit(as.character(stopAt), split=',', fixed=T))
        stopAt<-as.numeric(stopAt)
        stopAt<-stopAt[!is.na(stopAt)]
        if(length(stopAt)>0){
          stopAt<-pmin(pmax(0, round(stopAt)),N1) #lowest bound
        }
      }
    }
    if(is.character(maxIDR)){maxIDR<-max(min(as.numeric(maxIDR),1),0)}
    if(is.character(normIDR)){normIDR<-max(min(as.numeric(normIDR),maxIDR),0)}
    c2v<-function(xx){
      if(is.character(xx)){xx<-eval(parse(text=paste0('c(',xx,')')))}
      return(xx)
    }
    bay.prior<-c2v(bay.prior)
    rsk.xlim<-c2v(rsk.xlim)
    rsk.ylim<-c2v(rsk.ylim)
    errI.xlim<-c2v(errI.xlim)
    errI.ylim<-c2v(errI.ylim)
    errII.xlim<-c2v(errII.xlim)
    errII.ylim<-c2v(errII.ylim)
    sup.xlim<-c2v(sup.xlim)
    sup.ylim<-c2v(sup.ylim)

    #get stop reference relying number of ADR events
    if(!is.null(stopAt)&is.numeric(stopAt)&length(stopAt)>0){
      sa <- round(stopAt) #require an integer
      saLab<-paste(sa, collapse=',')
    }else{sa<-NULL; saLab<-NULL}
    
    #set default for normIDR
    if(is.null(normIDR)){normIDR <- maxIDR/2}
    
    #get normal expected rate 
    if(plot.type%in%c(1,3)){
      tP1<-NULL
    }else{tP1<-maxIDR}
    
    #order Bayesian hyper parameters
    bay.prior.nm<-c('alpha','beta')
    if(all(bay.prior.nm%in%names(bay.prior))){
      bay.prior<-bay.prior[bay.prior.nm]
    }
    
    #label the methods
    mNm<-c('NZI Bayesian', 'Bayesian', 'Binomial')
    #colors
    if(plot.type==2 & length(col1)>2){
      lab2<-col1[c(1,3)]; lin2<-c(1,3)
    }else{ lab2<-col1; lin2<-1:3 }
    
    #get type I/II errors (p-value and 1-power)  for 
    b.eg<-eb.eg<-NULL
    #: classic binomial
    if(plot.type%in%c(2,4)){
      b.eg<-binom_sim(N=N1, p0=normIDR, p=maxIDR)
    }
    #: Bayesian
    if(plot.type%in%c(3,4)){
      eb.eg<-nzi_Bayes_sim(B=B1, N=N1,a1=bay.prior[1], bet=bay.prior[2])
    }
    #: NZI Bayesian
    nzi.eg<-nzi_Bayes_sim(B=B1, N=N1, p=maxIDR)
    
    #adjust by plot type
    if(plot.type==4){#show all 3 lines
      eg<-list(nzi.eg, eb.eg, b.eg)
      names(eg)<-mNM0<-mNm
    }else if(plot.type==3){#show lines for Bayesian and NZIB
      eg<-list(nzi.eg, eb.eg)
      names(eg)<-mNM0<-mNm[1:2]
    }else if(plot.type==2){#show lines for binomial and NZIB
      eg<-list(nzi.eg, b.eg)
      names(eg)<-mNM0<-mNm[c(1,3)]
    }else{
      eg<-list(nzi.eg)
      names(eg)<-mNM0<-mNm[1]
    }
    
    #compare type I / II errors
    set.errs<-function(egL=eg){
      numEvts<-fpr<-fnr<-sup<-grp<-NULL
      for(i in 1:length(egL)){
        numEvts<-c(numEvts, egL[[i]]$mytab[1,]) 
        fpr<-c(fpr, egL[[i]]$mytab[4,]) 
        fnr<-c(fnr, egL[[i]]$mytab[5,])
        sup<-c(sup, egL[[i]]$mytab[3,])
        grp<-c(grp, rep(names(egL)[i], ncol(egL[[i]]$mytab)))
      }
      ors<- data.frame( numEvts, fpr, fnr, sup, grp )
      ors$sen<-1-ors$fpr;  
      ors$pwr<-1-ors$fnr
      ors$grp <- factor(ors$grp, levels=names(egL))
      return(ors)
    }
    errs<-set.errs(eg)
    errs.2<-errs[order(errs$grp, errs$numEvts),]
    errs.3<-errs[!is.na(errs$sup),]

    #internal functions for adding stopping thresholds into plot
    xyL<-function(pp, xl, yl, ssa, myLabel, leg='yes'){
      if(is.numeric(xl) & length(xl)==2) pp<-pp+ xlim(xl)
      if(is.numeric(yl) & length(yl)==2) pp<-pp+ ylim(yl)
      if(!is.null(ssa)){
        pp<-pp+ geom_vline(xintercept=ssa,colour='darkgreen', linetype=2)
        pp<-pp+geom_text_repel( data=myLabel[myLabel$numEvts%in%ssa,],
                       aes(label = mylab),
                       box.padding = unit(0.35, "lines"),
                       point.padding = unit(0.3, "lines"),
                       show.legend = FALSE)
      }
      if(leg=='no'){pp<-pp+theme(legend.position='none')}
      
      return(pp)
    }
    
    #1. get risk estimation
    #biomial
    b.rsk <- b.eg$postP
    if(is.matrix(b.rsk)) b.rsk<-b.rsk[paste0('p=',maxIDR),]
    #Bayesian
    eb.rsk <- eb.eg$risk
    #NZIB
    nzi.rsk <- nzi.eg$risk
    #integrate results
    rsko<-cbind(b.rsk, eb.rsk, nzi.rsk)
    rsko<-data.frame(at_least_number_ADR=rownames(rsko), rsko)
    colnames(rsko)[-1]<- paste('risk under', mNM0)
    getid<-function(n1){if(n1<=0){return(NULL)}else{1:n1}}
    rsk<-data.frame(
      numEvts=c(getid(length(b.rsk)), getid(length(eb.rsk)), 
                getid(length(nzi.rsk))),
      risk=c(b.rsk, eb.rsk, nzi.rsk),
      grp=c(rep(mNm[3], length(b.rsk)),
            rep(mNm[2], length(eb.rsk)),
            rep(mNm[1], length(nzi.rsk)) ) )
    rsk$grp <- factor(rsk$grp, levels=mNM0)
    rsk$mylab<-as.character(round(rsk$risk, 3))
    
    if(is.na(normIDR)|plot.type%in%c(1,3)){
      p0lab<-bquote(paste("P(wrong stop | p"<="", .(maxIDR), ", #ADR)"))
    }else{
      p0lab<-bquote(paste("P(wrong stop | p"<="", .(maxIDR), ", #ADR)"))
                           #", ", p[0], '=', .(normIDR), ")" ))
    }
    
    #1. risk plot
    p1<-ggplot(data=rsk, aes(x=numEvts, y=risk, color=grp, linetype=grp)) + 
      geom_line() + theme_bw() + theme(plot.title = element_text(size = 11)) +
      ggtitle(bquote(paste("Prior study risk profile, ",
                           p[a], '=', .(maxIDR)))) +
      xlab("#ADR") + 
      ylab(expression(paste("Predictive P(Y">="#ADR)"))) +
      scale_linetype('') + scale_colour_manual('', values=lab2) 
    p1<-xyL(pp=p1, xl=rsk.xlim, yl=rsk.ylim, ssa=sa, myLabel=rsk, leg='no')
    
    #2. Bayesian p-value Prob(type I)
    errs.2$mylab<-as.character(round(errs.2$fpr, 3))
    p2<-ggplot(data=errs.2, aes(x=numEvts, y=fpr, color=grp, linetype=grp)) + 
      geom_hline(yintercept=goTh[1], color='tan3') +
      geom_line() + theme_bw() + theme(plot.title = element_text(size = 11))+
      ggtitle(p0lab) + 
      scale_colour_manual( values=lab2) +
       ylab('p-value')  
    if(is.null(saLab)){ p2<- p2 + xlab("#ADR")
    }else{ p2<- p2+xlab(bquote(paste("if stopping at #ADR=", .(saLab)))) }  

    p2<-xyL(pp=p2, xl=errI.xlim, yl=errI.ylim, ssa=sa, myLabel=errs.2,
              leg='no') # + labs(colour='For A-E', linetype='For A-E')
      
      #3. power. note: keep obj name fnr but it actually means power 1-FNR
    errs.2$mylab<-as.character(round(errs.2$pwr, 3))
    p3<-ggplot(data=errs.2, aes(x=numEvts, y=pwr, color=grp, linetype=grp)) + 
        geom_hline(yintercept=1-goTh[2], color='tan3') +
        geom_line() + theme_bw() + theme(plot.title = element_text(size = 11))+
        ggtitle(paste0("P(correct stop | p>", maxIDR,", #ADR)")) + 
        ylab('Power') + 
        xlab(bquote(paste("if going with #ADR=", .(saLab))) ) +
        scale_linetype('For A-E') + 
        scale_colour_manual('For A-E', values=lab2) #+
        # theme(legend.position='none')
    p3<-xyL(pp=p3, xl=errII.xlim, yl=errII.ylim, ssa=sa, myLabel=errs.2, 
              leg='yes') 
    
    #graph
    if(plot4){
      
      #add type I vs type II
      #add bg color
      y.max<-max(errs.2$fpr, na.rm=T);
      y.max2<-max(y.max, goTh[1])
      x.max<-max(1, max(errs.2$fnr, na.rm=T));
      if(y.max<y.max2){
        plg<-data.frame(gp=c(rep('go',4),         rep('stop', 4)),
                        x=c(0,goTh[2],goTh[2],0,  0,0, x.max, x.max), 
                        y=c(goTh[1],goTh[1], y.max2,y.max2,   0,goTh[1],goTh[1], 0) )
        plg$gp<-factor(plg$gp, levels=c('go','stop'))
        plg.col<-c('green','magenta')
      }else{
        plg<-data.frame(gp=c(rep('go',4),   rep('stop', 4),    rep('n/a',4)), 
                      x=c(0,goTh[2],goTh[2],0, 0,0, x.max, x.max,
                          goTh[2],goTh[2],x.max,x.max), 
                      y=c(goTh[1],goTh[1],y.max2,y.max2,    0,goTh[1],goTh[1], 0,
                          goTh[1],y.max2,y.max2, goTh[1]) )
        plg$gp<-factor(plg$gp, levels=c('go', 'stop', 'n/a'))
        plg.col<-c('green', 'magenta', 'gray80')
      }
      #
      p6<-ggplot() + 
        geom_polygon(data=plg, aes(x=x, y=y, group=gp, fill=gp), 
                     colour='white', alpha=0.3, size=1)+
        scale_fill_manual("   ", values = plg.col) +
        geom_line(data=errs.2, aes(x=fnr, y=fpr, color=grp, linetype=grp)) +
        geom_point(data=errs.2, aes(x=fnr, y=fpr, color=grp)) + 
        geom_point(data=errs.2[errs.2$numEvts%in%sa,], 
                   aes(x=fnr, y=fpr, color=grp), size=5, shape=0) + 
        theme_bw() + theme(plot.title = element_text(size = 11))+
        ggtitle("About type I/II error") + 
        ylab(p0lab) + 
        xlab(paste(paste0("P(wrong go | p>", maxIDR,")"))) +
        scale_linetype('')+
        scale_colour_manual('', values=lab2) +
        theme(legend.position=c(0.95, 0.95), 
              legend.background = element_rect(fill = "transparent"),
              legend.justification=c(1,1), 
              legend.title=element_blank())+
        guides(linetype=F, col=F,
               shape = guide_legend(override.aes = list(size = 3)))
      
      
      #4. superiority prob
      errs.3$mylab<-as.character(round(errs.3$sup, 3))
      p4<-ggplot(data=errs.3, 
             aes(x=numEvts, y=sup, color=grp, linetype=grp)) + 
        geom_line() + theme_bw() + theme(plot.title = element_text(size = 11))+
        ggtitle('Posterior Probability') + 
        ylab(bquote(paste("P(p\'>", .(maxIDR), " | #ADR)"))) + xlab('#ADR') +
        scale_linetype('') + scale_colour_manual('', values=lab2)
      p4<-xyL(pp=p4, xl=sup.xlim, yl=sup.ylim, ssa=sa, myLabel=errs.3, leg='no')
      
      #5. show predictive distribution
      b.out<-bbin(prior.a=bay.prior[1], prior.b=bay.prior[2], 
                     N11=N1, pa=maxIDR, showBinom=showbm, drawPlot=F)
      errs.5<-b.out$data[,c('x','dx', 'model')] 
      #add variables to show text
      errs.5$numEvts<-errs.5$x
      errs.5$mylab<-as.character(round(errs.5$dx,3))
      #revise plot
      p5<- b.out$plot+ ylab('P(Y=#ADR)') +
        labs(colour='For E', linetype='For F')+
        theme(plot.title = element_text(size = 11))+
        xlab('#ADR')
      p5<-xyL(pp=p5, xl=errII.xlim, yl=errII.ylim, ssa=sa, myLabel=errs.5)
        
      #layout the 5 graphs
      if(!noplot){
        x2loc<-0.435; x3loc<-0.28; x4loc <- x3loc*2
        show(ggdraw() + 
              draw_plot(p1, x=0,     y=.5, width=x3loc, height=.5) + 
              draw_plot(p2, x=x3loc, y=.5, width=x4loc-x3loc, height=.5) +
              draw_plot(p3, x=x4loc, y=.5, width=1-x4loc, height=.5) + 
              draw_plot(p6, x=0,     y=0,  width=x3loc, height=.5) + 
              draw_plot(p4, x=x3loc, y=0,  width=x4loc-x3loc, height=.5) + 
              draw_plot(p5, x=x4loc, y=0,  width=1-x4loc, height=.5) + 
              draw_plot_label(c('A','B', 'C', 'D', 'E', 'F'), 
                              x=c(0, x3loc+0.01, x4loc+0.01, 0, x3loc, x4loc), 
                              y=c(1,1,1, 0.5,0.5,0.5), 
                              size=15))
      }
    }else{
#      p2<-xyL(pp=p2, xl=errI.xlim, yl=errI.ylim, ssa=sa, myLabel=errs.2)+
#         labs(colour='', linetype='')
      #layout the 2 graphs
      if(!noplot){
        x2loc<-0.435; x3loc<-0.28; x4loc <- x3loc*2
        show( ggdraw() + 
             draw_plot(p1, x=0,     y=.5, width=x3loc, height=.5) + 
             draw_plot(p2, x=x3loc, y=.5, width=x4loc-x3loc, height=.5) +
             draw_plot(p3, x=x4loc, y=.5, width=1-x4loc, height=.5) +
             draw_plot_label(c('A','B', 'C'), 
                      x=c(0, x3loc+0.01, x4loc+0.01), y=c(1,1,1), size=15))
      }
    }
    
    oth<-errs.2[,!colnames(errs.2)%in%'mylab']
    sel<-oth[oth$numEvts%in%sa, c('grp','numEvts', 'fpr', 'fnr')]
    if(nrow(sel)>0){
      sel$note<-"n/a"
      sel$note[sel$fnr<=goTh[2]]<-'go'
      sel$note[sel$fn>goTh[2]&sel$fpr<goTh[1]]<-'stop'
    }
    return(list(risk=rsko, oth=oth, sel=sel))
  }#End nzib function
  
  

} #end for all source functions


if(F){
  # main analysis
  rsk.tb1<- 
    nzib(stopAt="1, 4",   #1. stopping threshold
         N1=32,           #2. max number of samples
       maxIDR=0.01,       #3. max expected acceptable occurrence rate
       plot.type=1, 
       normIDR='0.01',    #4. normal occurrence rate, default maxIDR/2 
       bay.prior=c(alpha=0.2, beta=0.8), #5. hyper parameter in beta-binomial
       rsk.xlim="",       #6. x-axis range for risk plot
       rsk.ylim=NULL,     #7. y-axis range for risk plot
       errI.xlim=NULL,    #8. x-axis range for type I error plot
       plot4=T,           #9. whether show all 4 available plots
       B1=5000,           #10. number of simulations
       goTh="0.05, 0.2",  #11. threshold for type I and II errors
       noplot=F           #don't create any plot
  )
  #input$text:  1. stopping threshold for number of Adverse Drug Reaction (#IADR)
  #input$text2: 2. max number of samples
  #input$text3: 3. max expected acceptable occurence rate of ADR
  #input$text4: 4. expected occurence rate of ADR considered as normal, only useful for frequentist Binomial
  #input$text5: 5. Hyper parameters for traditional Bayesian
  #input$text6: 6. X-axis range in risk plot
  #input$text7: 7. Y-axis range in risk plot
  #input$text8: 8. X-axis range in type I error plot and Superiority plot
  #input$radio: 9. whether show all 4 available plots
  #input$text9: 10. number of simulations
  
  
  
  bbin(
    prior.a="1,0.5, 0.0051", #1. parameters in p~Beta(a=, b=) prior distribution
    prior.b="1,0.5,1", #2. parameters in p~Beta(a=, b=) prior distribution
    N1=45,            #3. planned sample size
    pa='0.01',           #4. expected average for event rate p
    p.xL='',        #5. xlim for beta distribution
    x.xL=''         #6. xlim for beta-binomial distribution
  )
  #input$text:  1. parameters in p~Beta(a=, b=) prior distribution
  #input$text2: 2. parameters in p~Beta(a=, b=) prior distribution
  #input$text3: 3. planned sample size
 
  
}

####################################################################################
#Author: Danni Yu
####################################################################################



#all functions
if(TRUE){

  library(lavaan) #a package for SEM
  library(semPlot)#for SEM plots

  library(survminer)#for surv plot with ggsurvplot
  library(survival) #for survfit

  print2<-function(x, sp='\n'){ #print splitted by sp
    print(strsplit(x, split=sp)[[1]])
  }


#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
#func: simulate a set of markers in which only 1 baseline marker and 
#multiple chgFromBsl markers are correlated with survival and tumor chg
#
sim.bmk1 <- function(
  outL=NULL,
  n=30, #the number of patients
  bmkType=1, #if 1 cateogrial, then binary variable; else contineous var
  bmkP.norm=data.frame(mu=c(1,3), sd=c(0.35, 0.35)), 
  #parameters for random norm if bmkType!=1
  bmkIns=0.5,#biomarker insidence for group1
  plotbmk=TRUE,#whether plot a histogram of bmk.t1
  lambda=1,  #baseline  hazards
  beta=c(-1,3), #coefficients of the true bmk in TC model and Survival model
  #good candidate is between 1 and 2 (absolute value)
  m.bmk=c(1, #Numb of true chgFromBsl markers
          2, #Numb of false categorical bmks
          2, #Numb of false numeric bmks
          2) #Numb of false chgFromBsl markers
){
  if(TRUE){
    #--------------------------------------------------------------------------#
    #input: parameters for data simulation to create the following objects     #
    # -> bmk: a data.frame with baseline biomarkers in columns                #
    # -> pmk: a list of data.frames for longitudinal                          #
    #          pharmacodynamic (PD) markers, a data.frame is for a PD marker   #
    #rm->pmk.bst: a data.frame of best changes of PD marker for each patient  #
    #                                                                           
    # -> dtte: a data.frame of time-to-event and censored data in two columns  #
    #rm->tchg: a list of data.frames for tumor changes from baseline over time #
    # -> tchg.bst: a data.frame of best tumor change                           #
    #--------------------------------------------------------------------------#
    #output is a list of the ojects described as above.
  }
  
  
  #for robust output in BEACH
  if(is.null(n)|is.null(bmkType)|is.null(bmkP.norm)|
     is.null(bmkIns)|is.null(lambda)|is.null(beta)|
     is.null(m.bmk)){return(NULL)}
  if(length(beta)!=2){
    if(length(beta)==1){
      beta<-rep(beta,2)
    }else{
      print('length(beta) must be 2! Please change')
      return(NULL)
    }
  }
  if(length(m.bmk)!=4){
    print('check m.bmk, 4 integers are required.')
    return(NULL)
  }
  
  
  #adjust samples sizes
  nump <- sum(c(m.bmk,4))
  if(nump>=n){
    print(paste0('n<p! This program increases n from ', n,
                 ' to n+p=', n <- n + nump))
  }
  
  if(plotbmk) par(mfrow=c(2,2))
  
  #~~~1. simulate baseline biomarker~~~#
  bmk.prob<-c(bmkIns, 1-bmkIns)
  bmk.t1 <- sample(x=1:0, size=n, replace=TRUE, prob=bmk.prob)
  bmkIns.est<-mean(bmk.t1)
  if(bmkType!=1){
    if(any(dim(bmkP.norm)!=c(2,2))){return(NULL)}
    bmk.t1<-bmk.t1*rnorm(n, bmkP.norm$mu[1], bmkP.norm$sd[1])+
      (1-bmk.t1)*rnorm(n, bmkP.norm$mu[2], bmkP.norm$sd[2])
    tt1 <- paste0("bmk incidence ",bmkIns,'\n',
                  '(mu=',bmkP.norm$mu[1],', sd=',bmkP.norm$sd[1],
                  '),  (',bmkP.norm$mu[2],', ', bmkP.norm$sd[2], ')')
    if(plotbmk) hist(bmk.t1, main=tt1)
  }else{
    if(plotbmk) hist(bmk.t1, main=paste0("bmk incidence ",bmkIns))
  }
  
  #~~~2. simulate tumor size change (or tumor burden) data~~~#
  #assume the coefficient of bmk.t1 is beta[1]
  #TC ranges from -100 to infinity
  rt1 <- exp(-beta[1]*bmk.t1)
  rt1 <- rt1/max(rt1)/10
  sp1 <-mean(rt1)*50
  tc<-rgamma(n, shape=sp1, rate=rt1)-100 
  if(plotbmk) {
    range(tc); 
    tt2 <- paste0('simmulate tumor change\nfrom rgama with bmk.t1,',
                  ' beta=', beta[1])
    plot(tc~bmk.t1, main=tt2)
  }
  #derive bor from tc
  bor<-rep('PD', n)
  bor[tc<= -30] <- 'PR|CR'
  bor[tc<=20 & tc>-30] <- 'SD'
  bor <- factor(bor, level=c('PD','SD','PR|CR'))
  print(table(bor))
  
  
  #~~~3. simulate survival data~~~#
  #assume weibull distribution
  tc.norm <- (tc-mean(tc))/sd(tc)
  range(sc2 <- exp(beta[2]*bmk.t1 - tc.norm))
  lambda=c(lambda, max(sc2))
  range(tte1 <- rweibull(n, shape=1, scale=lambda[1]* sc2))
  range(tte2 <- rweibull(n, shape=1, scale=lambda[2]))   #censoring time
  tte = pmin(tte1,tte2)  #observed time is max of censored and true
  cnsr = 1*(tte==tte2)   #set to 1 if tte is from censored data
  # head(cbind(tte,tc, cnsr))
  if(plotbmk){
    tt3<-paste0('survial time vs tumor change\npoint size matches bmk.t1')
    plot(tte~tc, pch=cnsr*15+1, cex=bmk.t1-min(bmk.t1)+0.5, main=tt3,col='red')
    legend('topright', legend=c('event','censor'), pch=c(1, 16), col='red')
    if(bmkType==1){
      bmk.bin<-bmk.t1
      leg3<-c('bmk.t1=0','bmk.t1=1')
    }else{
      cut<-round(quantile(bmk.t1, prob=bmkIns.est),3)
      bmk.bin<-1*(bmk.t1>cut)
      leg3<-paste0(c('bmk.t1<=','bmk.t1>'), cut)
    }
    #survival plot
    require(survival)
    sf1<-survfit(Surv(tte, 1-cnsr)~bmk.bin)
    plot(sf1, lty=1:2)
    legend('topright', legend=leg3, lty=1:2)
    cf1 <- survdiff(Surv(tte, 1-cnsr)~bmk.t1)
    pv1 <- round(1 - pchisq(cf1$chisq, 1), 3)
    legend('bottomleft', legend=paste0('p=',pv1), bty='n')
  }
  
  
  #~~~4. simulate the true chgFromBsl markers~~~#
  #for one marker, one change value per patient
  if(m.bmk[1]>=1){
    pmk.t<-data.frame(matrix(NA,nrow=n, ncol=m.bmk[1]))
    colnames(pmk.t)<-paste0('pmk.t',1:m.bmk[1])
    rslp<-0
    while(any(rslp==0)){
      rslp <- round(rnorm(m.bmk[1])) #random slope
    }
    for(j in 1:m.bmk[1]){
      pmk.t[,j] <- rnorm(n, mean=tc*rslp[j], sd=abs(rslp[j])*0.1)
      # boxplot(pmk.t[,j]~bor, ylab=colnames(pmk.t)[j])
    }
    #head(pmk.t)
  }else{pmk.t<-NULL}
  
  #~~~5. simulate the fasle markers~~~#
  if(m.bmk[2]>=1){ #false categorical
    bmk.fc<-data.frame(matrix(NA, nrow=n, ncol=m.bmk[2]))
    colnames(bmk.fc)<-paste0('bmk.fc',1:m.bmk[2])
    r.bi<-round(runif(m.bmk[2], 0.2,0.8),3) #random bmk incidence
    for(j in 1:m.bmk[2]){
      pb<-c(r.bi[j], 1-r.bi[j])
      bmk.fc[,j]<-factor(sample(c(1,0), n, replace=T, prob=pb),levels=c(0,1))
      # boxplot(tc~bmk.fc[,j], xlab=colnames(bmk.fc)[j])
    }
  }else{bmk.fc<-NULL}
  #
  if(m.bmk[3]>=1){ #false numeric
    bmk.fn<-data.frame(matrix(NA, nrow=n, ncol=m.bmk[3]))
    colnames(bmk.fn)<-paste0('bmk.fn',1:m.bmk[3])
    r.mu<-round(rnorm(m.bmk[3])) #random mean and sd
    r.sd<- rchisq(m.bmk[3], 1)
    for(j in 1:m.bmk[3]){
      bmk.fn[,j]<-rnorm(n, mean=r.mu[j], sd=r.sd[j])
      # boxplot(bmk.fn[,j]~bor, ylab=colnames(bmk.fn)[j])
    }
  }else(bmk.fn<-NULL)
  #
  if(m.bmk[4]>=1){ #false chgFromBsl
    pmk.f<-data.frame(matrix(NA, nrow=n, ncol=m.bmk[4]))
    colnames(pmk.f)<-paste0('pmk.f',1:m.bmk[4])
    r.mu<-round(rnorm(m.bmk[4])) #random mean and sd
    r.sd<- rchisq(m.bmk[4], 1)
    for(j in 1:m.bmk[4]){
      pmk.f[,j]<-rnorm(n, mean=r.mu[j], sd=r.sd[j])
      # boxplot(pmk.f[,j]~bor, ylab=colnames(pmk.f)[j])
    }
  }else{pmk.f<-NULL}
  
  #convert response status variable a sa factor
  if(bmkType==1){bmk.t1 <- factor(bmk.t1)}
  dtte<-data.frame(tte,cnsr)
  bmk <- data.frame(bmk.t1, bmk.fc, bmk.fn)
  pmk <- data.frame(pmk.t, pmk.f)
  outL <- list(dtte=dtte, 
               tchg.bst=tc, bor=bor, 
               bmk = bmk, pmk=pmk, 
               slopes=beta)
  outL$all <- data.frame(tc, dtte, bor, bmk, pmk)
  return(outL)
}
#if see error, try to sample again
#sim2 <- sim.bmk1(10)



#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#  
#plot biomarker in the struction of output from bmkJM.sim1
bmkJM.plot <- function(
  allData=sim1$all, #a data.frame including all variables
  tte.nm='tte',     #variable name for TTE
  cnsr.nm='cnsr',   #variable name for censor or not
  tc.nm='tc',       #variable name for tumor change
  bor.nm = 'bor',   #variable name of best objective response
  bmk.nm=colnames(sim1$bmk),  #variable names for baseline markers
  pmk.nm=colnames(sim1$pmk),  #variable names for longitudinal markers
  #note: all the logitudinal variables must have '.t1', '.t2', ....
  getTotNum=TRUE,   #get the total number of plots and not plot output
  plotAll=TRUE,     #whether plot all graphs or one-by-one
  plotID=NULL       #the index number for a graph
){
  #obj: is a listing object use the same structure as bmkJM.sim1 output
  #outL <- list(dtte=dtte, tchg.bst=tc, bor=bor, 
  #            bmk=bmk, pmk=pmk, slopes=slopes)
  #outL$all <- data.frame(tc, dtte, bor, bmk, pmk)
  
  ask1 <- function(id=NULL){
    if(is.null(id)){
      ot<-readline(prompt='Next plot? y or n: ')
    }else{
      ot<-readline(prompt=paste0('Drow plot ',id,'? y or n: '))
    }
    while(!ot%in%c('y','n')){
      ot<-readline(prompt=paste0(ot, ' is not right. Please input y or n: '))
    }
    return(ot)
  }
  #if plotAll is false, then users will see plots one by one
  
  #pre-define the interactive variable
  nxt <- 'y';
  #pre-define the total number of plots
  totnum <- 0
  #when plotAll==FALSE and getTotNum==FALSE and plotID is specified
  #then only one plot matched to the graph ID will be shown. 
  
  bmk.nm.v <- NULL
  for(i in bmk.nm){
    if(is.numeric(allData[,i])){
      bmk.nm.v <- c(bmk.nm.v, i)
    }
  }
  bmk.nm.c <- bmk.nm[!bmk.nm%in%bmk.nm.v]
  bmk.len.c <- length(bmk.nm.c)
  bmk.len.v <- length(bmk.nm.v)
  
  #1. survival plots grouped by different L or H of a biomarker
  if(all(c(tte.nm, cnsr.nm, bmk.nm)%in%colnames(allData))){
    if (getTotNum){
      totnum <- totnum + bmk.len.c
    }else{
      tte <- allData[,tte.nm]
      cnsr<- allData[,cnsr.nm]
      i <- 1
      while(nxt=="y" & i<=bmk.len.c){
        totnum <- totnum+1
        if(!is.null(plotID) && plotID!=totnum){i <- i+1;next}
        testData <- data.frame(tte=tte, cnsr=cnsr, lev=allData[,bmk.nm.c[i]])
        fit <- survfit(Surv(tte, 1-cnsr) ~ lev, data=testData)
        leg <- paste0(bmk.nm.c[i], ': ')
        # Visualize with survminer
        #ggsurvplot(fit, data=testData, risk.table = TRUE, legend.title=leg)
        print( ggsurvplot(
          fit,                     # survfit object with calculated statistics.
          data = testData,  # data used to fit survival curves. 
          legend.title=leg, 
          risk.table = TRUE,       # show risk table.
          pval = TRUE,             # show p-value of log-rank test.
          conf.int = TRUE,         # show confidence intervals for 
          # point estimaes of survival curves.
          #xlim = c(0,2000),        # present narrower X axis, but not affect
          # survival estimates.
          #break.time.by = 500,     # break X axis in time intervals by 500.
          ggtheme = theme_minimal(), # customize plot and risk table with a theme.
          risk.table.y.text.col = T, # colour risk table text annotations.
          risk.table.y.text = FALSE # show bars instead of names in text annotations
          # in legend of risk table
        ))
        if(!plotAll && is.null(plotID)) nxt <- ask1(totnum+1)
        i <- i+1
      }
    }
  }
  
  #2. boxplots of tc grpd by different L or H of a biomarker
  if(all(c(tc.nm, tte.nm, bmk.nm)%in%colnames(allData)) ){
    if (getTotNum){
      totnum <- totnum + bmk.len.c
    }else{
      i <-1; 
      par(mfrow=c(2,2))
      while(nxt=='y' & i<=bmk.len.c){
        totnum <- totnum+1
        if(!is.null(plotID) && plotID!=totnum){i <- i+1;next}
        boxplot(allData[,tc.nm]~allData[,bmk.nm.c[i]],
                ylab=tc.nm, xlab=bmk.nm.c[i])
        boxplot(allData[,tte.nm]~allData[,bmk.nm.c[i]],
                ylab=tte.nm, xlab=bmk.nm.c[i])
        if(!plotAll && is.null(plotID)) nxt <- ask1(totnum+1)
        i <- i+1
      }
      par(mfrow=c(1,1))
    }
  }
  
  #3. scatter plots of tte and tc grpd by different L or H of a biomarker
  if(all(c(tte.nm, cnsr.nm, tc.nm, bmk.nm)%in%colnames(allData))){
    if (getTotNum){
      totnum <- totnum + bmk.len.c
    }else{
      i <-1; 
      par(mfrow=c(1,2))
      while(nxt=='y' & i<=bmk.len.c){
        totnum <- totnum+1
        if(!is.null(plotID) && plotID!=totnum){i <- i+1;next}
        lev <- as.factor(unique(allData[,bmk.nm.c[i]]))
        col1<- as.numeric(lev); names(col1)<-lev;
        pch <- unique(allData[,cnsr.nm])*16
        plot(allData[,tte.nm]~allData[,tc.nm],
             col=allData[,bmk.nm.c[i]], pch=allData[,cnsr.nm]*16,
             ylab=tte.nm, xlab=tc.nm, main=bmk.nm.c[i])
        legend('topright', 
               legend=paste0(#bmk.nm.c[i],'=',
                 rep(lev, each=2), 
                 ', cnsr=', rep(pch/16, 2)),
               pch=rep(pch, 2),
               col=as.numeric(rep(lev, each=2))
        )
        form1<-as.formula(paste0(tte.nm, '~', tc.nm))
        for(k in lev){
          f1<-lm(form1, data=allData[allData[,bmk.nm.c[i]]==k,])
          abline(f1, col=col1[k])
        }
        if(!plotAll && is.null(plotID)) nxt <- ask1(totnum+1)
        i <- i+1
      }
      par(mfrow=c(1,1))
    }
  }
  
  #4. scatter plots of tc vs numeric baseline biomarker
  if(all(c(tc.nm,tte.nm, bmk.nm.v)%in%colnames(allData))){
    if (getTotNum){
      totnum <- totnum + bmk.len.v
    }else{
      i <-1; 
      par(mfrow=c(2,2))
      while(nxt=='y' & i<=bmk.len.v){
        totnum <- totnum+1
        if(!is.null(plotID) && plotID!=totnum){i <- i+1;next}
        plot(allData[,tc.nm]~allData[,bmk.nm.v[i]], pch=16, 
             ylab=tc.nm, xlab=bmk.nm.v[i])
        plot(allData[,tte.nm]~allData[,bmk.nm.v[i]], pch=16, 
             ylab=tte.nm, xlab=bmk.nm.v[i])
        if(!plotAll && is.null(plotID)) nxt <- ask1(totnum+1)
        i <- i+1
      }
    }
  }
  
  #5. scatter plots of tte vs numeric baseline biomarker pch by cnsr
  if(all(c(tte.nm, cnsr.nm, bmk.nm.v)%in%colnames(allData))){
    if (getTotNum){
      totnum <- totnum + bmk.len.v
    }else{
      i<-1;
      pchs <- (allData[,cnsr.nm])*16
      pch1 <- unique(allData[,cnsr.nm])
      par(mfrow=c(2,2))
      while(nxt=='y' & i<=bmk.len.v){
        totnum <- totnum+1
        if(!is.null(plotID) && plotID!=totnum){i <- i+1;next}
        plot(allData[,tte.nm]~allData[,bmk.nm.v[i]], pch=pchs,
             ylab=tte.nm, xlab=bmk.nm.v[i])
        legend('topleft', legend=paste0(cnsr.nm,'=',unique(pchs)/16), xpd=T,
               pch=unique(pchs), col='black', inset=c(0,0))
        form1<-as.formula(paste0(tte.nm, '~', bmk.nm.v[i]))
        for(k in pch1){
          print(k)
          f1<-lm(form1, data=allData[allData[,cnsr.nm]==k,])
          print(f1)
          if(all(!is.na(f1$coefficients)))
          abline(f1, lty=length(pch1)-as.numeric(k))
        }
        i <- i+1
        if(!plotAll && is.null(plotID)) nxt <- ask1(totnum+1)
      }
      par(mfrow=c(1,1))
    }
  }
  
  #6. line plots of longitudinal marker colored by bor level
  if(all(c(bor.nm, pmk.nm)%in%colnames(allData))){
    cols.nm<- as.factor(allData[,bor.nm])
    cols <- as.numeric(cols.nm)
    names(cols) <- cols.nm
    col1.nm <- unique(cols.nm)
    col1 <- as.numeric(col1.nm)
    #note: all the logitudinal variables must have '.t1', '.t2', ....
    pmk.nm.L <- 
      sapply(strsplit(pmk.nm, split='.t'), function(x){x[1]})
    pmk.nm.L1 <- unique(pmk.nm.L)
    if (getTotNum){
      totnum <- totnum + length(pmk.nm.L1)
    }else{
      par(mfrow=c(2,2))
      i<-1; # nxt='y'
      while(nxt=='y' & i<=length(pmk.nm.L1)){
        totnum <- totnum+1
        if(!is.null(plotID) && plotID!=totnum){i <- i+1;next}
        pmk.clnm <- pmk.nm[pmk.nm.L==pmk.nm.L1[i]]
        pmk.1 <- allData[,pmk.clnm]
        if(is.null(ncol(pmk.1))){
          bp<-boxplot(pmk.1~allData[,bor.nm], ylab=pmk.clnm)
        }else{
          xx <- 1:ncol(pmk.1)
          ylim<-range(pmk.1, na.rm=T)
          yy <- as.vector(as.numeric(pmk.1[1,]))
          plot(yy~xx, type='o', col=cols[1], ylim=ylim, pch=16,
               ylab=pmk.nm.L1[i], xlab='time points')
          for(m in 2:nrow(pmk.1)){
            yy <- as.vector(as.numeric(pmk.1[m,]))
            lines(x=xx, y=yy, type='o', pch=16, col=cols[m])
          }
          legend("topleft", legend=col1.nm, text.col=col1,
                 inset=c(0, 0), xpd=T)
        }
        i <- i+1
        if(!plotAll && is.null(plotID)) nxt <- ask1(totnum+1)
      }
      par(mfrow=c(1,1))
    }
  }
  
  if(getTotNum){
    return(totnum)
  }
  #the end of plots
}


#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
#Set up SEM structures
sem.struct <- function(
  allData=sim1$all, 
  subset=NULL, #T/F or index values to take subset of allData
  model=NULL,
  dtte.nm='tte',
  tc.nm = 'tc',
  bor.nm='bor',
  bmk.nm=colnames(sim1$bmk),
  pmk.nm=colnames(sim1$pmk),
  pmk.cov=NULL,
  cov.nm = NULL,
  getPlot=TRUE,
  est = 'ML',
  rmNode=TRUE, 
  rmTh=c(0.2,0.2), #Threshold of est and std for removed nodes
  fit=NULL,
  shortNM=T
){
  
   if(is.null(fit)){
     if(shortNM){
       colnames(allData)<-gsub('mk.','.',colnames(allData))
       bmk.nm <- gsub('mk.','.', bmk.nm)
       pmk.nm <- gsub('mk.','.', pmk.nm)
     }
    
    #take the subsets
    if(!is.null(subset) & length(subset)==nrow(allData)){
      #and remove all categorical variables
      tmp.bmk.nm<-NULL
      for(i in bmk.nm){
        if(is.numeric(allData[,i])){tmp.bmk.nm<-c(tmp.bmk.nm, i)}
      }
      bmk.nm <- tmp.bmk.nm
      print(bmk.nm)
      nrow1 <- nrow(allData)
      allData <- allData[subset,]
      print(paste('data reduced from', nrow1, 'to', nrow(allData)))
    }
    
    #convert factor into numeric
    all.nm <- c(dtte.nm, tc.nm, bor.nm, bmk.nm, pmk.nm, cov.nm)
    allData2 <- allData[,all.nm]
    for(i  in all.nm){
      if(!is.numeric(allData2[,i])){
        allData2[,i]<-as.numeric(as.factor(allData2[,i]))
      }
    }
    #apply(allData2[,all.nm], 2, is.numeric)
    
    #pre-define covariance.
    lower <- ''
    for(k in 1:length(all.nm)){
      lower <- paste(lower, '\n', 
                     paste(rep('0', k), collapse=' '))
    }
    # print2(lower)
    #crea.cov = getCov(lower, names = all.nm) # Assign variable names
    
    #construct models
    y.nm <- c(dtte.nm, tc.nm)
    mod.y <- paste(y.nm, collapse='+')
    mod.pmk <- paste(pmk.nm, collapse='+'); mod.pmk.l <-length(pmk.nm);
    mod.bmk <- paste(bmk.nm, collapse='+'); mod.bmk.l <-length(bmk.nm);
    cov.bmk <- ''
    for(kb in 1:length(bmk.nm)){
      cov.bmk<-paste(cov.bmk, ifelse(kb==1, '', '\n'),
                     paste(bmk.nm[kb],'~~',
                           paste0(bmk.nm[-kb], collapse='+')))
    }
    
    if(is.null(model)){
      model <- paste0(
        '# latent variables    \n', 
        paste0('eff =~ ', mod.y), '    \n',
        #assume at least one baseline markers are specified, 
        ifelse(mod.bmk.l>1, paste0('bsl =~ ', mod.bmk, '\n'), ''),
        #logitudinal markers are optional
        ifelse(mod.pmk.l>0, 
               ifelse(mod.pmk.l>1, paste0('log =~ ', mod.pmk, '\n'), ''),
               ''),
        '# regressions \n', 
        'eff ~ ', ifelse(mod.bmk.l>1, 'bsl', mod.bmk),
           ifelse(mod.pmk.l>0, 
                  paste0(' + ',  ifelse(mod.pmk.l>1, 'log', mod.pmk)),
                  ''), 
           '\n',
        '# residual covariances    \n',
        ifelse(is.null(dtte.nm)|is.null(tc.nm), '', 
               paste(dtte.nm, '~~', tc.nm)),  '\n',
        ifelse(is.null(pmk.cov), '', 
               paste(pmk.cov, collapse='     \n'))
      )
    }
    print2(model)
    
    fit <- lavaan::sem(model,  data=allData2, 
                       sample.nobs=round(n*.8),
                       #test = "bootstrap",
                       estimator=est)
    #varTable(fit)
    #summary(fit)
  }

  
  #--convert the fit object to semPlotModel structure, not lavaan
  if(class(fit)[1] !=  "semPlotModel"){
    fit.ch <- do.call(semPlotModel, 
                    c(list(fit), modelOpts = list(mplusStd = "std")))
  }else{fit.ch<-fit}
  if(rmNode){
    #print(fit.ch@Vars)
    if(is.null(rmTh)){
      rmTh<-c(quantile(abs(fit.ch@Pars$est), probs=0.25),
              quantile(abs(fit.ch@Pars$std), probs=0.25))
    }
    if(length(rmTh)==1) rmTh <- rep(rmTh,2)
    fit.ch@Pars<-fit.ch@Pars[!is.na(fit.ch@Pars$est)&!is.na(fit.ch@Pars$std),]
    fit.ch@Pars<-fit.ch@Pars[fit.ch@Pars$lhs!=fit.ch@Pars$rhs,]
    fit.ch@Pars<-fit.ch@Pars[abs(fit.ch@Pars$est) > rmTh[1], ]
    fit.ch@Pars<-fit.ch@Pars[abs(fit.ch@Pars$std) > rmTh[2], ]
    
  }
  fit <- fit.ch
  print(fit@Pars)
  
  
  if(getPlot){
    
    if(nrow(fit@Pars)==0){
      x=0; y=0;
      plot(y~x, ylab='', xlab='', axes=F, col='white')
      text(x=x,y=y, labels='0 nodes 0 edges', col='red')
    }else{
    
      # Visualize model
      if(length(unique(allData$bmk.t1))==2){
        bif <- 'bmk.t1'
      }else{bif<-NULL
      }
      bif<-c(bif,colnames(allData)[grepl('.fc',colnames(allData),fixed=T)])
      semPaths(fit,
               style = "lisrel",
               what='std',
               whatLabels='std',
               layout="tree",
               rotation = 3,
               allVars=F,
               intercepts=T,
               residuals=F, 
               thresholds=T,
               nCharNodes=0,
               exoCov=T,
      #         bifactor=bif,
               structural=F,
               optimizeLatRes=T)
      #std: standardized estimate
      #the solid edges represent free parameters estimated from the observed data 
      #and are believed by the investigator to be non-zero.
      #dashed edges represent the fixed parameters  not estimated from the data 
      #and are typically fixed at zero (indicating no relationship between variables)
      #http://userwww.sfsu.edu/efc/classes/biol710/path/SEMwebpage.htm
    }
  }
  
  return(fit)
}



###get selected data names###
get.cnm <- function(dat1, key='bmk.'){
  cnms <- colnames(dat1)
  cnms <- cnms[grepl(key, cnms, fixed=T)]
  return(cnms)
}

###check data names###
check.nm <- function(dat1,   
                     req.vnm=c('tc','tte','cnsr','bmk.', 'pmk.')
                     ){
  cnms <- substring(colnames(dat1), 1, 4)
  mis.vnm <- req.vnm[!req.vnm%in%cnms]
  oo <- 'Pass data names check'
  if(length(mis.vnm)>0){
    oo<-paste0('Fail data names check\nMissed var names: ',
               paste(mis.vnm, collapse=', '))
  }
  return(oo)
}

####plot text###
plottext<-function(tt){
  y=0; x=0; 
  plot(y~x, ylab='', xlab='', axes=F, col='white')
  text(y=y, x=x, labels=tt)
  
}

#convert all binary baseline marker into factor
bin2fac<-function(dat1, varnm){
  for(i in varnam){
    if(length(unique(dat1[,i]))==2){
      dat1[,i] <- factor(dat1[,i])
    }
  }
  return(dat1)
}

} #~~~end of all functions





if(FALSE){
  #BEACH code
  
  
  #^^^^^^^ I. get the data ^^^^^^^^# Figure
  input <- list(radio=NULL, text=NULL)
  #1. Get the data
  input$radio <- c("simulate a new set", "save as default", "use the default", "use uploaded data") [2]
  #2. for data simulation: sample size
  if(input$radio=='simulate a new set') input$text <-'30'
  #3. for data simulation: the true tailoring biomarker type, 1 for binary
  input$slide <- {if(input$radio=='simulate a new set'){1:2}else{NULL}}[2]
  #4. for data simulation: two means for a Normally distributed baseline marker that correlates tc or tte
  input$text2 <- ifelse(input$radio=='simulate a new set','1,3', NULL)
  #5. for data simulation: two std for a Normally distributed baseline marker that correlates tc or tte
  input$text3 <- ifelse(input$radio=='simulate a new set','0.35,0.35', NULL)
  #6. for data simulation: group 1 incidence for baseline marker that correlates tc or tte
  input$text4 <- ifelse(input$radio=='simulate a new set','0.5', NULL)
  #7. for data simulation: coefficients of bmk.t1 from TC model and Survival model
  input$text5 <- ifelse(input$radio=='simulate a new set','-1, 3', NULL)
  #8. for data simulation: Number of changeFromBaseline markers (pmk.t1) correlated with efficacy
  input$text6 <- ifelse(input$radio=='simulate a new set','1', NULL)
  #9. for data simulation: Number of bsl binary markers not correlated with efficacy
  input$text7 <- ifelse(input$radio=='simulate a new set','2', NULL)
  #10. for data simulation: Number of bsl continueous markers not correlated with efficacy
  input$text8 <- ifelse(input$radio=='simulate a new set','2', NULL)
  #11. for data simulation: Number of changeFromBaseline markers not correlated with efficacy
  input$text9 <- ifelse(input$radio=='simulate a new set','2', NULL)
  
  
  if(input$radio=='use the default'){
    load(file='data/sem_sim1_jsm.Rdata')
    allD <<- allD.d
    plottext(check.nm(allD))
  }else if(input$radio=='use uploaded data'){
    allD <- indataset[[1]]
    bmk.nms <- get.cnm(allD, 'bmk.')
    allD <<- bin2fac(allD, bmk.nms)
    plottext(check.nm(allD))
  }else if(input$radio=='save as default'){
    allD.d <- allD
    save(allD.d, file='data/sem_sim1_jsm.Rdata')
    plottext(check.nm(allD.d))
  }else{ #create the 
    sim1 <-   sim.bmk1(
      n=round(as.numeric(input$text)), #the number of patients
      bmkType=input$slide, #if 1 cateogrial, then binary variable; else contineous var
      bmkP.norm=data.frame(mu=as.numeric(strsplit(input$text2, split=',')[[1]]), 
                           sd=as.numeric(strsplit(input$text3, split=',')[[1]])), 
      #parameters for random norm if bmkType!=1
      bmkIns=as.numeric(input$text4),#biomarker insidence for group1
      plotbmk=TRUE,#whether plot a histogram of bmk.t1
      lambda=1,  #baseline  hazards
      #coefficients of the true bmk in TC model and Survival model
      beta=as.numeric(strsplit(input$text5, split=',')[[1]]), 
      #good candidate is between 1 and 2 (absolute value)
      m.bmk=c(as.numeric(input$text6), #Numb of true chgFromBsl markers
              as.numeric(input$text7), #Numb of false categorical bmks
              as.numeric(input$text8), #Numb of false numeric bmks
              as.numeric(input$text9)) #Numb of false chgFromBsl markers
    )
    allD <<- sim1$all
  }
  bmk.nms <<- get.cnm(allD, 'bmk.')
  pmk.nms <<- get.cnm(allD, 'pmk.')
  totPlot<<-bmkJM.plot(
    allData=allD,
    tte.nm='tte', 
    cnsr.nm='cnsr',
    tc.nm='tc',  
    bor.nm = 'bor',
    bmk.nm=bmk.nms,
    pmk.nm=pmk.nms,
    getTotNum = TRUE,
    plotAll=F
  )
  
  
  
  #^^^^^^^ II. see the data ^^^^^^^^# Table
  input <- NULL
  #1. choose variable names
  input$dropdown <- colnames(allD)[1:min(20, ncol(allD))]
  #2. number of rows
  input$slide <- min(50, nrow(allD))
  
  data.frame(allD[1:input$slide,input$dropdown])

  
  #^^^^^^^ III. Visual the data ^^^^^^^^# Figure
  input <- NULL
  #1. plot ID
  input$slide <- seq(1,   totPlot, by=1)[2]
  bmkJM.plot(
    allData=allD,
    tte.nm='tte', 
    cnsr.nm='cnsr',
    tc.nm='tc',  
    bor.nm = 'bor',
    bmk.nm=bmk.nms,
    pmk.nm=pmk.nms,
    getTotNum = F,
    plotAll=F,
    plotID = input$slide
  )
  
  
  #^^^^^^^ IV. analyse the data with structural equation model ^^^^^^^^# Figure
  input <- NULL
  #1. only keep the nodes above threshold
  input$radio <- c('TRUE', 'FALSE')[1]
  #2. thresholds for estimates and standardized estimates
  input$text <- '0.2, 0.2'
  #3. index of baseline markers
  input$slide <- c(0, 1:length(bmk.nms)) [2]
  #4. select baseline markers
  input$dropdown <- if(input$slide>0){bmk.nms[input$slide]}else{bmk.nms}
  #5. select changFromBaseline markers
  input$dropdown2 <- pmk.nms
  #6. shrink nodes names
  input$radio2 <- c('TRUE', 'FALSE')[1]
  
  if(input$slide==0){
    bmk.nm.sel<-input$dropdown
  }else{bmk.nm.sel<-bmk.nms[input$slide]}
  fit0 <- sem.struct(allData=allD, 
                     rmNode=as.logical(input$radio), 
                     rmTh=as.numeric(strsplit(input$text, split=',')[[1]]),
                     bmk.nm=bmk.nm.sel,
                     pmk.nm=input$dropdown2,
                     shortNM=as.logical(input$radio2) )
  title(paste(bmk.nm.sel, collapse=', '))    
}

if(length(indataset)==0){
  load('data/sem_sim1_jsm.Rdata')
  #pre-defined sim1 set is used
  allD <<- sim1$all
  indataset[[1]] <- allD
  print(head(allD))
}
print('ppp2')

conditionalPanel(condition='true',
                 h5(a('COSMIC Database',href='http://cancer.sanger.ac.uk/cancergenome/projects/cosmic/',target='_blank')),
                 h5(a('Memorial Sloan Kettering cBioPortal Cancer Genomics Database',href='http://www.cbioportal.org/public-portal/',target='_blank')),
                 h5(a('Roche Genome Cancer Database',href='http://rcgdb.bioinf.uni-sb.de/MutomeWeb/',target='_blank'))
)

# Run the BEACH Shiny App
#
# @export
run_app <- function() {
  app_dir <- system.file("app", package = "BEACHpkg")
  if (app_dir == "") stop("App not found")
  shiny::runApp(app_dir, display.mode = "normal")
}

if(TRUE){#header
  #*****************************************************************************
  #Eli Lilly and Company - GLOBAL STATISTICAL SCIENCES - PROGRAM
  #CODE NAME (required)                : LightON1_integrate.R
  #PROJECT NAME (required)             : geneAtlas
  #STUDY NUMBER                        : 
  #DESCRIPTION (required)              : update / organize / integrate data
  #SPECIFICATIONS(optional)            : 
  #VALIDATION TYPE (required)          : 
  #INDEPENDENT REPLICATION (optional)  : 
  #ORIGINAL CODE (required)            : 
  #EXTERNAL CODE FILES THAT ARE NOT 
  #RE-USEABLE CODE MODULES             : 
  #SOFTWARE/VERSION# (required)        : R Version 3.5.0
  #INFRASTRUCTURE                      : R studio server
  #DATA INPUT location                 : gene expression and mutation
  #SDD: 
  #                                    
  #OUTPUT location: 
  #
  #
  #R SCRIPT location
  #
  #
  #-----------------------------------------------------------------------------
  #     #Author                 Code History Description             Date Change
  #---- ------------       ---------------------------------------  ---------
  #1.1  Danni Yu            Code Creation                             01/10/2019
  #1.2  Danni Yu            Add ICGC projects                         01/29/2019
  #1.3  Danni Yu            Revision and debug                        03/12/2019
  #*****************************************************************************
}

#manage folders by project index 1, 2, .... in LightON1 folder
#Each project folder includes:
# X_datasum.feather for project summary
# X_clin.feather for patients and samples information (all with mut test)
# X_mut.feather for somatic mutation data
# X_gexp_array.feather, X_gexp_rnaseq.feather  for gene expression data
# X_pexp_antib.feather for protein expression named by antibody (optional)
# X_mut_cna.feather for copy numbers (optional)
# X_fus.feather for fusion (optional)
# where 'X' project names; 'xx' gene names

#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@#
#!!!!!!! survival_time in days !!!!!!!!!!#
# c('alive','deceased') in vital_status  #
#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@#

#define paths, files, program,...
if(TRUE){
  rm(list=ls());
  
  beginTime<-Sys.time()
  
  runDB1<-T #convert the 1st database ICGC to innitiate the project summary file
  runDB2<-FALSE #convert IMPACT database
  runDB3<-TRUE #convert GENIE database
  
  rerunClin<-F #enforce to update clin data
  rerunMut<-F #enforce to update mutation data
  rerunExp<-F #enforce to update gene expression data
  rerunPExp<-F #enforce to update protein expression data
  
  #define comment key words in output files
  com.clin<-'_clin.feather'
  com.gexp1<-'_gexp_array.feather'
  com.gexp1m<-'_mut_gexp_array.feather'
  com.gexp2<-'_gexp_rnaseq.feather'
  com.gexp2m <- '_mut_gexp_rnaseq.feather'
  com.mut1<-'_mut.feather'
  com.mut2<-'_mut_cnv.feather'
  com.cnv<-'_cnv.feather'
  com.pexp<-'_pexp_antib.feather'
  com.pexpm<-'_mut_pexp_antib.feather'
  com.sum<-'_datasum.feather'
  
  #global mapping variable
  conVar1 <- "submitted_id"
  #sample level mapping variable
  conVar2 <-"submitted_sample_id"
  
  options(stringsAsFactors=F)
  
  projP <- "local1" #to be defined by users with a local drive
  
  dir(progpath<-file.path(projP,'prog'))
  progfile<-'LightON1_integrate.R'
  
  dir(frompath<-"data")
  dir(topath<-'local2')#to be defined by users with a local drive
  projfile<-'projects_summary.csv'
  dsfile<-'dataspec.csv'
  gnameFile<-file.path(topath, 'gene_ensemble.Rdata')
  
  #icgc raw data
  db1<-'ICGC'
  dir(path1<-file.path(frompath, db1, 'release_27/Projects'))
  path1file<-c('icgc_fnm.Rdata',"icgc_project_code.csv",
               'icgc_protein_antibody.csv', 'illumina_probeID.csv')
  
  #MSK-impact raw data
  db2<-'MSK-IMPACT'
  path2<-file.path(topath, db2)
  
  #GINIE raw data
  db3<-'GENIE'
  path3<-file.path(topath, db3)
  path3f<-file.path(frompath, 'GENIE/data')
  
  #for a quick summary about platform
  cnv.plat<-mut.plat<-fus.plat<-NULL
  
  #grep all existing file names
  if(TRUE){
    f1s<-dir(file.path(topath,'ICGC')); f1nms<-list();
    for(i in 1:length(f1s)){
      f1nms[[i]]<-dir(file.path(topath,'ICGC', f1s[i]))
    }
    names(f1nms)<-f1s
    ##check file names for protein expression
    # unlist(sapply(f1nms, function(x){x[grep('_pexp',x)]}))
  }
  
  
}

# predefine functions
if(TRUE){
  library(data.table)
  library(feather)
  library(reshape)
  library(dplyr)
  
  #get or update datasum file
  getDSum<-function(din, kvar=NULL, v2=NULL, ds=datasum){
    if(is.null(din)||length(din)==0){return(ds)}
    if(is.null(kvar)){
      if(is.null(v2)){stop('define v2 in getDSum')}
      o<-data.frame(x1=unique(din), x2=1)
      colnames(o)<-v2
    }else{
      tmpv<-din[,!colnames(din)%in%kvar]
      tmpv[!is.na(tmpv)]<-1
      tmpv[is.na(tmpv)]<-0
      o<-data.frame(din[,kvar], tmpv)
      colnames(o)[1:length(kvar)]<-kvar
    }
    if(!is.null(ds)){
      ds<-merge(ds,o,all=T)
      ds[is.na(ds)]<-0
    }else{ds<-o}
    return(ds)
  }
  
  
  #update data spec file
  up.dataspec<-function(d1=dataspec, #
                        d2, #new data
                        v1){
    if(is.null(d2))return(d1)
    ds1<-data.frame(DataName=rep(v1,ncol(d2)),VarName=colnames(d2))
    d1<- unique(rbind(d1,ds1))
    return(d1)
  }
  
  #control gene names as Hugo_Symbol
  gnmIcgc<-function(d1=mut1, #or mut2 for expa
                    v1='gene_affected', #'gene_id'
                    gl=g_list12 ){
    d1v<-d1[,v1]
    d1v<-as.vector(as.character(d1v))
    d1v<-gsub(' ', '', d1v)
    d1<-d1[!is.na(d1v)&d1v!='',]
    d1v<-d1[,v1]
    d1v<-gsub('\\..*','', d1v)
    d1[,v1]<-d1v
    if(any(unique(d1v)%in%gl$refseq$Hugo_Symbol)){
      d1$Hugo_Symbol<-d1v
    }else if(any(unique(substring(d1v,1,3))%in%'NM_')){
      d1<-merge(d1, gl$refseq, by.x=v1, by.y='refseq')
    }else if(substring(d1v[1],1,4)=='ENSG'){
      d1<-merge(d1, gl$ensembl, by.x=v1, by.y='ensembl')
    }else if(any(unique(d1v)%in%gl$illprob$ILL_prob)){
      d1<-merge(d1, gl$illprob, by.x=v1, by.y='ILL_prob')
    }else if(any(unique(d1v)%in%gl$ensemblTr$ensemblTr)){
      d1<-merge(d1, gl$ensemblTr, by.x=v1, by.y='ensemblTr')
    }else{}
    return(d1[,!colnames(d1)%in%v1])
  }
  
  #calculate z score
  getZ<-function(d1=gexp, v1='submitted_sample_id', v2='Hugo_Symbol',  
                 v3='gexpZ'){
    d2<-d1[,c(v1, v2,v3)]
    for(q in unique(d2[,v1])){
      s<-d2[,v1]==q
      d2[s,v3] <- (d2[s,v3]-mean(d2[s,v3],na.rm=T))/sd(d2[s,v3],na.rm=T)
    }
    return(d2)
  }
  
  #map from chromosomal location to Hugo Symbol
  #exaustive mapping method: as long as having an overlap with the genes
  chrm2hs<-function(d1, vs=NULL, v2='mutation_type', vid='submitted_sample_id',
                    g1=g_list3){
    #internal function to filter out problomatic segments
    filt1<-function(x){
      x1s<-g2[x,]
      dis1<-max(x1s$end_position) - min(x1s$start_position)
      dis2<-max(x1s$end_position-x1s$start_position)
      x1<-x1s$Hugo_Symbol 
      #remove the pieces too long to be true
      if(dis1<=5*dis2){return(x1)}else{return(NULL)}
    }
    #d1=mut2; 
    vid<-vid[1]
    if(is.null(vs)){
      vs<-c('chromosome','chromosome_start','chromosome_end')
    }
    if(any(!vs%in%colnames(d1))){stop('chrm2hs, not matched vs var names')}
    #get LOH
    loh<-unique(d1[grepl('loh', tolower(d1[,v2])),c(vid,v2,vs)])
    loh3<-NULL
    if(nrow(loh)>0){
      loh$lab<-gsub(' ','_',loh[,v2])
      loh$Hugo_Symbol<-NA
      c1<-c2<-c3<-c4<-NULL
      for(chr1 in unique(loh[,vs[1]])){
        g2<-g1[g1$chromosome_name==chr1,]
        loh1<-loh[loh[,vs[1]]==chr1,]
        n1<-nrow(loh1); n2<-nrow(g2)
        if(any(n1==0|n2==0)) next
        mat1s<-matrix(rep(loh1[,vs[2]],n2), ncol=n2)
        mat1e<-matrix(rep(loh1[,vs[3]],n2), ncol=n2)
        mat2s<-t(matrix(rep(g2$start_position,n1), ncol=n1))
        mat2e<-t(matrix(rep(g2$end_position,n1), ncol=n1))
        s1<-mat1s<=mat2s&mat1e>=mat2s | mat1s<=mat2e&mat1e>=mat2e
        s2<-apply(s1, 1, filt1)
        if(is.null(s2) | length(s2)==0) next
        ls2<-sapply(s2, length);
        MM<-1:length(ls2);
        s2.ul<-unlist(s2)
        c1<-c(c1,unlist(lapply(MM,function(x){rep(loh1[x,vid],ls2[[x]])})))
        c2<-c(c2,s2.ul)
        c3<-c(c3,unlist(lapply(MM,function(x){rep(loh1[x,'lab'],ls2[[x]])})))
        c4<-c(c4,rep(chr1,length(s2.ul)))
      }
      d2<-data.frame(c1, c2,c3, c4)
      if(nrow(d2)>0){
        colnames(d2)<-c(vid,'Hugo_Symbol','cnv','chromosome')
        d2$mutation_type<-paste0('CNV:',d2$cnv)
        loh3<-d2
      }
    }
    
    #get gain or loss result
    d1[,v2]<-tolower(as.character(d1[,v2]))
    d1<-unique(d1[d1[,v2]%in%c('gain','loss'),c(vid,v2,vs)])
    tb1<-table(d1$mutation_type)
    print(tb1)
    if(all(is.na(tb1[c('gain','loss')]))) return(NULL)
    d1$dum<-ifelse(d1[,v2]=='gain', 1, -1) 
    d1$Hugo_Symbol<-NA
    c1<-c2<-c3<-c4<-d3<-NULL
    for(chr1 in unique(d1[,vs[1]])){#procece chrom by chrom
      g2<-g1[g1$chromosome_name==chr1,]
      dd1<-d1[d1[,vs[1]]==chr1,]
      n1<-nrow(dd1); n2<-nrow(g2)
      if(any(n1==0|n2==0)) next
      mat1s<-matrix(rep(dd1[,vs[2]],n2), ncol=n2)
      mat1e<-matrix(rep(dd1[,vs[3]],n2), ncol=n2)
      mat2s<-t(matrix(rep(g2$start_position,n1), ncol=n1))
      mat2e<-t(matrix(rep(g2$end_position,n1), ncol=n1))
      s1<-mat1s<=mat2s&mat1e>=mat2s | mat1s<=mat2e&mat1e>=mat2e
      s2<-apply(s1, 1, filt1)
      if(is.null(s2) | length(s2)==0) next
      ls2<-sapply(s2, length); 
      MM<-1:length(ls2);
      s2.ul<-unlist(s2)
      c1<-c(c1,unlist(lapply(MM,function(x){rep(dd1[x,vid],ls2[[x]])})))
      c2<-c(c2,s2.ul)
      c3<-c(c3,unlist(lapply(MM,function(x){rep(dd1[x,'dum'],ls2[[x]])})))
      c4<-c(c4,rep(chr1,length(s2.ul)))
    }
    d2<-data.frame(c1, c2,c3, c4)
    if(nrow(d2)>0){
      colnames(d2)<-c(vid,'Hugo_Symbol','cnv','chromosome')
      d3<-aggregate(cnv~., data=d2,FUN=sum)
      d3$mutation_type<-'CNV:eql'
      d3$mutation_type[d3$cnv>0]<-'CNV:amp'
      d3$mutation_type[d3$cnv<0]<-'CNV:del'
    }
    d4<-rbindlist(list(d3,loh3))
    return(d4)
  }
  
  #function convert numeric age to categories
  age2c<-function(ag1=clin$donor_age_at_enrollment){
    ag1C<-rep(NA,length(ag1))
    ag1C[ag1<=1]<-'0~1'
    ag1C[ag1>1 & ag1<=5]<-'2~5'
    ag1C[ag1>5 & ag1<=10]<-'6~10'
    ag1C[ag1>10 & ag1<=15]<-'11~15'
    ag1C[ag1>15 & ag1<=20]<-'16~20'
    ag1C[ag1>20 & ag1<=25]<-'21~25'
    ag1C[ag1>25 & ag1<=30]<-'26~30'
    ag1C[ag1>30 & ag1<=35]<-'31~35'
    ag1C[ag1>35 & ag1<=40]<-'36~40'
    ag1C[ag1>40 & ag1<=45]<-'41~45'
    ag1C[ag1>45 & ag1<=50]<-'46~50'
    ag1C[ag1>50 & ag1<=55]<-'51~55'
    ag1C[ag1>55 & ag1<=60]<-'56~60'
    ag1C[ag1>60 & ag1<=65]<-'61~65'
    ag1C[ag1>65 & ag1<=70]<-'66~70'
    ag1C[ag1>70 & ag1<=75]<-'71~75'
    ag1C[ag1>75 & ag1<=80]<-'76~80'
    ag1C[ag1>80 & ag1<=85]<-'81~85'
    ag1C[ag1>85 & ag1<=90]<-'86~90'
    ag1C[ag1>95]<-'96+'
    return(ag1C)
  }
  
  
  #---get ranges for age, os---#
  ifunc1<-function(x){
    x<-x[is.finite(x)&!is.na(x)]
    if(length(x)==0) return(NA) else return(range(x))
  }
  
}

#get mappings between genes symbols and ensembles
if(FALSE){
  load(gnameFile)#for gene.ensemble
  library('biomaRt')
  mart <- useMart(biomart = "ensembl", dataset = "hsapiens_gene_ensembl")
  # listAttributes(mart)
  G_list<-getBM(attributes=c("ensembl_gene_id", 'refseq_mrna', "hgnc_symbol",
                             'ensembl_transcript_id', 'chromosome_name',
                             'start_position', 'end_position'),
                filters ="ensembl_gene_id",
                values  =gene.ensemble, 
                mart    =mart)
  colnames(G_list)[1:4] <- c('ensembl','refseq', 'Hugo_Symbol', 'ensemblTr')
  G_list<-G_list[G_list$Hugo_Symbol!='',]
  g_list<-unique(G_list[,c('ensembl','Hugo_Symbol')])
  g_list2<-unique(G_list[G_list$refseq!='',c('refseq','Hugo_Symbol')])
  g_list5<-unique(G_list[G_list$ensemblTr!='',c('ensemblTr','Hugo_Symbol')])
  
  #for mapping between HG and chromosome location
  g_list3<-unique(G_list[,c('Hugo_Symbol','chromosome_name','start_position',
                            'end_position', 'band')])
  g_list3<-g_list3[!is.na(g_list3$Hugo_Symbol),]
  g_list3<-g_list3[g_list3$Hugo_Symbol!='',]
  st1<-aggregate(start_position~Hugo_Symbol+chromosome_name, 
                 data=g_list3, FUN=min)
  ed1<-aggregate(end_position~Hugo_Symbol+chromosome_name, 
                 data=g_list3, FUN=max)
  g_list3<-merge(st1,ed1)

  #get illumina probe ID
  g_list4<-read.csv(file.path(path1, path1file[4]), h=T, comment.char='#')
  g_list4<-unique(g_list4[,c('PROBE_ID','GENE')])
  colnames(g_list4)<-c('ILL_prob','Hugo_Symbol')
  
  #save the gene mapping file
  g_list12<-list(ensembl=g_list, refseq=g_list2, illprob=g_list4, ensemblTr=g_list5)
  save(gene.ensemble, g_list, g_list2, g_list12, g_list3, file=gnameFile)

  

}else{load(gnameFile)} #for the gene mapping: g_list

#build up the innitial data summary file
prj.sum0<-data.frame(id=NA, db=NA, db_id=NA, 
                     proj_id=NA, proj_name=NA, country=NA,
                     age_range=NA, #at enrollment age
                     OS_range=NA,  #survival_time
                     N=NA, #total number of subjects
                     N_mut=NA, N_mut_exp_array=NA, N_mut_exp_seq=NA, # Num pts
                     m_mutgene=NA, #number of unique genes
                     N_bmk=NA, #number of patients in bmk data
                     m_bmk=NA  #number of unique biomarkers
                     )

if(runDB1){
  prj.sum<-NULL
  dataspec<-data.frame(DataName=NULL, VarName=NULL)
}else{
  prj.sum<-read.csv(file.path(topath, projfile), h=T)
}


#---ICGC---#
#https://docs.icgc.org/submission/guide/donor-clinical-data-guidelines/
if(runDB1){
  icgc.stid<-0 #start id
  load(file.path(path1, path1file[1]))#fnm will be loaded here.
  prj_code<-read.csv(file.path(path1,path1file[2]), h=T)
  pexp_antb<-read.csv(file.path(path1,path1file[3]),h=T, comment.char='#')
  icgc.id<-1:length(fnm)
  if(!dir.exists(file.path(topath, db1))){dir.create(file.path(topath, db1))}
  #fnm1.cnt; fnm1.cnms; fnm1; fnm;
  prjid<-1
  for(i in icgc.id){
    #get the project name
    #i=78 #have donor therapy data
    pnm1<-names(fnm)[i]
    fin1<-file.path(path1,pnm1)#the input project folder
    ff1<-file.path(topath,db1,i)#output folder name
    print(paste(i, pnm1,'start.'))
    
    #define the output file names
    of.clin<-file.path(ff1, paste0(pnm1,com.clin))
    of.gexp1<-file.path(ff1, paste0(pnm1,com.gexp1)) #zscore only
    of.gexp1m<-file.path(ff1, paste0(pnm1,com.gexp1m)) 
    of.gexp2<-file.path(ff1, paste0(pnm1,com.gexp2)) #zscore only
    of.gexp2m<-file.path(ff1, paste0(pnm1,com.gexp2m))
    of.mut1<-file.path(ff1, paste0(pnm1,com.mut1))#including all the mutations
    of.mut2<-file.path(ff1, paste0(pnm1,com.mut2))
    of.cnv<-file.path(ff1, paste0(pnm1,com.cnv))
    of.pexp<-file.path(ff1, paste0(pnm1,com.pexp))
    of.pexpm<-file.path(ff1, paste0(pnm1,com.pexpm))
    of.sum<-file.path(ff1, paste0(pnm1,com.sum))#available for heatmap
    
    #define all the originial file names 
    clinf1<-file.path(fin1, paste0('donor.',pnm1,'.tsv'))
    clinf2<-file.path(fin1, paste0('donor_family.',pnm1,'.tsv'))
    clinf3<-file.path(fin1,paste0('donor_therapy.',pnm1,'.tsv'))
    clinf4<-file.path(fin1, paste0('sample.',pnm1,'.tsv'))
    clinf5<-file.path(fin1, paste0('specimen.',pnm1,'.tsv'))
    gexpf1<-file.path(fin1,paste0("exp_array.",pnm1, '.tsv'))
    gexpf2<-file.path(fin1,paste0("exp_seq.",pnm1, '.tsv'))
    pexpf1<-file.path(fin1,paste0("protein_expression.",pnm1, '.tsv'))
    mutf1<-file.path(fin1, paste0('simple_somatic_mutation.open.',pnm1,'.tsv'))
    mutf2<-file.path(fin1, paste0('copy_number_somatic_mutation.',pnm1,'.tsv'))
    
    #if no clin data, then skip the project
    if(!file.exists(clinf1)){next}
    if(!dir.exists(ff1)){dir.create(ff1)}

    #---setup original mutation files---#
    if(file.exists(of.mut1) & !rerunMut){
      t1<-try(mut<-as.data.frame(read_feather(of.mut1)))
      if(class(t1)=='try-error') file.remove(of.mut1)
    }else{mut<-NULL}
    subj1<-NULL
    if(file.exists(mutf1)){#simple somatic
      if(rerunMut|!file.exists(of.mut1)){
        mut1<-as.data.frame(fread(mutf1, h=T))
        mut1.nm<-c('submitted_sample_id', 'gene_affected', 'chromosome',
                   'mutation_type', 'aa_mutation','cds_mutation')
        mut<-gnmIcgc(unique(mut1[,mut1.nm]), 'gene_affected')
        write_feather(mut, of.mut1)#write down the mut data
      }
      u1s<-!grepl('CNV:|FUS:',mut$mutation_type)
      u1<-unique(mut$submitted_sample_id[u1s])
      if(length(u1)>0){
        subj1<-data.frame(submitted_sample_id=u1)
        subj1$mut<-1
      }
    }
    #setup mut_pts
    datasum<-NULL
    datasum<-getDSum(mut$submitted_sample_id, v2=c('submitted_sample_id','mut'))
    #---End original mutation data setup---#
    
    #---setup cnv files---#
    if(file.exists(of.mut2)){
      file.remove(of.mut2)
      # t1<-try(mut_cnv<-as.data.frame(read_feather(of.mut2)))
      # if(class(t1)=='try-error') file.remove(of.mut2)
    }
    subj2<-NULL; mut2<-mut_cnv<-NULL; 
    if(file.exists(mutf2)){#copy number somatic
      # if(rerunMut|!file.exists(of.mut2)){
      if(rerunMut&file.exists(of.mut1)){ #if mut.feather is ready
        mut2<-as.data.frame(fread(mutf2, h=T))
        print(tmp1<-paste('CNV: Proj',i,paste(unique(mut2$platform, collapse=', '))))
        cnv.plat<-c(cnv.plat,tmp1)
        print(paste(unique(mut2$mutation_type, collapse=', ')))
        mut_cnv<-chrm2hs(d1=mut2, g1=g_list3,
                         vs=c("chromosome", "chromosome_start","chromosome_end"), 
                         v2='mutation_type', vid='submitted_sample_id')
        if(!is.null(mut_cnv) && !is.null(nrow(mut_cnv)) && nrow(mut_cnv)>0){
          # write_feather(mut_cnv, of.mut2)
          cnv1c<-colnames(mut_cnv)[colnames(mut_cnv)%in%colnames(mut)]
          mut_cnv<-as.data.frame(mut_cnv)
          mut<-rbindlist(list(mut, mut_cnv[,cnv1c]),fill=T)
          write_feather(mut, of.mut1)#append to mut and overwrite.
        }
      }else if(!rerunMut){
        mut2<-mut_cnv<-mut[grepl('CNV:',mut$mutation_type,fixed=T),]
      }else{#when mut not exist but still require to update mut data
        mut2<-as.data.frame(fread(mutf2, h=T))
        print(tmp1<-paste('CNV: Proj',i,paste(unique(mut2$platform, collapse=', '))))
        cnv.plat<-c(cnv.plat,tmp1)
        mut_cnv<-chrm2hs(d1=mut2, g1=g_list3,
                         vs=c("chromosome", "chromosome_start","chromosome_end"), 
                         v2='mutation_type', vid='submitted_sample_id')
        write_feather(mut_cnv, of.cnv)
      }
      if(!is.null(mut_cnv) && nrow(mut_cnv)>0){
        u1<-unique(mut_cnv$submitted_sample_id)
        subj2<-data.frame(submitted_sample_id=u1)
        subj2$cnv<-1
      }
    }
    #setup mut_cnv_pts
    # datasum<-getDSum(mut2$submitted_sample_id, 
    #                  v2=c('submitted_sample_id','cnv'))
    #---End CNV data setup---#
    
    #---get sample id for mutation data---#
    subj.mut<-unique(mut$submitted_sample_id)
    has.subj.mut<-length(subj.mut)>0
    #---End sample id setup---#
    
    #---set gene expression array data---#
    if (file.exists(of.gexp1) & !rerunExp){
      try1<-try(gexpa<-as.data.frame(read_feather(of.gexp1)))
      if(class(try1)=='try-error')file.remove(of.gexp1)
    }else{gexpa<-NULL}
    subj3<-NULL
    if(file.exists(gexpf1)){
      if(rerunExp|!file.exists(of.gexp1)){
        gexp1<-as.data.frame(fread(gexpf1, h=T))
        gexp1.nm<-c('submitted_sample_id', 'gene_id',
                    'normalized_expression_value')
        if(!gexp1.nm[3]%in%colnames(gexp1)){stop('check gexp1.nm')}
        gexp1t<-gexp1[,gexp1.nm]
        colnames(gexp1t)[3]<-'gexpZ'
        gexpa<-gnmIcgc(d1=gexp1t, v1='gene_id')
        gexpa<-getZ(d1=gexpa)
        write_feather(gexpa, of.gexp1)
      }
      if(has.subj.mut){#samples with both mut and expa
        tmp<-gexpa[gexpa$submitted_sample_id%in%subj.mut,]
        if(nrow(tmp)>0){write_feather(tmp, of.gexp1m)}
      }
      if(!is.null(gexpa) && nrow(gexpa)>0){
        u1<-unique(gexpa$submitted_sample_id)
        subj3<-data.frame(submitted_sample_id=u1)
        subj3$gexpa<-1
      }
    }
    #setup gexpa_pts
    # datasum<-getDSum(gexpa$submitted_sample_id, 
    #                  v2=c('submitted_sample_id','gexpa'))
    #---End gene expression micro array data setup---#
    
    #---set gene expression rnaseq data---#
    if(file.exists(of.gexp2) & !rerunExp){
      try1<-try(gexps<-as.data.frame(read_feather(of.gexp2)))
      if(class(try1)=='try-error')file.remove(of.gexp2)
    }else{gexps<-NULL}
    subj4<-NULL
    if(file.exists(gexpf2)){
      if(rerunExp|!file.exists(of.gexp2)){
        gexp2<-as.data.frame(fread(gexpf2, h=T))
        gexp2.nm1<-c('normalized_expression_value', 'normalized_read_count')
        gexp2.nm1<-gexp2.nm1[gexp2.nm1%in%colnames(gexp2)]
        if(length(gexp2.nm1)==0){stop('check gexp2.nm1')}
        gexp2.nm<-c('submitted_sample_id', 'gene_id',gexp2.nm1[1])
        gexp2t1<-gexp2[,gexp2.nm]
        colnames(gexp2t1)[3]<-'gexpZ'
        gexps<-gnmIcgc(gexp2t1, 'gene_id')
        gexps<-getZ(d1=gexps)
        write_feather(gexps, of.gexp2)
      }
      if(has.subj.mut){
        tmp<-gexps[gexps$submitted_sample_id%in%subj.mut,]
        if(nrow(tmp)>0){write_feather(tmp, of.gexp2m)}
      }
      if(!is.null(gexps) && nrow(gexps)>0){
        u1<-unique(gexps$submitted_sample_id)
        subj4<-data.frame(submitted_sample_id=u1)
        subj4$gexps<-1
      }
    }
    #setup gexps_pts
    # datasum<-getDSum(gexps$submitted_sample_id, 
    #                  v2=c('submitted_sample_id','gexps'))
    #---End gene expression rnaseq data setup---#
    
    #---setup protein data---#
    if (file.exists(of.pexp) & !rerunPExp){
      try1<-try(pExp<-as.data.frame(read_feather(of.pexp)))
      if(class(try1)=='try-error')file.remove(of.pexp)
    }else{pExp<-NULL}
    subj5<-NULL
    if(file.exists(pexpf1)){
      if(rerunPExp|!file.exists(of.pexp)){
        pexp1<-as.data.frame(fread(pexpf1, h=T))
        pexp1.nm<-c('submitted_sample_id', 'gene_name', 
                    'normalized_expression_level')
        pexp1<-pexp1[,pexp1.nm]
        colnames(pexp1)[3]<-'pexpZ'
        pexp1.nm1<-c('gene_name','Hugo_Symbol')
        if(any(unique(pexp1$gene_name)[1:40]%in%g_list$Hugo_Symbol)){
          colnames(pexp1)[colnames(pexp1)=='gene_name']<-'Hugo_Symbol'
          pExp<-pexp1
        }else{
          pExp<-merge(pexp1,pexp_antb[,pexp1.nm1],by='gene_name')
        }
        write_feather(pExp, of.pexp)
      }
      if(has.subj.mut){
        tmp<-pExp[pExp$submitted_sample_id%in%subj.mut,]
        if(nrow(tmp)>0){write_feather(tmp, of.pexpm)}
      }
      if(!is.null(pExp) && nrow(pExp)>0){
        u1<-unique(pExp$submitted_sample_id)
        subj5<-data.frame(submitted_sample_id=u1)
        subj5$pExp<-1
      }
    }#ready to save
    #setup pexp_pts
    #---End protein data setup---#
    
    #---import and set up clin files---#
    if(file.exists(of.clin) & !rerunClin){
      t1<-try(clin<-as.data.frame(read_feather(of.clin)))
      if(class(t1)=='try-error') file.remove(of.clin)
    }
    if(rerunClin|!file.exists(of.clin)){
      clin1<-as.data.frame(fread(clinf1, h=T))
      clin1.nm<-c('submitted_donor_id', 'donor_sex', 
                  'donor_vital_status', 'disease_status_last_followup',
                  'donor_age_at_enrollment', 'donor_age_at_diagnosis',
                  'donor_age_at_last_followup', 'donor_relapse_interval',
                  'donor_tumour_stage_at_diagnosis', 'donor_survival_time')
      clin<-unique(clin1[,colnames(clin1)%in%clin1.nm])
      #categorize age level
      clin.nm.age<-c( 'donor_age_at_enrollment', 'donor_age_at_diagnosis',
                      'donor_age_at_last_followup')
      c1n<-colnames(clin)[colnames(clin)%in%clin.nm.age]
      if(length(c1n)>0){
        clin.agc<-apply(as.matrix(clin[,c1n],ncol=length(c1n)), 2, age2c)
        colnames(clin.agc)<-gsub('age','agec',c1n)
        clin<-data.frame(clin,clin.agc)
      }
      if(file.exists(clinf2)){#donor family
        clin2<-as.data.frame(fread(clinf2, h=T))
        clin2.nm<-c("submitted_donor_id",'donor_has_relative_with_cancer_history')
        clin2<-unique(clin2[, clin2.nm])
        clin2<-unique(clin2[clin2[,2]%in%c('yes','no'),])
        clin<-merge(clin, clin2, by='submitted_donor_id',all.x=T)
      }
      if(file.exists(clinf3)){#donor therapy
        clin3<-as.data.frame(fread(clinf3, h=T))
        clin3.nm<-c("first_therapy_type", "first_therapy_therapeutic_intent",
                    "first_therapy_start_interval", "first_therapy_duration",
                    "first_therapy_response", "second_therapy_type",
                    "second_therapy_therapeutic_intent",
                    "second_therapy_start_interval", "second_therapy_duration",
                    "second_therapy_response","other_therapy" )
        clin3.nm <- clin3.nm[clin3.nm%in%colnames(clin3)]
        clin3<-unique(clin3[,c("submitted_donor_id",clin3.nm)])
        clin3[clin3=='NA'|clin3==''|clin3=='unknown']<-NA
        clin<-merge(clin, clin3, by='submitted_donor_id',all.x=T)
      }
      if(file.exists(clinf4)){#samples
        clin4<-as.data.frame(fread(clinf4,h=T))
        clin4.nm<-c('submitted_donor_id','submitted_sample_id',
                    'submitted_specimen_id')
        clin4<-unique(clin4[,clin4.nm])
        clin<-merge(clin,clin4, by='submitted_donor_id',all.x=T)
      }
      if(file.exists(clinf5)){#specificity
        clin5<-as.data.frame(fread(clinf5,h=T))
        clin5.nm1<-c('submitted_donor_id', 'submitted_specimen_id')
        clin5.nm<-c('specimen_type', 'specimen_donor_treatment_type',
                    'specimen_interval', 'specimen_processing',
                    'tumour_stage_system','tumour_histological_type', 
                    'tumour_stage')
        clin5.nm<-clin5.nm[clin5.nm%in%colnames(clin5)]
        clin5<-unique(clin5[,c(clin5.nm1,clin5.nm)])
        clin<-merge(clin, clin5, by=clin5.nm1, all.x=T)
      }
      #clean up the final clin data
      colnames(clin)<-gsub('donor_','',colnames(clin))
      if(!is.null(subj1)){clin<-merge(clin,subj1, all.x=T)}
      if(!is.null(subj2)){clin<-merge(clin,subj2, all.x=T)}
      if(!is.null(subj3)){clin<-merge(clin,subj3, all.x=T)}
      if(!is.null(subj4)){clin<-merge(clin,subj4, all.x=T)}
      if(!is.null(subj5)){clin<-merge(clin,subj5, all.x=T)}
      write_feather(clin, of.clin)
    }
    #setup clin_pts
    kv1<-c('submitted_id', 'submitted_sample_id','submitted_specimen_id')
    datasum<-getDSum(clin, kvar=kv1, ds=NULL)
    #---End clin setup---#
    
    
    #---save the data summary file---#
    write_feather(datasum, of.sum)
    #---End: save the data summary file---#
    
    #---get ranges for age, os---#
    ifunc1<-function(x){
      x<-x[is.finite(x)&!is.na(x)]
      if(length(x)==0) return(NA) else return(range(x))
    }
    age.rg<-ifunc1(clin[,grepl('age_at_enrollment',colnames(clin))])
    os.rg<-ifunc1(clin[,grepl('survival_time', colnames(clin))])
    #---End get ranges for age, os---#
       
    #---update the summary table---#
    prj.sum<-rbind(prj.sum, prj.sum0)
    prj.sum$id[prjid] <- prjid + icgc.stid
    prj.sum$db[prjid] <- db1
    prj.sum$db_id[prjid] <- prjid
    prj.sum$proj_id[prjid]<-pnm1
    prj.sum$proj_name[prjid]<-prj_code$Project_Name[prj_code[,1]==pnm1]
    prj.sum$country[prjid]<-prj_code$Country[prj_code[,1]==pnm1]
    prj.sum$age_range[prjid]<-paste(age.rg,collapse='~')
    prj.sum$OS_range[prjid]<-paste(os.rg,collapse='~')
    prj.sum$N[prjid]<-length(unique(clin$submitted_id))
    prj.sum$N_mut[prjid]<-sum(datasum$mut==1)
    prj.sum$N_mut_exp_array[prjid]<-sum(datasum$mut==1&datasum$gexpa==1)
    prj.sum$N_mut_exp_seq[prjid]<-sum(datasum$mut==1&datasum$gexps==1)
    prj.sum$m_mutgene[prjid]<-length(unique(mut$Hugo_Symbol))
    print(prj.sum[prjid,])
    #---End: update the summary table---#
    
    prjid<-prjid+1
    print(paste(i, pnm1,'is done.'))
  }
  
  if(T){
    write.csv(prj.sum, 
              file=file.path(topath, gsub('.csv',paste0('_',db1,'.csv'),projfile)), 
              row.names=F)
  }
}
#---End: ICGC---#

#---MSK-IMPACT---#
if(runDB2){
  #load all impack data
  msk0<-get(load(file.path(frompath,db2, 'all_msk.Rdata')))
  lapply(msk0, dim)
  #create the folder for data depository
  if(!dir.exists(path2)){dir.create(path2)}
  
  #pull out mutation data
  mut<-distinct(msk0$mut[,c('Tumor_Sample_Barcode','Hugo_Symbol', 
                   'Variant_Classification', 'HGVSp_Short', 'cDNA_change')])
  colnames(mut)[1]<-conVar2
  colnames(mut)[3:5]<-c('mutation_type','aa_mutation','cds_mutation')
  #pull the samples had mut test
  mut.subj<-as.character(levels(mut[,conVar2]))
  
  #pull out samples had cna test
  cna.subj<-colnames(msk0$cna)[-1]
  cna.subj<-gsub('.', '-', cna.subj, fixed=T)
  #setup cna data
  cna<-melt(msk0$cna, id='Hugo_Symbol');  #proc.time()-t1
  cna<-cna[cna$value!=0,]
  colnames(cna)[2]<-conVar2
  cna$mutation_type<-'CNV:amp'
  cna$mutation_type[cna$value<0]<-'CNV:del'
  cna1<-cna[,c(conVar2, 'Hugo_Symbol','mutation_type')]
  cna1[,conVar2]<-gsub('.','-',cna1[,conVar2], fixed=T)
  
  #pull out samples had fusion test
  fus.subj<-as.character(levels(msk0$fus$Tumor_Sample_Barcode))
  #setup fusion data
  fus<-distinct(msk0$fus[,c('Tumor_Sample_Barcode', 'Hugo_Symbol', 'Fusion')])
  fus$mutation_type<-paste0('FUS:',fus$Fusion)
  colnames(fus)[1]<-conVar2
  fus1<-fus[,c(conVar2, 'Hugo_Symbol', 'mutation_type')]
  
  #add fus1 and cna1 into mut
  mut1<-data.frame(rbind_list(list(mut, cna1, fus1))) #a daa.table object
  
  #set up clinical data
  #get mapping between sample id and gene name
  clin.c1<-c('Tumor_Sample_Barcode', 'Hugo_Symbol')
  mut_ext<-distinct(msk0$mut_ext[,clin.c1])
  colnames(mut_ext)[1]<-conVar2
  #get tumor type variables
  clin.c2<-c("CANCER_TYPE", 'CANCER_TYPE_DETAILED',
    "PATIENT_ID",'SAMPLE_ID',"SPECIMEN_PRESERVATION_TYPE", 
             'SAMPLE_TYPE', "MATCHED_STATUS")
  clin.cn<-c("proj_id", "proj_name",
             conVar1, conVar2, "specimen_processing", 'specimen_type',
             'first_therapy_type')
  clin.prm<-distinct(msk0$samp[msk0$samp$SAMPLE_TYPE=='Primary',
                      c('PRIMARY_SITE',clin.c2)])
  clin.met<-distinct(msk0$samp[msk0$samp$SAMPLE_TYPE=='Metastasis',
                      c('METASTATIC_SITE',clin.c2)])
  colnames(clin.prm)[1]<-colnames(clin.met)[1]<-'tumour_histological_type'
  clin<-rbind_list(list(clin.prm, clin.met))
  colnames(clin)[-1]<-clin.cn
  clin$proj_id<-as.character(clin$proj_id)
  unique(clin$proj_id); # table(clin$proj_id)
  clin$proj_id<-gsub(' |Tumor|Tumour|Cancer|Carcinoma|Adenoma', "", clin$proj_id)
  clin$proj_id<-gsub('Skin,Non-|Sarcoma|Stromal|Neuroendocrine','',clin$proj_id)
  tb<-table(clin$proj_id)
  tb.ot<-names(tb)[tb<10]
  clin$proj_id[clin$proj_id%in%tb.ot]<-'Other'
  clin$proj_name[clin$proj_id%in%tb.ot]<-'Other'
  
  #add survial time
  pts<-distinct(msk0$pts[,c("PATIENT_ID",'SEX','SMOKING_HISTORY', 
                            'OS_MONTHS','VITAL_STATUS')])
  colnames(pts)<-c(conVar1, "sex", 'smoking_history','survival_time',
                   'vital_status')
  clin1<-data.frame(full_join(clin,pts, by=conVar1))###check survival_time
  for(i in 1:ncol(clin1)){clin1[,i]<-as.character(clin1[,i])}
  clin1[,"survival_time"]<-as.numeric(clin1[,"survival_time"])
  clin1<-clin1[!is.na(clin1$proj_id),]
  clin1$mut<-0
  clin1$mut[clin1[,conVar2]%in%mut.subj]<-1
  clin1$cna<-0
  clin1$cna[clin1[,conVar2]%in%cna.subj]<-1
  clin1$fus<-0
  clin1$fus[clin1[,conVar2]%in%fus.subj]<-1
  
  #split data by proj_id and proj_name
  kv1<-c(conVar1, conVar2)
  prjid<-1
  uni.prj<-sort(unique(clin1$proj_id))
  prj.sum2<-NULL
  icgc.stid<-nrow(prj.sum)
  for(i in 1:length(uni.prj)){
    pnm1<-uni.prj[i]
    sel1<-clin1$proj_id==uni.prj[i]
    pnm1.nm<-paste(unique(clin1$proj_name[sel1]), collapse=', ')
    clin1s<-data.frame(clin1[sel1,])
    datasum<-getDSum(clin1s, kvar=kv1, ds=NULL)
    samp1<-unique(clin1s[,conVar2])
    mut1s<-mut1[mut1[,conVar2]%in%samp1, ]
    #save data
    ff1<-file.path(topath,db2,i)#output folder name
    if(!dir.exists(ff1)){dir.create(ff1)}
    of.clin<-file.path(ff1, paste0(pnm1,com.clin))
    of.mut1<-file.path(ff1, paste0(pnm1,com.mut1))#including all the mutations
    of.sum<-file.path(ff1, paste0(pnm1,com.sum))#available for heatmap
    write_feather(clin1s, of.clin)
    write_feather(mut1s, of.mut1)
    write_feather(datasum, of.sum)
    
    #---update the summary table---#
    os.rg<-ifunc1(clin1s[,grepl('survival_time', colnames(clin1s))])
    prj.sum2<-rbind(prj.sum2, prj.sum0)
    prj.sum2$id[prjid] <- prjid + icgc.stid
    prj.sum2$db[prjid] <- db2
    prj.sum2$db_id[prjid] <- prjid
    prj.sum2$proj_id[prjid]<-pnm1
    prj.sum2$proj_name[prjid]<-pnm1.nm
    prj.sum2$country[prjid]<-'US'
    prj.sum2$age_range[prjid]<-'NA'
    prj.sum2$OS_range[prjid]<-paste(os.rg,collapse='~')
    prj.sum2$N[prjid]<-length(unique(clin1s[,conVar1]))
    prj.sum2$N_mut[prjid]<-sum(datasum$mut==1)
    prj.sum2$N_mut_exp_array[prjid]<-sum(datasum$mut==1&datasum$gexpa==1)
    prj.sum2$N_mut_exp_seq[prjid]<-sum(datasum$mut==1&datasum$gexps==1)
    prj.sum2$m_mutgene[prjid]<-length(unique(mut$Hugo_Symbol))
    print(prj.sum2[prjid,])
    #---End: update the summary table---#
    prjid<-prjid+1
    print(paste(i, pnm1,'is done.'))
  }
  write.csv(prj.sum2, 
            file=file.path(topath, 
                           gsub('.csv',paste0('_',db2,'.csv'), projfile)), 
            row.names=F) 
}
#---End: MSK-IMPACT---#

#---GENIE---#
if(runDB3){
  #load the GENIE data
  path3file <-dir(path3f); path3file;
  gne<-list()
  for(i in 1:length(path3file)){
    gne[[i]]<-get(load(file.path(path3f, path3file[i])))
  }
  names(gne)<-gsub('genie_|.Rdata','', path3file)
  lapply(gne, dim)
  #pull out mutation data
  mut<-distinct(gne$mut1[,c('Tumor_Sample_Barcode','Hugo_Symbol',
                            'Variant_Classification','HGVSp_Short', 'HGVSc','Chromosome')])
  colnames(mut)[1]<-conVar2
  colnames(mut)[3]<-'mutation_type'
  colnames(mut)[4]<-'aa_mutation'
  colnames(mut)[5]<-'cds_mutation'
  #pull out the samples with mutation test
  mut.subj<-as.character(levels(mut[,conVar2]))
  
  #pull out samples with cna test
  cna<-gne$cna1
  colnames(cna)[-1]<-gsub('.','-', colnames(cna)[-1], fixed=T)
  #pull out samples had cna test
  cna.subj<-colnames(cna)[-1]
  #setup cna data
  cna<-melt(cna, id='Hugo_Symbol');  #proc.time()-t1
  cna<-cna[!is.na(cna$value) & cna$value!=0,]
  table(cna$value)#check different levels of copy number alteration
  colnames(cna)[2]<-conVar2
  cna$mutation_type<-'CNV:amp'
  cna$mutation_type[cna$value<0]<-'CNV:del'
  cna1<-cna[,c(conVar2, 'Hugo_Symbol','mutation_type')]
  cna1[,conVar2]<-gsub('.','-',cna1[,conVar2], fixed=T)
  
  #pull out samples with fus test
  fus.subj<-as.character(levels(gne$fus1$Tumor_Sample_Barcode))
  #setup fusion data
  fus<-distinct(gne$fus1[,c('Tumor_Sample_Barcode', 'Hugo_Symbol', 'Fusion')])
  fus$mutation_type<-paste0('FUS:',gsub(' fusion', '', fus$Fusion))
  colnames(fus)[1]<-conVar2
  fus1<-fus[,c(conVar2, 'Hugo_Symbol', 'mutation_type')]

  #add fus1 and cna1 into mut
  mut1<-data.frame(rbind_list(list(mut, cna1, fus1))) #a data.table object

  #set up clinical data
  #get mapping between sample id and gene name
  clin.c1<-c('PATIENT_ID','SAMPLE_ID', 'CANCER_TYPE', 'SEX','PRIMARY_RACE',
             'ETHNICITY','AGE_AT_SEQ_REPORT','SAMPLE_TYPE')
  clin<-distinct(gne$clin[,clin.c1])
  clin$CANCER_TYPE<-as.character(clin$CANCER_TYPE)
  clin$ct<-gsub(' |Cancer|, NOS| Tumor|of|Sarcoma|Carcinoma|Neoplasm', "", 
                clin$CANCER_TYPE)
  clin.c2<-c("ct", "CANCER_TYPE", 
             "PATIENT_ID",'SAMPLE_ID',"SEX", 'AGE_AT_SEQ_REPORT', 
             'SAMPLE_TYPE', "PRIMARY_RACE", 'ETHNICITY')
  clin.cn<-c("proj_id", "proj_name",
             conVar1, conVar2, "sex", 'age_at_enrollment', 'specimen_type',
             'race','ethnicity')
  clin<-clin[,clin.c2]
  colnames(clin)<-clin.cn
  clin$proj_id<-as.character(clin$proj_id)
  tb<-table(clin$proj_id)
  tb.ot<-names(tb)[tb<10]
  clin$proj_id[clin$proj_id%in%tb.ot]<-'Other'
  clin$proj_name[clin$proj_id%in%tb.ot]<-'Other'
  
  #create the folder for data depository
  if(!dir.exists(path3)){dir.create(path3)}
  
  #add survial time
  clin1<-clin
  clin1$survival_time<-clin1$vital_status<-NA
  for(i in 1:ncol(clin1)){clin1[,i]<-as.character(clin1[,i])}
  clin1[,"survival_time"]<-as.numeric(clin1[,"survival_time"])
  clin1<-clin1[!is.na(clin1$proj_id),]
  clin1$mut<-0
  clin1$mut[clin1[,conVar2]%in%mut.subj]<-1
  clin1$cna<-0
  clin1$cna[clin1[,conVar2]%in%cna.subj]<-1
  clin1$fus<-0
  clin1$fus[clin1[,conVar2]%in%fus.subj]<-1
  
  #split data by proj_id and proj_name
  kv1<-c(conVar1, conVar2)
  prjid<-1
  uni.prj<-sort(unique(clin1$proj_id))
  prj.sum3<-NULL
  
  for(i in 1:length(uni.prj)){
    pnm1<-uni.prj[i]
    sel1<-clin1$proj_id==uni.prj[i]
    pnm1.nm<-paste(unique(clin1$proj_name[sel1]), collapse=', ')
    clin1s<-data.frame(clin1[sel1,])
    datasum<-getDSum(clin1s, kvar=kv1, ds=NULL)
    samp1<-unique(clin1s[,conVar2])
    mut1s<-mut1[mut1[,conVar2]%in%samp1, ]
    #save data
    ff1<-file.path(topath,db3,i)#output folder name
    if(!dir.exists(ff1)){dir.create(ff1)}
    of.clin<-file.path(ff1, paste0(pnm1,com.clin))
    of.mut1<-file.path(ff1, paste0(pnm1,com.mut1))#including all the mutations
    of.sum<-file.path(ff1, paste0(pnm1,com.sum))#available for heatmap
    write_feather(clin1s, of.clin)
    write_feather(mut1s, of.mut1)
    write_feather(datasum, of.sum)
    
    #---update the summary table---#
    os.rg<-ifunc1(clin1s[,grepl('survival_time', colnames(clin1s))])
    prj.sum3<-rbind(prj.sum3, prj.sum0)
    prj.sum3$id[prjid] <- prjid
    prj.sum3$db[prjid] <- db3
    prj.sum3$db_id[prjid] <- prjid
    prj.sum3$proj_id[prjid]<-pnm1
    prj.sum3$proj_name[prjid]<-pnm1.nm
    prj.sum3$country[prjid]<-'US'
    prj.sum3$age_range[prjid]<-'NA'
    prj.sum3$OS_range[prjid]<-paste(os.rg,collapse='~')
    prj.sum3$N[prjid]<-length(unique(clin1s[,conVar1]))
    prj.sum3$N_mut[prjid]<-sum(datasum$mut==1)
    prj.sum3$N_mut_exp_array[prjid]<-sum(datasum$mut==1&datasum$gexpa==1)
    prj.sum3$N_mut_exp_seq[prjid]<-sum(datasum$mut==1&datasum$gexps==1)
    prj.sum3$m_mutgene[prjid]<-length(unique(mut$Hugo_Symbol))
    print(prj.sum3[prjid,])
    #---End: update the summary table---#
    prjid<-prjid+1
    print(paste(i, pnm1,'is done.'))
  }
  write.csv(prj.sum3, 
            file=file.path(topath, gsub('.csv',paste0('_',db3,'.csv'),projfile)), 
            row.names=F)
}
#---End: GENIE---#


#---integrate projects_summary file---#
if(TRUE){
  candF<-paste0('projects_summary_',c(db1,db2,db3), '.csv')
  psf<-dir(gsub('/output','',topath))
  psf<-candF[candF%in%psf]
  prj.sum<-NULL
  for(j in 1:length(psf)){
    prj.sum<-rbind(prj.sum,
                   read.csv(file.path(topath,psf[j]), h=T))
  }
  prj.sum$id<-1:nrow(prj.sum)
  write.csv(prj.sum, file=file.path(topath, projfile), row.names=F)
}

#----save platform information---#
if(FALSE){
  write.csv(cnv.plat, file=file.path(topath, 'CNV_plotforms.csv'),row.names=F)
}

Sys.time()-beginTime


#process template
if(FALSE){
  #---setup original mutation files---#
  #---End original mutation data setup---#
  
  #---setup cnv files---#
  #---End CNV data setup---#
  
  #---get sample id for mutation data---#
  #---End sample id setup---#
  
  #---set gene expression array data---#
  #---End gene expression micro array data setup---#
  
  #---set gene expression rnaseq data---#
  #---End gene expression rnaseq data setup---#
  
  #---setup protein data---#
  #---End protein data setup---#
  
  #---import and set up clin files---#
  #setup clin_pts
  kv1<-c('submitted_id', 'submitted_sample_id','submitted_specimen_id')
  datasum<-getDSum(clin, kvar=kv1, ds=NULL)
  #---End clin setup---#
  
  #---save the data summary file---#
  write_feather(datasum, of.sum)
  #---End: save the data summary file---#
  
  #---get ranges for age, os---#
  #---End get ranges for age, os---#
  
  #---update the summary table---#
  prj.sum<-rbind(prj.sum, prj.sum0)
  prj.sum$id[prjid] <- prjid + icgc.stid
  prj.sum$db[prjid] <- db1
  prj.sum$db_id[prjid] <- prjid
  prj.sum$proj_id[prjid]<-pnm1
  prj.sum$proj_name[prjid]<-prj_code$Project_Name[prj_code[,1]==pnm1]
  prj.sum$country[prjid]<-prj_code$Country[prj_code[,1]==pnm1]
  prj.sum$age_range[prjid]<-paste(age.rg,collapse='~')
  prj.sum$OS_range[prjid]<-paste(os.rg,collapse='~')
  prj.sum$N[prjid]<-length(unique(clin$submitted_id))
  prj.sum$N_mut[prjid]<-sum(datasum$mut==1)
  prj.sum$N_mut_exp_array[prjid]<-sum(datasum$mut==1&datasum$gexpa==1)
  prj.sum$N_mut_exp_seq[prjid]<-sum(datasum$mut==1&datasum$gexps==1)
  prj.sum$m_mutgene[prjid]<-length(unique(mut$Hugo_Symbol))
  print(prj.sum[prjid,])
  #---End: update the summary table---#
}

if(TRUE){#select subsets of lb data
  markerInCohort<-function(comDD, #the combined data gain in getData_dy.r
                           subjid, #subject id (multiple selection)
                           armcd,  #cohort information (multiple selection)
                           lbspec, #specific (single selection)
                           lbtest,  #lab test marker (single selection)
                           selColumn,#select the other columns (multiple selection)
                           sex     #gender
  ){
    subd<-comDD
    subd$SUBJID<-as.character(subd$SUBJID)
    #print('markerInCohort_begin');print(sort(unique(subd$SUBJID)));print('markerInCohort_end');
    subd<-subd[subd$SUBJID%in%subjid,]
    subd<-subd[subd$ARMCD%in%armcd,]
    subd<-subd[subd$LBSPEC==lbspec&subd$LBTEST==lbtest,]
    subd<-subd[subd$SEX%in%sex,]
    subd<-subd[,c(keepColumn,selColumn)]
    return(subd)
  }  
  
}

if(TRUE){#draw profile plot for the selected lb markers
  
  #----Univariate Y-axis plot----#
  #----Univariate Y-axis plot----#
  #----Univariate Y-axis plot----#
  profilePlot_1Y<-function(comDD, #the combined data gain in getData_dy.r
                           subjid, #subject id (multiple selection)
                           armcd,  #cohort information (multiple selection)
                           lbspec, #specific (single selection)
                           lbtest, #lab test marker (single selection)
                           sex,    #gender
                           Xaxis='numeric',
                           strip_cex=0.7, pt_cex=0.7, islog=FALSE, yrg=NA, xrg=NA,
                           showkey=TRUE,
                           dataonly=FALSE,
                           xlog=FALSE,
                           changeFromBL=FALSE,
                           changeFromBL.rf2="screening",  #or "day1", "both"
                           addBoxplot=TRUE,
                           onlyBoxplot=TRUE,
                           panelByPart=NULL,
                           returnData=FALSE,
                           addPval = TRUE,   #add pvalues
                           drawNumSamples=FALSE, #create a plot showing numbers of samples in Y-axi
                           refDay=1,         #the reference day as the baseline
                           exposure=NULL,       #add the exposure data
                           addExposure=TRUE,
                           visitAnno=NULL,    #a table of user-defined visit.anno
                           avgDup=FALSE       #using the averge value over duplicates                           
  ){
    
    subd<-comDD
    
    #clean up user-defined visit annotation
    if(!is.null(visitAnno)){
      #colnames: LBDY.L  LBDY.H  visit.anno
    }
    
    #clean up exposure data
    if(!is.null(exposure) && addExposure){
      myex <- unique(exposure[,c('USUBJID','EXDOSE', 'EXDOSU', 'EXTRT', 'EXSTDY')])
      myex <- reshape(data=myex, v.names = "EXDOSE", timevar='EXTRT',
                      idvar = c("USUBJID", 'EXSTDY'), direction='wide')
      myex$LBDY <- myex$EXSTDY
      subd <- merge(subd, myex, by=c('USUBJID','LBDY'), all=TRUE)
      library(latticeExtra)
    }
    
    library(lattice)
    library(latticeExtra)
    
    if(is.null(panelByPart)) panelByPart<- FALSE
    if(is.null(onlyBoxplot)) onlyBoxplot<- FALSE
    if(is.null(addBoxplot)) addBoxplot<- FALSE
    
    
    
    subd$LBTESTCD[is.na(subd$LBTESTCD)]<-''
    subd$SUBJID<-as.character(subd$SUBJID)
    subd<-subd[subd$SUBJID%in%subjid,]
    subd$arm<-subd$ARMCD
    subd<-subd[subd$ARMCD%in%armcd,]
    subd<-subd[subd$LBSPEC%in%lbspec&subd$LBTEST%in%lbtest,]
    subd<-subd[subd$SEX%in%sex,]
    
    #clean up duplicate values using LBSEQ and LBREFID
    #a problem identifed from JYCA data transfer
    #only keep the duplicat with the lowest LBSEQ
    if(all(c('LBSEQ','LBREFID') %in% colnames(subd))){
      if(!all(subd$LBREFID == "")){
        orig.nrow <- nrow(subd)
        smp.dup   <- unique(subd[,c('LBSEQ','LBREFID')])
        smp.seq   <- tapply(smp.dup$LBSEQ, smp.dup$LBREFID, 
                            function(x){sort(x)[1]})
        smp.dup   <- data.frame(LBSEQ=smp.seq, LBREFID=names(smp.seq))
        subd      <- merge(subd, smp.dup, by=c('LBSEQ','LBREFID'))
        print(paste('Remove',
                    orig.nrow-nrow(subd), 
                    'duplicate sample(s) for',
                    lbtest))
      }
    }
    
    subd<-subd[order(subd$LBDY),]
    un1<-unique(subd$LBSTRESU)[1]
    subd$SUBJID<-as.factor(subd$SUBJID)
    subd$LBSTRESN<-as.numeric(subd$LBSTRESN)
    subd<-subd[!is.na(subd$LBSTRESN)&subd$LBSTRESN!="",]
    subd$arm<-gsub('COHORT ','C', subd$arm, fixed=TRUE)
    if( tolower(substring(unique(subd$ARM), 1, 4))=='part' && panelByPart){
      subd$arm <- substring(subd$ARM, 1, 5)
      if(all(grepl(":", (subd$ARM)))){
        tma1 <- sapply(strsplit(dm$ARM, split=":", fixed=TRUE), function(x){x[1]})
        subd$arm <- paste(subd$arm, gsub(" ", "", tma1))
      }
    }else if (all(grepl(":", (subd$ARM))) && panelByPart){
      tma1 <- sapply(strsplit(subd$ARM, split=":", fixed=TRUE), function(x){x[1]})
      subd$arm <- gsub(" ", "", tma1)
    }
    
    if(drawNumSamples){
      subd$SUBJID <- subd$LBTEST
      subd$LBSTRESN <- 1
      un1 <- 'count'
    }
    
    if(changeFromBL && !drawNumSamples){
      if(changeFromBL.rf2=='screening'){
        s1<-subd$LBDY<1
        if(sum(s1)>0)
          tm1<-aggregate(LBSTRESN~SUBJID, data=subd[s1,c('SUBJID','LBSTRESN')], FUN=mean, na.rm=TRUE)
        else
          tm1<-data.frame(matrix( ncol=2, dimnames=list(NULL, c('SUBJID','LBSTRESN'))))
        s2<-subd$LBDY==1&!(subd$SUBJID%in%tm1$SUBJID)
        if(sum(s2)>0)
          tm2<-aggregate(LBSTRESN~SUBJID, data=subd[s2,c('SUBJID','LBSTRESN')], FUN=mean, na.rm=TRUE)
        else
          tm2<-data.frame(matrix( ncol=2, dimnames=list(NULL, c('SUBJID','LBSTRESN'))))
        if(nrow(tm1)>0 & nrow(tm2)==0) 
          tm12<-tm1
        else if (nrow(tm1)==0 & nrow(tm2)>0) 
          tm12<-tm2
        else
          tm12<-rbind(tm1, tm2)
      } else if(changeFromBL.rf2=="day1" ){
        if(!is.null(subd$LBBLFL) & sum(subd$LBBLFL=="Y")>0){ #use baseline flags
          tm12 <- unique(subd[subd$LBDY==refDay & subd$LBBLFL=='Y', c('SUBJID', 'LBSTRESN')])
        }else{
          tm12 <- unique(subd[subd$LBDY==refDay, c('SUBJID', 'LBSTRESN')])
        }
        try( tm12 <- aggregate(LBSTRESN~SUBJID, data=tm12, FUN=mean, na.rm=TRUE))
      } else {
        #or both
        tm12 <- unique(subd[subd$LBDY<=1, c('SUBJID', 'LBSTRESN')])
        tm12 <- aggregate(LBSTRESN~SUBJID, data=tm12, FUN=mean, na.rm=TRUE)
      }
      
      names(tm12)[names(tm12)=='LBSTRESN']<-'LBSTRESN.start'
      tm12$LBSTRESN.start <- tm12$LBSTRESN.start + .05
      subd<-merge(subd, tm12, by='SUBJID')
      #percent change from baseline
      subd$LBSTRESN<- 100*(subd$LBSTRESN-subd$LBSTRESN.start)/subd$LBSTRESN.start
      subd <- subd[order(subd[,c('LBDY')]),]
      subd$LBTESTCD[subd$LBTESTCD==""]<-subd$LBTEST[subd$LBTESTCD==""]
      subd$LBTESTCD <- paste("%chgFromBL for", subd$LBTESTCD)
      
      if(changeFromBL.rf2=="day1" ){
        subd <- subd[subd$LBDY> -1,]
      }
      
      if(avgDup){
        cc.na <- NULL
        for(cc in 1:ncol(subd)) {
          if(nrow(subd)>nrow(unique(subd[,-cc]))) cc.na <- c(cc.na, colnames(subd[cc]))
        }
        subd <- subd[,~colnames(subd)%in%c('LBBLFL')]
        try( subd <- aggregate(LBSTRESN~., data=subd, FUN=mean, na.rm=TRUE) )
      }
      
    }
    
    if(length(xrg)==0||any(is.na(xrg)|toupper(xrg)=='NA'|tolower(xrg)=='~')){
      xrg<-range(subd$LBDY,na.rm=TRUE,finite=TRUE)
    }else{
      xrg<-paste(xrg, collapse=',')
      xrg<-gsub("(", "", xrg, fixed=TRUE)
      xrg<-gsub(")", "", xrg, fixed=TRUE)
      xrg<-as.numeric(strsplit(xrg,split=',', fixed=TRUE)[[1]])
      xrg<-xrg[!is.na(xrg)]
      if(length(xrg)<2){
        xrg<-range(subd$LBDY,na.rm=TRUE,finite=TRUE)
      }else{
        subd <- subd[subd$LBDY>=xrg[1]&subd$LBDY<=xrg[2],]
      }
    }
    
    lattice.theme <- trellis.par.get()
    #col <- lattice.theme$superpose.symbol$col[1:nS]
    if(islog && !drawNumSamples){
      subd$LBSTRESN<-log(subd$LBSTRESN)
      yL<-paste0("log(",subd$LBTESTCD[1],"): ", subd$LBTEST[1])
      if(length(yrg)==0||any(is.na(yrg)|toupper(yrg)=='NA'|tolower(yrg)=='~')){
        yrg<-range(subd$LBSTRESN,na.rm=TRUE,finite=TRUE)
      }else{
        yrg<-paste(yrg, collapse=',')
        yrg<-gsub("(", "", yrg, fixed=TRUE)
        yrg<-gsub(")", "", yrg, fixed=TRUE)
        yrg<-as.numeric(strsplit(yrg,split=',', fixed=TRUE)[[1]])
        yrg<-yrg[!is.na(yrg)]
        if(length(yrg)<2){yrg<-range(subd$LBSTRESN,na.rm=TRUE,finite=TRUE)}
      }
      if(length(xrg)==0||any(is.na(xrg)|toupper(xrg)=='NA'|tolower(xrg)=='~')){
        xrg<-range(subd$LBDY,na.rm=TRUE,finite=TRUE)
      }else{
        xrg<-paste(xrg, collapse=',')
        xrg<-gsub("(", "", xrg, fixed=TRUE)
        xrg<-gsub(")", "", xrg, fixed=TRUE)
        xrg<-as.numeric(strsplit(xrg,split=',', fixed=TRUE)[[1]])
        xrg<-xrg[!is.na(xrg)]
        if(length(xrg)<2){xrg<-range(subd$LBDY,na.rm=TRUE,finite=TRUE)}
      }
      if(showkey){
        p1<-xyplot(LBSTRESN~LBDY|arm, data=subd, groups=SUBJID,
                   ylab=yL, xlab="LBDY", type=c('o','g'), cex=pt_cex, xlim=xrg,ylim=yrg,
                   scales=list(x=list(cex=1, rot=90, log=xlog), y=list(cex=1)),
                   strip=strip.custom(par.strip.text=list(cex=strip_cex)),
                   par.settings = list(superpose.symbol = list(pch = 0:20, alhpa=0.75),
                                       superpose.line=list(lty=1:8)),
                   auto.key = list(space = "right", lines=TRUE, cex=strip_cex)  );
      }else{
        p1<-xyplot(LBSTRESN~LBDY|arm, data=subd, groups=SUBJID,
                   ylab=yL, xlab="LBDY", type=c('o','g'), cex=pt_cex, xlim=xrg,ylim=yrg,
                   scales=list(x=list(cex=1, rot=90, log=xlog), y=list(cex=1)),
                   strip=strip.custom(par.strip.text=list(cex=strip_cex)));
      }
    }else{
      if(drawNumSamples){
        yL <- 'Samples'
      }else{
        yL<-paste0(subd$LBTESTCD[1],": ", subd$LBTEST[1])
      }
      if(length(yrg)==0||any(is.na(yrg)|toupper(yrg)=='NA'|tolower(yrg)=='~')){
        yrg<-range(subd$LBSTRESN,na.rm=TRUE,finite=TRUE)
      }else{
        yrg<-paste(yrg, collapse=',')
        yrg<-gsub("(", "", yrg, fixed=TRUE)
        yrg<-gsub(")", "", yrg, fixed=TRUE)
        yrg<-as.numeric(strsplit(yrg,split=',', fixed=TRUE)[[1]])
        yrg<-yrg[!is.na(yrg)]
        if(length(yrg)<2){yrg<-range(subd$LBSTRESN,na.rm=TRUE,finite=TRUE)}
      }
      
      subd$LBDY2 <- subd$LBDY
      subd$LBDY2[subd$LBDY<0] <- -14
      
      #add test P-value
      if(addPval){
        subd$LBDY3 <- subd$LBDY-mean(subd$LBDY, na.rm=T)
        if(length(unique(subd$arm))>1){
          mod1 <- aov(LBSTRESN~LBDY3 * arm, data=subd)
          mod2 <- aov(LBSTRESN~LBDY3 + arm, data=subd)
          rs1  <- anova(mod1, mod2) 
          pv1  <- rs1[2, "Pr(>F)"]
          xL   <- paste0("Days after 1st dose. F_Pvalue(day*arm)=", round(pv1,4))
        }else{
          require(lme4)
          mod1 <- lme4::lmer(LBSTRESN~LBDY3+(1|SUBJID), data=subd)
          mod2 <- lme4::lmer(LBSTRESN~(1|SUBJID), data=subd)
          rs1  <- anova(mod1, mod2, refit=FALSE) #use REML
          #rs1  <- anova(mod1, mod2, refit=TRUE) #use ML
          pv1  <- rs1[2, "Pr(>Chisq)"]
          xL   <- paste0("Days after 1st dose. Chisq_Pvalue(day)=", round(pv1,4))
        }
        
      } else {xL   <- paste0("Days after 1st dose")}
      
      
      if(Xaxis!='numeric'){
        subd<-subd[order(subd$LBDY),]
        if(!is.null(visitAnno)){
          subd$LBDY2 <- ''
          my.anno.L <- NULL
          for(va.i in 1:nrow(visitAnno)){
            if(is.na(visitAnno$LBDY.L[va.i] )) next
            my.anno <- as.character(visitAnno$visit.anno[va.i])
            my.lw   <- visitAnno$LBDY.L[va.i]
            my.hg   <- visitAnno$LBDY.H[va.i]
            #enfore the anno to be screening if VISIT defined
            if(grepl('scr', tolower(my.anno))&'VISIT'%in%colnames(subd)){
              subd$LBDY2[subd$VISIT=='SCREENING']<-my.anno
              subd$LBDY[subd$VISIT=='SCREENING'] <- my.lw
            }
            if('VISIT'%in%colnames(subd)){
              subd$LBDY2[subd$LBDY>=my.lw & subd$LBDY<=my.hg & 
                           subd$VISIT!='SCREENING']<-my.anno
              subd$LBDY[subd$LBDY>=my.lw & subd$LBDY<=my.hg & 
                          subd$VISIT!='SCREENING']<-my.lw
            }else{
              subd$LBDY2[subd$LBDY>=visitAnno$LBDY.L[va.i] & 
                           subd$LBDY<=visitAnno$LBDY.H[va.i]]<-my.anno
              subd$LBDY[subd$LBDY>=visitAnno$LBDY.L[va.i] & 
                          subd$LBDY<=visitAnno$LBDY.H[va.i]]<-my.lw
            }#..
            my.anno.L <- c(my.anno.L, my.anno)
          }
          subd <- subd[subd$LBDY2!='', ]
          subd<-subd[subd$LBDY>=xrg[1]&subd$LBDY<=xrg[2],]
          my.anno.L <- my.anno.L[my.anno.L%in%unique(subd$LBDY2)]
          subd$LBDY2 <- factor(subd$LBDY2, level=my.anno.L)
        }else if('VISIT'%in%colnames(subd)){
          sel.day1 <- !is.na(subd$LBDY) && subd$LBDY==1
          sel.dy <- subd$LBDY<0 | subd$VISIT=='SCREENING'
          subd$LBDY2[!sel.dy]<-paste0("D",subd$LBDY2[!sel.dy])
          #subd$LBDY2[!sel.dy]<-paste0("W",ceiling(subd$LBDY2[!sel.dy]/7))
          visit <- gsub('SCREENING', 'SCRN', toupper(subd$VISIT))
          visit[grepl('follow', tolower(visit))] <- 'FU'
          visit <- gsub('CYCLE', 'C', visit)
          #visit[sel.day1] <- 'C1'
          sel.997 <- grepl('997', visit)
          visit[sel.997]<-paste0("C",ceiling(subd$LBDY[sel.997]/28))
          #visit <- gsub('997', '1', visit)
          head( lbd <- strptime(subd$LBDTC,format="%Y-%m-%dT%H:%M") )
          head( std <- strptime(subd$RFSTDTC,format="%Y-%m-%dT%H:%M") )
          prpo <- ifelse(std<=lbd, "", ""); #'pre')
          visit[sel.day1] <- paste0(visit[sel.day1], prpo[sel.day1])
          subd$LBDY2<-paste0(subd$LBDY2, visit)
          #if(addBoxplot){
          subd$LBDY2[sel.dy]<-'SCRN'
          #} else {
          #  subd$LBDY2[sel.dy]<-paste0("D", subd$LBDY[sel.dy], 'SCRN')
          #}
        }
        
        #order the X-axis variable
        subd <- subd[order(subd$LBDY),]
        print( ord1 <- unique(subd[,c("LBDY2", "LBDY")]) )
        subd$LBDY2 <- factor(subd$LBDY2, level=ord1$LBDY2[order(ord1$LBDY)])
        subd$LBDY  <-subd$LBDY2
        
        if(drawNumSamples){
          subd<-aggregate(LBSTRESN~arm+ARMCD+LBDY+SUBJID, data=subd, FUN=sum, na.rm=T)
        }
        
        if(dataonly){
          return(list(subd=subd, yL=yL, pt_cex=pt_cex,
                      yrg=yrg, xrg=xrg, strip_cex=strip_cex))
        }
        if(onlyBoxplot){
          subd2<-subd
          subd <- aggregate(LBSTRESN~arm+ARMCD+LBDY, data=subd, FUN = mean, na.rm=T)
          subd$SUBJID <- subd$ARMCD
        }
        if(showkey){
          p1<-xyplot(LBSTRESN~factor(LBDY)|arm, data=subd, groups=SUBJID,
                     ylab=yL, xlab=xL, type=c('o','g'), cex=pt_cex, ylim=yrg, 
                     scales=list(x=list(cex=0.65, rot=30, log=xlog), y=list(cex=1)),
                     strip=strip.custom(par.strip.text=list(cex=strip_cex)),
                     par.settings = list(superpose.symbol = list(pch = 0:20, alhpa=0.75),
                                         superpose.line=list(lty=1:8)),
                     auto.key = list(space = "right", lines=TRUE, cex=strip_cex)  );
        }else{
          p1<-xyplot(LBSTRESN~factor(LBDY)|arm, data=subd, groups=SUBJID,
                     ylab=yL, xlab=xL, type=c('o','g'), cex=pt_cex, ylim=yrg, 
                     scales=list(x=list(cex=0.65, rot=30, log=xlog), y=list(cex=1)),
                     strip=strip.custom(par.strip.text=list(cex=strip_cex)));
        }
        
        if(addBoxplot){
          if(onlyBoxplot){
            p1 <- p1+bwplot(LBSTRESN~ factor(LBDY)|arm, data=subd2, cex=0.9, pch='*', box.ratio=0.25,
                            fill='transparent', 
                            lattice.options=lattice.options(key=list(border='black')) )
          }else{
            p1 <- p1+ bwplot(LBSTRESN~ factor(LBDY)|arm, data=subd, cex=0.9, pch='*', box.ratio=0.25,
                             fill='transparent', 
                             lattice.options=lattice.options(key=list(border='black')) )
          }
        }
      }else{
        if(dataonly){
          return(list(subd=subd, yL=yL, pt_cex=pt_cex,
                      yrg=yrg, xrg=xrg, strip_cex=strip_cex))}
        
        if(drawNumSamples){
          subd<-aggregate(LBSTRESN~arm+ARMCD+LBDY+SUBJID, data=subd, FUN=sum, na.rm=T)
        }
        
        if(showkey){
          p1<-xyplot(LBSTRESN~LBDY|arm, data=subd, groups=SUBJID,
                     ylab=yL, xlab=xL, type=c('o','g'), cex=pt_cex, ylim=yrg, xlim=xrg,
                     scales=list(x=list(cex=1, rot=90, log=xlog), y=list(cex=1)),
                     strip=strip.custom(par.strip.text=list(cex=strip_cex)),
                     par.settings = list(superpose.symbol = list(pch = 0:20, alhpa=0.75),
                                         superpose.line=list(lty=1:8)),
                     auto.key = list(space = "right", lines=TRUE, cex=strip_cex)  );
        } else {
          p1<-xyplot(LBSTRESN~LBDY|arm, data=subd, groups=SUBJID,
                     ylab=yL, xlab=xL, type=c('o','g'), cex=pt_cex, ylim=yrg, xlim=xrg,
                     scales=list(x=list(cex=1, rot=90, log=xlog), y=list(cex=1)),
                     strip=strip.custom(par.strip.text=list(cex=strip_cex)));
        }
      }
    }
    
    if(!is.null(exposure) && addExposure && Xaxis=='numeric'){
      subd <- subd[!is.na(subd$EXSTDY), colSums(!is.na(subd))>1]
      trt.var <- colnames(subd)[grepl('EXDOSE.',colnames(subd), fixed=TRUE)]
      col.ref <- c('darkblue','red', 'darkgreen',  'orange')
      subd$col.ref1 <- 'white'
      subd$trtn     <- 0
      for(i in 1:length(trt.var)){
        subd$col.ref1[!is.na(subd[,trt.var[i]])] <- col.ref[i]
        subd$trtn[!is.na(subd[,trt.var[i]])] <- subd$trtn[!is.na(subd[,trt.var[i]])] +1
      }
      subd$col.ref1[subd$trtn>1] <- col.ref[i+1]
      
      p2 <- xyplot(LBSTRESN~EXSTDY|arm, 
                   data=subd,
                   #groups=EXTRT, 
                   fill.color = as.character(subd$col.ref1),
                   panel=function(x,y, fill.color,...,subscripts){
                     fill = fill.color[subscripts] 
                     panel.abline(v=x, col=fill, lwd=0.3)
                   })
      p1 <- p1+as.layer(p2)
      
      
    }
    
    if(returnData){
      return(list(p1=p1, dat1=subd))
    }else{
      return(p1)
    }
  }
  
  
  
  #----Summary Univariate Y-axis with error bar plot----#
  profilePlot_1Yer<-function(comDD, #the combined data gain in getData_dy.r
                             subjid, #subject id (multiple selection)
                             armcd,  #cohort information (multiple selection)
                             lbspec, #specific (single selection)
                             lbtest,  #lab test marker (single selection)
                             strip_cex=0.8, pt_cex=0.7,
                             Xaxis="numeric", #only "numeric" or "factor"
                             islog=FALSE, yrg=NA, xrg=NA
  ){
    subd<-comDD[comDD$SUBJID%in%subjid,]
    subd<-subd[subd$ARMCD%in%armcd,]
    subd<-subd[subd$LBSPEC==lbspec&subd$LBTEST==lbtest,]
    subd<-subd[order(subd$LBDY),]
    un1<-unique(subd$LBSTRESU)[1]
    subd$SUBJID<-as.factor(subd$SUBJID)
    subd$LBSTRESN<-as.numeric(subd$LBSTRESN)
    subd<-subd[!is.na(subd$LBSTRESN)&subd$LBSTRESN!="",]
    subd<-subd[subd$LBDY>- 21,]
    subd$week<-floor(subd$LBDY/7)+1
    #subd$week<-floor(subd$LBDY)
    if(islog){
      subd$LBSTRESN<-log(subd$LBSTRESN)
      yL<-paste0("log(",gsub(" ", '', subd$LBTEST[1]), ") ", 
                 " +/- 2*sdErr")
    }else{
      yL<-paste(gsub(" ", "", subd$LBTEST[1]), " +/- 2*sdErr")
    }
    
    #get averages
    subd<-unique(subd[,c("SUBJID","ARM","week","LBSTRESN","LBSTRESU")])
    tm1<-aggregate(x=subd[,"LBSTRESN"], by=list(subd$ARM, subd$week),
                   FUN=mean, na.rm=TRUE)
    colnames(tm1)<-c("ARM", "week", "avg_LBSTRESN")
    tm2<-aggregate(x=subd[,"LBSTRESN"], by=list(subd$ARM, subd$week),
                   FUN=sd, na.rm=TRUE)
    colnames(tm2)<-c("ARM", "week", "sd_LBSTRESN")
    tm3<-aggregate(x=subd[,"LBSTRESN"], by=list(subd$ARM, subd$week),
                   FUN=function(x){sum(!is.na(x))})
    colnames(tm3)<-c("ARM", "week", "freq")
    tm4<-aggregate(x=subd[,"SUBJID"], by=list(subd$ARM),
                   FUN=function(x){length(unique(x))})
    colnames(tm4)<-c("ARM", "ARM2")
    tm4$ARM2<-paste0(tm4$ARM,", N=", tm4$ARM2)
    
    tm12<-merge(tm1,tm2, by=c("ARM", "week"))
    tm12<-merge(tm12,tm3, by=c("ARM", "week"))
    tm12<-merge(tm12,tm4, by=c("ARM"))
    
    tm12<-tm12[!is.na(tm12$avg_LBSTRESN)&!is.na(tm12$sd_LBSTRESN),]
    tm12$low<-pmax(0, tm12$avg_LBSTRESN-2*tm12$sd_LBSTRESN)
    tm12$up<- tm12$avg_LBSTRESN + 2*tm12$sd_LBSTRESN
    tm12<-tm12[order(tm12$week),]
    
    y1rg<-range(c(tm12$low, tm12$up))
    if(TRUE){#change xlim and ylim
      if(length(yrg)==0||(is.na(yrg)|toupper(yrg)=='NA'|tolower(yrg)=='~')){
        yrg<-y1rg
      }else{
        yrg<-gsub("(", "", yrg, fixed=TRUE)
        yrg<-gsub(")", "", yrg, fixed=TRUE)
        yrg<-as.numeric(strsplit(yrg,split=',',fixed=TRUE)[[1]])
        if(any(is.na(yrg))){ yrg<-y1rg }
      }
      if(length(xrg)==0||(is.na(xrg)|toupper(xrg)=='NA'|tolower(xrg)=='~')){
        xrg<-range(tm12$week,na.rm=TRUE,finite=TRUE)
      }else{
        xrg<-gsub("(", "", xrg, fixed=TRUE)
        xrg<-gsub(")", "", xrg, fixed=TRUE)
        xrg<-as.numeric(strsplit(xrg,split=',',fixed=TRUE)[[1]])
        if(any(is.na(xrg))){ xrg<-range(tm12$week,na.rm=TRUE,finite=TRUE)}
      }
    }
    if(Xaxis=="factor"){
      p1<-xyplot(avg_LBSTRESN~factor(week)|ARM2, data=tm12, type=c('g',"b"), col="blue4",
                 ylab=yL, xlab="week",
                 scales=list(x=list(cex=1, rot=90),y=list(cex=1)),
                 ylim=yrg, groups=ARM,  cex=pt_cex,
                 strip=strip.custom(par.strip.text=list(cex=strip_cex)),
                 panel.groups=function(x, y, subscripts, col, ...){
                   low<-tm12$low[subscripts]
                   up<- tm12$up[subscripts]
                   label<-as.character(tm12$freq[subscripts])
                   yLabel<-rep(y1rg[2]*.95, length(label))
                   panel.xyplot(x, y, col=col, ...)
                   panel.arrows(x, low, x, up, angle=90, code=3, length=0.05, col=col) 
                   panel.text(x, yLabel, label=label, col=col, srt=90, cex=strip_cex)
                 }, panel='panel.superpose')
    }else{
      p1<-xyplot(avg_LBSTRESN~week|ARM2, data=tm12, type=c('g',"b"), col="blue4",
                 ylab=yL, xlab="week",
                 scales=list(x=list(cex=1, rot=90),y=list(cex=1)),
                 groups=ARM,  cex=pt_cex, xlim=xrg, ylim=yrg, 
                 strip=strip.custom(par.strip.text=list(cex=strip_cex)),
                 panel.groups=function(x, y, subscripts, col, ...){
                   low<-tm12$low[subscripts]
                   up<- tm12$up[subscripts]
                   label<-as.character(tm12$freq[subscripts])
                   yLabel<-rep(y1rg[2]*.95, length(label))
                   panel.xyplot(x, y, col=col, ...)
                   panel.arrows(x, low, x, up, angle=90, code=3, length=0.05, col=col) 
                   panel.text(x, yLabel, label=label, col=col, srt=90, cex=strip_cex)
                 }, panel='panel.superpose')
    } 
    return(p1)
  }
  
}

if(TRUE){#pairwise profile plot for two markers
  pkpd<-function(comDD, #the combined data gain in getData_dy.r
                 subjid, #subject id (multiple selection)
                 armcd,  #cohort information (multiple selection)
                 lbspec, #specific (single selection)
                 lbtest1,  #lab test marker (single selection)
                 lbtest2,  #lab test marker (single selection)
                 byVar='SUBJID'
  ){
    subd<-comDD[comDD$SUBJID%in%subjid,]
    subd<-subd[subd$ARMCD%in%armcd,]
    subd$LBTESTCD[is.na(subd$LBTESTCD)] <- ''
    subd<-subd[subd$LBSPEC==lbspec&subd$LBTEST==lbtest,]
    #get common subject
    s1<-unique(subd$SUBJID)
    s2<-unique(pk$SUBJID)
    s12<-s1[s1%in%s2]
    subd<-subd[subd$SUBJID%in%s12,]
    pk1<-pk[pk$SUBJID%in%s12,]
    
    if(!is.null(subd$LBELTM)){
      subd$LBELTM<-gsub("P", "", subd$LBELTM)
      subd$LBELTM<-gsub("T", "", subd$LBELTM)
      subd$LBELTM<-as.numeric(subd$LBELTM)/24
      subd$LBELTM[is.na(subd$LBELTM)]<-0
      subd$LBDY<-subd$LBDY+subd$LBELTM
      subd$LBELTM<-NULL
    }
    
    subd<-subd[order(subd$LBDY),]
    un1<-unique(subd$LBSTRESU)[1]
    subd$SUBJID<-as.factor(subd$SUBJID)
    subd$LBSTRESN<-as.numeric(subd$LBSTRESN)
    yL<-paste0(subd$LBTESTCD[1],": ", subd$LBTEST[1])
    p1<-xyplot(LBSTRESN~LBDY|subd[,byVar], data=subd, groups=SUBJID,
               ylab=yL, xlab="DY", type=c('o','g'), col="red",
               scales=list(x=list(cex=0.5, rot=90), y=list(cex=1)))
    
    if(!is.null(pk1$PCELTM)){
      pk1$PCELTM<-gsub("P", "", pk1$PCELTM)
      pk1$PCELTM<-gsub("T", "", pk1$PCELTM)
      pk1$PCELTM<-as.numeric(pk1$PCELTM)/24
    }
    pk1$PCELTM[is.na(pk1$PCELTM)]<-0
    pk1$PCDY<-pk1$PCDY+pk1$PCELTM
    pk1<-pk1[order(pk1$PCDY),]
    un2<-unique(pk1$PCSTRESU)[1]
    pk1$SUBJID<-as.factor(pk1$SUBJID)
    pk1$PCSTRESN<-as.numeric(pk1$PCSTRESN)
    yL2<-paste0(pk1$PCTESTCD[1],": ", pk1$PCTEST[1])
    p2<-xyplot(PCSTRESN~PCDY|pk1[,byVar], data=pk1, groups=SUBJID,
               ylab=yL2, xlab="Day of Study",type=c('o','g'), col="black", pch=16, cex=0.6,
               scales=list(x=list(cex=0.5, rot=90), y=list(cex=1)))
    
    p12<-doubleYScale(p2,p1, style1=0, style2=4,add.ylab2=TRUE, 
                      main=paste(yL2,"and",yL))
    
    return(p12)
  }
  
}

if(TRUE){#QC plot (histogram of selected lb markers)
  histQC<-function(comDD, #the combined data gain in getData_dy.r
                   subjid, #subject id (multiple selection)
                   armcd,  #cohort information (multiple selection)
                   lbspec, #specific (single selection)
                   lbtest  #lab test marker (single selection)
  ){
    subd<-comDD[comDD$SUBJID%in%subjid,]
    subd<-subd[subd$ARMCD%in%armcd,]
    subd<-subd[subd$LBSPEC==lbspec&subd$LBTEST==lbtest,]
    subd<-subd[order(subd$LBDY),]
    un1<-unique(subd$LBSTRESU)[1]
    subd$SUBJID<-as.factor(subd$SUBJID)
    subd$LBSTRESN<-as.numeric(subd$LBSTRESN)
    yL<-paste0(subd$LBTESTCD[1],": ", subd$LBTEST[1], " (", un1, " )")
    p1<-histogram(~LBSTRESN, data =subd, main=yL, col='red', type = "density",
                  panel=function(x, ...) {
                    panel.histogram(x, ...)
                    panel.grid()
                    panel.mathdensity(dmath = dnorm, col = "black", lwd=2,
                                      args = list(mean=mean(x),sd=sd(x)))
                  })
    return(p1)
  }
  
  histQC_arm<-function(comDD, #the combined data gain in getData_dy.r
                       subjid, #subject id (multiple selection)
                       armcd,  #cohort information (multiple selection)
                       lbspec, #specific (single selection)
                       lbtest  #lab test marker (single selection)
  ){
    subd<-comDD[comDD$SUBJID%in%subjid,]
    subd<-subd[subd$ARMCD%in%armcd,]
    subd<-subd[subd$LBSPEC==lbspec&subd$LBTEST==lbtest,]
    subd<-subd[order(subd$LBDY),]
    un1<-unique(subd$LBSTRESU)[1]
    subd$SUBJID<-as.factor(subd$SUBJID)
    subd$LBSTRESN<-as.numeric(subd$LBSTRESN)
    yL<-paste0(subd$LBTESTCD[1],": ", subd$LBTEST[1], " (", un1, " )")
    p1<-histogram(~LBSTRESN|factor(ARMCD), data =subd, main=yL, type = "density",
                  panel=function(x, ...) {
                    panel.histogram(x, ...)
                    panel.grid()
                    panel.mathdensity(dmath = dnorm, col = "red", lwd=2,
                                      args = list(mean=mean(x),sd=sd(x)))
                  })
    return(p1)
  }
}

if(TRUE){#Marker distribution with boxplots
  boxp_lb<-function(comDD, lbspec, lbtest, byVar){
    subd<-comDD[comDD$LBSPEC==lbspec&comDD$LBTEST==lbtest,]
    un1<-unique(subd$LBSTRESU)[1]
    subd$LBSTRESN<-as.numeric(subd$LBSTRESN)
    yL<-paste0(subd$LBTESTCD[1],": ", subd$LBTEST[1])   
    if(byVar%in%colnames(subd)){
      p1<-qplot(factor(subd[,byVar]),LBSTRESN,data=subd,geom="boxplot", 
                main=yL, xlab=byVar, ylab=yL)+
        theme(axis.text.x=element_text(angle=90))
    }else{ #draw overall
      subd$overall<-'overall'
      p1<-qplot(overall,LBSTRESN,data=subd,geom="boxplot", 
                main=yL, xlab=byVar, ylab=yL)+
        theme(axis.text.x=element_text(angle=90))
    }
    return(p1)
  }
}

if(TRUE){#PK/PD
  pkpd<-function(comDD, #the combined data gain in getData_dy.r
                 subjid, #subject id (multiple selection)
                 armcd,  #cohort information (multiple selection)
                 lbspec, #specific (single selection)
                 lbtest,  #lab test marker (single selection)
                 pk, byVar='SUBJID'
  ){
    subd<-comDD[comDD$SUBJID%in%subjid,]
    subd<-subd[subd$ARMCD%in%armcd,]
    subd<-subd[subd$LBSPEC==lbspec&subd$LBTEST==lbtest,]
    #get common subject
    s1<-unique(subd$SUBJID)
    s2<-unique(pk$SUBJID)
    s12<-s1[s1%in%s2]
    subd<-subd[subd$SUBJID%in%s12,]
    pk1<-pk[pk$SUBJID%in%s12,]
    
    if(!is.null(subd$LBELTM)){
      subd$LBELTM<-gsub("P", "", subd$LBELTM)
      subd$LBELTM<-gsub("T", "", subd$LBELTM)
      subd$LBELTM<-as.numeric(subd$LBELTM)/24
      subd$LBELTM[is.na(subd$LBELTM)]<-0
      subd$LBDY<-subd$LBDY+subd$LBELTM
      subd$LBELTM<-NULL
    }
    
    subd<-subd[order(subd$LBDY),]
    un1<-unique(subd$LBSTRESU)[1]
    subd$SUBJID<-as.factor(subd$SUBJID)
    subd$LBSTRESN<-as.numeric(subd$LBSTRESN)
    yL<-paste0(subd$LBTESTCD[1],": ", subd$LBTEST[1])
    p1<-xyplot(LBSTRESN~LBDY|subd[,byVar], data=subd, groups=SUBJID,
               ylab=yL, xlab="DY", type=c('o','g'), col="red",
               scales=list(x=list(cex=0.5, rot=90), y=list(cex=1)))
    
    if(!is.null(pk1$PCELTM)){
      pk1$PCELTM<-gsub("P", "", pk1$PCELTM)
      pk1$PCELTM<-gsub("T", "", pk1$PCELTM)
      pk1$PCELTM<-as.numeric(pk1$PCELTM)/24
    }
    pk1$PCELTM[is.na(pk1$PCELTM)]<-0
    pk1$PCDY<-pk1$PCDY+pk1$PCELTM
    pk1<-pk1[order(pk1$PCDY),]
    un2<-unique(pk1$PCSTRESU)[1]
    pk1$SUBJID<-as.factor(pk1$SUBJID)
    pk1$PCSTRESN<-as.numeric(pk1$PCSTRESN)
    yL2<-paste0(pk1$PCTESTCD[1],": ", pk1$PCTEST[1])
    p2<-xyplot(PCSTRESN~PCDY|pk1[,byVar], data=pk1, groups=SUBJID,
               ylab=yL2, xlab="Day of Study",type=c('o','g'), col="black", pch=16, cex=0.6,
               scales=list(x=list(cex=0.5, rot=90), y=list(cex=1)))
    
    p12<-doubleYScale(p2,p1, style1=0, style2=4,add.ylab2=TRUE, 
                      main=paste(yL2,"and",yL))
    
    return(p12)
  }
  
}

if(TRUE){#safety review
  # Create heatmap
  doPlot2<-function(mydata, usubjid1, ori='portrait'){
    colnames(mydata)<-tolower(colnames(mydata))
    newdata<-subset(mydata, usubjid==usubjid1)
    # Create a variable, for.labels, that will be used to match 
    # colors to labels in the legend
    if('cmdecod'%in%colnames(newdata)){
      newdata$cmdecod[is.na(newdata$cmdecod)]<-""
    } else {
      newdata$cmdecod <- ""
    }
    if('aedecod'%in%colnames(newdata)){
      newdata$aedecod[is.na(newdata$aedecod)]<-""
      newdata$aeser[is.na(newdata$aeser)]<-""
    }else{
      newdata$aedecod<-""
      newdata$aeser<-""
    }
    if(!'lbnrind'%in%colnames(newdata)){
      newdata$lbnrind <- ""
    }
    newdata<-mutate(newdata, cmdecod=cmdecod,
                    aedecod=aedecod,
                    for.labels=ifelse(domain=="AE" & aeser=="", as.character(aetoxgr),#"NA",
                                      ifelse(domain=="LB" & lbnrind=="", "NA",
                                             ifelse(domain=="CM", "CM",
                                                    ifelse(domain=="AE", as.character(aeser),
                                                           ifelse(domain=="LB", as.character(lbnrind),""))))))
    sVar<-c("days","daystr",'daysend',"cmstrdy","cmenddy")
    if(all(sVar%in%colnames(newdata)))
      newdata<-newdata[rowSums(newdata[,sVar]< -20, na.rm=TRUE)==0,]
    # Create factors to set the measurement order on the y-axis
    # newdata<-newdata[order(newdata$domain, newdata$aedecod, 
    #                        newdata$cmdecod, newdata$param),]
    newdata<-newdata[order(newdata$domain, newdata$aedecod, newdata$cmdecod),]
    newdata$aedecod<- factor(newdata$aedecod, ordered=TRUE)
    newdata$cmdecod<- factor(newdata$cmdecod, ordered=TRUE)
    #newdata$param<- factor(newdata$param, ordered=TRUE)
    
    have.lb<- ifelse("LB" %in% unique(newdata$domain), 1, 0)
    have.cm<- ifelse("CM" %in% unique(newdata$domain), 1, 0)
    have.ae<- ifelse("AE" %in% unique(newdata$domain), 1, 0)
    
    col.val<-c("NA"="tan4", "0"="gray60", "1"="green", "2"="yellow", 
               "3"="orange", "4"="red", 
               "ABSENT"="gray40","MILD"="green","MODERATE"="yellow", "SEVERE"="red",
               "LOW"="blue","NORMAL"="gray50",  "HIGH"="red3", "CM"="skyblue4")
    brks <- c("NA", "0", "1", "2", "3", "4", 
              "ABSENT","MILD","MODERATE","SEVERE",
              "LOW", "NORMAL", "HIGH", "CM")
    
    if(ori=="portrait"){
      bp<- ggplot()+
        theme(text=element_text(size=6),
              axis.text.y=element_text(angle=15, vjust=0.5))+
        facet_grid(domain ~ ., scales = "free", space = "free")+
        scale_y_discrete(expand=c(0.05, 0.6))+
        scale_color_manual("Color Coding", values=col.val,breaks=brks)+
        labs(title=paste("Patient Profile for ", usubjid1, sep=""),
             x="Study Day", y="Test Name", fill="Color Coding")+
        theme_bw()+
        theme(legend.position="bottom")+
        theme(legend.key=element_blank())+
        theme(legend.text=element_text(size = 10))+
        theme(legend.title=element_text(size = 10, face="italic"))+
        theme(panel.background=element_rect(fill='white', colour='black'))+
        theme(panel.border=element_blank(), axis.line=element_line(colour="black"))+
        theme(axis.text.x=element_text(size=rel(0.9)))+
        theme(axis.text.y=element_text(size=rel(0.9)))+
        theme(axis.title.x=element_text(size=11))+
        theme(axis.title.y=element_text(size=11))+
        theme(plot.title=element_text(size=12, face="bold"))
      
      if(have.ae==1){
        if(!"daystr"%in%colnames(newdata)){
          subd1<-subset(newdata,domain=="AE")
          subd1$daystr<-subd1$aestdy
          subd1$daysend<-subd1$aeendy
        }
        bp<- bp +
          geom_segment(data=subd1, 
                       aes(x=daystr, xend=daysend, y=aedecod, yend=aedecod, 
                           color=for.labels), 
                       size=1)+
          geom_point(data=subd1, 
                     mapping=aes(x=daystr, y=aedecod, color=for.labels), shape=24, size=2)+
          geom_point(data=subd1, 
                     mapping=aes(x=daysend, y=aedecod, color=for.labels), 
                     shape=25, size=2, fill="grey")
      }
      
      if(have.cm==1){
        bp<- bp +
          geom_segment(data=subset(newdata,domain=="CM"), 
                       aes(x=cmstrdy, xend=cmenddy, y=cmdecod, yend=cmdecod, color=for.labels), 
                       size=1)+
          geom_point(data=subset(newdata, domain=="CM"), 
                     mapping=aes(x=cmstrdy, y=cmdecod, color=for.labels), 
                     shape=24, size=2)+
          geom_point(data=subset(newdata, domain=="CM"), 
                     mapping=aes(x=cmenddy, y=cmdecod, color=for.labels), 
                     shape=25, size=2, fill="skyblue4")
      }
      
      if(have.lb==1){
        bp<- bp +
          geom_text(data=subset(newdata,domain=="LB"), 
                    aes(x=days, y=param, label=lbstresn, color=for.labels, angle=35), 
                    size=2.5)
      }
      
    }else{ #landscape
      bp<- ggplot()+
        theme(text=element_text(size=6),
              axis.text.x=element_text(angle=0, vjust=0.5))+
        facet_grid(.~ domain , scales = "free", space = "free")+
        scale_x_discrete(expand=c(0.05, 0.6))+
        scale_color_manual("Color Coding", 
                           values=c("NA"="tan4", "0"="gray60", "1"="green", "2"="yellow", 
                                    "3"="orange", "4"="red", 
                                    "ABSENT"="gray40","MILD"="green","MODERATE"="yellow","SEVERE"="red",
                                    "LOW"="blue","NORMAL"="gray50",  "HIGH"="red3", "CM"="skyblue4"),
                           breaks=c("NA", "0", "1", "2", "3", "4", 
                                    "ABSENT","MILD","MODERATE","SEVERE",
                                    "LOW", "NORMAL", "HIGH", "CM"))+
        labs(title=paste("Patient Profile for ", usubjid1, sep=""),
             y="Study Day", x="Test Name", fill="Color Coding")+
        theme_bw()+
        theme(legend.position="bottom")+
        theme(legend.key=element_blank())+
        theme(legend.text=element_text(size = 10))+
        theme(legend.title=element_text(size = 10, face="italic"))+
        theme(panel.background=element_rect(fill='white', colour='black'))+
        theme(panel.border=element_blank(), axis.line=element_line(colour="black"))+
        theme(axis.text.x=element_text(size=rel(0.9)))+
        theme(axis.text.y=element_text(size=rel(0.9)))+
        theme(axis.title.x=element_text(size=11))+
        theme(axis.title.y=element_text(size=11))+
        theme(plot.title=element_text(size=12, face="bold"))
      
      if(have.ae==1){
        bp<- bp +
          geom_segment(data=subset(newdata,domain=="AE"), 
                       aes(y=daystr, yend=daysend, x=aedecod, xend=aedecod, color=for.labels, angle=90), 
                       size=1)+
          geom_point(data=subset(newdata, domain=="AE"), 
                     mapping=aes(y=daystr, x=aedecod, color=for.labels), shape=24, size=2)+
          geom_point(data=subset(newdata, domain=="AE"), 
                     mapping=aes(y=daysend, x=aedecod, color=for.labels), 
                     shape=25, size=2, fill="grey")
      }
      
      if(have.cm==1){
        bp<- bp +
          geom_segment(data=subset(newdata,domain=="CM"), 
                       aes(y=cmstrdy, yend=cmenddy, x=cmdecod, xend=cmdecod, color=for.labels, angle=90), 
                       size=1)+
          geom_point(data=subset(newdata, domain=="CM"), 
                     mapping=aes(y=cmstrdy, x=cmdecod, color=for.labels), 
                     shape=24, size=2)+
          geom_point(data=subset(newdata, domain=="CM"), 
                     mapping=aes(y=cmenddy, x=cmdecod, color=for.labels), 
                     shape=25, size=2, fill="skyblue4")
      }
      
      if(have.lb==1){
        bp<- bp +
          geom_text(data=subset(newdata,domain=="LB"), 
                    aes(y=days, x=param, label=lbstresn, color=for.labels, angle=90), 
                    size=2.5)
      }
      
    }
    
    
    return(bp)
  }
  
  
}

options(stringsAsFactors=FALSE)

DD<<-indataset
  try(dm<<-DD[["dm.csv"]]) #must have
  try(lb<<-DD[["lb.csv"]]) #must have
  try(ae<<-DD[["ae.csv"]])
  try(cm0<<-DD[["cm.csv"]])
  try(ex<<-DD[["ex.csv"]])
  try(pc<<-DD[["pc.csv"]])
  try(pf0<<-DD[["pf.csv"]] ) #biomarker: rtPCR datasets for PD effect
  try(pf_ref<<-DD[["pf_ref.csv"]])

  if(is.null(dm)) try(dm<<-DD[["dm.sas7bdat"]]) #must have
  if(is.null(lb)) try(lb<<-DD[["lb.sas7bdat"]]) #must have
  if(is.null(ae)) try(ae<<-DD[["ae.sas7bdat"]])
  if(is.null(ex)) try(ex<<-DD[["ex.sas7bdat"]])
  if(is.null(cm0)) try(cm0<<-DD[["cm.sas7bdat"]])
  if(is.null(pc)) try(pc<<-DD[["pc.sas7bdat"]])
  if(is.null(pf0)) try(pf0<<-DD[["pf.sas7bdat"]] ) #biomarker: rtPCR datasets for PD effect
  if(is.null(pf_ref)) try(pf_ref<<-DD[["pf_ref.sas7bdat"]])

  if(is.null(dm))  try(dm<<-DD[grepl('dm.',tolower(names(DD)))][[1]])
  if(is.null(lb))  try(lb<<-DD[grepl('lb.',tolower(names(DD)))][[1]])
  if(is.null(ae))  try(ae<<-DD[grepl('ae.',tolower(names(DD)))][[1]])
  if(is.null(cm0)) try(cm0<<-DD[grepl('cm.',tolower(names(DD)))][[1]])
  if(is.null(pc))  try(pc <<-DD[grepl('pc.',tolower(names(DD)))][[1]])

  inh.sel<-grepl("inhibition", names(DD))
  if(any(inh.sel)){
    try(inhib<<-DD[inh.sel][[1]])
  }else {inhib<<-NULL}

  bm1s1<-grepl("biomarker_cst", names(DD), fixed=TRUE)
  if(any(bm1s1)){bm1<<-DD[bm1s1][[1]]}else{bm1<<-NULL}
if(!is.null(bm1)){
  
  colnames(bm1)<-gsub(" ", "", colnames(bm1), fixed=TRUE)
  colnames(bm1) <-toupper(gsub(".", "", colnames(bm1), fixed=TRUE))
  selcol<-toupper(c("patientid", "colldate", "referencetimingcode",
    "testname", "result", "unitcode"))
  if(any(!selcol%in%colnames(bm1))){
      selcol<-toupper(c("PATIENTNUMBER", "DATECOLLECTED", "TIMECOLLECTED",
      "TESTabbrev", "LABRESULT", "RESULTUOM"))
  }
  if(any(!selcol%in%colnames(bm1))){
      selcol<-toupper(c("PATIENTID", "COLLDATE", "COLLTIME",
      "TESTNAME", "RESULT", 'LBSTRESU'))
      #bm1$LBSTRESU<-''
  }
  bm1<-bm1[,selcol]
  selColnm<-c('SUBJID', 'LBDTC', 'LBELTM','LBTESTCD','LBSTRESN', 'LBSTRESU')
  colnames(bm1)<-selColnm

  bm1<-bm1[!is.na(bm1$SUBJID),]
  bm1<-merge(unique(dm[,c("STUDYID","USUBJID",'SUBJID')]), bm1, by="SUBJID", all.y=TRUE)
  bm1<-bm1[,!colnames(bm1)%in%"SUBJID"]
  bm1$LBTEST<-bm1$LBTESTCD

  lbcol<-colnames(lb)
  n_lbcol<-lbcol[!lbcol%in%colnames(bm1)]
  tmdd<-matrix(NA, nrow=nrow(bm1), ncol=length(n_lbcol))
  colnames(tmdd)<-n_lbcol
  bm1<-data.frame(bm1, tmdd)
  bm1<-bm1[,lbcol]
  bm1$LBSPEC<-"biomarkers"
  bm1$LBSTRESN<-as.numeric(as.character(bm1$LBSTRESN), na.rm=TRUE)
  bm1$LBTEST<-gsub(" ", "", bm1$LBTEST)
  bm1$LBTESTCD<-gsub(" ", "", bm1$LBTESTCD)  
  bm1$LBDTC<-as.Date(bm1$LBDTC, format="%d-%b-%y")

  #get lbdy value
  #dat<-unique(lb[grepl("CYCLE1 DAY1",lb$LBTPTREF),c("USUBJID","LBDTC")])
  head(dat<-unique(lb[lb$LBDY==1,c("USUBJID","LBDTC")]))
  dat<-dat[!is.na(dat$LBDTC),]
  dat<-tapply(as.Date(dat$LBDTC,format="%Y-%m-%d"),   
    dat$USUBJID, function(x){as.character(min(x,na.rm=TRUE))})
  #colnames(dat)<-c("USUBJID","startdate")
  dat<-data.frame(USUBJID=names(dat), startdate=dat)
  dat$startdate<-as.Date(dat$startdate, format="%Y-%m-%d")
  dat<-unique(dat)
  #remove patients with different starting date of study
  frq_dat<-tapply(rep(1,nrow(dat)), dat$USUBJID, sum)
  dat<-dat[dat$USUBJID%in%names(frq_dat)[frq_dat==1],]
  lb$LBDTC<-as.Date(lb$LBDTC, format="%Y-%m-%d")

  lb<<-rbind(lb, bm1[,lbcol])

  lb<<-merge(lb, dat,  all.x=TRUE, by="USUBJID")
  lb$LBDTC<-as.Date(lb$LBDTC, format="%Y-%m-%d")
  lb$LBDY<- as.numeric(lb$LBDTC-lb$startdate+1)

  } #if biomarker_cst.csv is available

#for the biomarker rtPCR data
if(!is.null(pf0)){
  #use MEANCT
  pf0<<-pf0[pf0$PFTESTCD_qPCR=="MEANCT",]
  pf_ref$LBDAT<-paste(pf_ref$SPECIMEN_COLL_DATE, pf_ref$SPECIMEN_COLL_TIME,sep="-")
  pf1<<-merge(pf0, pf_ref[,c('SUBJID','LAB_REQ_NUMBER','LBDAT')],
    by=c('SUBJID','LAB_REQ_NUMBER'))
  dim(pf1<-pf1[pf1$LBDAT!='',])
  dim(hh<-unique(pf1[,c("SUBJID","LBDAT")]))
  hh$LBDAT<-strptime(hh$LBDAT,format='%d-%b-%y-%H:%M')
  hh<-hh[!is.na(hh$LBDAT),]#the useful date and time in gene expression

  #get date for LBDY==1
  dat<-unique(lb[!is.na(lb$LBDY)&lb$LBDY==1, c("USUBJID","LBDTC")])
  dat$LBDTC<-as.Date(dat$LBDTC,format=c("%Y-%m-%d"))
  dat<-unique(dat)
  nchar1<-nchar(dat$USUBJID)
  dat$SUBJID<-substr(dat$USUBJID, nchar1-3, nchar1)

  #add the LBSPEC column
  if(!'LBSPEC'%in%colnames(pf1)){
    pf1$LBSPEC<-'PF domain'
  }
  
  pf2<<-merge(pf1, dat, by='SUBJID')
  pf2$LBDAT<-strptime(pf2$LBDAT,format='%d-%b-%y-%H:%M')
  pf2<-pf2[!is.na(pf2$LBDAT),]
  pf2$LBDTC<-strptime(pf2$LBDTC,format=c("%Y-%m-%d"))
  pf2$LBDY<-as.numeric(pf2$LBDAT-pf2$LBDTC)/24+1
 
  colnames(pf2)<-gsub("PF","LB", colnames(pf2))
  colnames(pf2)<-gsub("_qPCR","", colnames(pf2))
  pf2$LBTEST<-pf2$LBTESTCD<-pf2$LBGENROI
  col1<-colnames(lb)
  pf3<<-pf2[,colnames(pf2)%in%col1]
  pf3$LBSTRESN<-pf3$LBORRES
  pf3$LBSTRESN[gsub(" ", "", pf3$LBSTRESN,fixed=TRUE)==""]<-40
  pf3$LBSTRESU<-pf3$LBORRESU
  col2<-col1[!col1%in%colnames(pf3)]
  pf4<-cbind(pf3,matrix(NA, nrow=nrow(pf3),ncol=length(col2)))
  colnames(pf4)<-c(colnames(pf3),col2)

  lb$LBDTC<-as.Date(lb$LBDTC, format="%Y-%m-%d")
  pf4$LBDTC<-as.Date(pf4$LBDTC, format="%Y-%m-%d")
  lb<<- rbind(lb, pf4)

}

#merge the data
noCol1 <- c("STUDYID",'SUBJID', 'DOMAIN')
comDD<<-merge(dm[,!colnames(dm)%in%noCol1], 
              lb[,!colnames(lb)%in%noCol1], 
              all.y=TRUE, by=c("USUBJID"))
comDD$USUBJID<-as.character(comDD$USUBJID)
comDD$SUBJID <- substring(comDD$USUBJID, nchar(comDD$USUBJID)-3)

print(head(comDD))

  if(is.null(comDD$startdate)){
    comDD$startdate<-as.Date(NA)
  }else{
    comDD$startdate<-as.character(comDD$startdate)
  }

  if(TRUE){#re-calculate lbdy
    na.sub<-unique(comDD$SUBJID[is.na(comDD$LBDY)])
    for(i in na.sub){
      sel1<-comDD$SUBJID==i
      sel2<-sel1&comDD$LBDY==1  #&comDD$LBELTM>0&comDD$LBELTM<15
      #try(comDD$startdate[sel1]<-min(as.Date(comDD$LBDTC[sel2]),na.rm=T))
      tm<-class(try(stt<-min(as.Date(comDD$LBDTC[sel2]),na.rm=T)))
      #try(comDD$LBDY[sel1]<-as.numeric(comDD$LBDTC[sel1]-comDD$startdate[sel1]+1))
      #if(tm!="try-error")
      comDD<-comDD[!is.na(comDD$LBDY),]
    }
    
    if(!is.null(comDD$LBELTM)){
      comDD$LBELTM<-gsub("P", "", comDD$LBELTM)
      comDD$LBELTM<-gsub("T", "", comDD$LBELTM)
      comDD$LBELTM<-as.numeric(comDD$LBELTM)/24
      comDD$LBELTM[is.na(comDD$LBELTM)]<- 0
      comDD$LBELTM[comDD$LBELTM>=1] <- 0
      comDD$LBDY<-comDD$LBDY+comDD$LBELTM
      comDD$LBELTM<-NULL
  }
  comDD$SUBJID<-paste(comDD$ARMCD, comDD$SUBJID)
  ss1<-is.na(comDD$LBSTRESN)&!is.na(comDD$LBSTRESC)
  comDD$LBSTRESN[ss1]<-as.numeric(gsub("<","", comDD$LBSTRESC[ss1]))

}

if(TRUE){#revise comDD data
  comDD$LBTEST<-paste0(as.character(comDD$LBTEST), ' (',
    gsub(' ', '', as.character(comDD$LBSTRESU), fixed=TRUE), ')')
   fill.na <- !is.na(comDD$LBSTRESN)&gsub(' ','',comDD$LBSTRESN)!=''
   comDD$LBSTRESN[!fill.na]<-comDD$LBORRES[!fill.na]
   comDD$LBSTRESU[!fill.na]<-comDD$LBORRESU[!fill.na]
  comDD<-comDD[!is.na(comDD$LBDY)&comDD$LBDY>-50,]
  comDD$LBSPEC[comDD$LBSPEC=='']<-'blank'
  comDD$LBTEST[comDD$LBTEST=='']<-'blank'
}

if(!is.null(pc)){#concatenate the data, get PK/LB combinatin long table
  pk<<-merge(dm, pc, by=c("USUBJID","STUDYID"))
  ss2<-is.na(pk$PCSTRESN)&!is.na(pk$PCSTRESC)
  pk$PCSTRESN[ss2]<-as.numeric(gsub("<","", pk$PCSTRESC[ss2]))
  pk$SUBJID<-paste(pk$ARMCD, pk$SUBJID)
  comDD2<<-comDD[comDD$SUBJID%in%unique(pk$SUBJID),]
}

if(TRUE){#define demographic variables of boxplot selection
  dmVar<-c("SITEID","SEX","RACE","ETHNIC","ARMCD","COUNTRY")
  dmVar<<-dmVar[dmVar%in%colnames(comDD)]
  uni_subjid<<-sort(unique(comDD$SUBJID))
  uni_armcd<<-unique(comDD$ARMCD)
  uni_lbspec<<-unique(comDD$LBSPEC)
  #uni_lbtest<-unique(comDD$LBTEST);#depend on uni_lbspec
  keepColumn<<-c("SUBJID","ARM","ARMCD","LBDY","LBSTRESN","LBSTRESU","LBTEST","LBTESTCD")
  sel_col<<-colnames(comDD)[!colnames(comDD)%in%c(keepColumn,"DOMAIN.x","DOMAIN.y")]

}



if(TRUE){#get data for safety review
  if(!is.null(ae) && !"SUBJID"%in%colnames(ae)){
    ae$SUBJID <- substring(ae$USUBJID, nchar(ae$USUBJID)-3)
  }
  
  
  lb2.col <- c("LBDY","USUBJID","SUBJID","LBSTRESN","LBNRIND", 
               "LBTESTCD","LBTEST","LBSTRESU","LBSPEC")
  lb2.col <- lb2.col[lb2.col%in%colnames(comDD)]
  lb2<-comDD[,lb2.col]
  colnames(lb2)[1]<-c("days")
  lb2$DOMAIN<-'LB'
  lb2$param<-paste0(lb2$LBTESTCD,": ", lb2$LBTEST, " (", lb2$LBSTRESU, ")")
  
  lb2.col2 <- c("DOMAIN","USUBJID","LBSTRESN","LBNRIND","param", 
                "days", "SUBJID","LBSPEC")
  lb2.col2 <- lb2.col2[lb2.col2%in%colnames(lb2)]
  lb2<-lb2[, lb2.col2]
  

  if(!is.null(ae)){
    ae2.col<-c("AESTDY", "AEENDY", "DOMAIN","USUBJID", "AESER", #"AESEV",
              "AEDECOD",  "AETOXGR")
    ae2<-ae[,ae2.col]  
    colnames(ae2)[1:2]<-c("daystr","daysend")
    ae2<-merge(ae2, unique(lb2[,c("USUBJID","SUBJID")]), by="USUBJID")
  }else{ae2 <- NULL}
  
  if(!is.null(cm0)){
    cm2.col <- c("CMSTDY","CMENDY","DOMAIN","USUBJID","CMDECOD")
    cm2<-cm0[, cm2.col]
    colnames(cm2)[1:2]<-c("CMSTRDY","CMENDDY")
    cm2<-merge(cm2, unique(lb2[,c("USUBJID","SUBJID")]), by="USUBJID")
  }else{cm2 <- NULL}

  by123<-c("DOMAIN","USUBJID", "SUBJID")
  if(!is.null(ae)){
    mydata<<-merge(lb2, ae2, by=by123, all=TRUE, sort=FALSE)
    mydata<-mydata[!(mydata$DOMAIN=="AE"&is.na(mydata$daystr)),]
  }else{
    mydata<<-lb2;
  }
  
  if(!is.null(cm2)){
    mydata<<-merge(mydata, cm2, by=by123, all=TRUE, sort=FALSE)
    mydata<-mydata[!(mydata$DOMAIN=="CM"&is.na(mydata$CMSTRDY)),]
  }
  
  mydata$USUBJID<-mydata$SUBJID
  mydata<-mydata[!(mydata$DOMAIN=="LB"&is.na(mydata$days)),]
  
  colnames(mydata)<-tolower(colnames(mydata))

  subject.id <<- unique(mydata$usubjid)  
  mydata<<-mydata
  
  #baseline lb data
  day1befor<-strptime(comDD$RFSTDTC,
                      format='%Y-%m-%dT%H:%M')>=strptime(comDD$LBDTC,format='%Y-%m-%dT%H:%M')
  dim(mylb.log<<-unique(comDD[,c('SUBJID', "LBTEST", "LBSPEC", "LBSTRESN", "LBDY")]))
  names(mylb.log)<-c('usubjid','param','lbspec','lbstresn', 'lbdy')
  dim(mylb<<-unique(comDD[comDD$LBDY<1|(!is.na(day1befor)&day1befor),
                          c('SUBJID', "LBTEST", "LBSPEC", "LBSTRESN")]))
  names(mylb)<-c('usubjid','param','lbspec','lbstresn')
  
  #baseline lb data and ae data
  if(!is.null(ae)){
    dim(myae<<-unique(mydata[mydata$domain=='AE',c("usubjid", "aedecod", "aetoxgr")]))
    mylbae.log<<-merge(mylb.log, myae)
    dim(mylb<<-aggregate(lbstresn~usubjid+param+lbspec, data=mylb, FUN=mean, na.rm=TRUE))
    mylbae<<-merge(mylb, myae)
  }else{mylbae<-NULL}
  
  if(FALSE){
    # sort(unique(mylb.log$param))
    #head(tm<-mylb.log[grepl('CK18', mylb.log$param),])
    head(tm<-mylb.log[mylb.log$param=="Amyloid, Beta (pg/mL)",])
    # sort(unique(myae$aedecod))
    ae1term<-'VOMITING'
    ae.sub<-unique(myae$usubjid[myae$aedecod==ae1term])
    tm$subgrp<-'other'
    tm$subgrp[tm$usubjid%in%ae.sub]<-ae1term
    dim(tm2<-unique(tm[,c('lbdy','lbstresn','usubjid','subgrp', 'param')]))
    qplot(lbdy, lbstresn, data=tm2, group=usubjid, xlim=c(0,100))+
      geom_line()+geom_point()#+facet_grid(subgrp~param)+geom_hline(yintercept=c(500, 250), colour=c('red', 'blue'))
  }
  #ggplot(dynamicData, aes(x=subgroup, y=lbstresn)) +geom_boxplot(outlier.colour="red", outlier.shape=8, outlier.size=4)+guides(colour=FALSE)+geom_point()+theme(plot.margin=unit(c(1,1,1,3),'cm')) +coord_flip()
}


mydata <<- mydata

if(!is.null(inhib) & !is.null(dm)){
  inhib1<-inhib[inhib$blfl==0,]
  inhib2<<-merge(unique(inhib1[,c('SUBJID', 'inhib2', 'geneid')]), unique(dm[,c('SUBJID', 'ARMCD', 'ARM')]))
  uni_gene_inhib2<<-sort(unique(inhib2$geneid))
  uni_arm_inhib2<<-sort(unique(inhib2$ARMCD))
  #
#  dynamicData<<-inhib2[inhib2$geneid=='NRARP',]
#  qplot(ARMCD, inhib2, data=dynamicData, geom='boxplot')+guides(colour=FALSE)+theme(plot.margin=unit(c(1,2,1,1),'cm'))+ylab('%Inhibition')+xlab("ARM")+geom_abline(intercept=50, slope=0)+geom_point(colour='red')
}

if(TRUE){#header
  #*****************************************************************************
  #Eli Lilly and Company - GLOBAL STATISTICAL SCIENCES - PROGRAM
  #CODE NAME (required)                : LightON1_meta.R
  #PROJECT NAME (required)             : geneAtlas
  #STUDY NUMBER                        : 
  #DESCRIPTION (required)              : update / organize / integrate data
  #SPECIFICATIONS(optional)            : 
  #VALIDATION TYPE (required)          : 
  #INDEPENDENT REPLICATION (optional)  : 
  #ORIGINAL CODE (required)            : 
  #EXTERNAL CODE FILES THAT ARE NOT 
  #RE-USEABLE CODE MODULES             : 
  #SOFTWARE/VERSION# (required)        : R Version 3.5.0
  #INFRASTRUCTURE                      : R studio server
  #DATA INPUT location                 : gene expression and mutation
  #SDD: 
  #                                    
  #OUTPUT location: 
  #
  #
  #R SCRIPT location
  #
  #
  #-----------------------------------------------------------------------------
  #     #Author                 Code History Description             Date Change
  #---- ------------       ---------------------------------------  ------------
  #1.1  Danni Yu            Code Creation                             02/01/2019
  #1.2  Danni Yu            Revise code to for feather data analysis  02/28/2019
  #*****************************************************************************
}

#dataset was integrated by LightON1_integrate.R 
#set data access permition as chmod a+r+x-w LightON1



#define paths and load clinical & mutation datasets
if(F){#tbd after run LightON1_integrate.R
  projP <- "TBD_by_user"
  progfile<-'LightON1_meta.R'
  
  #define data paths  
  dir(frompath<<-"data")
  smfile.nm<-'projects_summary.csv'
  gnameFile<-file.path(frompath, 'gene_ensemble.Rdata')
  
  #the selected list of datasets under project selections
  sprjL<<-list(clin=NULL, mut=NULL, gexp_array=NULL, gexps_rnase=NULL,
               mut_cna=NULL, pexp_antib=NULL)
  
  #innitiate global vectors that will be updated in select.prj function
  uni.mutg<<-uni.gexpA<<-uni.gexpR <<- uni.pexpA <<- uni.gene <<-NULL
  uni.gene.default<<-c('RB1', 'KMT2C', 'KMT2D', 'ARID1A')
  grpVar.clin<<-numVar.clin<<-sprgVar<<-NULL
  grpVar.clin0<<-c('proj_id','proj_name','sex','vital_status', 
                   'agec_at_enrollment','agec_at_diagnosis',
                   #'agec_at_last_followup',
                  'disease_status_last_followup', 'tumour_stage_at_diagnosis',
                  'tumour_stage_system', 'tumour_histological_type', 
                  'tumour_stage', 'specimen_type', 'specimen_treatment_type',
                  'specimen_processing', 'first_therapy_type',
                  'frist_therapy_therapeutic_intent',  'first_therapy_response',
                  'second_therapy_type', 'second_therapy_therapeutic_intent',
                  'second_therapy_response', 'other_therapy', 'dummy','db')
  numVar.clin0<<-c('age_at_enrollment', 'age_at_diagnosis',
                   'age_at_last_followup',
                   'relapse_interval', 'survival_time',
                  'specimen_interval', 'first_therapy_duration',
                  'first_therapy_start_interval', 'second_therapy_start_interval',
                  'second_therapy_duration')
  sgrpVar0<<-c('mutation_type','aa_mutation','cds_mutation','chromosome')
  
  #global mapping variable
  conVar1 <<- "submitted_id"
  #sample level mapping variable
  conVar2<<-"submitted_sample_id"
    
}

#select projects from the project summary table
if(F){#tbd
  require(survival)
  require(plyr)
  require(dplyr)
  require(gplots)
  library(data.table)
  library(feather)
  library(glmnet)
  
  #get gene match to chromosom
  load(gnameFile)
  g.chrom<<-distinct(data.table(Hugo_Symbol=g_list3$Hugo_Symbol,
                       chromosome=g_list3$chromosome_name))
  
  #read in the project summary table
  prjsm<<-read.csv(file.path(frompath,smfile.nm), 
                   h=T, stringsAsFactors=F)
  
  #function    sel.id="75,5"
  select.prj<<-function(sel.id, #input$text, the 'id' value in prjsm
                        prjTbl=prjsm #the project summary table
  ){
    #setup an internal function for read in data
    rbF<-function(kw='_clin.feather', 
                  fp=tp, #file path and file names
                  pj=NULL,   #project id and project name
                  subj=NULL){
      t1<-fp[[2]][grepl(kw, fp[[2]])] #get data name
      if(length(t1)==0){return(NULL)}
      tm<-read_feather(file.path(fp[[1]], t1))
      if(!is.null(pj)){
        tm$proj_id<-pj[1]
        tm$proj_name<-pj[2]
        tm$db<-pj[3]
        tm$db_id<-pj[4]
        tm$dummy<-'integrate'
      }
      tm<-tm[colSums(!is.na(tm))>0]#tm is a data.table object, not data.frame
      if(!is.null(subj)){
        tm<-tm[tm$submitted_sample_id%in%subj,]
        if(nrow(tm)==0) return(NULL)
      }
      return(tm)
    }
    #convert id1 into a numeric vector
    if(length(sel.id)>0 && grepl('all',tolower(sel.id))){sel.id<-prjTbl$id}
    if(is.null(sel.id)||gsub(' ','',sel.id)==''){sel.id<-1}
    if(length(sel.id)>0 && !is.numeric(sel.id)){
      sel.id<-as.numeric(strsplit(as.character(sel.id),split=',')[[1]])
      sel.id<-sel.id[!is.na(sel.id)]
    }
    if(length(sel.id)==0){  sel.id<-1 }
    Oclin<-Omut<-OgexpA<-OgexpR<-OmutCNV<-OpexpA<-list()
    for(i in 1:length(sel.id)){
      p0<-prjTbl[sel.id[i],]
      tmp<-file.path(frompath, paste(p0[,c('db','db_id')],collapse='/'))
      tp<-list(tmp, dir(tmp))
      pj1<-c(p0$proj_id[1], p0$proj_name[1], p0$db[1], p0$db_id[1])
      Oclin[[i]]<-rbF(kw='_clin.feather', pj=pj1) #read in clin data
      ds<-rbF(kw='_datasum.feather', fp=tp)  #read in data summary data
      Omut[[i]]<-rbF(kw='_mut.feather')#read in mut&cnv&fus
      # #pull out the expression datasets match to mutational datasets
      # sub1<-unique(mut1$submitted_sample_id)
      if(F){#this takes additional 2 minutes to load
        OgexpA[[i]]<-rbF(kw='_mut_gexp_array.feather')
        OgexpR[[i]]<-rbF(kw='_mut_gexp_rnaseq.feather')
        OpexpA[[i]]<-rbF(kw='_mut_pexp_antib.feather')
      }
    }
    #remove columns with missing data
    rbL<-function(dd){as.data.frame(rbindlist(dd, fill=TRUE))}
    mut<-rbL(Omut); s1.mut<<-unique(mut[,conVar2])#global variable for sampleID
    clin<-rbL(Oclin); clin<-clin[clin[,conVar2]%in%s1.mut,]
    outL<-list(clin=clin, mut=mut)
               # gexpA=rbL(OgexpA),gexpR=rbL(OgexpR), pexpA=rbL(OpexpA))
    #lapply(outL, dim)
    #update the global vectors for gene names
    if(!is.null(outL$mut)){uni.mutg<<-unique(outL$mut$Hugo_Symbol)}

    uni.gene<<-sort(uni.mutg,method="quick")
    uni.gene.default<<-uni.gene.default[uni.gene.default%in%uni.gene]
    if(length(uni.gene.default)==0){uni.gene.default<<-uni.gene[1]}

    #update the global vectors for selecting variable names    
    grpVar.clin<<-grpVar.clin0[grpVar.clin0%in%colnames(outL$clin)]
    numVar.clin<<-numVar.clin0[numVar.clin0%in%colnames(outL$clin)]
    sgrpVar<<-sgrpVar0[sgrpVar0%in%colnames(outL$mut)]
    
    #change clin data into numberic
    for(c1 in numVar.clin){
      outL$clin[,c1]<-as.numeric(outL$clin[,c1])
    }
      
    return(outL)
  }
  #example list
  #tt1<-Sys.time(); sprjL<<-select.prj('7,8,9,10,11'); print(Sys.time()-tt1)
  #tt1<-Sys.time(); sprjL<<-select.prj('All'); print(Sys.time()-tt1)
  #lapply(sprjL, dim)
  
  
  #function for data summary heatmap
  see.click.prj<<-function(chk.id=NULL, #input$text, the 'id' value in prjsm
                          prjTbl=prjsm, #the project summary table
                           showMutOnly=T
  ){
    ff1<-function(tt='no project is selected yet.'){
      plot(0~0, axes=F, ylab='',xlab='', col='white')
      mtext(text=tt)
    }
    if(is.null(chk.id)){ ff1(); return(NULL) }
    #choose the last selected id and the load the datasummary data
    chk.id<-chk.id[length(chk.id)]
    p0<-prjTbl[chk.id,]
    tt<-paste0(p0$db, p0$db_id, "_", p0$proj_id,'\nData Availability')
    tmp<-file.path(frompath, paste(p0[,c('db','db_id')],collapse='/'))
    fn<-dir(tmp); fn<-fn[grepl('_datasum.feather',fn)]
    if(length(fn)>0) ds0<-as.data.frame(read_feather(file.path(tmp, fn[1])))
    if(nrow(ds0)>5000){showMutOnly<-T}
    if(showMutOnly){
      if('mut'%in%colnames(ds0)){
        ds0<-ds0[ds0$mut==1,]
      }else{ff1('mut data is not available');return(NULL)}
    }
    #create the heatmap
    c1n<-c(conVar1, conVar2, 'submitted_specimen_id')
    ds1<-t(apply(ds0[, !colnames(ds0)%in%c1n], 2, as.numeric))
    rs<-rowSums(ds1)
    ds1<-ds1[rs>0,]
    colnames(ds1)<-ds0[,c1n[1]]
    rownames(ds1) <- paste(rownames(ds1) , rs[rs>0])
    heatmap.2(ds1, col=c('white','lightblue'), scale='none', labCol=FALSE,
            Rowv=T,  Colv=T, dendrogram='none', margins=c(3,10), offsetRow=0, 
            key=F,xlab='samples', main=tt, trace='none',
            lmat=rbind(c(5,3,4),c(2,1,4)), lwid=c(0.5,30,5), lhei=c(1,6.5))
            #rowsep=1:nrow(ds1), colsep=1:ncol(ds1), sepwidth=c(0.01, 0.005))
  }
  # see.click.prj(chk.id=c(3,75)) #only show the plot for the last click

  see.select.prj<<-function(chk.id=NULL, #input$text, the 'id' value in prjsm
                             prjTbl=prjsm, #the project summary table
                            showMutOnly=T
  ){
    if(length(chk.id)>0 && is.character(chk.id))
      try(chk.id<-as.numeric(strsplit(as.character(chk.id), split=',')[[1]]))
    if(is.null(chk.id) || length(chk.id)<1 || is.na(chk.id)){
      plot(0~0, axes=F, ylab='',xlab='', col='white')
      mtext(text='no project is selected yet.')
      return(NULL)
    }
    tt<-nn<-NULL; dsL<-list();
    c1n<-c("submitted_id", 'submitted_sample_id', 'submitted_specimen_id')
    #choose the last selected id and load the datasummary data
    for(i in 1:length(chk.id)){
      p0<-prjTbl[chk.id[i],]
      tt<-c(tt, paste0(p0$db, p0$db_id, "_", p0$proj_id))
      tmp<-file.path(frompath, paste(p0[,c('db','db_id')],collapse='/'))
      fn<-dir(tmp); fn<-fn[grepl('_datasum.feather',fn)]
      if(length(fn)>0){
        ds0<-as.data.frame(read_feather(file.path(tmp, fn[1])))
        if(showMutOnly){
          if('mut'%in%colnames(ds0)){
            ds0<-ds0[ds0$mut==1,]
          }else{next}
        }
        c2n<-colnames(ds0)[!colnames(ds0)%in%c1n]
        ds0[,c2n]<-apply(ds0[,c2n],2, as.numeric)
        ds0<-ds0[order(rowSums(ds0[,c2n])),]
        dsL[[i]]<-ds0
        nn<-c(nn, nrow(ds0))
      }
    }
    tt1<-paste0('Data Availability\n',paste(tt,collapse=', '))
    lab1<-rep('',sum(nn))
    nn2<-cumsum(nn[-length(nn)])
    lab1[round(nn/2)+c(0,nn2)]<-tt
    ds0<-do.call('rbind.fill', dsL)
    ds0[is.na(ds0)]<-0
    ds1<-t(apply(ds0[, !colnames(ds0)%in%c1n], 2, as.numeric))
    #create the heatmap
    rs<-rowSums(ds1)
    rownames(ds1) <- paste(rownames(ds1) , rs)
    ds1<-ds1[order(rowSums(ds1)),]
    heatmap.2(ds1, col=c('white','lightblue'), scale='none', 
              labCol=lab1, srtCol=0, cexCol=1,
              Rowv=F,  Colv=F, dendrogram='none', margins=c(4,10), offsetRow=0, 
              key=F,xlab='samples', main=tt1, trace='none',
              colsep=nn2, sepcolor='black',
              lmat=rbind(c(5,3,4),c(2,1,4)), lwid=c(0.5,30,3), lhei=c(1.5,4))
  }
  # see.select.prj(chk.id=c(3,75)) #show the integrated plot for all selection

}


#for realtime summary table, visualization and and download. 
if(TRUE){
  
  #function to grab matched gene names for mutation data,
  #and find and return hugo gene names 
  findHugo<<-function(x='CDK7, ARID1A, MYCN', HG.v=uni.gene, 
                      dum=NULL #input$userdo will be used to trigger the update
                      ){
    #x='AAA1,BBB'
    #HG.v: a vector of gene names
    if(length(x)==0)return(NULL)
    x<-strsplit(x, split=',', fixed=T)[[1]]
    x<-toupper(gsub(' ', '', x, fixed=T))
    x2<-lapply(x, function(s){HG.v[grepl(s,HG.v, fixed=T)]})
    y<-sapply(x2, function(s){paste(s,collapse='||')})
    y1<-paste('gene names matched to the search:\n', paste(y, collapse='\n'))
    y2<-x[x%in%HG.v]
    return(list(y1, y2, unlist(x2)))
  } 
  # findHugo("aka, csm,or2b, cdk7, arid1a")
  
  #function to pull out available levels from group variable
  #sprjL$clin is used here
  gLv1<<-function(varName=NA, limit=200, 
                  dum=NULL #input$userdo will be used to trigger the update
                  ){
    if(is.null(varName) || is.na(varName) || 
       gsub(' ', '', varName, fixed=T)==''){
      return(NA)}
    tmp<-sprjL$clin[,varName]
    if(is.numeric(tmp)){
      return(NA)
    }else{
      tmp<-sort(unique(as.character(tmp)),method="quick")
      return(tmp[1:min(length(tmp), limit)])
    }
  }
  #function to pull out available levels from sub group variable
  #sprjL$mut is used here
  gLv2<<-function(varName, geneName, limit=200,
                  dum=NULL #input$userdo will be used to trigger the update
                  ){
    if(is.null(varName) || is.na(varName)){return(NULL)}
    tmp<-sprjL$mut[sprjL$mut$Hugo_Symbol%in%geneName,varName]
    if(is.numeric(tmp)){
      return(NULL)
    }else{
      tmp<-sort(unique(as.character(tmp)),method="quick")
      return(tmp[1:min(length(tmp), limit)])
    }
  }
  #function to get the range of number variable.
  #....tbd
  
  #construct the levels in a listing object x into matrix
  lev2mat<<-function(x){
    if(!is.list(x)){return(data.frame(x='x is not a list in lev2mat'))}
    x<-lapply(x,function(x){x[!is.na(x)]})
    x<-lapply(x,function(x){x[!toupper(x)%in%c('NULL','NA')]})
    len.x<-sapply(x, length)
    x<-x[len.x>0]
    if(length(x)==1){
      o1<-data.frame(x[[1]])
      colnames(o1)<-names(x[1])
      return(o1)
    }
    if(length(x)<1){
      return(NULL)
    }
    x2<-list(); 
    len.x<-sapply(x, length)
    for(m in 1:length(x)){
      x2[[m]]<-rep(rep(x[[m]], each=prod(len.x[-(1:m)])),
                   times=prod(len.x[0:(m-1)]))
    }
    o1<-do.call("cbind",x2)
    colnames(o1)<-names(x)
    return(o1)
  }
  
  #pull mOS from survfit summary table
  survSum1<<-function(sel1){
    if(is.null(sel1)){return('NA(NA, NA)')}
    paste0(round(sel1['median'],2), '(',
           round(sel1['0.95LCL'],2), ', ',
           round(sel1['0.95UCL'],2), ')')
  }
  
  #Function for clinical summary table at subtypes nested in groups Bootstrap
  sgrpBSsum<<-function(
    d0=sdat2.1,   #data to be summarized with OS_mon and OS_cnr and bmk
    d0all=sMut1.sa, #all candidate genes and samples
    size1=n1, m1=b1,
    var1=sel_grpVar,
    mutFreqTh=0.01
  ){
    #group levels
    if(length(var1)==0){
      v1<-'NULL'
    }else if(length(var1)==1){
      v1<-paste(unique(d0[,var1]), collapse=' | ')
    }else{
      v1<-t(apply(d0[,var1],2, function(x){paste(unique(x), collapse=' | ')}))
    }
    #biomarker labels
    v2<-strsplit(d0$labelBmk[d0$labelBmk!=''], split='|', fixed=T)
    v2<-paste(unique(unlist(v2)), collapse='|')
    #get parameters
    N <-length(unique(d0[,conVar1]))
    n <-length(unique(d0[d0$testBmk==1, conVar1]))
    if(n==0){return(NULL)}
    #bootstrap estimate prevalence or mutaion rate
    pctv<-rep(NA, m1)
    a<-rep(0, N)
    a[sample(1:length(a),n)]<-1
    for(i in 1:m1){ #BS samples
      # d0s<-d0[sample(1:nrow(d0),size1, T),]
      # Ni <-length(unique(d0s[,conVar1]))
      # ni <-length(unique(d0s[d0$testBmk==1, conVar1]))
      # pctv[i]<-round(ni/Ni,3)
      b<-sample(a, size1, T)
      pctv[i]<-round(sum(b)/size1,3)
    }
    pctv<-pctv[!(is.na(pctv)|is.nan(pctv))]
    pct<-round(quantile(pctv, prob=c(0.5,0.025,0.975)),3)
    pct0<-round(n/N, 3)
    bs1<-paste0(m1, ' times, size=',size1)
    if(sum(d0$OS_mon, na.rm=T)==0){
      sr6mon_BMKpos<-sr6mon_BMKneg<-mOS1<-mOS0<-HR<-pval<-NA
      f0<-st.f0<-leg1<-col1<-lty1<-NULL
    }else{
      #6 month survival rate
      sr6mon_BMKpos<-round(mean(d0$OS_mon[d0$testBmk==1]>=6,na.rm=T),2);
      sr6mon_BMKneg<-round(mean(d0$OS_mon[d0$testBmk==0]>=6,na.rm=T),2);
      #get mOS values
      d0$bmk <- as.factor(d0$testBmk)
      d00<-distinct(d0[!is.na(d0$OS_mon)&!is.na(d0$OS_cnr),
                       c('bmk','OS_mon', 'OS_cnr', conVar1)])
      if(nrow(d00)<3){f0<-st.f0<-NULL}else{
        try(f0<-survfit(Surv(OS_mon, OS_cnr)~bmk, data=d00))
        try(st.f0 <- summary(f0)$table)
      }
      tb.bmk<-table(d00$bmk)
      if(all(tb.bmk>0)&length(tb.bmk)==2){
        mOS1<-survSum1(st.f0['bmk=1',])
        mOS0<-survSum1(st.f0['bmk=0',])
        col1<-c('blue','red')
        lty1<-c(2,1)
        leg1<-paste(c(tb.bmk['0'],tb.bmk['1']), c('bmk0 mOS=','bmk1 mOS='), 
                    c(mOS0, mOS1))
      }else if('1'%in%names(tb.bmk) && tb.bmk['1']>0){
        mOS1<-survSum1(st.f0); mOS0<-'no obs'
        col1<-c('red')
        lty1<-c(1)
        leg1<-paste(c(tb.bmk['0']), c('bmk0 mOS='), c(mOS0))
      }else if ('0'%in%names(tb.bmk) && tb.bmk['0']>0){
        mOS0<-survSum1(st.f0); mOS1<-'no obs'
        col1<-c('blue')
        lty1<-c(2)
        leg1<-paste(c(tb.bmk['0']), c('bmk0 mOS='), c(mOS0))
      }else{
        mOS0<-mOS1<-'no obs'
        f0<-col1<-lty1<-leg1<-NULL
      }
      #get HR
      if(sum(!is.na(d00$OS_mon))<5){
        HR<-pval<-NA
      }else{
        # hh<<-d0
        t1<-try(f1<-coxph(Surv(OS_mon, OS_cnr)~bmk, data=d00))
        if(class(t1)=='try-error') {
          HR<-pval<-NA
        }else if (any(is.na(f1$coefficients))){
          HR<-pval<-NA
        }else{
          sc.f1<-summary(f1)$coefficients
          HR<-round(sc.f1['bmk1','exp(coef)'],2)
          pval<-round(sc.f1['bmk1','Pr(>|z|)'],2)
        }
      }
    }
    #set up the summary in a row
    otb<-data.frame(v1, sgrp=v2, n=N, n_BMKpos=n, 
                    prevl_BMKpos_95CI=paste0(pct0,' (',pct[2],',',pct[3],')'), 
                    HR=HR, pval=pval, 
                    mOS_BMKpos=mOS1, mOS_BMKneg=mOS0, 
                    SurvivalRate6mon_BMKpos=sr6mon_BMKpos,
                    SurvivalRate6mon_BMKneg=sr6mon_BMKneg)
    outb.c1<-grepl('prevl_BMK_pos_95CI', colnames(otb))
    colnames(otb)[outb.c1]<-paste0('prevl_BMKpos_95CI_n',size1)
    #get gene freqency in the group
    #can be very slow if the mutation numbers are large. !!!!
    # gfreq1<-merge(d0all[,c(conVar2, 'Hugo_Symbol')], d0[,c(conVar1,conVar2)])
    gfreq1<-inner_join(d0all[,c(conVar2, 'Hugo_Symbol')], 
                       d0[,c(conVar1,conVar2)], by=conVar2)
    gfreq1<-gfreq1[,c(conVar1,'Hugo_Symbol')]
    gfreq1<-distinct(gfreq1)
    gfreq2<-table(gfreq1$Hugo_Symbo)/N
    gfreq2<-sort(gfreq2[gfreq2>mutFreqTh], decreasing=T, method="quick")
    if(length(gfreq2)==0){gfreq2<-NULL}
    gHR2<-NULL
    if(sum(d0$OS_mon, na.rm=T)>10){
      # ghr<-ghrp<-NULL
      # for(x in names(gfreq2[1:max(30,length(gfreq2))])){
      #   s1<-d0all[d0all[,'Hugo_Symbol']==x, conVar2]
      #   bm1<-rep(0, nrow(d0))
      #   bm1[d0[,conVar2]%in%s1]<-1
      #   t1<-try(f1<-coxph(Surv(OS_mon, OS_cnr)~bm1, data=d0))
      #   if(class(t1)=='try-error' | any(is.na(f1$coefficients))){
      #     ghr<-c(ghr,NA)
      #     ghrp<-c(ghrp,NA)
      #   }else{
      #     sc.f1<-summary(f1)$coefficients
      #     ghr<-c(ghr, round(sc.f1['bm1','exp(coef)'],2))
      #     ghrp<-c(ghrp,round(sc.f1['bm1','Pr(>|z|)'],2))
      #   }
      # } #needs to improve with fast fit
    }
    #get significant correlations with interested biomarker
    #get non-NA Hazard ratios with p-values
    
    #components for KM plot
    leg2<-paste0('HR=',HR, ' p=',pval)
    forplot<-list(f0=f0,leg1=leg1,leg2=leg2, col1=col1,lty1=lty1, tt1=v1,
                  BS_size_number=bs1, pctv=pctv)
    return(list(otb=otb, forplot=forplot, bmk1freq=gfreq2, bmk1HR=gHR2))
  }
  
  #function for get correlated genes
  #output a one-row matrix for multiple genes
  scorT<<-function(yy=distinct(sdat2.1[,c('submitted_sample_id','testBmk')]),
        xx=sMut2t[,c('submitted_sample_id','labelBmk')], 
        th=0.05){
    xx<-xx[xx$submitted_sample_id%in%yy$submitted_sample_id,]
    if(nrow(xx)<11){return(NULL)}
    xx2<-as.data.table(xx); xx2$dum<-1
    xx2w<-dcast(xx2, submitted_sample_id~labelBmk, value.var='dum')
    yy2<-yy[yy$submitted_sample_id%in%xx2w$submitted_sample_id,]
    o1<-order(yy2$submitted_sample_id)
    t1<-try(f1<-cv.glmnet(as.matrix(xx2w[,-1]), yy2[o1,2], 
                      family='binomial', alpha=.5))
    if(class(t1)=='try-error'){return(NULL)}
    cef1<-coef(f1, s=0)[-1,1]
    cef1<-cef1[abs(cef1)>th]
    if(length(cef1)>0){
      cef2<-data.frame(matrix(cef1,nrow=1));colnames(cef2)<-names(cef1);
      return(cef2)
    }else{return(NULL)}
  }
  
  #Function for group summary tables
  #global objects: sprjL$clin, sprjL$mut, conVar1 
  grpSum<<-function(
    geneText='rb1,mycn',  #for mutated gene names
    geneHS=NULL, #exact Hugo_Symbol
    n1=40, b1=500, #sample size and numbers of times for bootstrap
    sel_grpVar=input$dropdown, #select the group variable names (upto 3)
    sel_grpVar_lev=list(v1=gLv1(sel_grpVar), v2=NA,
                        v3=NA),#select levels under the grpVar 
    maxLev_grp=1000, #the maximum number of groups or sub groups
    sel_sgrpVar=input$dropdown4, #var names for biomarker selection
    sel_sgrpVar_lev=gLv2(sel_sgrpVar,c('RB1','MYCN')), #levs in bmk
    min_n_sgrp=5, #the maximum number of subgroups or sub groups
    runCorMut=FALSE, #whether run corMut analysis
    mutFreqTh1=0
  ){
    #just take upto 3 variables for grouping, upto 1 variables
    len.sel_grpVar<-length(sel_grpVar)
    if(len.sel_grpVar>3){sel_grpVar<-sel_grpVar[1:3]}
    if(length(sel_sgrpVar)>1){sel_sgrpVar<-sel_sgrpVar[1]}
    if(!is.list(sel_grpVar_lev)){
      sel_grpVar_lev<-list(v1=sel_grpVar_lev,v2=NA,v3=NA)
    }else{
      l0<-list(v1=NA,v2=NA,v3=NA)
      if(length(sel_grpVar)>0)l0$v1<-sel_grpVar_lev[[1]]
      if(length(sel_grpVar)>1)l0$v2<-sel_grpVar_lev[[2]]
      if(length(sel_grpVar)>2)l0$v3<-sel_grpVar_lev[[3]]
      sel_grpVar_lev<-l0
    }
    
    o1<-'fail to find any matched mutated genes for '
    o1<-data.frame(id=1, x1=paste0(o1,geneText))
    
    #find matched mutated genes
    print(geneHS)
    geneHS<-gsub(' ', '', geneHS, fixed=T)
    geneHS<-geneHS[geneHS!='']
    if(!is.null(geneHS) && length(geneHS)==0){
      return(list(stb=o1,kmplot=NULL, cor_mut=NULL, bmk1freq=NULL))
    }
    if(!is.null(geneHS)){
      gene1 <- geneHS
    }else{
      if(!is.null(geneText)){
        gene1<-findHugo(geneText, uni.mutg)[[2]]
      }else{
        gene1<-NULL
      }
    }
    if(length(gene1)==0){
      return(list(stb=o1,kmplot=NULL, cor_mut=NULL, bmk1freq=NULL))
    }
    #confirm the existence of the group variables
    if(any(!(has.sel_grpVar<-sel_grpVar%in%grpVar.clin))){
      return(list(stb=data.frame(id=1,
        x1=paste("failed to find group variables:",
                  paste(sel_grpVar[has.sel_grpVar],collapse=', '))),
        kmplot=NULL, cor_mut=NULL, bmk1freq=NULL))
    }
    #confirm the existence of sub group variable for biomarkers
    if(!sel_sgrpVar%in%sgrpVar){
      return( list(stb=data.frame(id=1,
        x1=paste('failed to find sub group variables:', sel_sgrpVar)), 
        kmplot=NULL, cor_mut=NULL, bmk1freq=NULL))
    }
    #~~~~stat to use sprjL
    #setup the mutation data
    sMut1<-sprjL$mut; #s1.mut<-unique(sMut1[,conVar2]);#get sample ids
    #setup the clinical data
    sdat1<-sprjL$clin; #sdat1<-sdat1[sdat1[,conVar2]%in%s1.mut,];
    #correct typo in colnames
    colnames(sdat1)[colnames(sdat1)=='cna']<-'cnv'
    if(!'cnv'%in%colnames(sdat1)){sdat1$cnv<-NA}
    if(nrow(sdat1)<3){
      return( list(stb=data.frame(id=1,
        x1=paste('failed to find 3+ clin/mut matched samples.')), 
        kmplot=NULL, cor_mut=NULL, bmk1freq=NULL))
    }
    #remove NA values in survival_time
    if(!"survival_time"%in%colnames(sprjL$clin)){
      sdat1$survival_time<-NA
      sdat1$vital_status<-NA
    }
    sdat1$survival_time<-as.numeric(as.character(sdat1$survival_time))
    sdat1$vital_status<-as.character(sdat1$vital_status)
    #pull out and clean up the levels in group variables
    for(m in 1:length(sel_grpVar)){
      u.lev<-as.character(unique(sdat1[,sel_grpVar[m]])) 
      if(length(u.lev)==0) next
      #limit number of group levels to show
      tmp<-sel_grpVar_lev[[m]][sel_grpVar_lev[[m]]%in%u.lev]
      if(length(tmp)>maxLev_grp){sel_grpVar_lev[[m]]<-tmp[1:maxLev_grp]}
      #update the subset of clinical data with group variables
      sdat1<-sdat1[sdat1[,sel_grpVar[m]]%in%sel_grpVar_lev[[m]],]
    }
    #update patient&sample ids after group selection
    sdat1[,conVar1]<-as.character(sdat1[,conVar1])
    #shrink down if only CNV marker
    if(all(grepl('CNV:', sel_sgrpVar_lev))){
      sdat1<-sdat1[!is.na(sdat1$cnv),]
    }else if(all(grepl('FUS:', sel_sgrpVar_lev))){
      #shrink down if only fusion marker
      sdat1<-sdat1[!is.na(sdat1$fus),]
    }else if(sum(grepl('CNV:|FUS:', sel_sgrpVar_lev))==0){
     #shrink down if only somatic mutation samples are available
      sdat1<-sdat1[!is.na(sdat1$mut),]
    }
    uni.ids<-unique(sdat1[,conVar1])
    #pull data for mutant frequency estimate across genes
    sa0<-sMut1[,sel_sgrpVar[1]]%in%sel_sgrpVar_lev
    sMut1.sa<-sMut1[sa0,c(conVar2, 'Hugo_Symbol', sel_sgrpVar[1])]
    #sMut1.sa$labelBmk<-paste(sMut1.sa$Hugo_Symbol, sMut1.sa[,sel_sgrpVar[1]])
    #let the mutation data have only the selected genes
    s1<- sMut1$Hugo_Symbol%in%gene1 
    s11<-sa0 & s1
    if(runCorMut){
      sMut1t<-sMut1
      sMut1t$labelBmk<-paste(sMut1t$Hugo_Symbol, sMut1t[,sel_sgrpVar[1]])
      sMut2t<-sMut1t[!s11,]#pull out data with other markers
      sMut1t$labelBmk[!s11]<-rep('', sum(!s11))
      #set numeric 0,1 value for biomarker positive samples
      sMut1t$testBmk<-0; sMut1t$testBmk[s11]<- 1;
      sMut1t<-as.data.table(sMut1t)
      sMut1s<-sMut1t[,1*(sum(testBmk)>0), by=submitted_sample_id]
      colnames(sMut1s)[2]<-'testBmk'
      sMut1s1<-sMut1t[labelBmk!='',paste(unique(labelBmk),collapse='|'), 
                      by=submitted_sample_id]
      colnames(sMut1s)[2]<-'labelBmk'
      sMut1s<-inner_join(sMut1s, sMut1s1);
    }else{
      sMut1t<-sMut1[s11,]
      sMut1t$labelBmk<-paste(sMut1t$Hugo_Symbol, sMut1t[,sel_sgrpVar])
      sMut1t<-as.data.table(sMut1t)
      sMut1s<-sMut1t[,paste(unique(labelBmk),collapse='|'), 
                     by=submitted_sample_id]
      colnames(sMut1s)[2]<-'labelBmk'
      sMut1s$testBmk<-1
    }
    # sdat1.1<-merge(sdat1, sMut1s, by=conVar2, all.x=T)
    sdat1.1<-left_join(sdat1, sMut1s, by=conVar2)
    if(nrow(sdat1.1)==0){
      return(list(stb=o1,kmplot=NULL, cor_mut=NULL, bmk1freq=NULL))
    }
    #derive tte in months for overal survival
    sdat1.1$OS_mon<-sdat1.1$survival_time/30
    sdat1.1$OS_cnr<-NA #censor variable: 0=alive, 1=deceased
    sdat1.1$OS_cnr[sdat1.1$vital_status=='alive']<-0
    sdat1.1$OS_cnr[sdat1.1$vital_status=='deceased']<-1
    #colnames in the data ready for sub-group summary
    sdat2.c <-c('OS_mon','OS_cnr','testBmk', 'labelBmk',sel_grpVar)
    #get the data ready for group summary
    col1.1<-c(conVar1, conVar2, sdat2.c, 'mut','cnv')
    #col1.1<-col1.1[!col1.1%in%colnames(sdat1.1)]
    sdat2<-distinct(sdat1.1[,col1.1])
    s22<-is.na(sdat2$testBmk)
    if(length(s22))
    sdat2$testBmk[s22]<-0
    sdat2$labelBmk[s22]<-''
    
    #construct unique levels across group variables
    grpVar_l2m<-lev2mat(sel_grpVar_lev)
    
    #~~start to get summary table within each group~~#
    oo<-pplot<-corM<-bmk1freq<-list() #the output object of summary table
    pplot.id<-1;#the object for KM plots
    for(m1 in 1:nrow(grpVar_l2m)){
      print(m1) #here is very slow
      sdat2.1<-sdat2[!(is.na(sdat2$mut)&is.na(sdat2$cnv)),]
      for(m2 in 1:ncol(grpVar_l2m)){ #only keep obs in sel_grpVar
        sdat2.1s<-sdat2.1[,sel_grpVar[m2]]%in%grpVar_l2m[m1,m2]
        sdat2.1<-sdat2.1[sdat2.1s, ]
      }
      n.sdat2.1<-nrow(sdat2.1)
      if(n.sdat2.1<5){oo[[m1]]<-NULL;next}
      # sdat2.1$bmk<-ifelse(sdat2.1[,sel_sgrpVar]%in%sel_sgrpVar_lev,1,0)
      tm.bmk<-table(sdat2.1$testBmk)
      if(length(tm.bmk[names(tm.bmk)==1])==0){next}
      oo1<-sgrpBSsum(d0=sdat2.1, var1=sel_grpVar, d0all=sMut1.sa, #total gene
                     size1=n1, m1=b1, mutFreqTh=mutFreqTh1)#get bootstrap result
      if(is.null(oo1)){next}
      #correlational study with other mutations
      if(runCorMut){
        scort1<-scorT(yy=distinct(sdat2.1[,c('submitted_sample_id','testBmk')]),
              xx=sMut2t[,c("submitted_sample_id",'labelBmk')], th=0.05)
        if(!is.null(scort1)){scort1<-data.frame(id=pplot.id,scort1)}
        corM[[pplot.id]]<-scort1 #1 row for 1 group
      }
      oo[[pplot.id]]<-oo1$otb
      pplot[[pplot.id]]<-oo1$forplot
      bmk1freq[[pplot.id]]<-oo1$bmk1freq
      pplot.id<-pplot.id+1
    }
    oo<-do.call('rbind',oo)
    colnames(oo)[1:(len.sel_grpVar+1)]<-c(sel_grpVar, sel_sgrpVar)
    oo<-data.frame(id=1:nrow(oo), oo)
    if(runCorMut){corMm<-rbindlist(corM, fill=TRUE)}else{corMm<-NULL}
    return(list(stb=oo, kmplot=pplot, cor_mut=corMm, bmk1freq=bmk1freq))
  }
  
  #draw KM plot sgrp_sum
  sgrp_km_plot<<-function(refL){ #refL=forplot
    #refL is a list entry from a list of KM reference collections
    col1<-refL$col1
    lty1<-refL$lty1
    tt1<-refL$tt1
    f0<-refL$f0
    leg1<-refL$leg1
    leg2<-refL$leg2
    if(is.null(col1)){
      plot(0~0,col='white',ylab='',xlab='',axes=F)
      mtext('no data')
    }else{
      plot(f0, xlab=paste0('months'), 
           ylab='Probability of Survival',
           main=tt1,
           col=col1, lty=lty1)
      legend('topright',legend=leg1,col=col1, lty=lty1, bty='n')
      legend('bottomleft',legend=leg2, bty='n')
    }
  }
  
  #draw hist for bootstrap prevalence
  sgrp_hist_bspct<<-function(refL){
    hist(refL$pctv,
         xlab=paste0('Bootstrap estimated prevalence','\n',
                     refL$BS_size_number),
         main=refL$tt1)
  }
  
  #get BS size and number
  gBS1<<-function(x='40,500'){
    if(is.null(x)){x='40, 100'}
    x1<-as.numeric(strsplit(x,split=',')[[1]])
    x1<-x1[!is.na(x1)]
    if(length(x1)==0){
      return(c(40,1000))
    }else if(length(x1)==1){
      return(c(x1,1000))
    }else{
      return(x1[1:2])
    }
  }
  
  #for BS, KM, bar, heatmap
  sgrpPlot<<-function(ids=input$outTbl_rows_selected,
                      freqTH=as.numeric(input$text3)){
    ids1<-ids[length(ids)]
    if(is.null(freqTH) || is.na(freqTH)){freqTH<-0.1}
    if(freqTH<=0 | freqTH>=1){freqTH<-0.1}
    forBarpFreq<-km_out$bmk1freq[[ids1]][km_out$bmk1freq[[ids1]]>freqTH]
    if(length(forBarpFreq)>0){
      nf<-layout(t(matrix(c(1,2,3,3),nrow=2)),widths=c(1,1),
                 heights=c(2,2))
      # layout.show(nf)
      par(mai=c(0.5,0.5,0.5,0.5))
      sgrp_hist_bspct(km_out$kmplot[[ids1]])
      sgrp_km_plot(km_out$kmplot[[ids1]])
      par(mai=c(1.3,0.7,0.5,0))
      barplot(forBarpFreq,las=2)
    }else{
      par(mfrow=c(1,2)) 
      sgrp_hist_bspct(km_out$kmplot[[ids1]])
      sgrp_km_plot(km_out$kmplot[[ids1]])
    }
  }
  
}


#pull out all variables as a reference for new database add-in
if(F){
  tt1<-Sys.time();try(sprjL<<-select.prj('all'));Sys.time()-tt1
  allVars<-rbind(
    data.frame(X1=colnames(sprjL$clin), X2=rep('clin',ncol(sprjL$clin))),
    data.frame(X1=colnames(sprjL$mut), X2=rep('mut', ncol(sprjL$mut))) )
  write.csv(allVars, file=file.path(frompath,'LightON_variables.csv'),
            row.names=F)
}


#test codes to check bugs
if(F){
  source(file.path(projP, progfile))
  
  input<-NULL
  #1st module
  #input$text<- '85, 11,10,9,8,7' #'all'
  tx1<-'85, 11,10,9,8,7'
  tt1<-Sys.time();try(sprjL<<-select.prj(tx1));Sys.time()-tt1
  # see.click.prj(c(78), showMutOnly = F)
  
  #2nd module
  input$text<-'RB1,ARID1A,KMT2C,KMT2D, MYCN, AURKA, AURKB'
  # paste(findHugo(input$text)[[1]])
  
  input$text2<-'40,1000' #parameters for bootstrap
  input$dropdown<-'proj_id'
  input$dropdown2<-gLv1(input$dropdown)
  input$dropdown3<-"mutation_type"; #sgrpVar
  input$dropdown7<-'RB1'  #c('RB1','AURKA','KMT2C','KMT2D','ARID1A')#, 'MYCN')
#  input$dropdown7<-c('NTRK1','NTRK2', 'NTRK3')
  input$dropdown4<-gLv2(input$dropdown3, input$dropdown7)
  
  n1b1<<-gBS1(input$text2)
  ttt1<-Sys.time()
  try(km_out<<-grpSum(geneText=NULL, 
                      geneHS=input$dropdown7,
                      n1=n1b1[1], b1=n1b1[2],
                      sel_grpVar=input$dropdown, 
                      sel_grpVar_lev=list(v1=input$dropdown2,
                                          v2=input$dropdown5,
                                          v3=input$dropdown6),
                      sel_sgrpVar=input$dropdown3, #varnames for sel bmk
                      sel_sgrpVar_lev=input$dropdown4,
                      mutFreqTh1=0))
  Sys.time()-ttt1
  print( km_out$stb )
  print( km_out$bmk1freq )
  par(mfrow=c(1,2))
  sgrp_hist_bspct(km_out$kmplot[[1]])
  sgrp_km_plot(km_out$kmplot[[1]])
  sgrpPlot(ids=1)
  
  if(F){
    geneText=NULL; 
    geneHS=input$dropdown7;
    n1=n1b1[1]; b1=n1b1[2];
    sel_grpVar=input$dropdown; 
    sel_grpVar_lev=list(v1=input$dropdown2,
                        v2=input$dropdown5,
                        v3=input$dropdown6);
    sel_sgrpVar=input$dropdown3; #varnames for sel bmk
    sel_sgrpVar_lev=input$dropdown4;
    maxLev_grp=500;
    min_n_sgrp=5;
    runCorMut=FALSE;
    mutFreqTh1=0.02
  }
  
}

if(F){ #for KRAS G12C
  source(file.path(projP, progfile))
  input<-NULL
  
  #1st module
  tx1<-'all'
  tt1<-Sys.time();try(sprjL<<-select.prj(tx1));Sys.time()-tt1
  # lapply(sprjL, dim)
  # head(sprjL$mut)
  
  #2nd module
  input$text<-'KRAS'
  print(paste(findHugo(input$text)[[1]]))
  input$text2<-'40,1000' #parameters for bootstrap
  input$dropdown<-c('db','proj_id','proj_name')
  input$dropdown2<-gLv1('db')
  input$dropdown5<-gLv1('proj_id')
  input$dropdown6<-gLv1('proj_name')
  input$dropdown3<-"aa_mutation"; #sgrpVar
  input$dropdown7<-'KRAS'
  mtype<-gLv2(input$dropdown3, input$dropdown7)
  print(input$dropdown4<-mtype[grep('g12c',tolower(mtype))])
  
  n1b1<<-gBS1(input$text2)
  ttt1<-Sys.time()
  try(km_out<<-grpSum(geneText=NULL, 
                      geneHS=input$dropdown7,
                      n1=n1b1[1], b1=n1b1[2],
                      sel_grpVar=input$dropdown, 
                      sel_grpVar_lev=list(v1=input$dropdown2,
                                          v2=input$dropdown5,
                                          v3=input$dropdown6),
                      sel_sgrpVar=input$dropdown3, #varnames for sel bmk
                      sel_sgrpVar_lev=input$dropdown4,
                      mutFreqTh1=0))
  Sys.time()-ttt1
  head( outtb1<-km_out$stb )
  #colnames(outtb1)[grepl('95CI', colnames(outtb1))]<-c('N','prevl_BMKpos_95CI_n40')

}


#set default project 
try(sprjL<<-select.prj("1"))

#function for update covariate names
grpVar.clin.fun<<-function(
  dum=NULL
){
  print(dum)
  return(grpVar.clin0[grpVar.clin0%in%colnames(sprjL$clin)])
}

##############################################################################################
#Source Code received from Profession Jason Hsu
#BEACH CD created by Danni Yu
#Initial Date: 2020-11-19
#Last Modify Date: 2021-1-4
##############################################################################################


if(F){
  getwd(); dir();
  source("functions/users/JasonHsu.R")

  lapply(indataset, head)
  varlist <<- colnames(indataset[[1]])

  #"Simultaneous Confidence Intervals for Efficacy"
  input<-NULL
  input$dropdown<-c("Ratio of Median", "Difference of Median") #"Efficacy Measurement"
  input$slide<-5 # "Alpha (in percents)",  min = 1,  max = 50, value = 5)
  input$slide4<-50 #"Proportion of marker negative subjects in population (in percents)", min = 0,  max = 100, value = 50)
  input$dropdown2<-'Subj' #"Patient ID Variable", varlist
  input$dropdown3<-'Trt'  #"Treatment Variable", varlist
  input$dropdown4<-'0' #"Control Value", trt_levels= sort(unique(indataset[[1]][,input$dropdown3]))  
  input$dropdown5<-'M' #"Biomarker Variable", varlist
  input$slide2<-0.95 #"Data filter cut-point c0 (subjects w/ value < C0 are excluded)", 
                    #min=min(indataset[[1]][, input$dropdown5],na.rm=TRUE)
                    #max=as.numeric(quantile(indataset[[1]][, input$dropdown5], 0.50,na.rm=TRUE))
                    #value=min(indatast[[1]][, input$dropdown5],na.rm=TRUE)
  input$slide3<-1.66 #"Marker +/- cut-point c1 (subjects w/ value < C1 are marker -)"
                    #min=min.inSliderC1 
                    #max=max.inSliderC1
                    #value=median(c(CMarker, RxMarker)
                    #get3(mrk=input$dropdown5, slide0=input$slide2,trtVar=input$dropdown3, conVal=input$dropdown4)
  input$dropdown6<-'Y' #"Time to Event Outcome Variable", varlist
  input$dropdown7<-'Delta' #"Censor Indicator Variable", varlist
  input$dropdown8<-'1' #"Censor Value", censor_levels = c("", sort(unique(indataset[[1]][, input$dropdown7])))

  intiPlot(meth=input$dropdown)

  #grepl('Relative Response',input$dropdown, fixed=T)

}

#-----------------------------------------#
#Author: Danni Yu
#Additional functions created to adapt into BEACH. 
if(TRUE){
  library(eha)
  library(survival)
  library(rootSolve)
  library(mvtnorm)
  library(plotrix)

  varlist <<- colnames(indataset[[1]])

  fill.sp<<-function(xx, nch, sep=' '){
    yy<-NULL
    for(i in 1:length(xx)){
      yy<-c(yy, paste0(xx[i], paste(rep(' ', max(0, nch-nchar(xx[i]))), collapse='') ))
    }
    return(yy)
  }

  get3<<-function(mrk=input$dropdown5, slide0=input$slide2, 
                     trtVar=input$dropdown3, conVal=input$dropdown4, 
                     dd=indataset[[1]]){
    trt<-dd[dd[, mrk]>=slide0, trtVar]
    Marker<-dd[dd[, mrk]>=slide0, mrk]
    CMarker<-Marker[trt==conVal]
    RxMarker<-Marker[trt!=conVal]
    ind.C.max<-order(-CMarker,na.last=NA)[2] # na.last=NA for missing values
    ind.Rx.max<-order(-RxMarker,na.last=NA)[2]
    ind.C.min<-order(CMarker,na.last=NA)[2]
    ind.Rx.min<-order(RxMarker,na.last=NA)[2] 

    if(CMarker[order(CMarker,na.last=NA)[2]]==CMarker[order(CMarker,na.last=NA)[3]]){
       min.inSliderC1<-max(CMarker[ind.C.min], RxMarker[ind.Rx.min],na.rm=TRUE)+0.01
       max.inSliderC1<-min(CMarker[ind.C.max], RxMarker[ind.Rx.max],na.rm=TRUE)
     }else{
       min.inSliderC1<-max(CMarker[ind.C.min], RxMarker[ind.Rx.min],na.rm=TRUE)
       max.inSliderC1<-min(CMarker[ind.C.max], RxMarker[ind.Rx.max],na.rm=TRUE)
     }  
     return(list(min=min.inSliderC1, max=max.inSliderC1, 
                 med=median(c(CMarker, RxMarker)), 
                 by=(max.inSliderC1-min.inSliderC1)/20))
  }

  ## ---- model fit reactive object ----##
  ## ---- analysis data reactive object ----
  analysisData <<- function(dd2=input$dropdown2, 
       dd3=input$dropdown3, dd4=input$dropdown4, dd5=input$dropdown5,
       dd6=input$dropdown6, dd7=input$dropdown7, dd8=input$dropdown8, 
       ss2=input$slide2, ss3=input$slide3
    ){
    if (is.null(dd2)|  
          is.null(dd3)|  
          is.null(dd4)|
          is.null(dd5)|
          is.null(dd6)|
          is.null(dd7)|
          is.null(dd8)) { return() }
    tmp <- indataset[[1]]
    # assemble all variable names selected from various inputs
    cols_select <- c(dd2, dd3, dd5, dd6, dd7)
    
    analysis_set <- tmp[, cols_select]
    if(class(analysis_set[, dd3]) != "character") {
      analysis_set[, dd3] <- as.character(analysis_set[, dd3])
    }
    
    ## --------------------------------------------##
    ## -- remove data with Marker value below C0 --##
    ## --------------------------------------------##
    
    if(sum(indataset[[1]][, dd5]<ss2,na.rm=TRUE)>0){
      analysis_set<- analysis_set[indataset[[1]][, dd5]>=ss2,]
    }
    
    analysis_set[, dd5]<-factor(ifelse(analysis_set[, dd5] < ss3, "Neg", "Pos"))
    analysis_set
  }# end of analysisData 

  WeibullFit <<- function( d3=input$dropdown3, d2=input$dropdown2, d4=input$dropdown4,
       d5=input$dropdown5, d6=input$dropdown6, d7=input$dropdown7, d8=input$dropdown8, 
       s2=input$slide2, s3=input$slide3, s4=input$slide4, s0=input$slide, rtLab=F, metd=input$dropdown
   ){
        anaTemp <<- analysisData(dd2=d2, dd3=d3, dd4=d4, dd5=d5,
                       dd6=d6, dd7=d7, dd8=d8, ss2=s2, ss3=s3)
        if (length(unique(indataset[[1]][, d3]))>10 |
              is.null(d2)|  
              is.null(d3)|  
              is.null(d4)|
              is.null(d5)|
              length(levels(factor(anaTemp[, d5])))<2|
              is.null(d6)|
              is.null(d7)|
              is.null(d8)) { return() }
                
        outcomeEventInd <- anaTemp[, d7]
        outcomeEventInd[outcomeEventInd == d8] <- 0
        outcomeEventInd[outcomeEventInd != d8] <- 1    
        
        # define survival object
        response_vec <- Surv(time = as.numeric(anaTemp[, d6]), 
                             event = as.numeric(outcomeEventInd))
        Trt <- anaTemp[, d3]
        M <- anaTemp[, d5]  
        d4 <- as.character(d4)      
    
        # fit Weibull model that reacts to event in user interface 
        fit <- weib(formula = response_vec ~ 
                    relevel(as.factor(Trt), d4)+
                    relevel(as.factor(M),"Neg")+
                    relevel(as.factor(Trt),d4)*relevel(as.factor(M),"Neg"), 
                  data=anaTemp) 
        # log.param are the log scaled parameter estimates from weibull fitting
        log.param.est <- fit$log.coef
        log.param.var <- diag(fit$log.var)
        # param are the original scale (exponential of log.param) parameter estimates
        param.est <- fit$coef
        param.var <- fit$var
        param.var.diag <- diag(param.var)
        
        # get prevalence of marker negative group from slider 
        p.neg = as.double(s4)/100
        
        #-------------------------------------------------------------------------------#
        # compute median survival times and their associated variance covariance matrix #
        #-------------------------------------------------------------------------------#
        comp.median <- median.surv(lambda=param.est[1],k=param.est[2],theta=param.est[3:5],p.neg=p.neg)
        (median.surv.est <- unlist(comp.median))
    
        median.surv.C <- median.surv.est[c(1,2,5)]
        median.surv.Rx <- median.surv.est[c(3,4,6)]
    
        median.surv.estiMates <- matrix(ncol=3, rbind(median.surv.Rx, median.surv.C))
        Negative <- median.surv.estiMates[,1]
        Positive <- median.surv.estiMates[,2]
        Mixture <- median.surv.estiMates[,3]
        Estimates <- data.frame(Negative, Positive, Mixture)
        row.names(Estimates) <- c("Rx", "C")
    
        median.var.est <-var.median.surv.dt.dim6(med.C.neg=median.surv.est[1], med.C.pos=median.surv.est[2], 
                                             med.Rx.neg=median.surv.est[3], med.Rx.pos=median.surv.est[4],
                                             med.C=median.surv.est[5],med.Rx=median.surv.est[6],p.neg=p.neg,
                                             lambda=param.est[1],k=param.est[2],theta=param.est[3:5],
                                             param.var=fit$var)$median.var        
        #----------------------------------------#
        # Calculate ratio of median and their CI #
        #----------------------------------------#  
        #----------------------------------------------------------#
        # begin log scale delta method
        comp.ratio <- log.ratio.median.surv.dt.dim3(median.surv=median.surv.est,median.var=median.var.est)
        log.ratio <- c(comp.ratio$log.ratio.neg,comp.ratio$log.ratio.pos,comp.ratio$log.ratio.mix)
        var.log.ratio <- comp.ratio$var.log.ratio
        
        original.ratio <- c(comp.ratio$ratio.neg,comp.ratio$ratio.pos,comp.ratio$ratio.mix)
        ratio.negative <- original.ratio[1]
        ratio.positive <- original.ratio[2]
        ratio.mixture  <- original.ratio[3]
        Ratios <- data.frame(ratio.negative, ratio.positive, ratio.mixture)
        row.names(Ratios) <- c("Rx/C")
        colnames(Ratios) <- c("Negative", "Positive", "Mixture")
        
        comp.ratio.CI <- log.ratio.simu.CI(seed=12345, alpha=as.double(s0)/100,
                                       log.ratio=log.ratio, var.log.ratio=var.log.ratio)
        ratio.CI.lbd <- comp.ratio.CI$ratio.CI.lbd
        ratio.CI.ubd <- comp.ratio.CI$ratio.CI.ubd
        
        # end of log delta method
        #----------------------------------------------------------#
        # CIs from lg scale delta method
        ratio.CI <- matrix(ncol=3, rbind(ratio.CI.ubd, ratio.CI.lbd))
        
        ratio.CI.negative <- ratio.CI[,1]
        ratio.CI.positive <- ratio.CI[,2]
        ratio.CI.mixture <- ratio.CI[,3]
        Ratio.CI <- data.frame(ratio.CI.negative, ratio.CI.positive, ratio.CI.mixture)
        row.names(Ratio.CI) <- c("Upper","Lower")
        colnames(Ratio.CI) <- c("Negative", "Positive", "Mixture")
        
    
    
        #---------------------------------------------#
        # Calculate difference of median and their CI #
        #---------------------------------------------#
        #----------------------------------------------------------#
        # begin of delta method
        comp.dif <- dif.median.surv.dt.dim3(median.surv=median.surv.est,median.var=median.var.est)
        dif.median <- c(comp.dif$dif.neg, comp.dif$dif.pos,comp.dif$dif.mix)
        var.dif.median <- comp.dif$var.dif
        
        dif.median.negative <- dif.median[1]
        dif.median.positive <- dif.median[2]
        dif.median.mixture <- dif.median[3]
        Diff <- data.frame(dif.median.negative, dif.median.positive, dif.median.mixture)
        row.names(Diff) <- c("Rx-C")
        colnames(Diff) <- c("Negative", "Positive", "Mixture")
        
        comp.dif.CI <- dif.median.simu.CI(seed=12345,alpha=as.double(s0)/100, 
                                     dif.median=dif.median, var.dif.median=var.dif.median)
        median.dif.CI.lbd <- comp.dif.CI$dif.median.CI.lbd
        median.dif.CI.ubd <- comp.dif.CI$dif.median.CI.ubd
    
        # end of delta method
        #----------------------------------------------------------#
        # CIs from delta method
        median.dif.CI <- matrix(ncol=3, rbind(median.dif.CI.ubd, median.dif.CI.lbd))
        
        median.dif.CI.negative <- median.dif.CI[,1]
        median.dif.CI.positive <- median.dif.CI[,2]
        median.dif.CI.mixture <- median.dif.CI[,3]
        Diff.CI <- data.frame(median.dif.CI.negative, median.dif.CI.positive, median.dif.CI.mixture)
        row.names(Diff.CI) <- c("Upper","Lower")
        colnames(Diff.CI) <- c("Negative", "Positive", "Mixture")
        
        #---------------#
        # return retuls #
        #---------------#    
        WeibullResult <<- list(Estimates = Estimates,
                              Ratios = Ratios,
                              Ratio.CI = Ratio.CI,
                              Diff = Diff,
                              Diff.CI = Diff.CI,
                              median.surv.estiMates = median.surv.estiMates)
        if(!rtLab){
          return(WeibullResult)
        }else{
          printDF<-function(x=WeibullResult$Estimates){
            xx<-cbind(` `=rownames(x), round(x, 3))
            xx<-rbind(c(paste(rep(' ', max(nchar(xx[,1]))), collapse=''), colnames(x)), xx)
            p1<-paste(apply(xx, 1, paste, collapse='\t'), collapse='\n')
          }
          tm1<-paste0("Estimated Median Time-to-Event:\n", printDF(WeibullResult$Estimates))

          tm2<-paste0("Estimated Ratio of Median Time-to-Event:\n", printDF(WeibullResult$Ratios))
          tm3<-paste0("Confidence Interval for Ratio of Median Time-to-Event:\n", printDF(WeibullResult$Ratio.CI))

          tm4<-paste0("Estimated Difference of Median Time-to-Event:\n", printDF(WeibullResult$Diff))
          tm5<-paste0("Confidence Interval for Ratio of Difference of Median Time-to-Event:\n", printDF(WeibullResult$Diff.CI))

          if(metd=="Ratio of Median"){
            rt.label<-paste(tm1, tm2, tm3, sep='\n')
          }else{
            rt.label<-paste(tm1, tm4, tm5, sep='\n')
          }
          return(rt.label)
        }
  } #end of WeibullFit


  #--------------------For plot output in BEACH----------------------#
  intiPlot<<-function( meth=input$dropdown, 
      drd3=input$dropdown3, drd2=input$dropdown2, drd4=input$dropdown4,
      drd5=input$dropdown5, drd6=input$dropdown6, drd7=input$dropdown7, drd8=input$dropdown8, 
      sid2=input$slide2, sid3=input$slide3, sid4=input$slide4, sid0=input$slide,
      rt.tb=F
  ){

    if(is.null(meth) ){
      return(NULL)
    }else if(meth=="Ratio of Median"){
      weibTemp <<- WeibullFit(d3=drd3, d2=drd2, d4=drd4,
         d5=drd5, d6=drd6, d7=drd7, d8=drd8, 
         s2=sid2, s3=sid3, s4=sid4, s0=sid0 )
      plotLimit <- max(weibTemp$median.surv.estiMates)*1.3
      if(is.null(weibTemp)){return(NULL)}
      RatPlot(xlim=c(0,plotLimit), ylim=c(0,plotLimit), # range of the data
              xlab=expression(paste(nu[C]," = median time for C")),
              ylab=expression(paste(nu[Rx]," = median time for Rx")), # label of two axes
              med.surv.Rx=weibTemp$median.surv.estiMates[1,], # median survival time for the Rx (sub)groups
              med.surv.C=weibTemp$median.surv.estiMates[2,], # median survival time for the C (sub)groups
              angle.1=as.numeric(weibTemp$Ratio.CI[2,]), # angle.1 (a vector) = the upper bounds of simultaneous CIs for the ratios
              angle.2=as.numeric(weibTemp$Ratio.CI[1,]), # angle.2 (a vector) = the lower bounds of simultaneous CIs for the ratios
              color=c(2,3,4), #the color of the lines/arcs
              pch=c(21,22,23), #the shape of points (to represent the median survival times)
              legend=c(paste(":       ", "g-"), 
                       paste(":       ", "g+"),
                       paste(": {", "g-", "," , "g+", "}")), # the legend of the plot
              axis.1=c(expression(paste(nu[C],"-")),expression(paste(nu[C],"+")), expression(paste(nu[C],"*"))),
              axis.2=c(expression(paste(nu[Rx],"-")),expression(paste(nu[Rx],"+")), expression(paste(nu[Rx],"*")))# labels of the two axes
        )
    }else if(grepl('Relative Response',meth, fixed=T)){
    ####convert colnames to function default #cn0 <- c(input$dropdown6, input$dropdown3, input$dropdown5)
      cn0<-c(drd6, drd3, drd5); cn2 <- c("Y", "Trt", "M")
      dd <- indataset[[1]][,cn0]; colnames(dd)<-cn2
      if(grepl('Logistic', meth, fixed=T)){
        mod <- logistic(dd, 0)
        fit <- logistic.log.RR.dt.dim3(theta=mod$theta, p.neg=sid4/100, param.var=mod$fit.theta.Var)
        log.rr <- c(fit$log.RR.neg, fit$log.RR.pos, fit$log.RR.mix)
        sim <- log.RR.simu.CI(seed=123456, alpha=sid0/100, log.RR=log.rr, var.log.RR=fit$var.log.RR)
      }else{
        mod <- loglinear(dd, 0)
        fit <- loglinear.log.RR.dt.dim3(theta=mod$theta, p.neg=sid4/100, param.var=mod$fit.theta.Var)
        log.rr <- c(fit$log.RR.neg, fit$log.RR.pos, fit$log.RR.mix)
        sim <- log.RR.simu.CI(seed=123456, alpha=sid0/100, log.RR=log.rr, var.log.RR=fit$var.log.RR)
      }
      if(rt.tb){
        ot <- do.call('rbind', sim)
        ot <- rbind(round(log.rr, 3), round(ot, 3))
        nch0 <- max(nchar(ot), na.rm=T)
        gp <- fill.sp(c('g-', 'g+', 'g.mix'), nch0)
        ot <- rbind(gp, ot)
        rownames(ot)[1:2] <- c("group", "RR")
        ot <- cbind(fill.sp(rownames(ot), max(nchar(rownames(ot)), na.rm=T)), ot)
        ot <- paste(apply(ot, 1, paste, collapse= '\t\t'), collapse='\t\t\n')
        return(ot)
      }else{
        lineP(rr=exp(log.rr), s=sim, ylab=meth)#line plot
      }
    }else if(meth=="Difference of Median"){
      weibTemp <<- WeibullFit(d3=drd3, d2=drd2, d4=drd4,
         d5=drd5, d6=drd6, d7=drd7, d8=drd8, 
         s2=sid2, s3=sid3, s4=sid4, s0=sid0 )
      plotLimit <- max(weibTemp$median.surv.estiMates)*1.3
      if(is.null(weibTemp)){return(NULL)}
      DifPlot(xlim=c(0,plotLimit),ylim=c(0,plotLimit), # range of the data
                xlab=expression(paste(nu[C]," = median time for C")),
                ylab=expression(paste(nu[Rx]," = median time for Rx")), # label of two axes
                med.surv.Rx=weibTemp$median.surv.estiMates[1,], # median survival time for the Rx (sub)groups
                med.surv.C=weibTemp$median.surv.estiMates[2,], # median survival time for the C (sub)groups
                UCI=weibTemp$Diff.CI[2,], # UCI (a vector) = the upper bounds of simultaneous CIs for the differences
                LCI=weibTemp$Diff.CI[1,], # LCI (a vector) = the lower bounds of simultaneous CIs for the differences
                color=c(2,3,4), # the color of the lines/arcs
                pch=c(21,22,23), # the shape of points (to represent the median survival times)
                legend=c(paste(":    ", "g-"), 
                         paste(":    ", "g+"),
                         paste(": {", "g-", "," , "g+", "}")), # the legend of the plot
                axis.1=c(expression(paste(nu[C],"-")),expression(paste(nu[C],"+")), expression(paste(nu[C],"*"))),
                axis.2=c(expression(paste(nu[Rx],"-")),expression(paste(nu[Rx],"+")), expression(paste(nu[Rx],"*")))# labels of the two axes
        )
    }else{return(NULL)}
  } 

}

#^^^^^^^^Original name: Weibull_median_RatDiff_2grp.R^^^^^^^^^^^#
#-----------------------------------------#
# Weibull_Median_RatDiff_2grp.R includes 4 functions: 
#  	1. weib: weibull fitting for 2 group case
#   2. median.surv: calculate median survival for each subgroup and combined group
#  	3. var.median.surv.dt.dim6
#  	4. log.ratio.median.surv.dt.dim3
#   5. log.ratio.simu.CI: CI computation is based on log-scale ratio 
#	  6. dif.median.surv.dt.dim3
#   7. dif.median.simu.CI
#
#-----------------------------------------#

weib <- function(formula, data){
  # data contain the following columns: Y, Delta, Trt, M
  # Trt=1: treatment; Trt=0: control
  fit.weib <- weibreg(formula=formula, data=data)
  #fit.weib <- weibreg(Surv(Y,Delta) ~ relevel(as.factor(Trt),"1")+as.factor(M)+relevel(as.factor(Trt),"1")*as.factor(M), data=data)
  fit.LogCoeff <- fit.weib$coef
  fit.Coeff <- exp(fit.LogCoeff) # the coefficient in the "original" scale (exponentiated from the log scale)
  # change the order of the parameters (so that they correspond to "lambda","k","theta1","theta2","theta3")
  fit.Coeff <- fit.Coeff[c(4,5,1:3)]
  names(fit.Coeff)[1:2]<-c("Scale","Shape")
  # change the order of the var parameters accordingly 
  fit.LogVar <- fit.weib$var
  tmp1 <- fit.LogVar[1:3,1:3]
  tmp2 <- fit.LogVar[4:5,4:5]
  tmp3 <- fit.LogVar[1:3,4:5]
  
  fit.LogVar.2 <- rbind(cbind(tmp2,t(tmp3)),cbind(tmp3,tmp1))
  # delta method to compute the Variance matrix for the parameter estimates in the "original" scale
  fit.Var <- diag(fit.Coeff) %*% fit.LogVar.2 %*% diag(fit.Coeff) 
  
  return(list(log.coef=fit.LogCoeff,log.var=fit.LogVar,coef=fit.Coeff,var=fit.Var))
}



# calculate the median survival time for each subgroup and the combined groups
median.surv <- function(lambda,k,theta,p.neg){
  
  # lambda: Weibull distribution's scale parameter 
  # k: Weibull distribution's shape parameter 
  # theta=(theta1,theta2,theta3): =exp(beta) where beta is the slope parameter in the Cox PH model
  # p.neg: Prob(g-) (assume Prob(g-|C)=Prob(g-|Rx))
  
  median.C.neg <- as.numeric(lambda*(log(2))^(1/k))
  median.C.pos <- as.numeric(lambda*(log(2)/theta[2])^(1/k))
  median.Rx.neg <- as.numeric(lambda*(log(2)/theta[1])^(1/k))  
  median.Rx.pos <- as.numeric(lambda*(log(2)/(theta[1]*theta[2]*theta[3]))^(1/k))
  
  f.C <- function(t){
    f=p.neg*exp(-(t/lambda)^k)+(1-p.neg)*exp(-theta[2]*(t/lambda)^k)-0.5
    return(f)
  }
  f.Rx <- function(t){
    f=p.neg*exp(-theta[1]*(t/lambda)^k)+(1-p.neg)*exp(-theta[1]*theta[2]*theta[3]*(t/lambda)^k)-0.5
    return(f)
  }
  median.C <- uniroot(f.C,c(max(median.C.neg,median.C.pos),min(median.C.neg,median.C.pos)))$root
  median.Rx <- uniroot(f.Rx,c(max(median.Rx.neg,median.Rx.pos),min(median.Rx.neg,median.Rx.pos)))$root
  
  return(list(median.C.neg=median.C.neg,median.C.pos=median.C.pos,
              median.Rx.neg=median.Rx.neg,median.Rx.pos=median.Rx.pos,
              median.C=median.C,median.Rx=median.Rx))
  
}

# use the delta method for implicitly defined RVs
# reference paper: Jacques Benichou and Mitchell Gail (The American Statistician, 1989, Vol.43, No.1) 

var.median.surv.dt.dim6 <- function(med.C.neg, med.C.pos, med.Rx.neg, med.Rx.pos, med.C, med.Rx,
                                    p.neg,lambda,k,theta,param.var){
  

  # calculate the variance estimate for the median survival time estimate of all group
  # using delta method for implicitly defined random variables
  
  J.11 <- (-k*exp(-(med.C.neg/lambda)^k)*(med.C.neg/lambda)^(k-1))/lambda 
  J.22 <- (-k*theta[2]*exp(-theta[2]*(med.C.pos/lambda)^k)*(med.C.pos/lambda)^(k-1))/lambda 
  J.33 <- (-k*theta[1]*exp(-theta[1]*(med.Rx.neg/lambda)^k)*(med.Rx.neg/lambda)^(k-1))/lambda 
  J.44 <- (-k*theta[1]*theta[2]*theta[3]*exp(-theta[1]*theta[2]*theta[3]*(med.Rx.pos/lambda)^k)*(med.Rx.pos/lambda)^(k-1))/lambda 
  J.55 <- (-p.neg*k*exp(-(med.C/lambda)^k)*(med.C/lambda)^(k-1)
           -(1-p.neg)*k*theta[2]*exp(-theta[2]*(med.C/lambda)^k)*(med.C/lambda)^(k-1))/lambda 
  J.66 <- (-p.neg*k*theta[1]*exp(-theta[1]*(med.Rx/lambda)^k)*(med.Rx/lambda)^(k-1)
           -(1-p.neg)*k*theta[1]*theta[2]*theta[3]*exp(-theta[1]*theta[2]*theta[3]*(med.Rx/lambda)^k)*(med.Rx/lambda)^(k-1))/lambda 
  
  J.mat <- diag(c(J.11, J.22, J.33, J.44, J.55, J.66))  
  J.mat.inv <- solve(J.mat)
  
  H.mat <- mat.or.vec(6,5)
  H.mat[1,] <- c(exp(-(med.C.neg/lambda)^k)*k*(med.C.neg/lambda)^(k-1)*(med.C.neg/lambda^2), 
                 -exp(-(med.C.neg/lambda)^k)*(med.C.neg/lambda)^k*log(med.C.neg/lambda),
                 0,
                 0,
                 0)
  H.mat[2,] <- c(exp(-theta[2]*(med.C.pos/lambda)^k)*theta[2]*k*(med.C.pos/lambda)^(k-1)*(med.C.pos/lambda^2), 
                 -exp(-theta[2]*(med.C.pos/lambda)^k)*theta[2]*(med.C.pos/lambda)^k*log(med.C.pos/lambda),
                 0,
                 -exp(-theta[2]*(med.C.pos/lambda)^k)*(med.C.pos/lambda)^k,
                 0)
  H.mat[3,] <- c(exp(-theta[1]*(med.Rx.neg/lambda)^k)*theta[1]*k*(med.Rx.neg/lambda)^(k-1)*(med.Rx.neg/lambda^2),
                 -exp(-theta[1]*(med.Rx.neg/lambda)^k)*theta[1]*(med.Rx.neg/lambda)^k*log(med.Rx.neg/lambda),   
                 -exp(-theta[1]*(med.Rx.neg/lambda)^k)*(med.Rx.neg/lambda)^k,
                 0,
                 0)
  H.mat[4,] <- c(exp(-theta[1]*theta[2]*theta[3]*(med.Rx.pos/lambda)^k)*theta[1]*theta[2]*theta[3]*k*(med.Rx.pos/lambda)^(k-1)*(med.Rx.pos/lambda^2),
                 -exp(-theta[1]*theta[2]*theta[3]*(med.Rx.pos/lambda)^k)*theta[1]*theta[2]*theta[3]*(med.Rx.pos/lambda)^k*log(med.Rx.pos/lambda),   
                 -exp(-theta[1]*theta[2]*theta[3]*(med.Rx.pos/lambda)^k)*theta[2]*theta[3]*(med.Rx.pos/lambda)^k,
                 -exp(-theta[1]*theta[2]*theta[3]*(med.Rx.pos/lambda)^k)*theta[1]*theta[3]*(med.Rx.pos/lambda)^k,
                 -exp(-theta[1]*theta[2]*theta[3]*(med.Rx.pos/lambda)^k)*theta[1]*theta[2]*(med.Rx.pos/lambda)^k)
  
  H.mat[5,] <- c(p.neg*exp(-(med.C/lambda)^k)*k*(med.C/lambda)^(k-1)*(med.C/lambda^2)
                 +(1-p.neg)*exp(-theta[2]*(med.C/lambda)^k)*theta[2]*k*(med.C/lambda)^(k-1)*(med.C/lambda^2), 
                 -p.neg*exp(-(med.C/lambda)^k)*(med.C/lambda)^k*log(med.C/lambda)
                 -(1-p.neg)*exp(-theta[2]*(med.C/lambda)^k)*theta[2]*(med.C/lambda)^k*log(med.C/lambda),
                 0,
                 -(1-p.neg)*exp(-theta[2]*(med.C/lambda)^k)*(med.C/lambda)^k,
                 0)
  
  H.mat[6,] <- c(p.neg*exp(-theta[1]*(med.Rx/lambda)^k)*theta[1]*k*(med.Rx/lambda)^(k-1)*(med.Rx/lambda^2)
                 +(1-p.neg)*exp(-theta[1]*theta[2]*theta[3]*(med.Rx/lambda)^k)*theta[1]*theta[2]*theta[3]*k*(med.Rx/lambda)^(k-1)*(med.Rx/lambda^2),
                 -p.neg*exp(-theta[1]*(med.Rx/lambda)^k)*theta[1]*(med.Rx/lambda)^k*log(med.Rx/lambda) 
                 -(1-p.neg)*exp(-theta[1]*theta[2]*theta[3]*(med.Rx/lambda)^k)*theta[1]*theta[2]*theta[3]*(med.Rx/lambda)^k*log(med.Rx/lambda),   
                 -p.neg*exp(-theta[1]*(med.Rx/lambda)^k)*(med.Rx/lambda)^k-(1-p.neg)*exp(-theta[1]*theta[2]*theta[3]*(med.Rx/lambda)^k)*theta[2]*theta[3]*(med.Rx/lambda)^k,
                 -(1-p.neg)*exp(-theta[1]*theta[2]*theta[3]*(med.Rx/lambda)^k)*theta[1]*theta[3]*(med.Rx/lambda)^k,
                 -(1-p.neg)*exp(-theta[1]*theta[2]*theta[3]*(med.Rx/lambda)^k)*theta[1]*theta[2]*(med.Rx/lambda)^k)
  
  median.var <- J.mat.inv %*% H.mat %*% param.var %*% t(H.mat) %*% t(J.mat.inv)
  
  return(list(median.var = median.var))
}

#-------#
# ratio #
#-------#
# Use ratio (med.Rx.neg/med.C.neg, med.Rx.pos/med.C.pos, med.Rx/med.C) as the efficacy measure

log.ratio.median.surv.dt.dim3 <- function(median.surv,median.var){
  
  median.C.neg <- median.surv["median.C.neg"]
  median.C.pos <- median.surv["median.C.pos"]
  median.Rx.neg <- median.surv["median.Rx.neg"]
  median.Rx.pos <- median.surv["median.Rx.pos"]
  median.C <- median.surv["median.C"]
  median.Rx <- median.surv["median.Rx"]
  
  # ratio for M-, M+, combined
  gamma.neg <- median.Rx.neg/median.C.neg
  gamma.pos <- median.Rx.pos/median.C.pos
  gamma.mix <- median.Rx/median.C
  
  # log(ratio) for M-, M+, combined
  log.gamma.neg <- log(median.Rx.neg/median.C.neg)
  log.gamma.pos <- log(median.Rx.pos/median.C.pos)
  log.gamma.mix <- log(median.Rx/median.C)
  
  
  D.log.gamma <- t(matrix(c(-1/median.C.neg, 0, 1/median.Rx.neg, 0, 0, 0,
                            0, -1/median.C.pos, 0, 1/median.Rx.pos, 0, 0, 
                            0, 0, 0, 0,  -1/median.C, 1/median.Rx),3, 6, byrow =TRUE))
  # var.log.gamma is the variance/covariance matrix for log(ratio)
  var.log.gamma <- t(D.log.gamma) %*% median.var %*% (D.log.gamma)  
  
  return(list(log.ratio.neg=log.gamma.neg, log.ratio.pos=log.gamma.pos, log.ratio.mix=log.gamma.mix, 
              ratio.neg=gamma.neg, ratio.pos=gamma.pos, ratio.mix=gamma.mix,
              var.log.ratio=var.log.gamma))
}

# CI computation is based on log-scale ratio
log.ratio.simu.CI <- function(seed,alpha,log.ratio,var.log.ratio){
  # qmvnorm is simulation based, provide a seed
  set.seed(seed)
  log.CIs <- qmvnorm(1-alpha, corr=cov2cor(var.log.ratio), tail = "both")$quantile*sqrt(diag(var.log.ratio))
  
  ratio.CI.lbd <- exp(log.ratio - log.CIs)
  ratio.CI.ubd <- exp(log.ratio + log.CIs)
  
  return(list(ratio.CI.lbd=ratio.CI.lbd,ratio.CI.ubd=ratio.CI.ubd))
}



#------------#
# difference #
#------------#
# Use difference (med.Rx.neg-med.C.neg, med.Rx.pos-med.C.pos, med.Rx-med.C) as the efficacy measure

dif.median.surv.dt.dim3 <- function(median.surv, median.var){
	
	median.C.neg <- median.surv["median.C.neg"]
	median.C.pos <- median.surv["median.C.pos"]
	median.Rx.neg <- median.surv["median.Rx.neg"]
	median.Rx.pos <- median.surv["median.Rx.pos"]
	median.C <- median.surv["median.C"]
	median.Rx <- median.surv["median.Rx"]
	
	delta.neg <- median.Rx.neg-median.C.neg
	delta.pos <- median.Rx.pos-median.C.pos
	delta.mix <- median.Rx-median.C
	
	D.delta <- t(matrix(c(-1, 0, 1, 0, 0, 0,
							0, -1, 0, 1, 0, 0, 
							0, 0, 0, 0,	-1, 1),3, 6, byrow =TRUE))
	var.delta <- t(D.delta) %*% median.var %*% (D.delta)  
	
	return(list(dif.neg=delta.neg, dif.pos=delta.pos, dif.mix=delta.mix, var.dif=var.delta))
}


# CI computation is based on difference of median

dif.median.simu.CI <- function(seed, alpha, dif.median, var.dif.median){
  # qmvnorm is simulation based, provide a seed
  set.seed(seed)
  CIs <- qmvnorm(1-alpha, corr=cov2cor(var.dif.median), tail = "both")$quantile*sqrt(diag(var.dif.median))
  
  dif.median.CI.lbd <- dif.median - CIs
  dif.median.CI.ubd <- dif.median + CIs
  
  return(list(dif.median.CI.lbd=dif.median.CI.lbd, dif.median.CI.ubd=dif.median.CI.ubd))
}



#^^^^^^^^Original name: App_RateDiffPlot.R^^^^^^^^^^^#
#----------------------#
#-- M&M PLOT for App --#
#----------------------#

# the following is the function for generating the ratio M&M plot
RatPlot <- function(xlim=c(0,20),ylim=c(0,20), # range of the data
                    xlab=expression(paste(m[C]," = median OS for C")),
                    ylab=expression(paste(m[Rx]," = median OS for Rx")), # label of two axes
                    med.surv.Rx=c(10,18,14), # median survival time for the Rx (sub)groups
                    med.surv.C=c(8,10,9), # median survival time for the C (sub)groups
                    angle.1=c(1.65,2.5,2.16), 
                    angle.2=c(0.85,1.1,0.96), 
                    color=c(2,3,4), # the color of the lines/arcs
                    pch=c(21,22,23), # the shape of points (to represent the median survival times)
                    legend=c(": g+ group",": g- group", ": {g+,g-} combined group"), # the legend of the plot
                    axis.1=c(expression(paste(m[C],"+")),expression(paste(m[C],"-")), expression(paste(m[C],"*"))),
                    axis.2=c(expression(paste(m[Rx],"+")),expression(paste(m[Rx],"-")), expression(paste(m[Rx],"*")))# labels of the two axes
){
  
  # calculate the median survival ratios for the (sub)groups  			
  ratio = med.surv.Rx/med.surv.C
  
  par(mar=c(5, 5, 2, 2), cex.lab=1.2, cex.axis=1.2)
  # generate a blank plot with axes labels
  plot(xlim,ylim,type="n",xaxt='n',yaxt='n',xaxs="i",yaxs="i",
       ylab=ylab,
       xlab=xlab,asp=1)
  
  # add the 45 degree diagonal line
  abline(a=0,b=1,lwd=1,lty=2,col="grey") 
  # dots for the observed median survival
  lines(med.surv.C,med.surv.Rx,type="p",lwd=1.5,pch=pch,col="black",bg=color)
  for(i in 1:length(ratio)){
    # add lines and arcs
    abline(a=0,b=ratio[i],lwd=1.5,lty=1,col=color[i])
    draw.arc(0,0,radius=sqrt(med.surv.C[i]^2+med.surv.Rx[i]^2),
             angle1=atan(angle.1[i]),angle2=atan(angle.2[i]),n=0.05,col=color[i],
             lwd=1.5,xaxs="i",yaxs="i",lend=1)
    
    # guidelines (vertical/horizontal) for the observed median survival
    lines(c(med.surv.C[i],med.surv.C[i]),c(0,med.surv.Rx[i]),type="l",lwd=1,lty=3,col=color[i])
    lines(c(0,med.surv.C[i]),c(med.surv.Rx[i],med.surv.Rx[i]),type="l",lwd=1,lty=3,col=color[i])
  }
  
  #axis labels
  axis(1, at=med.surv.C, lab=axis.1)
  axis(2, at=med.surv.Rx, lab=axis.2)
  
  #legend
  legend("topright", legend, cex=1.2,col="black",pt.bg=color, pch=pch)
  
}

lineP <- function(rr=log.rr, s, ylab=meth){ #fit and sim result from logistic or loglinear for RR
    #setup 
    leg <- c(paste(":       ", "g-"),  
             paste(":       ", "g+"), paste(": {", "g-", "," , "g+", "}"))
    rr.x <- 1:length(rr)
    rr.lo<- s$RR.CI.lbd
    rr.hi<- s$RR.CI.ubd
    ylim = range(c(rr.lo, rr.hi), rm.na=T) + c(-0.5, 0.5)
    xlim = c(0,5)
    xlab = ''
    color=c(2,3,4)
    pch=c(21,22,23)
  
    par(mar=c(5, 5, 2, 2), cex.lab=1.2, cex.axis=1.2)
    plot(rr~rr.x, xlim=xlim, ylim=ylim, axes=F, ylab=ylab, xlab=xlab, 
         col='black', bg=color, pch=pch, cex=3)
    arrows(rr.x, rr.lo, rr.x, rr.hi, code=3, angle=90, col=color, lwd=4)
      
    #legend
    legend("topright", leg, cex=1.2, pch=pch, col="black", pt.bg=color)
    box()
    axis(2)
}


DifPlot <- function(xlim=c(0,20),ylim=c(0,20), # range of the data
                    xlab=expression(paste(m[C]," = median OS for C")),
                    ylab=expression(paste(m[Rx]," = median OS for Rx")), # label of two axes
                    med.surv.Rx=c(10,18,14), # median survival time for the Rx (sub)groups
                    med.surv.C=c(8,10,9), # median survival time for the C (sub)groups
                    # radius=c(sqrt(20),sqrt(25),sqrt(30)), # the length of the arcs
                    UCI=c(3,10, 7), # UCI (a vector) = the upper bounds of simultaneous CIs for the differences
                    LCI=c(1, 6, 3), # LCI (a vector) = the lower bounds of simultaneous CIs for the differences
                    color=c(2,3,4), # the color of the lines/CI
                    pch=c(21,22,23), # the shape of points (to represent the median survival times)
                    legend=c(": g+ group",": g- group", ": {g+,g-} combined group"), # the legend of the plot
                    axis.1=c(expression(paste(m[C],"+")),expression(paste(m[C],"-")), expression(paste(m[C],"*"))),
                    axis.2=c(expression(paste(m[Rx],"+")),expression(paste(m[Rx],"-")), expression(paste(m[Rx],"*"))) # labels of the two axes
){
  # calculate the differences of median survival for the (sub)groups				
  dif  = med.surv.Rx-med.surv.C
  
  par(mar=c(5, 5, 2, 1), cex.lab=1.2, cex.axis=1.2)
  # generate a blank plot with axes labels
  plot(xlim,ylim,type="n",xaxt='n',yaxt='n',xaxs="i",yaxs="i",
       ylab=ylab,
       xlab=xlab,asp=1)
  
  # add the 45 degree diagonal line
  abline(a=0,b=1,lwd=1,lty=2,col="grey") 
  # dots for the observed median survival
  lines(med.surv.C, med.surv.Rx,type="p",lwd=1.5,pch=pch,col="black",bg=color)
  
  for(i in 1:length(dif)){
    # add lines for prognostic and predictive
    abline(a=dif[i],b=1,lwd=1.5,lty=1,col=color[i])
    
    # CI for the difference
    lines(c((med.surv.C[i]-(UCI[i]-dif[i])/2), (med.surv.C[i]+(dif[i]-LCI[i])/2)),
          c((med.surv.Rx[i]+(UCI[i]-dif[i])/2), (med.surv.Rx[i]-(dif[i]-LCI[i])/2)), type='l', lwd=1.5, col=color[i], lend=1)
    
    # guidelines for the observed median survival
    lines(c(med.surv.C[i],med.surv.C[i]),c(0,med.surv.Rx[i]),type="l",lwd=1,lty=3,col=color[i])
    lines(c(0,med.surv.C[i]),c(med.surv.Rx[i],med.surv.Rx[i]),type="l",lwd=1,lty=3,col=color[i])
  }
  
  #axis labels
  axis(1, at=med.surv.C, lab=axis.1)
  axis(2, at=med.surv.Rx, lab=axis.2)
    
  #legend
  legend("topright", legend, cex=1.2,col="black",pt.bg=color, pch=pch)
  
}


#-----------------------------------------#
# Binary outcome_logRR.R includes 5 functions: 
#	1. logistic: run logistic model
#     2. logistic.log.RR.dt.dim3: delta method for log RR (logistic model)
#     3. loglinear: run loglinear model
#	4. loglinear.log.RR.dt.dim3:: delta method for log RR (loglinear model)
#	5. log.RR.simu.CI: CI computation
#
# jch 01/01/2018
#-----------------------------------------#

#install required libraries
if(TRUE){
  library(msm) # for deltamethod

  list.of.packages <- c("eha", "survival", "rootSolve", "mvtnorm", "plotrix")
  new.packages <- list.of.packages[!(list.of.packages %in% installed.packages()[,"Package"])]
  if(length(new.packages)) install.packages(new.packages)

  library(eha)
  library(survival)
  library(rootSolve)
  library(mvtnorm)
  library(plotrix)
}


logistic <- function(data, m){
  # m: the total number of marker groups
  # data are generated from "dataLogistic" function
  
  fit.logit <- glm(Y ~ Trt+as.factor(M)+Trt*as.factor(M), family=binomial(logit), data=data)
  beta <- fit.logit$coef	# beta1, ... , beta4
  theta <- exp(beta)	# theta1, ... ,theta4
  
  fit.beta.Var <- vcov(fit.logit)
  #fit.theta.Var <- diag(theta) %*% fit.beta.Var %*% diag(theta) 
  
  #-- applying delta method : using the function "deltamethod" 
  fit.theta.Var <- deltamethod ( list( ~exp(x1), ~exp(x2), ~exp(x3),~exp(x4)), beta, fit.beta.Var, ses=FALSE)		  
  
  return(list(beta=beta, fit.beta.Var=fit.beta.Var, theta=theta, fit.theta.Var=fit.theta.Var))
}

# Use log(response.Rx.neg/response.C.neg, response.Rx.pos/response.C.pos, response.Rx/response.C) as the efficacy measure

logistic.log.RR.dt.dim3 <- function(theta, p.neg, param.var){
	
	# response rate 
	response.C.neg = theta[1] / (1 + theta[1])
	response.C.pos = theta[1] * theta[3] / (1 + theta[1] * theta[3])
	response.Rx.neg = theta[1] * theta[2] / (1 + theta[1] * theta[2])
	response.Rx.pos = theta[1] * theta[2] * theta[3] * theta[4] / (1 + theta[1] * theta[2] * theta[3] * theta[4])
	
	response.C = p.neg * (theta[1] / (1 + theta[1])) + (1-p.neg) * (theta[1] * theta[3] / (1 + theta[1] * theta[3]))
	response.Rx = p.neg * (theta[1] * theta[2] / (1 + theta[1] * theta[2])) + (1-p.neg) * (theta[1] * theta[2] * theta[3] * theta[4] / (1 + theta[1] * theta[2] * theta[3] * theta[4]))
	
	RR.neg <- response.Rx.neg/response.C.neg
	RR.pos <- response.Rx.pos/response.C.pos
	RR.mix <- response.Rx/response.C
	
	# log relative response
	log.RR.neg <- log(response.Rx.neg/response.C.neg)
	log.RR.pos <- log(response.Rx.pos/response.C.pos)
	log.RR.mix <- log(response.Rx/response.C)
	
	# compute the variance estimates for the relative response
	
	#D.RR <- matrix(c(0,	1/theta[2],	0,	0,
	#					0,	1/theta[2],	0,	1/theta[4], 
	#					0,	1/theta[2],	(p.neg*(1-p.neg)*(theta[4]-1))/((p.neg+(1-p.neg)*theta[3])*(p.neg+((1-p.neg)*theta[3]*theta[4]))),	
	#					((1-p.neg)*theta[3])/(p.neg+(1-p.neg)*theta[3]*theta[4])),3, 4, byrow =TRUE)
	#var.log.RR <- D.RR %*% param.var %*% t(D.RR)  	
	
	## extra variable p.neg build up the formula as a string, and convert to a formula.
	form <- sprintf("~ log( ( %f*x2 / (1+x1*x2) + (1- %f)*x2*x3*x4 / (1+x1*x2*x3*x4) ) / ( %f / (1+x1) + (1- %f)*x3/ (1+x1*x3) ) )", p.neg, p.neg, p.neg, p.neg)
	var.log.RR <- deltamethod ( list( ~log( (x2*(1+x1)) / (1+x1*x2) ), ~log((x2*x4*(1+x1*x3)) / (1+x1*x2*x3*x4)), as.formula(form)), theta, param.var, ses=FALSE)
	
	return(list(response.C.neg=response.C.neg, 		response.C.pos=response.C.pos,
					response.Rx.neg=response.Rx.neg,	response.Rx.pos=response.Rx.pos,
					response.C=response.C, response.Rx=response.Rx,
					RR.neg=RR.neg, RR.pos=RR.pos, RR.mix=RR.mix,
					log.RR.neg=log.RR.neg, log.RR.pos=log.RR.pos, log.RR.mix=log.RR.mix, var.log.RR=var.log.RR))
}



loglinear <- function(data, m){
  # m: the total number of marker groups
  # data are generated from "dataLoglinear" function
  
  fit.loglinear <- glm(Y ~ Trt+as.factor(M)+Trt*as.factor(M), family=poisson, data=data)
  beta <- fit.loglinear$coef	# beta1, ... , beta4
  theta <- exp(beta)	# theta1, ... ,theta4
  
  fit.beta.Var <- vcov(fit.loglinear)
  #fit.theta.Var <- diag(theta) %*% fit.beta.Var %*% diag(theta) 
  
  #-- applying delta method : using the function "deltamethod" 
  fit.theta.Var <- deltamethod ( list( ~exp(x1), ~exp(x2), ~exp(x3),~exp(x4)), beta, fit.beta.Var, ses=FALSE)
  
  return(list(beta=beta, fit.beta.Var=fit.beta.Var, theta=theta, fit.theta.Var=fit.theta.Var))
}

# Use log(response.Rx.neg/response.C.neg, response.Rx.pos/response.C.pos, response.Rx/response.C) as the efficacy measure

loglinear.log.RR.dt.dim3 <- function(theta, p.neg, param.var){
	
	# response rate 
	response.C.neg = theta[1]
	response.C.pos = theta[1]*theta[3]
	response.Rx.neg = theta[1]*theta[2]
	response.Rx.pos = theta[1]*theta[2]*theta[3]*theta[4]
	
	response.C = p.neg*theta[1] + (1-p.neg)*theta[1]*theta[3]
	response.Rx = p.neg*theta[1]*theta[2] + (1-p.neg)*theta[1]*theta[2]*theta[3]*theta[4]
	
	RR.neg <- response.Rx.neg/response.C.neg
	RR.pos <- response.Rx.pos/response.C.pos
	RR.mix <- response.Rx/response.C
	
	# log relative response
	log.RR.neg <- log(response.Rx.neg/response.C.neg)
	log.RR.pos <- log(response.Rx.pos/response.C.pos)
	log.RR.mix <- log(response.Rx/response.C)
	
	# compute the variance estimates for the relative response

	#D.RR <- matrix(c(0,	1/theta[2],	0,	0,
	#					0,	1/theta[2],	0,	1/theta[4], 
	#					0,	1/theta[2],	(p.neg*(1-p.neg)*(theta[4]-1))/((p.neg+(1-p.neg)*theta[3])*(p.neg+((1-p.neg)*theta[3]*theta[4]))),	
	#					((1-p.neg)*theta[3])/(p.neg+(1-p.neg)*theta[3]*theta[4])),3, 4, byrow =TRUE)
	#var.log.RR <- D.RR %*% param.var %*% t(D.RR)  	
	
	## extra variable p.neg build up the formula as a string, and convert to a formula.
	form <- sprintf("~ log(( %f * x2 + (1- %f) * x2 * x3 * x4)/( %f + (1- %f) * x3))", p.neg, p.neg, p.neg, p.neg)
	var.log.RR <- deltamethod ( list( ~log(x2), ~log(x2 * x4), as.formula(form)), theta, param.var, ses=FALSE)
	
	return(list(response.C.neg=response.C.neg, 		response.C.pos=response.C.pos,
				response.Rx.neg=response.Rx.neg,	response.Rx.pos=response.Rx.pos,
				response.C=response.C, response.Rx=response.Rx,
				RR.neg=RR.neg, RR.pos=RR.pos, RR.mix=RR.mix,
				log.RR.neg=log.RR.neg, log.RR.pos=log.RR.pos, log.RR.mix=log.RR.mix, var.log.RR=var.log.RR))
}


# CI computation
log.RR.simu.CI <- function(seed, alpha, log.RR, var.log.RR){
  # qmvnorm is simulation based, provide a seed
  set.seed(seed)
  log.CIs <- qmvnorm(1-alpha, corr=cov2cor(var.log.RR), tail = "both")$quantile*sqrt(diag(var.log.RR))

  RR.CI.lbd <- exp(log.RR - log.CIs)
  RR.CI.ubd <- exp(log.RR + log.CIs)
  
  return(list(RR.CI.lbd=RR.CI.lbd, RR.CI.ubd=RR.CI.ubd))
}


#######try functions##############
if(F){

  #load data
  dd <- indataset[[1]]
  head(dd)

  #run model
  mod1 <- logistic(dd, 1)
  fit1 <- logistic.log.RR.dt.dim3(theta=mod1$theta, p.neg=0.2, param.var=mod1$fit.theta.Var)
  sim1 <- log.RR.simu.CI(seed=123456, alpha=0.05, log.RR=fit1$log.RR.neg, var.log.RR=fit1$var.log.RR)

  mod2 <- loglinear(dd, 1)
  fit2 <- loglinear.log.RR.dt.dim3(theta=mod2$theta, p.neg=0.2, param.var=mod2$fit.theta.Var)
  sim2 <- log.RR.simu.CI(seed=123456, alpha=0.05, log.RR=fit2$log.RR.neg, var.log.RR=fit2$var.log.RR)

  #show result
  mod1
  sim1  
  mod2
  sim2



}

if (TRUE) {    # header
  #/*soh*************************************************************************
  # CODE NAME             : server.r
  # CODE TYPE  						: Program 
  # DATE OF UPDATE:         1-Feb-2019
  # DESCRIPTION           : Server code for BEACH app 
  # SOFTWARE/VERSION#     : R 3.3.0
  # INFRASTRUCTURE        : MS WINDOWS XP
  # LIMITED-USE MODULES   : N/A
  # BROAD-USE MODULES     : N/A
  # INPUT                 : 													
  # OUTPUT                : 
  #   VALIDATION LEVEL      : 
  #   REPLICATION PROGRAM   : N/A
  #   REGULATORY STATUS     : N/A
  #   REQUIREMENTS LOCATION : N/A
  #  -----------------------------------------------------------------------------
  #  Requirements: 
  #  -----------------------------------------------------------------------------
  #  Ver#  Author &                   Program History Description
  #        Peer Reviewer
  #  ----  ---------------            --------------------------------------------
  #  001   Danni Yu                   program (2013-now)
  #  002   Chenchen Yu                program (2013-2014)
  #  -----------------------------------------------------------------------------
}
if(!file.exists(local.path3)){dir.create(local.path3)}
myVersionCtr <<- "BEACH1.3.3" #2019-2-1 #add pump up window for plot

BeachUI <- fluidPage(
  
  #------- CSS code: Formats of radiobutton & checkbox -------#
  headerPanel(windowTitle='BEACH',
              tags$head(
                tags$link(rel = "stylesheet", type = "text/css"), #href = "bootstrap_dy.css"),
                tags$style(type="text/css","label.radio { display: inline-block; }",
                           "input[type=\'file\']{color: transparent;}",
                           ".radio input[type=\"radio\"] { float: none; }",
                           "label.checkbox { display: inline-block; }",
                           ".checkbox input[type=\"checkbox\"] { float: none; }",
                           #".shiny-output-error { visibility: hidden; }", 
                           #suppress red errors in shiny, to enable using visible
                           #".shiny-output-error:before { visibility: hidden; }",
                           "#TFL{max-width:95%; overflow-x:scroll; max-height:800px; overflow-y:scroll;}",
                           "#Input_outExpert{max-width:95%; overflow-x:scroll; max-height:400px; overflow-y:scroll;}",
                           "#widgetSide{max-width:100%; overflow-x:scroll;  max-height:100%; overflow-y:scroll;}",
                           "#add_analysis{height: 36px;}",
                           "#rcode{max-height:1000px; overflow-y:scroll;}",
                           "#scode{max-height:1000px; overflow-y:scroll;}",
                           "#pumpPlotOut{overflow-x:scroll; overflow-y:scroll;}",
                           ".shiny-text-output{max-width:95%; max-height:40%; overflow-y:scroll; }",
                           "th{text-align: center; border: 1px solid black;}",
                           "td{text-align: center; }", 
                           "table{border: 2px solid black;}"
                ))),
  
  #-----Start of Main Panel-----#
  absolutePanel( #for Analysis panel
    style = "background-color: #FFFFFF;",
    id = "controls1", class = "panel panel-default", fixed = FALSE,
    draggable=FALSE, top = "0%", left = "1%", right = "20%", bottom ="auto",
    width = "auto", height = "auto" , 
    uiOutput('tabs'),
    uiOutput('AnalysisTab'),
    uiOutput('SpecialTab') 
  ),
  
  #-----Start of Widget Panel-----#
  absolutePanel( #for widget/parameter panel
    style = "background-color: #F4F4F4;z-index: 200;",
    id = "controls1", class = "panel panel-default", fixed = FALSE,
    draggable = TRUE, top = "0%", left = "auto", right = "0%", bottom ="auto",
    width = "20%", height = "auto" , 
    p(style="color:black;",strong(myVersionCtr)),
    checkboxInput("collSidebar", "Show the sidebar for data input", value=TRUE),
    checkboxInput("useDT", "use renderDataTable", value=TRUE),
    checkboxInput("pumpPlot", "Show plot in a single window", value=FALSE),
    # checkboxInput("rundPAI", "run dPAI", value=FALSE),
    radioButtons("ncol.widg.rd", "number of columns", c(2, 1, 3), inline=TRUE),
    sliderInput('wpW', 'Width of the widget panel', 
                min=20, max=100, value=30, animate=TRUE),
    uiOutput('beachColor')
  ),  
  uiOutput('wp.width'),
  
  #-----Start of Sidebar Panel for LOA input-----#  
  absolutePanel( #for LOA panel
    style = "background-color: #F4F4F4;z-index: 500;",
    id = "controls2", class = "panel panel-default", fixed = FALSE,
    draggable = TRUE, top = "0%", left = "100%", right = "auto", bottom ="auto",
    width = "25%", height = "auto" , 
    
    
    #------LOA------# 
    p(style="color:black;",strong("List of Analysis")),
    fileInput('upfile', label='upload a LOA csv file',
              accept=c('.csv', 'text/csv', 
                       'text/comma-separated-values,text/plain'), multiple=FALSE),
    actionButton("load_analysis","load LOA"),
    downloadButton("save_loa","save LOA"),
    downloadButton("save_loa_cd", "save_CD"),
    checkboxInput('delete_loa', 'Only Selected', value=FALSE),
    wellPanel( uiOutput('LOA'), width="20%" ),
    radioButtons('landscp', 'RTF page layout', 
                 choices=c("Landscape", "Portrait"), selected="Portrait", inline=TRUE),
    radioButtons('onefileRTF', 'RTF output', 
                 choices=c('one file','multiple files'), selected='one file', inline=TRUE),
    downloadButton("save_output","OutputRTF"), #output as a RTF file    
    br(),
    #textInput('hPath', label='HTM file location:', value=htmlPath), 
    #actionButton("outputH", "Overwrite the HTM file"),
    uiOutput('save_outputH'),
    
    checkboxInput('expert', 'expert', value=FALSE),
    uiOutput('userExp'),
    checkboxInput('usage', 'usage', value=FALSE),
    checkboxInput('showAllSource', 'Show all R source code', value=FALSE),
    
    
    #----Data Manipulation, No UI output-----#
    uiOutput("getData"),
    uiOutput("getWidgets"),
    uiOutput("loa"),
    uiOutput('DTsel'),
    uiOutput('getDataSelected'), #defined to data_selected
    uiOutput("getTFL")
  ),    
  
  #-----Start of Sidebar Panel for data input-----#  
  div('data-display-if'="input.collSidebar == true", 
      absolutePanel( #for data input panel
        style = "z-index: 999;",
        id = "controls1", class = "panel panel-default", 
        fixed = FALSE,
        draggable = TRUE, top = "20%", left = "auto", right = "0%", bottom ="auto",
        width = "20%", height = "auto" , 
        
        #------Logo------#
        wellPanel(style = "background-color: #dbdbdb;", #D52B1E Lilly Red 100%
                  uiOutput("setTitle"),
                  #helpText(a('feedback', 
                  #target="_blank",
                  #href="https://gist.github.com/DanniYuGithub/74d2b327dcd63ff8e91633340ff95afa#file-forum-for-beach-users")),
                  #------Upload dataset------#
                  checkboxInput('data_reload', 'Make csv files reloadable with risk of messing up data.'),
                  uiOutput('status'), 
                  selectInput('comm_chr', "Comment Charactor in a CSV file", c("", "#", "*", "!", "~", "%", "^", "&")),
                  uiOutput('file'),
                  uiOutput("setconfig"),
                  selectInput('config.sel', 'Select A CD in the pool', choices=cdpool2),      
                  uiOutput('subsetcode1'), actionButton("submitcode","Submit Code"),
                  div(class='row'),
                  uiOutput('subsetcode2'),
                  actionButton("delete_tmpfile",'Clean trash on server.'), uiOutput('delete')
        ))
  ),
  #-----End of Sidebar Panel-----#
  
  
  #-----Start pumpPlot single Window-----#  
  div('data-display-if'="input.pumpPlot == true", 
      absolutePanel( #for pumping out a single window
        style = "z-index: 999; background-color: #dbdbdb;",
        id = "controls1", class = "panel panel-default",  fixed=FALSE,
        draggable=TRUE, top="1%", left="20%", right="40%", bottom ="auto",
        width = "50%", height = "auto" , 
        plotOutput('pumpPlotOut')
      ))
  #-----End of Sidebar Panel-----#
  
  
  
) #Generate Tabs

shinyUI(BeachUI)

conditionalPanel(
  condition="true",
  div(class='row'),
  div(class='span4', 
    textInput('datPath','Path for read in dataset.', value="")), 
  div(class='span4',
    textInput('outPath','Path for output RTF file.',
	value= tempfile(pattern='shiny',
	  tmpdir="", 
	  fileext='.rtf'))),
  br(),
  div(class='row'),
  div(class='span11',
	tabsetPanel(
	  tabPanel('Run Code', 
	           downloadButton("save_rcode","Save Code"),
	           div(class="alert alert-info", strong("Note: "), r.lib.alert),
	           verbatimTextOutput("rcode")),
    tabPanel('Source Functions', 
             downloadButton("save_scode","Save Source"),
             verbatimTextOutput("scode"))))
)

if (TRUE) {    # header
  #/*soh*************************************************************************
  # Eli Lilly and Company - Global Statistical Sciences
  # CODE NAME             : server.r
  # CODE TYPE							: Program
  # DATE OF UPDATE:         1-Feb-2019
  # DESCRIPTION           : Server code for BEACH app
  # SOFTWARE/VERSION#     : R 3.3.0
  # INFRASTRUCTURE        :
  # LIMITED-USE MODULES   : N/A
  # BROAD-USE MODULES     : N/A
  # INPUT                 :
  # OUTPUT                :
  #   VALIDATION LEVEL      :
  #   REPLICATION PROGRAM   : N/A
  #   REGULATORY STATUS     : N/A
  #   REQUIREMENTS LOCATION : N/A
  #  -----------------------------------------------------------------------------
  #  Requirements:
  #  -----------------------------------------------------------------------------
  #  Ver#  Author &                   Program History Description
  #        Peer Reviewer
  #  ----  ---------------            --------------------------------------------
  #  001      Danni Yu                   Program    (2013-now)
  #  002      Chenchen Yu                Program    (2013 2014)
  #  -----------------------------------------------------------------------------
  # To enable RTF creation run:
  # remotes::install_github("DanniYuGithub/RTF2")
} #Header


rm(list=ls())
#source('global.r')

#install packages
if(TRUE){
  dep.packages <- c("shiny", "DT", "haven", "xtable", "plyr", "sas7bdat",
                    "WriteXLS",  #"rJava", "rtf",
                    "devtools");
  na.packages <- dep.packages[!dep.packages %in% installed.packages()]
  if (length(na.packages)>0) install.packages(na.packages);

  newWay<<-TRUE
  #if(!"sas7bdat.parso" %in% installed.packages())
  #devtools::install_github('BioStatMatt/sas7bdat.parso', force=TRUE)

  dPAI_load <<- 0
  #1 if dPAI is activated at least once.

  userActionLabel <<- 'user click'
  userdo_action <<- function(){return(NULL)}
  #predefined global value for user do action button.

}

#required libraries
if(TRUE){#load relative libraries safety analysis
  library(beanplot)

  library(corrplot)  #create heatmap for correlation matrix#

  library(grid)
  library(gridExtra)

  if(FALSE){
    if (!require("BiocManager", quietly = TRUE))
      install.packages("BiocManager")
    BiocManager::install("Heatplus")
  }
  library(Heatplus)  #creating customized heatmaps with covariate profile#
  library(Hmisc)

  library(lattice)
  library(latticeExtra)
  library(lmtest)

  if(FALSE){
    BiocManager::install("multtest")
  }
  library(multtest)

  library(plotrix)   #use 2D-heatmap#

  library(shiny)
  library(sp)
  library(survival)  #time to event analysis#

  library(vioplot)
}

if(TRUE){
  # devtools::install_version("shiny", version = "1.0.3",
  #   repos = "http://cran.us.r-project.org")

  library(DT)
  library(WriteXLS)
  library(plyr)
  library(xtable)
  library(xtable)
  library(shiny)
  library(animation)


  #load a libray not in cran
  if(T && "sas7bdat.parso" %in% installed.packages() ){
    library(sas7bdat.parso)
  }

  #library(WriteXLS)
  library(readxl)
  #library(SASxport)

  #a pre-defined function object for plotting functions when click a row in DT.
  click2plot.o<<-function(ids){
    x=0; y=0;
    plot(y~x,col='white',axes=F,ylab='', xlab='')
    leg<-paste0('please define a global function\n',
                'click2plot(ids=...)\nis not defined yet')
    legend('topleft', legend=leg, bty='n')
  }
  click2plot<-NULL


} #required libraries

#Key objects and functions
if (TRUE){
  use_haven<<-T
  tmpFig <<-"tmpFig.png"
  showBrush<<-FALSE
  click_data<<- near_points <<- brush_points <<-NULL
  currTabL <<- list()
  input0 <<- list()
  input0.code <<- new.code <<- NULL
  ault <<- '480, 480, NA'
  tfl.h <<- tfl.w <<- tfl.r <<- NA

  #keyword in widges
  wid.keywd<<-c('check','radio','dropdown','slide',
                'date', 'dateR', 'num', 'text', 'textbox')

  infilelab <<- 'Step 1 Upload data (csv, sas7bdat, xlsx, rdata, xpt)'
  infilenm <<- c('.csv', '.sas7bdat', '.xlsx', '.rdata', '.Rdata', '.xpt')

  na_sign <<- c('NA', '', '.', ' ', '-', 'NaN')

  #standard headers
  if(TRUE){
    sop_head<<-paste( paste(readLines("sopHead.txt"), collapse="\n "), "\n ")
  } else {
    data('sopHead')
  }

  if(!exists('muliHead.split')){
    muliHead.split <<- ";"
  }

  #get the current userid for usage track
  uids<<-NULL
  uid1<<-Sys.info()['user']

  #---------source code for shiny functions---------------#
  source(file=file.path(local.path1,'shinyFun.r'))
  source(file=file.path(local.path1,'RTF_functions_DY.r'))



  #function: read sas, csv or excel files.
  BeachRead<<-function(file, header=TRUE, nrow=-1,
                       name=NULL, comment.char="",
                       xlsx1=NULL,
                       na.string=c('NA', '', '.', ' ', '-', 'NaN'),
                       SF=FALSE, use_haven=T, ...){
    # require(haven)
    # require(readxl)
    hhhh<<-name
    ot<-NULL
    if(is.null(name)){name<-file}
    is.sas<-grepl('.sas7bdat', tolower(name), fixed=TRUE)
    is.csv<-grepl('.csv', tolower(name), fixed=TRUE)
    is.xlsx<-grepl('.xls', tolower(name), fixed=TRUE)
    is.rdat<-grepl('.rda', tolower(name), fixed=TRUE)
    is.xpt<-grepl('.xpt', tolower(name), fixed=TRUE)
    if(is.sas){
      ot.t <<- try(ot<-haven::read_sas(file))
      if(class(ot.t)[1]=='try-error' &&
         "sas7bdat.parso" %in% installed.packages() #&&
         # requireNamespace("sas7bdat.parso", quietly = TRUE)
      ) {
        library(sas7bdat.parso)
        print(ot.t)
        ot.kk<<-try(ot<<-sas7bdat.parso::read.sas7bdat.parso(file))
      }
      if(#class(ot.kk)[1]=='try-error' ||
        is.null(ot)){
        if("sas7bdat.parso" %in% installed.packages() ){
          return(paste("Error: fail to import", name))
        }else{
          return(paste("Error: fail to import", name,
                       ". Please import sas7bdat.parso at GitHub."))
        }
      }
      ot <- data.frame(ot)
      for(i in 1:ncol(ot)){
        if(is.factor(ot[,i]))
          ot[,i] <- as.character(ot[,i])
      }
      if(nrow==1)
        ot <- ot[1,]
      if(nrow==1 & !header)
        ot <- data.frame(matrix(colnames(ot), nrow=1))
    }else if (is.csv){
      tm<-try(ot<-read.csv(file=file, h=header, nrow=nrow,
                           na=na.string, stringsAsFactors=SF,
                           fileEncoding="UTF-8",
                           comment.char=comment.char,...))
      if(class(tm)=='try-error')
        tm<-try(ot<-read.csv(file=file, h=header, nrow=nrow,
                             na=na.string, stringsAsFactors=SF,
                             fileEncoding="Latin1",
                             comment.char=comment.char, ...))
      if(class(tm)=='try-error')
        tm<-try(ot<-readLines(con=file))
    }else if (is.xlsx){
      if(is.null(xlsx1))
        xlsx1 <-1
      tm<-try(ot<- readxl::read_excel(path=file, sheet=xlsx1, col_names=header, na=na.string, ...))
      if(class(tm)=='try-error')
        tm<-try(ot<-readLines(con=file))
    }else if (is.rdat){
      load(file, ot<-new.env())
      ot <- as.list(ot)
      names(ot) <- paste0(name, ".", names(ot))
    }else if (is.xpt){
      #ot.t <- try( ot <- SASxport::read.xport(file) )
      ot.t <- try( ot <- haven::read_xpt(file) )
    }else{
      ot<-NA
    }
    return(ot)
  }


  if(!'www'%in%dir(local.path2)) {dir.create(local.path3)}


  options(stringsAsFactors=FALSE, shiny.usecairo=FALSE, shiny.maxRequestSize=1024*1024^2)
  options(warn=0, error = NULL)
}#Key objects and functions


#-----------------------------------#
if(TRUE){#other setup#

  #define the users folder for Analysis Code
  cnt<-0
  user_folder<-c('users/')
  function_r<-dir(local.path1, ".r")
  function_r<-c(function_r, dir(local.path1, ".R"))

  tmConf<<-'configuration_empty_dy1.csv'

  #clean up open device
  if(TRUE){
    na_file<-dir()
    na_file<-na_file[substr(na_file,1,2)=='NA'|na_file=="Rplot.pdf"]
    na_file<-file.path(getwd(),na_file)
    if(length(na_file)>0){do.call(file.remove, as.list(na_file))}
    tm_png<-dir(local.path3)
    tm_png<-tm_png[substr(tm_png,1,3)=='tfl'|substr(tm_png,1,3)=='.nf'|
                     substr(tm_png,nchar(tm_png)-5,nchar(tm_png))=='.rdata']
    loatextf<-dir(local.path2)
    loatextf<-file.path(local.path2, loatextf)
    if(length(tm_png)>5 | length(loatextf)>5){
      if(length(loatextf)>0)
        try(do.call(file.remove, as.list(loatextf)))
      tm_png<-file.path(local.path3, tm_png)
      if(length(tm_png)>0)
        try(do.call(file.remove, as.list(tm_png)))
    }
  }


  #set up temporary tflfile names
  if(TRUE){
    randseed<-round(runif(1,1,10^7))
    loatext<<-tempfile(pattern=paste0("loa",randseed),
                       tmpdir=local.path2, fileext=".txt")
    tflfile<<-tempfile(pattern=paste0("tfl",randseed),
                       tmpdir=local.path2, fileext="_")
  }else{tflfile<-NULL}

  #save history of Rscript in expert
  text1<-'#For text output'
  text2<-'#For figure output'

}#other setup#

#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@#
BeachServer <- function(input,output, session){

  #close your app when the browser is closed
  session$onSessionEnded(function() {
    stopApp(NULL)
  })

  rawrow1<<-list() #for changing colnames with row 1 in a table data.
  indataset<<-list()
  indataR  <<-list()


  #------change the width of widget panel and the color------#
  output$beachColor <- renderUI({
    code0 <- selectInput_color(id='wpColor',
                               label='Background color',
                               choices=colors(),
                               selected='azure3'
    )
    return(shiny::HTML(code0))
  })

  output$wp.width <- renderUI({
    #width of the widgets panel
    widget.panel.width<-paste0(input$wpW, "%")

    wp.out <- paste0("<div class=\"panel panel-default draggable\" ",
                     "id=\"controls1\" ",
                     "style=\"top:50%;left:auto;right:0%;bottom:auto;width:",
                     widget.panel.width,
                     ";height:auto", #widget.panel.height,
                     ";position:absolute;cursor:move; ",
                     "background-color: ", HEXColors[input$wpColor],
                     ";z-index: 199;\">",
                     # "<div id=\"set.ncol.widg\" class=\"shiny-html-output\"></div>",
                     "<div id=\"widgetSide\" class=\"shiny-html-output\"></div>",
                     "</div> <script>$(\".draggable\").draggable();</script> ")
    return(shiny::HTML(wp.out))
  })


  #-------Webpage Title in the data input panel---------#
  output$setTitle<-renderUI( try( {
    VdicTitle<<-reactive({ #note: only one or two rows should be defined.
      if (is.null(input$config) & input$config.sel==" "){
        Vdic0<<-read.csv(file.path(tmConf),header=TRUE,check.names=FALSE, encoding='UTF-8')
      }else{
        if(!is.null(input$config)){
          isolate({Vdic0<<-read.csv((input$config)$datapath,
                                    header=TRUE,check.names=FALSE, encoding='UTF-8') })
        }
        if(input$config.sel!=" "){
          isolate({ Vdic0<<-read.csv(file.path(local.path1,
                                               cdpool[cdpool2==input$config.sel]),
                                     header=TRUE,check.names=FALSE, encoding='UTF-8') })
        }
      }
      ret<-Vdic0
      nCol<-ncol(ret)
      titleValue<-c("title_image","title_text")
      titleRowsID<-which((!is.na(ret$Type) & ret$Type%in%titleValue) | ret$Num==1)
      titleRows<-ret[titleRowsID,]
      return(titleRows)
    })

    if(nrow(r123<-VdicTitle())>0){
      r1<-r123[r123$Type=='title_image',]
      r2<-r123[r123$Type=='title_text',]
      r1c<-r2c<-''
      if(nrow(r1)>0&&grepl(".png", r1$Title, fixed=TRUE)){
        r1c<-as.character(img(src=r1$Title[1], height="10%",width="100%"))
      }
      if(nrow(r2)>0){
        r2c<-paste0('<h4 style="color:black; background-color:white; width:100%; height:10%;"> ',
                    #r2$Title[1], Sys.getlocale(), "</h4>")
                    r2$Title[1], "</h4>")
      }
      retTitle<-shiny::HTML(paste0(r1c,r2c))
      #run the getData source code
      s1s<-r123[ as.numeric(r123$Num)%in%c(0,1),'Source']
      for(s1 in s1s){
        if(length(s1)>0&&grepl('.r', tolower(s1), fixed=TRUE)){
          if(!grepl('users/', s1, fixed=TRUE)) s1<-file.path('users', s1)
          s1<-file.path(local.path0, s1)
          if(file.exists(s1)){
            source(s1)
          }
        }}
      s1<-r123[ as.numeric(r123$Num)==1,'Source']
      if(length(s1)>0&&grepl('.r', tolower(s1), fixed=TRUE)){
        if(!grepl('users/', s1, fixed=TRUE)) s1<-file.path('users', s1)
        s1<-file.path(local.path0, s1)
        if(file.exists(s1)){
          source(s1)
        }
      }
      #run the uesr-free functions
      eval(parse(text=r123[ as.numeric(r123$Num)==1,"PlotCode"]))

    }else{
      retTitle<-shiny::HTML('<h4 style="color:black;">  BEACH-PARTY </h4>')
    }

    return(retTitle)

  }) )

  #-------Update webpage accroding to user-defined CD---------#
  output$setconfig<-renderUI({
    Vdic<<-reactive({
      if (is.null(input$config) & input$config.sel==" "){
        Vdic0<<-read.csv(file.path(tmConf),header=TRUE,check.names=FALSE, encoding='UTF-8')
      }else{
        if(!is.null(input$config)){
          isolate({Vdic0<<-read.csv((input$config)$datapath,
                                    header=TRUE,check.names=FALSE, encoding='UTF-8') })
        }
        if(input$config.sel!=" "){
          isolate({ Vdic0<<-read.csv(file.path(local.path1,
                                               cdpool[cdpool2==input$config.sel]),
                                     header=TRUE,check.names=FALSE, encoding='UTF-8') })
        }
      }

      #Vdic0$Add<-unlist(lapply(Vdic0$Add,function(x){eval(parse(text=x))}))
      ret<-Vdic0[ as.numeric(Vdic0$Num)>0,]
      if(!'res'%in%colnames(ret)){
        ret$res <- NA
      }
      if(!'width'%in%colnames(ret)){
        ret$width <- NA
      }
      if(!'height'%in%colnames(ret)){
        ret$height <- NA
      }

      #insert user folders if it is not exist in the source function list
      for(i in 1:nrow(ret)){
        if(!is.na(ret$Source[i])&ret$Source[i]!=''&!ret$Source[i]%in%function_r){
          xSel<-sapply(user_folder, function(x){
            substr(ret$Source[i], 1, nchar(x))==x
          })
          if(sum(xSel)==0){
            ret$Source[i]<-paste0(user_folder[1],ret$Source[i])
          }
        }
      }
      runSource<-unique(ret$Source[!is.na(ret$select.label)&!is.na(ret$Source)])
      sapply(runSource,function(x){
        source(file=file.path(local.path0,x))})
      ret$Add<-unlist(lapply(ret$Add,function(x){eval(parse(text=x))}))
      ret<-ret[ret$Add,]
      return(ret)
    })#end Vdic
    UIdic<<-reactive( Vdic()[Vdic()$Add & !is.na(Vdic()$Request.Name),] )

    UInames<-names(UIdic())[grepl('uiInput',names(UIdic()))]
    UInames<<-UInames[!sapply(UInames,function(x){all(is.na(UIdic()[,x]))})]

    temp<-strsplit(names(UIdic())[grepl('.label',names(UIdic()))],'.label',fixed=TRUE)
    temp1<-sapply(temp,function(x){
      if(x[1] %in% wid.keywd){
        return(paste0(x,collapse=''))
      }else{
        return(NULL)
      }
    })

    #----params includes all the relative widgets----#
    params<<-sort(unlist(temp1))
    max.n<<-c(check=length(grep('check',params)),radio=length(grep('radio',params)),
              dropdown=length(grep('dropdown',params)),slide=length(grep('slide',params)),
              date=length(grep('date',params)),dateR=length(grep('dateR',params)),
              num=length(grep('num',params)),text=length(grep('text',params)),
              textbox=length(grep('textbox',params)) )

    max.n2<<-max.n#[max.n!=0]
    params.lab<<-paste0(params, '.lab')

    #--order params by its indes--#
    strsplit1 <- function(x, split){
      out1 <- NULL
      for(i in 1:length(x)){
        for(j in 1:length(split)){
          if(grepl(split[j], x[i], fixed=T)){
            t1 <- strsplit(x[i], split=split[j], fixed=TRUE)[[1]]
            if(length(t1)==1){
              out1 <- rbind(out1, data.frame(m1=split[j], m2=0))
              break
            }else{
              if(!is.na(as.numeric(t1[2]))){
                out1 <- rbind(out1, data.frame(m1=split[j], m2=as.numeric(t1[2])))
                break
              }
            }
          }
        }
      }
      return(out1)
    }
    params.id <<- strsplit1(params, names(max.n))
    params.ord <<- order(params.id$m1, params.id$m2)
    #params.ord <- order(params)
    #get a map between LOA and CD for widgets
    #slide.value  radio.choice  check.choice dropdown.choice
    #date.value   dateR.value    text.value
    m1<-params.id$m1; m2<-params.id$m2; m2[m2==0]<-'';
    m3<-rep('value', length(m1))
    m3[m1%in%c('check', 'radio', 'dropdown')]<-'choice'
    params.map<<-data.frame(loa_lab=params.lab,
                            cd_lab=paste0(m1,'.label', m2),
                            loa=paste0(m1,m2),
                            cd=paste0(m1,'.',m3,m2))

    #re-set the other tabs

    tmp<-readLines(file.path(local.path0,Vdic()$Source[1]))
    r.lib<-tmp[grepl('library(',tmp,fixed=TRUE)|grepl('require(',tmp,fixed=TRUE)]
    r.lib.temp<-gsub(' ', '', r.lib, fixed=TRUE)
    r.lib<-r.lib[!grepl('#library', r.lib.temp, fixed=TRUE)&!grepl('#require',r.lib.temp, fixed=TRUE)]
    r.lib<-sort(unique(r.lib))
    r.lib.alert<<-paste0( #'  #required packages: \n',
      paste0(r.lib, collapse='\n') )
    #Get the libraries needed for running the analysis

    if(!is.null(tflfile)){
      randseed<-round(runif(1,1,10^7))
      loatext<<-tempfile(pattern=paste0("loa",randseed),
                         tmpdir=local.path2, fileext=".txt")
      tflfile<<-tempfile(pattern=paste0("tfl",randseed),
                         tmpdir='', fileext="_")
    }

    write.table(t(c("Request.Name","Type","Titles", "height", "width", "res",
                    "Footnote", "Abbreviations.Footnote","Statistical.Analysis",
                    "Test.Statistic.Footnote", as.vector(rbind(params.lab, params)))),
                file=loatext,append=FALSE,col.names=FALSE,row.names=FALSE)

    fileInput(inputId='config', label='Step 2 Input configuration file',
              accept=c('.csv', 'text/csv', 'text/comma-separated-values,text/plain'),
              multiple=FALSE)
  })

  #----------Obtain number of analysis request for TFL------------#
  loaTF<<-reactive(eval(parse(
    text=paste0("c(",paste0("input$result_",1:400,collapse=','),")"))))
  AnalyN<<-reactive({
    if(is.null(input$analysis)){
      return(1)
    }else{
      return(which(Vdic()$Request.Name==input$analysis))
    }
  }) # Capture the corresponding configuration for the selected analysis
  AnalyC<<-reactive(which(Vdic()$Request.Name==input$analysis)[1])

  #----------Generate Tabs------------#
  output$tabs<-renderUI({
    tabset<-Vdic()[!is.na(Vdic()$Tab.label),c('Tab.value','Tab.label')]
    tabcode<-tabs(tab.id='Tabs',tab.label=tabset[,1],tab.value=tabset[,2])
    return(shiny::HTML(tabcode))
  })  # Generate the Tabs

  #----------Update webpage according to user-defined mock data------------#
  #indataset is a list object including all the uploaded dataset
  #indataset.i is a data.frame object, the 1st dataset in indataset.
  #indataR is a list obeject including all the elements in the uploaded R files
  output$file<-renderUI({
    if(is.null(input$infile)){
      return(conditionalPanel('true',
                              radioButtons('csv_enc', 'Encoding format for CSV file',
                                           choices=c('UTF-8', 'unkown'), inline=TRUE),
                              radioButtons('checknames',
                                           'Change " " or "-" in column names into "."',
                                           choices=c(FALSE, TRUE), inline=TRUE),
                              fileInput('infile', label=infilelab,
                                        accept=infilenm,
                                        multiple=TRUE)))
    }else{
      isolate({
        input_infile <<- input$infile

        ###import the files under a pre-specified location
        if(nrow(input_infile)==1 #& grepl('.csv', input_infile) &
           #grepl('File_Names', input_infile)
           ){

          input_infile_1 <- BeachRead(file=input_infile[1, 'datapath'],
                                      name=input_infile[1, 'name'])
          #check file name
          if(any(!colnames(input_infile_1)%in%c('datapath', 'name'))){
            print(paste0("Files in 'File_Names...csv' are not loaded.\n",
                  "The colum names must be 'datapath' and 'name'."))
          } else {
            input_infile_1$datapath <- file.path(input_infile_1$datapath,
                                                 input_infile_1$name)
            input_infile <<- input_infile_1[,c('name', 'datapath')]
          }

        }

        if(nrow(input_infile)>1 | length(indataset)>0){
          indataset0<-list()

          indataset0.wh <- NULL
          for(i in 1:nrow(input_infile)){
            tmpload <- BeachRead((input_infile[i, 'datapath']),
                                 header=TRUE, name=input_infile[i,'name'],
                                 encoding=isolate(input$csv_enc),
                                 comment.char=isolate(input$comm_chr),
                                 check.names=as.logical(input$checknames))
            if(is.list(tmpload) & grepl('.rda', tolower(input_infile[i,'name']))){
              indataR <<- c(indataR, tmpload)
            }else{
              indataset0.wh <- c(indataset0.wh, i)
              indataset0[[i]]<- tmpload
            }
          }
          indataset0 <- indataset0[!sapply(indataset0, is.null)]
          names(indataset0)<-input_infile[indataset0.wh, 'name']
          indataset0<<-indataset0
          wh1<<-names(indataset)[names(indataset)%in%names(indataset0)]
          if(length(wh1)>0){
            indataset[wh1]<<-indataset0[wh1]
            indataset0<-indataset0[!names(indataset0)%in%wh1]
          }
          if(length(indataset0)>0){
            indataset<<-c(indataset, indataset0)
          }
        }else{
          indataset0<-list()
          tmpload <- BeachRead((input_infile)$datapath, header=TRUE, name=input_infile[1,'name'],
                               encoding=isolate(input$csv_enc),
                               comment.char=isolate(input$comm_chr),
                               check.names=as.logical(input$checknames))
          if( is.list(tmpload) & grepl('.rda', tolower(input_infile[1,'name'])) ){
            indataR <<- c(indataR, tmpload)
            indataset.i <<- indataR[[1]]
          } else {
            indataset.i <<- tmpload
            indataset0[[1]]<-indataset.i
            names(indataset0)<-input_infile[,'name']
            indataset<<-indataset0
          }

        }
      }) # End of isolate

      if(length(indataR)>0){
        indataR <<- indataR[unique(names(indataR))]
        indataset <<- c(indataset, indataR)
        indataset <<- indataset[unique(names(indataset))]
      }
      rawrow1 <<- lapply(indataset, function(x){x[1,]})

      studyname1 <-na.omit(unique(unlist(lapply(indataset,function(x){
        unique(x$STUDYID) }))))
      if(!is.null(studyname1)) studyname1 <-paste(unique(studyname1), collapse=", ")
      tumortype1 <-unlist(lapply(indataset,function(x){
        unique(x$TUMOR_TYPE) }))
      if(is.null(studyname1)) studyname1 <- ""
      if(is.null(tumortype1)) tumortype1 <- ""
      if(!is.null(input$study)) studyname1 <- input$study
      if(!is.null(input$tumor)) tumortype1 <- input$tumor


      if(length(indataset)<2){
        stnm<-inlinetext(text.id='study',text.label='Study Name ',
                         text.value=studyname1)
        datanote<-paste0(input$infile$name,' has ', nrow(indataset.i),
                         ' rows, ',ncol(indataset.i),' columns.')
        tmtp<-inlinetext(text.id='tumor',text.label='Tumor Type ',
                         text.value=tumortype1)
        studyname <<- input$study
        tumortype <<- input$tumor
        datanote<-paste0('<h6>', datanote, ' </h6>')
        if(input$data_reload | (is.null(input$config) & input$config.sel==" ")){
          return(
            conditionalPanel(
              condition='true',
              fileInput('infile', label=infilelab,
                        accept=infilenm, multiple=TRUE),
              shiny::HTML(c(stnm, "<br>",
                            tmtp, datanote)) ) )
        }else{
          return(conditionalPanel(condition='true',
                                  shiny::HTML(c(stnm, "<br>", tmtp, datanote)) ) )
        }
      }else{
        if(!is.null(tumortype1)) tumortype1<-paste(tumortype1, collapse=", ")
        stnm<-inlinetext(text.id='study',text.label='Study Name ',
                         text.value=studyname1)
        datanote<-paste0(names(indataset),' has ',
                         sapply(indataset, nrow), ' rows, ',
                         sapply(indataset, ncol),' columns.')
        tmtp<-inlinetext(text.id='tumor',text.label='Tumor Type ',
                         text.value=tumortype1)
        studyname <<- input$study
        tumortype <<- input$tumor
        datanote<-paste0('<h6>', datanote, ' </h6>')
        if(input$data_reload | (is.null(input$config) & input$config.sel==" ")){
          return(
            conditionalPanel('true',
                             radioButtons('csv_enc', 'Encoding format for CSV file', choices=c('UTF-8', 'unkown'), inline=TRUE),
                             radioButtons('checknames', 'Change "_" in column names into "."', choices=c(FALSE, TRUE), inline=TRUE),
                             fileInput('infile', label=infilelab,
                                       accept=infilenm,
                                       multiple=TRUE),
                             shiny::HTML(c(stnm, "<br>", tmtp, datanote)) ))
        }else{
          return(conditionalPanel(condition='true',
                                  shiny::HTML(c(stnm, "<br>",
                                                tmtp, datanote)) ) )
        }
      }

    }
  })  # Widget to upload dataset

  #----------Get data.frame objects (subset of CD) only for widgets----------#
  output$getWidgets<-renderUI({
    #a row is a Request.name
    check.param<<-reactive({widgets.param(uidic=UIdic(),wid='check',max.n=max.n2)})
    radio.param<<-reactive({widgets.param(uidic=UIdic(),wid='radio',max.n=max.n2)})
    dropdown.param<<-reactive({widgets.param(uidic=UIdic(),wid='dropdown',max.n=max.n2)})
    slide.param<<-reactive({widgets.param(uidic=UIdic(),wid='slide',max.n=max.n2)})
    date.param<<-reactive({widgets.param(uidic=UIdic(),wid='date',max.n=max.n2)})
    dateR.param<<-reactive({widgets.param(uidic=UIdic(),wid='dateR',max.n=max.n2)})
    num.param<<-reactive({widgets.param(uidic=UIdic(), wid='num', max.n=max.n2)})
    text.param<<-reactive({widgets.param(uidic=UIdic(),wid='text',max.n=max.n2)})
    textbox.param<<-reactive({widgets.param(uidic=UIdic(),wid='textbox',max.n=max.n2)})
    return(NULL)
  })

  widgetOrd<<-reactive({
    widgets.order(analysis=input$analysis, UIdic1=UIdic(), UInames=UInames,
                  ncol.widg=as.numeric(input$ncol.widg.rd))
  })

  output$widgets<-renderUI({
    #HTML code of all the widgets
    eval(parse(text=unique(widgetOrd()$code)))
  })

  output$getData<-renderUI({#Declare global variables#
    #    if(!is.null(input$infile)|!is.null(input$infileR)){
    tm.Vdic<-Vdic()
    if(!is.na(tm.Vdic$select.label[1])) #load source code in 1st available row
      source(file.path(local.path0, tm.Vdic$Source[1]))
    #    }
    return(NULL)
  }) # Data manipulation for the uploaded dataset

  output$getTFL<-renderUI({
    #only table data is output to local.path3 (a temporary folder)
    if(F){
      tflname<-sapply(AnalyN(),function(x){
        ifelse(all(is.na(widgetOrd()$names)),               #Condition
               paste0(tflfile,Vdic()$Num[x]),    #if TRUE
               paste0(tflfile,Vdic()$Num[x],'x',        #if FALSE
                      paste0(#Paste all UIs together
                        sapply(widgetOrd()$names,function(y){
                          y0<-eval(parse(text=paste0('input$',y)))
                          if(!is.null(y0)){y0[is.na(y0)]<-''}
                          y0<-paste0(y0[length(y0):1],collapse='_')#Paste all Params for each UI
                          substring(y0, max(nchar(y0)-30,1))
                        }),collapse=''))
        )
      })
      tflname<-gsub(" ",'',tflname)
      tab.name<-file.path(local.path3,paste0(input$submitcode,gsub("[[:punct:]]","",tflname),'.rdata'))
    }
    if('Table' %in% Vdic()$Type[(AnalyN())] ){
      AnalyNt<-reactive(AnalyN()[Vdic()$Type[AnalyN()]=='Table'])
      tmp<-eval(parse(text=Vdic()$tmp[AnalyNt()[1]]))
      sapply(AnalyNt(),function(x){
        if (eval(parse(text=Vdic()$Condition[AnalyNt()[1]]))){
          tmptab<-NULL
        }else{
          tmptab<-eval(parse(text=Vdic()$PlotCode[x]))

        }
      })
    }

    return(NULL)
  }) # Generate png files if the output is plot

  output$status<-renderUI({
    if(is.null(input$infile)&is.null(input$infileR)){
      tmpcode<-'<span class=\"label label-important\" style=\"background-color:red; color:black;\">Data not loaded</span>'
    }else{
      tmpcode<-'<span class=\"label label-success\" style=\"color:black;\">Data loaded</span>'
    }
    return(shiny::HTML(tmpcode))
  }) # Status of data manipulation process

  output$select<-renderUI({
    selectN<-which(Vdic()$Tab.value==input$Tabs)
    if (all(is.na(Vdic()$select.label[selectN])))return(NULL)
    label<-unique(Vdic()$select.label[selectN])
    label<-label[!is.na(label)]
    selection<-unique(Vdic()$Request.Name[selectN])
    return(selectInput(inputId="analysis",label=strong(label),choices=selection, width="80%"))
  }) # Generate the downdrop list


  #-----Generate code for output$widgets
  widgetCode<-widgets.code(UInames=UInames,max.n=max.n1)
  eval(parse(text=widgetCode))

  #-------Output results to the current screen------------#

  output$save_data_ext<-renderUI({

    choiceN<-AnalyN()[Vdic()$Type[AnalyN()]=='Table']
    choiceP<-AnalyN()[Vdic()$Type[AnalyN()]=='Figure']
    if(length(choiceN)==0 & length(choiceP)==0)return(NULL)
    if(length(choiceN)==0 & length(choiceP)>0){
      return( conditionalPanel(condition='true',
                               div( downloadButton('getEPS','download EPS plot'),
                                    downloadButton('getPDF','download PDF plot') )
      ))
    }
    if(length(choiceN)>0 & length(choiceP)==0){
      choice<-sapply(choiceN,
                     function(x){
                       ifelse(substr(Vdic()$Title[x],1,5)=='paste',
                              eval(parse(text=Vdic()$Title[x])),
                              Vdic()$Title[x])
                     })
      return( conditionalPanel(condition='true',
                               checkboxGroupInput('multdat',
                                                  'Please Choose a table to save',
                                                  choices=choice,
                                                  selected=NULL, inline =TRUE),
                               radioButtons('multdat_ext',
                                            'Format',
                                            c('csv','rdata','xpt','xls','SAS code'='sas'),
                                            selected = NULL,
                                            inline = TRUE),
                               downloadButton("save_data","Save Data")
      ) )

    }

    if(length(choiceN)>0 & length(choiceP)>0){
      choice<-sapply(choiceN,
                     function(x){
                       ifelse(substr(Vdic()$Title[x],1,5)=='paste',
                              eval(parse(text=Vdic()$Title[x])),
                              Vdic()$Title[x])
                     })
      return( conditionalPanel(condition='true',
                               div( downloadButton('getEPS','download EPS plot'),
                                    downloadButton('getPDF','download PDF plot') ),
                               checkboxGroupInput('multdat',
                                                  'Please Choose a table to save',
                                                  choices=choice,
                                                  selected=NULL, inline =TRUE),
                               radioButtons('multdat_ext',
                                            'Format',
                                            c('csv','rdata','xpt','xls','SAS code'='sas'),
                                            selected = NULL,
                                            inline = TRUE),
                               downloadButton("save_data","Save Data")
      ) )

    }

  })
  output$TFL<-renderUI({
    plotcode <- NULL
    currTabL <<- list()
    currTabL_i <- 1


    #redefine fig size/resolution according to the text bar on top.
    if(is.null(input$hwr))
      hwr.c <- ''
    else
      hwr.c <- as.character(input$hwr)
    tfl.h<<-ifelse(is.na(as.numeric(strsplit(hwr.c,split=';')[[1]])[1]), 480,
                   as.numeric(strsplit(hwr.c, split=';')[[1]])[1])
    tfl.w<<-ifelse(is.na(as.numeric(strsplit(hwr.c,split=';')[[1]])[2]), 480,
                   as.numeric(strsplit(hwr.c, split=';')[[1]])[2])
    tfl.r<<-ifelse(is.na(as.numeric(strsplit(hwr.c,split=';')[[1]])[3]), 72,
                   as.numeric(strsplit(hwr.c, split=';')[[1]])[3])

    if (all(!Vdic()$Type[AnalyN()] %in% c('Figure','Table'))||
        all(eval(parse(text=Vdic()$Condition[AnalyN()])))){
      return(NULL)
    }

    for (i in AnalyN()){
      input0.code <- Vdic()$PlotCode[i]
      pdf.label <<- paste("H1", Vdic()$Tab.label[i],
                          "H2", Vdic()$Request.Name[i])

      myInput <<- Vdic()[i,UInames]
      mylab <<- Vdic()[i,gsub('Input', 'lab', UInames)]
      names(myInput) <<- mylab
      myInput <<- myInput[!is.na(myInput)]

      for(m0 in 1:length(myInput)){
        x <- myInput[m0]
        if(grepl('date', x))
          x <-paste0("paste(",x, ")")
        input0[[m0]] <- eval(parse(text=x))
      }
      if(length(myInput) == length(input0))
        names(input0) <- gsub("input$", "", myInput, fixed=TRUE)
      input0 <<- input0

      #date and dateR widgets have to be a character before running eval.
      for(m1 in 1:length(input0)){
        if(length(input0)>0 && grepl('date', names(input0)[m1], fixed=TRUE)){
          date.value <- paste("c(",
                              paste( paste0("\"", input0[[m1]], "\""), collapse=', '),
                              ")")
          input0.code<- gsub(paste0('input$',names(input0)[m1]),
                             date.value, input0.code, fixed=TRUE)
        }
      }
      new.code <<- input0.code
      input0.code <<- input0.code

      if(!is.na(Vdic()$Title[i])){
        title<-ifelse(substr(Vdic()$Title[i],1,5)=='paste',
                      eval(parse(text=Vdic()$Title[i])),Vdic()$Title[i])
        titlecode<-paste0('<h3><textarea name=\"titlebox\" rows=\"1\" style=\"width:80%\">',
                          title,'</textarea></h3>')
      }else{titlecode<-NULL}


      try( addResourcePath('images',local.path3) )
      if(Vdic()$Type[i]=='Figure'){
        if(length(input0.code)>0 && grepl("dynamicData", input0.code, fixed=TRUE)){
          dynamicCode<<-input0.code
          if(FALSE){
            tmpcode<-paste0("<div class=\"row\">", "\n",
                            "<div class=\"col-sm-12\">", "\n",
                            #"<div id=\"dynamicPlot\" class=\"shiny-plot-output\" style=\"width:",input$figSize*100,"% ; height:",100*input$figSize,"%\" ",
                            "<div id=\"dynamicPlot\" class=\"shiny-plot-output\" style=\"width:100%; height=400px\" ",
                            "data-click-id=\"dynamicPlot_click\" data-click-clip=\"TRUE\" ",
                            "data-brush-id=\"dynamicPlot_brush\" data-brush-fill=\"#9cf\" data-brush-stroke=\"#036\" ",
                            "data-brush-opacity=\"0.25\" data-brush-delay=\"300\" data-brush-delay-type=\"debounce\" ",
                            "data-brush-clip=\"TRUE\" data-brush-direction=\"xy\" data-brush-reset-on-new=\"FALSE\"></div>",
                            "\n", "</div></div>", "\n",
                            "<div class=\"row\">", "\n",

                            "<div class=\"col-sm-12\">", "\n",
                            "<a id=\"click_info_dl\" class=\"btn btn-default shiny-download-link\" href=\"\" target=\"_blank\">",
                            "\n",
                            "<i class=\"fa fa-download\"></i>", "\n",
                            "Save Clicked Data",
                            "</a>",
                            "<h4>Points near click</h4>",
                            "\n",
                            "<pre id=\"click_info_DT\" class=\"shiny-html-output\"></pre>", "\n",
                            "</div>", "\n",

                            "<div class=\"col-sm-12\">", "\n",
                            "<a id=\"brush_info_dl\" class=\"btn btn-default shiny-download-link \" href=\"\" target=\"_blank\">",
                            "\n",
                            "<i class=\"fa fa-download\"></i>",
                            "Save Brushed Data",
                            "</a>",
                            "<h4>Brushed points</h4>",
                            "\n",
                            "<pre id=\"brush_info_DT\" class=\"shiny-html-output\"></pre>", "\n",
                            "</div>", "\n", "</div>", "\n")
          }else{
            tmpcode <- paste0(plotOutput('dynamicPlot', click='dynamicPlot_click',
                                         brush="dynamicPlot_brush"),
                              #click data
                              "<h4>Points near click</h4>", "\n",
                              downloadButton('click_info_dl', 'save clicked data'),
                              uiOutput('click_info_DT'),
                              #brush data
                              "<h4>Brushed points</h4>",  "\n",
                              downloadButton('brush_info_dl', 'save brushed data'),
                              uiOutput('brush_info_DT')
            )
          }
        }else{
          tmpFig1 <- NULL
          for(k in 1:length(i)){
            tmpFig1 <- c(tmpFig1, tempfile(tmpdir=local.path3, fileext='.png'))

            png(tmpFig1[k],
                height=tfl.h,
                width=tfl.w,
                res=tfl.r )

            plottry<-try(eval(parse(text=input0.code[k])))
            if(class(plottry)[1]=='try-error') {
              plot(0,axes=F, col='white',ylab='',xlab='')
              legend('top', 'Plotting\nError', cex=5, bty='n', text.col='red')
            }
            dev.off()
          }
          tmpFig2 <- gsub(local.path3, "", tmpFig1, fixed=TRUE)
          tmpFig2 <- gsub('/', "", tmpFig2, fixed=TRUE)
          tmpcode<-paste0("<img src=\"images/",
                          tmpFig2,
                          "\" alt=\"Calculating...\" style=\"width:",
                          100*input$figSize,
                          "% ; height: ",
                          100*input$figSize,
                          "%\"/> \n")
        }
      }else if(Vdic()$Type[i]=='Table'){


        if(class(try(tmptab<<-eval(parse(text=input0.code))))[1]=='try-error'){
          tmptab<-''
        }
        #save(tmptab, file=tab.name)

        outTable<-tmptab

        #update the current table list in the parent environment
        currTabL[[currTabL_i]] <<- outTable
        currTabL_i <- currTabL_i+1

        if(class(try(tmpcode<-xtable::xtable(outTable)))[1]=='try-error'){
          tmpcode<-outTable
        }
        if(input$useDT){#if TRUE using render table
          tmpcode<-paste0(
            "<div id=\"outTbl_DT\" style=\"width:",input$figSize*100, "%;",
            "height:auto\" class=\"shiny-html-output\"></div>"
          )
        }else{
          tmpcode<-capture.output(print(tmpcode,type="html",
                                        include.rownames=FALSE,include.colnames=TRUE))
          if(is.na(tmpcode[2])){ tmpcode[2]<-''}
          tmpcode <- toMultH(tbc=tmpcode, split1=muliHead.split)
          tmpcode[3]<-paste0("<TABLE style=\'width:",
                             input$figSize*100,
                             "%;\' >")
        }
      }

      plotcode<-c(plotcode,titlecode,tmpcode)
    }

    return(shiny::HTML(plotcode))
  }) # Generate TFL with title

  output$footnote<-renderUI({
    footnote<-Vdic()$FootCode[AnalyC()]
    footnote<-gsub("\\\\n","\n",footnote)
    if(!is.na(footnote)&&gsub("", " ", footnote)!=''&&substr(footnote,1,5)=='paste')
      footnote<-eval(parse(text=footnote))
    #cat(footnote)
    fo1<-paste(footnote, collapse=' ')
    shiny::HTML(
      paste0("<textarea name=\"footnotebox\" rows=\"4\"
             style=\"width:80%\"\">",
             fo1,
             "</textarea>"))
  }) # Generate footnote

  #------Output for user input code------#
  output$userExp<-renderUI({
    isolate(input$expert)
    if(is.null(input$expert)||!(input$expert)){
      return(NULL)
    } else {
      return(
        conditionalPanel(
          condition="true",
          div(shiny::HTML(paste0("<textarea name=\"Rscript\" rows=\"2\"",
                                 "  style=\"width:100%\"",
                                 "  placeholder=\"#For text output \"></textarea>")),
              actionButton('submit','execute')),
          div(shiny::HTML(paste0("<textarea name=\"RscriptF\" rows=\"2\"",
                                 "  style=\"width:100%\"",
                                 "  placeholder=\"#For plot output \"></textarea>")),
              actionButton('submit2','execute')),
          div(downloadButton('save_Rhist', 'save expert code history'))
        ))
    }
  })
  output$Input_outExpert<-renderPrint({
    if(TRUE){
      myInput <<- Vdic()[AnalyN(),UInames]
      mylab <<- Vdic()[AnalyN(),gsub('Input', 'lab', UInames)]
      names(myInput) <<- mylab
      myInput <<- myInput[!is.na(myInput)]
      for(m0 in 1:length(myInput)){
        x <- myInput[m0]
        if(grepl('date', x))
          x <-paste0("paste(",x, ")")
        input0[[m0]] <- eval(parse(text=x))
      }
      names(input0) <- gsub("input$", "", myInput, fixed=TRUE)
      input0 <<- input0
    }
    input0
  })


  output$RoutExpert<-renderPrint({
    if(is.null(input$submit)||input$submit==0){
      return('For text output from Rscript')
    }
    isolate({
      text1<<-c(text1, input$Rscript)
      eval(parse(text=input$Rscript), env=sys.frame())
    })
  })
  output$RoutExpertF<-renderPlot({
    if(is.null(input$submit2)||input$submit2==0){
      return(NULL)
    }
    isolate({
      text2<<-c(text2, input$RscriptF)
      eval(parse(text=input$RscriptF), env=sys.frame())
    })
  })
  output$save_Rhist<-downloadHandler(
    filename=function(){paste0(input$study,"_",input$tumor,"_Rhist.r")},
    content=function(file){
      tmpout<-paste(text1,"\n#~~~~~~~~~~~~~~#\n", text2)
      colnames(tmpout)<-''
      write(tmpout,
            file=file, row.names=FALSE, col.names=FALSE)
    }
  ) # Download Source code

  #-----Text bar for figure size/resolution output -----#
  output$hwrCtrl <- renderUI({
    if(TRUE){
      h1 <- eval(parse(text=Vdic()$height[(AnalyN())]))
      w1 <- eval(parse(text=Vdic()$width[(AnalyN())]))
      r1 <- eval(parse(text=Vdic()$res[(AnalyN())]))
      h2 <- ifelse(is.null(h1), 480, as.numeric(eval(parse(text=h1))))
      w2 <- ifelse(is.null(w1), 480, paste(as.numeric(eval(parse(text=w1))), collapse=', ') )
      r2 <- ifelse(is.null(r1), 72, as.numeric(eval(parse(text=r1))) )
      hwr.default <<- paste(
        ifelse(is.na(h2)||h2==0, 480, h2),
        ifelse(is.na(w2)||w2==0, 480, w2),
        ifelse(is.na(r2)||r2==0, 72,  r2),
        sep='; ')
    }
    textInput('hwr',
              'Height(px for figure; #MaxRows/page for table: 1~35 or 1~50); width(px); resolution(px/inch).',
              value=hwr.default, width="50%" )
  })
  output$AnalysisTab<-renderUI({
    selN<-!is.na(Vdic()$Tab.label) & is.na(Vdic()$Request.Name)
    unAnalyTab<-unique(Vdic()$Tab.value[selN])
    cpCon<-paste0(paste0("input.Tabs!=","\'",unAnalyTab,"\'"), collapse='&&')

    selN.addbar<-!is.na(Vdic()$Tab.label) & grepl("dynamicData", Vdic()$PlotCode, fixed=TRUE)
    cpCon.addbar<-paste0(paste0("input.analysis!=","\'",
                                unique(Vdic()$Request.Name[selN.addbar]),"\'"), collapse='&&')
    print(cpCon.addbar)

    conditionalPanel(condition=cpCon, width='100%',
                     div(class='row'), div(class='span6', uiOutput('select')),
                     div(class='span2', actionButton(inputId="add_analysis",label="Add Analysis")),
                     sliderInput('figSize', label="Relative Size",
                                 min=0.1, max=1, value=0.3, step=0.1, animate=FALSE),
                     uiOutput('hwrCtrl'),
                     div(class='span12',
                         uiOutput("TFL"),
                         uiOutput("footnote"),
                         #actionButton("userdo", userActionLabel),
                         uiOutput('userdo_button'),
                         verbatimTextOutput("userdo_out"),
                         br(),
                         uiOutput("save_data_ext"),
                         conditionalPanel(condition="input.expert==true",
                                          div(verbatimTextOutput("Input_outExpert"), br(),
                                              verbatimTextOutput("RoutExpert"), br(),
                                              plotOutput("RoutExpertF") )),
                         conditionalPanel(condition="input.usage==true",
                                          verbatimTextOutput("counter"))
                     ))
  })
  output$widgetSide<-renderUI({
    selN<-!is.na(Vdic()$Tab.label) & is.na(Vdic()$Request.Name)
    unAnalyTab<-unique(Vdic()$Tab.value[selN])
    cpCon<-paste0(paste0("input.Tabs!=","\'",unAnalyTab,"\'"), collapse='&&')
    conditionalPanel(condition=cpCon, uiOutput("widgets"))
  })

  output$SpecialTab<-renderUI({
    selN<-!is.na(Vdic()$Tab.label) & is.na(Vdic()$Request.Name)
    unAnalyTab<-unique(Vdic()$Tab.value[selN])
    if (!is.null(input$Tabs) && (input$Tabs%in%unAnalyTab)){
      eval(parse(text=readLines(
        file.path(local.path0,Vdic()$Source[which(Vdic()$Tab.value==input$Tabs)])
      )))
    }
  })





  #-------List of Analysis, R code ------------#
  output$loa<-renderUI({


    loaAdd<-reactive({
      t.names <<- c("Request.Name","Type","Titles", "height","width", "res",
                    "Footnote",
                    "Abbreviations.Footnote","Statistical.Analysis",
                    "Test.Statistic.Footnote", as.vector(rbind(params.lab,params)) )

      if (is.null(input$add_analysis) || input$add_analysis==0){
        tmprow <- data.frame(matrix(NA, nrow=0, ncol=length(t.names)))
        colnames(tmprow) <- t.names
        return(tmprow)
      }
      isolate({

        tmp0<-sapply(params[1:length(params)],function(x){
          if (x %in% widgetOrd()$names){
            if(grepl('date', x)){
              tmp<-eval(parse(text=paste0('paste(input$',x, ")")))
            } else {
              tmp<-eval(parse(text=paste0('input$',x)))
            }
            tmp<-ifelse(is.null(tmp),'',tmp)
            tmp<-ifelse(length(eval(parse(text=paste0('input$',x))))>1,
                        paste0(eval(parse(text=paste0('input$',x))),collapse=','), tmp)
          }else{tmp<-NA}

          return(tmp)
        })

        tmp1<-rep(NA,length(params))
        names(tmp1) <- params
        tmp1.lab <- widgetOrd()$labs
        names(tmp1.lab) <- widgetOrd()$names
        tmp1.nm <- params[params %in% names(tmp1.lab)]
        tmp1[tmp1.nm]<-tmp1.lab[tmp1.nm]

        footnote<-input$footnotebox
        if(is.na(footnote)){
          footnote<-''
        }
        footnote<-gsub("\\\\n","\n",footnote)
        if(!is.na(footnote)&&gsub("", " ", footnote)!=''&&substr(footnote,1,5)=='paste'){
          footnote<-eval(parse(text=footnote))
        }
        footnote2<-paste0(substr(footnote,1,10),'...')

        #title<-Vdic()$Title[AnalyC()]
        title<-input$titlebox

        if(!is.na(title) && grepl(title, 'paste', fixed=TRUE)){
          title<-eval(parse(text=title))
        }

        my.hwr <<- strsplit(input$hwr,split=';')[[1]]

        w1<<-eval(parse(text=Vdic()$width[AnalyC()]))
        tmprow<-data.frame(t(c(input$analysis,Vdic()$Type[AnalyC()],title,
                               height=my.hwr[1],
                               width=my.hwr[2],
                               res=my.hwr[3],
                               footnote,
                               footnote2,Vdic()$StatModel[AnalyC()],
                               Vdic()$StatNote[AnalyC()],
                               as.vector(rbind(tmp1,tmp0)) )))
        colnames(tmprow)<-t.names

        return(tmprow)

      })
    }) # Add analysis by selection

    loaLoad<-reactive({
      if (input$load_analysis==0||is.null(input$upfile))
        return(NULL)
      isolate({
        tmp<-read.csv((input$upfile)$datapath,header=TRUE,
                      encoding='UTF-8', na = na_sign)
        if(!'height'%in%colnames(tmp)){
          tmp$height <- NA
        }
        if(!'width'%in%colnames(tmp)){
          tmp$width <- NA
        }
        if(!'res'%in%colnames(tmp)){
          tmp$res <- NA
        }

        return(tmp)
      })
    }) # Add analysis by upload
    myTTT <<- plyr::rbind.fill(loaAdd(),loaLoad())
    if(!is.null(nrow(myTTT)))  myTTT <<- myTTT[, colnames(loaAdd())]

    write.table(myTTT,
                loatext,append=TRUE,col.names=FALSE,row.names=FALSE)


    if((is.null(input$add_analysis)||is.null(input$load_analysis)) ||
       input$add_analysis+input$load_analysis==0){
      return(NULL)
    }else{
      ret<-read.table(loatext,header=TRUE,check.names=FALSE)
      ret<-unique(ret)
      write.table(ret,loatext,append=FALSE,row.names=FALSE,col.names=TRUE)
    }

    LOA<<-reactive({
      if((is.null(input$add_analysis)||is.null(input$load_analysis)) ||
         (input$add_analysis+input$load_analysis)==0){
        return(NULL)
      }else{
        return(ret)
      }
    })

    return(NULL)
  }) # Generate LOA

  output$LOA<-renderUI({
    if((is.null(input$add_analysis) || is.null(input$load_analysis)) ||
       input$add_analysis+input$load_analysis==0
    ){
      return(NULL)
    }else{
      tf<-reactive({
        tf<-isolate({loaTF()})
        #is a TRUE/FALSE vector checking the availability of input$result_i
        #see checkboxTableInput in shinyFun.r
        addrow<-nrow(LOA())-length(tf)
        if(addrow>0){
          tfb<-c(tf,rep(TRUE,addrow))
        }else{
          tfb<-tf
        }
        return(tfb)
      })  #TRUE/FALSE of LOA
      isolate({
        sel_Table<-tf()
        tmploaTable<-LOA()[,c('Titles','Abbreviations.Footnote')]
        tmploaTable<-data.frame(ID=1:nrow(tmploaTable), tmploaTable)
        input$delete_loa
      })
      if(nrow(tmploaTable)==0){return(NULL)}
      if(is.null(input$delete_loa)||!(input$delete_loa)){
        shiny::HTML(checkboxTableInput(
          tmploaTable,
          table.id="LOAtable",id.name="result",
          checked=sel_Table, check.name= " ",labels=c("Title","Stat.Method","Footnote")))
      }else{

        shiny::HTML(checkboxTableInput(
          tmploaTable,
          table.id="LOAtable",id.name="result",
          checked=sel_Table,
          check.name= " ",labels=c("Title","Stat.Method","Footnote"),
          showSelectedOnly=TRUE))
      }
    }
  }) # Display LOA

  output$rcode<-renderPrint({
    if (all(is.null(loaTF()))||length(which(loaTF()))==0){
      return(cat(''))
    }else{
      loalistT<-LOA()[loaTF(),]
      loalistT$order<-1:nrow(loalistT)
      if(!'width'%in%colnames(loalistT))  loalistT$width <- NA
      if(!'height'%in%colnames(loalistT)) loalistT$height <- NA
      if(!'res'%in%colnames(loalistT))    loalistT$res <- NA
      temp.vdic <- Vdic()
      temp.vdic <- temp.vdic[,!colnames(temp.vdic)%in%c('width', 'height','res')]
      codelist<-merge(loalistT,Vdic(),by=c('Request.Name'),all.x=TRUE)
      codelist<<-codelist[order(codelist$order,codelist$Layout,decreasing=FALSE),]

      if(is.null(input$tumor) || is.na(input$tumor))
        title0<-paste0("Study: ",input$study,"\t\t", "  ")
      else
        title0<-paste0("Study: ",input$study,"\t\t","Tumor Type: ",input$tumor)

      r_out<-runcode(codelist=codelist, datPath=input$datPath,
                     outPath=input$outPath,
                     libs=paste0(r.lib.alert,collapse='\n'),
                     sourceCode=Vdic()$Source[!is.na(Vdic()$Request.Name)&!is.na(Vdic()$Source)],
                     subCode=subRcode,
                     title=title0,devpath=devpath,
                     params1=params[params.ord], paramLabs1=params.lab[params.ord],
                     outBcode=Vdic()$PlotCode[Vdic()$Num==1] )
      rcode<<-r_out
      cat(r_out)
    }
  }) # Generate R code

  output$scode<-renderPrint({
    files<-file.path(local.path1,
                     unique(Vdic()$Source[!is.na(Vdic()$Source)]))
    f1<-files[tolower(substring(files, nchar(files)-1,))==".r"]
    if(length(f1)>1)
      f1<-f1[!grepl('rcode.r', f1)]

    rF<-fLoop<-f1
    while(length(fLoop)>0){
      f0<-NULL
      for(i in 1:length(f1)){
        f2<-file.path(local.path1, "users", checkSource(fnm=f1[i]))
        fLoop<-fLoop[fLoop!=f1[i]]
        if(length(f2)>0){
          f0<-c(f0, f2)
          rF<-c(rF, f2)
        }
      }
      if(length(f0)>0){
        fLoop<-f1<-f0
      }
    }
    f1<-unique(rF)
    f1<-f1[length(f1):1] #so that source files can be run first
    if(allSourceIn1||input$showAllSource){ #copy all the source code into one file
      code00<-lapply(f1,readLines)
      code00<-lapply(code00, function(x){gsub("source",
                                              "###Search the copied code in this file\n### source", x)})
      code00<-unlist(lapply(1:length(f1),
                            function(x){c(" ", " ",
                                          paste0('#---Source ',x,': "',f1[x],'"---#'),
                                          " ", code00[[x]])}))
      code00<-c(paste0("if(TRUE) { #list of ", length(f1), " R source files"),
                paste0("   # source(file=paste0(local.path1, \'", gsub(local.path1, '', f1), "\'))"),
                paste0("} #end of ", length(f1), " R source files."), code00)
    } else {#only list the source files
      code00<-c(paste0("if(TRUE) { #list of ", length(f1), " R source files"),
                paste0("    source(file=paste0(local.path1, \'", gsub(local.path1, '', f1), "\'))"),
                paste0("} #end of ", length(f1), " R source files.") )
    }
    code11<<-code00
    cat(paste0(code00,collapse='\n'))
  }, width=60) # Generate Source code

  #------ Download LOA, R code, RTF output ------#
  output$save_loa<-downloadHandler(
    filename=function(){paste0(input$study,"_", input$tumor,"_loa.csv")},
    content=function(file){
      write.csv(LOA()[loaTF(),],file,row.names=FALSE, fileEncoding = 'UTF-8')
    }) # Download LOA

  output$save_loa_cd<-downloadHandler(
    filename=function(){paste0(input$study,"_", input$tumor,"_loa_cd.csv")},
    content=function(file){
      f12<-function(d1,d2){
        n2<-nrow(d2)
        d2$FootCode <- d2$Footnote
        d2$StatNote <- d2$Test.Statistic.Footnote
        d2$StatModel <-d2$Statistical.Analysis
        d2m<-params.map[,c('loa_lab','cd_lab')]
        d2cm<-d2m$loa_lab; names(d2cm)<-d2m$cd_lab;
        d2mv<-params.map[,c('loa','cd')]
        d2cmv<-d2mv$loa; names(d2cmv)<-d2mv$cd;
        for(i in 1:length(d2cm)){
          colnames(d2)<-gsub(d2cm[i], names(d2cm)[i], colnames(d2), fixed=T)
          colnames(d2)<-gsub(d2cmv[i], names(d2cmv)[i], colnames(d2), fixed=T)
        }
        dcm<-colnames(d2)[colnames(d2)%in%colnames(d1)]
        dcm.txt<-dcm[grepl('text.value',dcm)]
        dcm.ntx<-dcm[!grepl('text.value',dcm)]
        d2$rn<-1:n2
        d2$rn2<-paste(d2$rn, d2$Request.Name)
        d12<-merge(d1, d2[,c('rn','Request.Name', 'rn2')],
                   by='Request.Name', all=T, sort=F)
        d12$Num[d12$Num!=0] <- NA
        d12$Num[d12$Tab.value=='cd']<-n2+1
        d12$Num[d12$Tab.value=='rcode']<-n2+2
        d12 <- d12[d12$Num%in%c(0, n2+1, n2+2)|!is.na(d12$rn),]
        d12$Num[!is.na(d12$rn)]<-d12$rn[!is.na(d12$rn)]
        for(i in d2$rn){
          d12[d12$Num==i, dcm.ntx]<-d2[d2$rn==i,dcm.ntx]
          dcm.txt.tmp <- d2[d2$rn==i,dcm.txt]
          d12[d12$Num==i, dcm.txt]<-ifelse(is.na(dcm.txt.tmp),
                                           NA,
                                           paste0('\"',dcm.txt.tmp,'\"'))
        }
        d12$Request.Name<-d12$rn2
        d12<-d12[,colnames(d1)]
        d12<-d12[order(d12$Num),]
        loc.wd<-grepl(',',d12$width, fixed=T)
        d12$width[loc.wd]<-paste0('\"c(',d12$width[loc.wd],')\"')
        rownames(d12)<-NULL
        return(d12)
      }
      tt1<<-Vdic0; tt2<<-LOA()[loaTF(),];
      #f12(Vdic0, tt2);
      write.csv(  f12(Vdic0, LOA()[loaTF(),]) ,
                  file,row.names=FALSE, fileEncoding = 'UTF-8')
    }) # Download LOA in cd

  #------ Download EPS plot ------#
  output$getEPS <- downloadHandler(
    filename="current_BEACH_EPS_Plot.eps",
    content =function(file){
      postscript(file,
                 title = paste("BEACH Output", pdf.label),
                 height=tfl.h/tfl.r,
                 width=tfl.w/tfl.r,
                 pointsize = 1/tfl.r )
      plottry<-try(eval(parse(text=input0.code[1])))
      if(class(plottry)[1]=='try-error') {
        plot(0,axes=F, col='white',ylab='',xlab='')
        legend('top', 'Plotting\nError', cex=5, bty='n', text.col='red')
      }
      dev.off()
    }
  )
  #------ Download PDF plot ------#
  output$getPDF <- downloadHandler(
    filename="current_BEACH_PDF_Plot.pdf",
    content =function(file){
      pdf(file,
          title = paste("BEACH Output", pdf.label),
          height=tfl.h/tfl.r,
          width=tfl.w/tfl.r,
          pointsize = 1/tfl.r )
      plottry<-try(eval(parse(text=input0.code[1])))
      if(class(plottry)[1]=='try-error') {
        plot(0,axes=F, col='white',ylab='',xlab='')
        legend('top', 'Plotting\nError', cex=5, bty='n', text.col='red')
      }
      dev.off()
    }
  )


  #--------save output as a RTF file------------#
  output$save_output<-downloadHandler(
    filename=function(){
      if(input$onefileRTF=='one file'){
        f1<-paste0(input$study,"_",input$tumor, "_", Sys.Date(), ".rtf")
      }else{
        f1<-paste0(input$study,"_",input$tumor, "_", Sys.Date(), ".zip")
      }
      return(f1)
    },
    content=function(file){
      if(is.null(input$tumor) || is.na(input$tumor) || gsub(" ", '', input$tumor)=='')
        title0<-c(paste0("Study: ",input$study), '')
      else
        title0<-c(paste0("Study: ",input$study), paste0("Tumor Type: ",input$tumor))
      loalistT<<-LOA()[loaTF(),]
      loalistT$order<-1:nrow(loalistT)
      codelist<-merge(loalistT, Vdic(),by='Request.Name',all.x=TRUE)
      codelist<-codelist[order(codelist$order,codelist$Layout,decreasing=FALSE),]
      codelist$width <- codelist$width.x
      codelist$height <- codelist$height.x
      codelist$res <- codelist$res.x
      codelist<<-codelist

      #define the page margin
      mag1<-1
      #define the font size on each page
      fs <<- 8

      if(input$landscp=="Landscape"){
        pageW<-11      #page width
        pageH<-8.5     #page height
        nline<-52      #number of lines on a page
        nline.max<- 35 #maximum number of table rows on a page
        nline.min<- 5  #minimum number of table rows on a page
      } else {
        pageW<-8.5       #page width
        pageH<-11        #page height
        nline<-68        #number of lines on a page
        nline.max <- 50  #maximum number of table rows on a page
        nline.min <- 5   #minimum number of table rows on a page
      }
      maxH<-pageH-4*mag1
      maxW<-pageW-2*mag1
      if(input$onefileRTF=='one file'){
        rtf<-RTF(file, width=pageW, height=pageH, font.size=fs,omi=rep(mag1, 4) )
        rtf$.rtf <- gsub('\\rtf1\\ansi', '\\rtf1\\ansi\\BEACHoutput',
                         rtf$.rtf, fixed=TRUE)
      }
      # rtf$.rtf <- gsub('Times New Roman', 'Courier New', rtf$.rtf)  # make "Courier New" as default

      npage<-1
      prd.status<-''
      nfile<-0
      zipfs<-NULL

      #reorder codelist according to heading levels
      all.tit <- codelist$Titles
      all.tit0<- strsplit(all.tit, split='HHH:', fixed=TRUE)
      all.tit0<-lapply(all.tit0, function(x){
        if(gsub(" ", "", x[1])==""){return(x[-1])} else{ return(x)}
      })
      totLayer<-max(sapply(all.tit0, length))
      all.tit0<-lapply(all.tit0, function(x){
        c(x, rep(NA, max(0, totLayer-length(x))))
      })
      mat.tit <-t( matrix(unlist(all.tit0), nrow=totLayer) )
      if(ncol(mat.tit)>1){
        wh.tit <- do.call(order, as.data.frame(mat.tit))
        codelist<-codelist[wh.tit,]
        mat.tit <-mat.tit[wh.tit, ]
      }
      if(is.vector(mat.tit)){
        mat.tit <- matrix(mat.tit, nrow=1)
      }

      mat.1<-matrix(TRUE, nrow=1, ncol=ncol(mat.tit))
      mat.tit[is.na(mat.tit)] <- ""
      nr.mat <- nrow(mat.tit)
      mat.1<- rbind(mat.1, !apply(mat.tit, 2, function(x){x[2:nr.mat]==x[1:(nr.mat-1)]}) )
      if(ncol(mat.1)>1){
        mat.1<-t( apply(mat.1, 1, function(x){
          wh.T<- which(x)
          if(length(wh.T)>0)
            x[wh.T[1]:length(x)] <- TRUE
          x
        }) )
      }


      for (i in 1:nrow(codelist)){
        if (!is.na(codelist[i,params.lab[1]])&&is.na(codelist[i,params[1]]))
          next
        if(!all(is.na(codelist[i,params]))){
          #k.list<-params[!is.na(codelist[i,params])]\
          k.list<-sort(params)
          for (k in k.list[length(k.list):1]){
            print(     tmp0<-unlist(strsplit(as.character(codelist[i,k]),',',fixed=TRUE))   )
            tmp<-ifelse(any(is.na(as.numeric(tmp0))),paste0('c(\"',paste0(tmp0,collapse='\",\"'),'\")'),
                        paste0('c(',codelist[i,k],')'))
            codelist$PlotCode[i]<- gsub(paste0('input$',k),tmp,codelist$PlotCode[i],fixed=TRUE)
          }
        }

        nfile<-nfile+1
        #if all TFLs are NOT saved to one RTF file, a zip file will be downloaded
        if(input$onefileRTF!='one file'){
          f2<-file.path(local.path2, paste0(input$study,"_",input$tumor, "_", Sys.Date(),'_', nfile, ".rtf"))
          zipfs<-c(zipfs, f2)
          rtf<-RTF(f2, width=pageW, height=pageH,font.size=fs, omi=rep(mag1, 4) )
          rtf$.rtf <- gsub('\\rtf1\\ansi', '\\rtf1\\ansi\\BEACHoutput',
                           rtf$.rtf, fixed=TRUE)
        }

        #Add Plot
        tmp<-eval(parse(text=codelist$tmp[i]))
        tflname<-ifelse(is.na(codelist[i,params[1]]),        #Condition
                        paste0(tflfile,codelist$Num[i]),     #if TRUE
                        paste0(tflfile,codelist$Num[i],'x',  #if FALSE
                               paste0(#Paste all UIs together
                                 sapply(params,function(y){
                                   y0<-codelist[i,y]
                                   if(!is.null(y0)){y0[is.na(y0)]<-''}
                                   y0<-paste0(y0[length(y0):1],collapse='_')
                                   #Paste all Params for each UI
                                   substring(y0, max(nchar(y0)-30,1))
                                 }),collapse=''))
        )
        fig.name<-paste0(gsub("[[:punct:]]","",tflname),'.png')
        fig.name<-gsub(" ", "", fig.name)
        fig.name.i<-file.path(local.path3,fig.name)
        tab.name<-paste0(gsub("[[:punct:]]","",tflname),'.rdata')
        tab.name<-gsub(" ", "", tab.name)
        tab.name.i<-file.path(local.path3,tab.name)

        if(codelist$Type.y[i]=='Figure'){
          figH<-eval(parse(text=codelist$height[i]))
          figW<-eval(parse(text=codelist$width[i]))
          figR<-eval(parse(text=codelist$res[i]))
          png(file=fig.name.i, height=figH, width=figW, res=figR)
          plottry<<-try(eval(parse(text=codelist$PlotCode[i])))
          if(class(plottry)[1]=='try-error') {
            plot(0,axes=F, col='white',ylab='',xlab='')
            legend('top', 'Plotting\nError', cex=5, bty='n', text.col='red')
          }else if(grepl('gg', class(plottry))){
            ggsave(fig.name.i, plottry, height=figH/100, width=figW/100, dpi=figR, limitsize=FALSE)
          } else {}
          dev.off()

          #Add Header
          title00<-title0
          title00[2]<-paste(title0[2],'    Page', npage, '     ',
                            format(Sys.time(), "%H:%M %d%b%Y"), "   ", prd.status)  # main header
          npage<-npage+1
          title<-codelist$Titles[i]

          for(t1 in 1:ncol(mat.tit)){
            if(mat.1[i,t1] && mat.tit[i,t1]!=""){
              addHeader(rtf, title=mat.tit[i,t1], font.size=10, TOC.level=t1)
            }else if (mat.tit[i,t1]!="") {
              addParagraph(rtf, mat.tit[i,t1])
            }else{}
          }
          #addParagraph(rtf, title)
          addParagraph(rtf, title00)
          rtf$.font.size <- fs

          tmW<- min(eval(parse(text=codelist$width[i]))/90, maxW)
          tmH<- min(eval(parse(text=codelist$height[i]))/90, maxH)
          tmR<- eval(parse(text=codelist$res[i]))
          addPng(rtf, fig.name.i, width=tmW, height=tmH, res=tmR, col.justify='L')

          #footnote for figures
          #addNewLine(rtf, n=1)
          footnote<-codelist$Footnote[i]
          addParagraph(rtf, footnote)
        }

        #Add Table
        if(codelist$Type.y[i]=='Table'){
          tab.h <<- codelist$height[i]
          tab.w <<- as.numeric( eval(parse(text=paste("strsplit(' ",
                                                      codelist$width[i], " ', split=',')")   ))[[1]] )

          tmp<-eval(parse(text=codelist$tmp[i]))

          codelist$PlotCode[i]
          print(  outTable <<- eval(parse(text= codelist$PlotCode[i]))  )
          print(outTable)
          tmptab <<- eval(parse(text= codelist$PlotCode[i]))



          #check colnames
          outTable.colNm<-colnames(outTable)
          ot1 <- strsplit(outTable.colNm, split=";", fixed=TRUE)

          ot1n<-sapply(ot1, length)

          if(max(ot1n)==1){
            multiHeader<-FALSE
          }else{
            multiHeader<-TRUE
            nheader <- max(ot1n)
            #add extra row if a column names' level is smaller than the others
            ot1ns <- ot1n < nheader
            outTable.colNm[ot1ns] <- paste0(outTable.colNm[ot1ns],
                                            sapply(nheader-ot1n[ot1ns],
                                                   function(x){paste(rep('; ',x), collapse = '')}) )
            colnames(outTable) <- outTable.colNm

            ot2 <- sapply(outTable.colNm, strsplit, split=';', fixed=TRUE)

            names(ot2) <- NULL
            ot2<-matrix( unlist(ot2), ncol=length(ot2))
            var.ul <- unique(as.vector(ot2[-nrow(ot2),]))
            var.ul0 <- gsub(' ', '', var.ul)
            var.ul0 <- var.ul[var.ul0!=""]


          }


          footnote<-codelist$Footnote[i]
          footnote<-ifelse(is.na(footnote), '', footnote)

          nrTab<-nrow(outTable)
          ncTab<-ncol(outTable)
          print(paste("footnote: ", footnote))
          if(is.null(footnote)) footnote<-" "
          if(!is.character(footnote)) footnote <- " "
          nrFoot<-1+length(strsplit(footnote, split='\n', fixed=TRUE)[[1]])
          nline1<-max(1, nline-nrFoot - 10) #header lines

          tWidth<-pageW-mag1*2

          nc<-nchar(as.character(outTable[,1]))
          #use the 1st column width for table width
          c1W<-pmax(max(nc)*0.079/2, 20*0.1)
          caW<-nc*0.1

          if(pageW < 9){
            lcW<-.711
            if(ncol(outTable)>2){
              othW<-(tWidth-c1W-lcW)/(ncol(outTable)-2)
              centW<-rep(othW,ncol(outTable)-2)
              cWs<-c(c1W,centW,lcW)
            }else{
              cWs<-c(c1W, lcW)
              othW<-1
            }
          } else{
            if(ncol(outTable)>1){
              othW<-(tWidth-c1W)/(ncol(outTable)-1)
              centW<-rep(othW,ncol(outTable)-1)
              cWs<-c(c1W,centW)
            }else{
              cWs<-c(c1W,0)
              othW<-1
            }
          }
          max_cW<-max(apply(outTable,2, function(x){max(nchar(x))}))
          max_rW1<-ceiling(max_cW/othW)

          if(multiHeader)
            nline1 <- nline.max
          else
            nline1<-max(min(nline1-max_rW1+1, nline.max), nline.min)

          #nline1 is the max number Table rows shown on each page
          if(tab.h<=nline.max & tab.h>=1){
            nline1 <- tab.h
          }
          if(length(tab.w) == length(cWs) ){
            cWs <- tab.w
          }
          nline1 <<- nline1
          nrTab <<- nrTab

          for(j in 1:ceiling(nrTab/(nline1))){ #j matches the page number of the table
            #Add Header
            title00<-title0
            title00[2]<-paste0(title0[2], '    Page ', npage, '     ',
                               format(Sys.time(), "%H:%M %d%b%Y"), "   ", prd.status)  # main header
            npage<-npage+1
            title<-codelist$Titles[i]

            for(k in 1:length(title00))
              title00[k]<-paste0(title00[k], paste(rep(' ', max(0, pageW*7-nchar(title00[k]))), collapse=''))
            title00<-paste(c(title00, "\n"), collapse=' ')
            #add heading sections or bookmark
            for(t1 in 1:ncol(mat.tit)){
              if(j==1 && mat.1[i,t1] && mat.tit[i,t1]!=""){
                addHeader(rtf, title=mat.tit[i,t1], font.size=10, TOC.level=t1)
              }else if (mat.tit[i,t1]!="") {
                addParagraph(rtf, mat.tit[i,t1])
              }else{}
            }
            #addParagraph(rtf, title)
            rtf$.font.size <- 10   #define the font size of titles
            addParagraph(rtf, title00)
            rtf$.font.size <- fs   #redefine the font size of text

            bottLine<-min(nline1*j, nrTab)
            if(TRUE){#the table structure previously used.
              tableBL<- bottLine-((j-1)*nline1)
              tb1<-outTable[((j-1)*nline1+1):bottLine,]
              if(is.null(nrow(tb1))){
                tb1<-data.frame(` `=tb1)
              }

              if(multiHeader){# 17-Mar-2016
                rtf.table.out(rtf,  tb=tb1,
                              cell1=max(nheader+1,3), #number of levels in header and then plus 1
                              nheader=max(nheader,2), #number of levels in header
                              colFormat=c("L", rep("C",ncol(outTable)-1)),
                              nline.body= nline1, #min(tableBL, ncol(tb1)), #number of lines per page
                              height=pageH,
                              width=pageW,
                              omi=rep(mag1, 4),
                              cw=cWs,      #column width
                              var.ul=var.ul0 #key string for underline, must be the entire string
                              #eg. if changing " X1" to "X1", then it will not have the underline
                )
                if( exists("outTable") ) {rm('outTable'); outTable <<- tmptab}
                addParagraph(rtf,footnote)
              } else {
                rtf<-rtf_table_out_as_sas(rtf, tb1,
                                          cw=cWs, colFormat=c("L", rep("J",ncol(outTable)-1)),
                                          nline.body=tableBL,
                                          width=maxW, height=maxH, omi=rep(mag1, 4) )
                addParagraph(rtf,footnote)
              }
            }

            if(bottLine<nrTab )
              addPageBreak(rtf, width=pageW, height=pageH, font.size=fs, omi=rep(mag1, 4) )
          }

        }

        #get a new RTF page for the next analysis
        if(i < nrow(codelist))
          addPageBreak(rtf, width=pageW, height=pageH, font.size=fs, omi=rep(mag1, 4) )

        #one file is for one analysis
        if(input$onefileRTF!='one file'){
          done(rtf)
          print(paste(f2, 'is saved.'))
        }
      }

      if(input$onefileRTF=='one file'){
        done(rtf)
      }else{
        zipfs.gb<<-zipfs
        zip(zipfile=file, files=zipfs)
      }
    }) # Download rtf output
  #---------End of save output as a RTF file---------------#

  #---------run user defined action button-----------------#
  output$userdo_button<-renderUI({
    AnalyN()
    but_code<-paste0(
      '<button id="userdo" type="button" class="btn btn-default action-button">',
      userActionLabel, '</button>')
    return(shiny::HTML(but_code))
  })
  #observeEvent(input$userdo, {userdo_action()})
  userdo_out_reac<-eventReactive(input$userdo, {AnalyN(); userdo_action()})
  output$userdo_out<-renderPrint({
    if(!is.character(userdo_out_reac())){
      return(NULL)
    }else{return(userdo_out_reac())}
  })
  #---------End of run user defined action button-----------------#

  #--------save output as a shiny::HTML file------------#
  output$save_outputH<-renderUI({
    if(is.null(input$outputH)||input$outputH==0){
      return(NULL)
    }
    if(!dir.exists(htmlPath)){
      return(shiny::HTML('Please input an existing director for HTML output!'))
    }

    isolate({
      curP0<-getwd()

      tp<-try(setwd(input$hPath))
      if(class(tp)[1]=="try-error"){
        return(shiny::HTML('<h6>The path for HTML file output is not working.</h6>'))
      }else{setwd(curP0)}
      file00<-paste0(input$study,"_",input$tumor,"_", Sys.Date())
      file0<-file.path(input$hPath, file00)
      file01<-file.path(file0, file00)
      if(file.exists(file0)){
        setwd(file0)
        try(file.remove(dir()))
        if(file.exists(file00)){
          setwd(file00)
          try(file.remove(dir()))
        }else{dir.create(file00, showWarnings=FALSE, recursive=TRUE)}
      }else{ #create a folder for linked files
        dir.create(file0, showWarnings=FALSE, recursive=TRUE)
        dir.create(file.path(file0, file00), showWarnings=FALSE, recursive=TRUE)
      }

      title0<-paste0("Study: ",input$study,"\t\t","Tumor Type: ",input$tumor)
      loalistT<-LOA()[loaTF(),]
      loalistT$order<-1:nrow(loalistT)
      codelist<-merge(loalistT, Vdic(),by='Request.Name',all.x=TRUE)
      codelist<-codelist[order(codelist$order,codelist$Layout,decreasing=FALSE),]
      ind<-0

      #start HTML

      #remember to create a folder under htmlPath
      setwd(curP0)
      indexH<-readLines(con=file.path(htmltem, 'index.htm'))
      bodyH<-readLines(con=file.path(htmltem, 'body.htm'))
      bodyH<-gsub("Biomarker Analyses Output From BEACH Platform",
                  title0, bodyH)
      contH<-readLines(con=file.path(htmltem, 'content.htm'))
      #one row in one codelist is one page in the study report
      for (i in 1:nrow(codelist)){#update source code in codelist$PlotCode
        if (!is.na(codelist[i,params.lab[1]])&&is.na(codelist[i,params[1]]))next
        if(!all(is.na(codelist[i,params]))){
          k.list<-params[!is.na(codelist[i,params])]
          for (k in k.list[length(k.list):1]){
            tmp0<-unlist(strsplit(as.character(codelist[i,k]),',',fixed=TRUE))
            tmp<-ifelse(any(is.na(as.numeric(tmp0))),
                        paste0('c(\"',paste0(tmp0,collapse='\",\"'),'\")'),
                        paste0('c(',codelist[i,k],')'))
            codelist$PlotCode[i] <- gsub(paste0('input$',k),
                                         tmp,codelist$PlotCode[i], fixed=TRUE)
          }
        }
        #Add Header
        title<-codelist$Titles[i]
        tmpTit<-paste(title0, "/n", title)

        #Add Plot&Table
        tmp<-eval(parse(text=codelist$tmp[i]))
        tflname<-ifelse(is.na(codelist[i,params[1]]),             #Condition
                        paste0(tflfile, codelist$Num[i]),         #if TRUE
                        paste0(tflfile, codelist$Num[i],'x',      #if FALSE
                               paste0(#Paste all UIs together
                                 sapply(params,function(y){
                                   y0<-codelist[i,y]
                                   if(!is.null(y0)){y0[is.na(y0)]<-''}
                                   y0<-paste0(y0[length(y0):1], collapse='_')
                                   #Paste all Params for each UI
                                   substring(y0, max(nchar(y0)-30,1))
                                 }),collapse=''))
        )
        tflname<-gsub('tfl', paste0('t',i,'fl'),tflname, fixed=TRUE)
        fig.name<-paste0(gsub("[[:punct:]]","",tflname),'.png')
        fig.name.i<-file.path(local.path3, fig.name)
        tab.name<-paste0(gsub("[[:punct:]]","",tflname),'.rdata')
        tab.name.i<-file.path(local.path3, tab.name)

        #insert figure
        if(codelist$Type.y[i]=='Figure'){
          myres<-ifelse(is.null(codelist$res[i])||is.na(codelist$res[i]), 150,
                        eval(parse(text=codelist$res[i])))

          png(fig.name.i, height=eval(parse(text=codelist$height[i])),
              width=eval(parse(text=codelist$width[i])), res=myres)
          plottry<-try(eval(parse(text=codelist$PlotCode[i])))
          if(class(plottry)[1]=='try-error') {
            plot(0,axes=F, col='white',ylab='',xlab='')
            legend('top', 'Plotting\nError', cex=5, bty='n', text.col='red')
          }
          dev.off()

          fig.name.1<-strsplit(fig.name.i, split="www/",fixed=TRUE)[[1]][2]
          file.copy(from=fig.name.i, file01)
          ind<-ind+1
          bodyH<-c(bodyH, fig2html(figNm=fig.name.1, figTit=codelist$Titles[i],
                                   figH=eval(parse(text=codelist$height[i])),
                                   figW=eval(parse(text=codelist$width[i])) ,
                                   fnote=codelist$Footnote[i], ind=ind ))
          contH<-c(contH, cLink(tit=codelist$Titles[i], ind=ind))
        }

        #Insert Table
        if(codelist$Type.y[i]=='Table'){
          #generate the temporary table
          tmp<-eval(parse(text=codelist$tmp[i]))
          tmptab<-eval(parse(text=codelist$PlotCode[i]))
          save(tmptab,file=tab.name.i)

          #load(tab.name.i)
          outTable<-tmptab
          if(FALSE){
            tWidth<-9
            nc<-nchar(as.character(outTable[,1]))
            c1W<-pmax(max(nc)*0.079/2, 20*0.079)
            caW<-nc*0.079
            lcW<-.711
            othW<-(tWidth-c1W-lcW)/(ncol(outTable)-2)
            centW<-rep(othW,ncol(outTable)-2)
            cWs<-c(c1W,centW,lcW)
          }

          ind<-ind+1
          bodyH<-c(bodyH, df2html(datF=outTable, tabTit=tmpTit,
                                  fnote=codelist$Footnote[i], ind=ind))
          contH<-c(contH, cLink(tit=codelist$Titles[i], ind=ind))
        }
      }
      bodyH<-c(bodyH, '<br>', '</div>', '</body>', '</html>')
      contH<-c(contH, '<br>', '</ol>', '</body>', '</html>')

      write(bodyH, file=file.path(file01, 'body.htm'))
      write(contH, file=file.path(file01, 'content.htm'))

      indexH<-gsub("tmpfolder", file00, indexH, fixed=TRUE)
      file1<-paste0(file00,".htm")
      write(indexH, file=file.path(file0, file1))

      setwd(curP0)
      return(shiny::HTML(paste('<h6>', file.path(file0, file1),
                               'and its folder are successfully downloaded.</h6>')))
    }) })  # Download HTML output
  #---------End of save output as a HTML file---------------#

  output$save_data<-downloadHandler(
    filename=function(){
      tt <- paste0('download_tmpData.', input$multdat_ext)
      return(tt)
    },
    content=function(file){
      #      if (is.null(input$infile)&&is.null(input$infileR))
      #        return(NULL)

      choice<-sapply(AnalyN(),function(x){
        ifelse(substr(Vdic()$Title[x],1,5)=='paste',
               eval(parse(text=Vdic()$Title[x])),
               Vdic()$Title[x])
      })

      outList <<- currTabL
      outdata <<- outList[[1]]

      sapply(1:length(currTabL),
             function(x){
               assign(paste0('outmplkhdnttawr',x),currTabL[[x]],envir=globalenv() )
             } )

      if(input$multdat_ext=='rdata'){
        save(currTabL,file=file)
      } else if(input$multdat_ext=='xls'){
        WriteXLS::WriteXLS(paste0('outmplkhdnttawr',1:length(currTabL)),
                 ExcelFileName=file,SheetNames=1:length(input$multdat))
      }  else if(input$multdat_ext=='sas'){
        if(!is.vector(currTabL[[1]])){
          o1<-apply(currTabL[[1]], 2, paste, collapse='\t\t\t')
        }else{
          o1 <- currTabL[[1]]
        }
        writeLines(o1,con=file)

      } else if(input$multdat_ext=='csv'){
        write.csv(currTabL[[1]], file=file, row.names=FALSE, fileEncoding='UTF-8')
      } else if(input$multdat_ext=='xpt'){
        #write.xport(currTabL[[1]], file=file, autogen.formats=FALSE)
        haven::write_xpt(currTabL[[1]], path=file)
      }

    }) # Download data output


  output$save_rcode<-downloadHandler(
    filename=function(){paste0(input$study,"_",input$tumor,".r")},
    content=function(file){
      writeLines(rcode,file)}) # Download R code

  output$save_scode<-downloadHandler(
    filename=function(){paste0(input$study,"_",input$tumor,"_source.r")},
    content=function(file){
      writeLines(code11,file)
    }) # Download Source code

  output$delete<-renderUI({#remove temporary files
    if(input$delete_tmpfile==0){
      return(NULL)
    } else {
      cnt<-cnt+input$delete_tmpfile
      #for files under the tmpfile folder
      loatextf<-dir(local.path2)
      loatextf<-loatextf[nchar(loatextf)>3]
      if(length(loatextf)>0)
        loatextf<-loatextf[substr(loatextf,1,3)=='loa']
      #for files under the www folder
      tm_png<-dir(local.path3)
      tm_png<-tm_png[nchar(tm_png)>3]
      if(length(tm_png)>0){
        tmsel<-substr(tm_png,1,3)=='tfl'|substr(tm_png,2,4)=='tfl'|substr(tm_png,1,2)=='.n'|
          substr(tm_png,3,4)=='fl'|
          substr(tm_png,nchar(tm_png)-6,nchar(tm_png))=='.rdata'
        tm_png<-tm_png[tmsel]
      }
      if(length(tm_png)==0 & length(loatextf)==0){
        return('Empty now.')
      }else{
        if(length(loatextf)>0){
          loatextf<-file.path(local.path2, loatextf)
          do.call(file.remove, as.list(loatextf))
        }
        if(length(tm_png)>0){
          tm_png<-file.path(local.path3,tm_png)
          do.call(file.remove, as.list(tm_png))
        }
        return(paste('Done',cnt))
      }
    }
  })

  #define data subset
  output$subsetcode1<-renderUI({
    if(is.null(input$submitcode)||input$submitcode==0){
      subRcode<<-NULL
    }else{subRcode<<-isolate(input$subRcode)}
    return(conditionalPanel(condition='true',
                            shiny::HTML("<textarea name=\"subRcode\" rows=\"4\"  style=\"width:100%\"
                                        placeholder=\"#drag the right bottom corner to make this larger.
                                        #indataset is a list object including all the uploaded csv files.
                                        #indataset.i is indataset[[1]] by default. indataR is a list object including
                                        #all the objects in the uploaded R file.
                                        #Input your R code here to re-define indataset.i, for example
                                        indataset.i<<-indataset[[1]]
                                        indataset.i<<-indataset.i[1:10,]
                                        #or
                                        indataset.i<<-indataset[[1]]; indataset.i<<-indataset.i[1:10,]\"></textarea>") ))
  })
  output$subsetcode2<-renderPrint({
    if(input$submitcode==0 && length(indataset)>0){
      indataset.i<<-indataset[[1]]
      return(NULL)
    }else if(input$submitcode!=0 && length(indataset)>0){
      rpt.cls<-class(try(rpt<-eval(parse(text=subRcode))))
      if(rpt.cls!='try-error'){
        n.row<-nrow(indataset.i)
        n.col<-ncol(indataset.i)
      }
      rpt
    }else{}
  })

  output$showAS<-renderUI({#show all source code or not
    if(input$showAllSource){
      allSourceIn1<<-TRUE
    }else{
      allSourceIn1<<-FALSE
    }
  })

  #######for dynamic output########
  output$dynamicPlot <- renderPlot({
    eval(parse(text=dynamicCode))
  } )

  output$click_info_DT<-renderUI({
    return(DT::dataTableOutput('click_info'))
  })

  output$click_info <- DT::renderDataTable({
    # Because it's a ggplot2, we don't need to supply xvar or yvar; if this
    # were a base graphics plot, we'd need those.
    near_points <<- nearPoints(dynamicData, input$dynamicPlot_click,
                               xvar=dynamicData.xvar, yvar=dynamicData.yvar,
                               addDist = TRUE)
    near_points
  },  rownames = FALSE)


  output$click_info_dl<-downloadHandler(
    filename=function(){paste0(input$study,"_",input$tumor,"_clicked_dynamicData.csv")},
    content=function(file){
      tmpout<-nearPoints(dynamicData, input$dynamicPlot_click,
                         xvar=dynamicData.xvar, yvar=dynamicData.yvar,
                         addDist = TRUE)
      write.csv(tmpout, file=file, row.names=FALSE, fileEncoding='UTF-8')
    }
  ) # Download clicked data


  output$brush_info_DT<-renderUI({
    return(DT::dataTableOutput('brush_info'))
  })

  output$brush_info <- DT::renderDataTable({
    if(showBrush)
      #     print(trytry<<-input$dynamicPlot_brush)
      brush_points<<-brushedPoints(dynamicData, input$dynamicPlot_brush,
                                   xvar=dynamicData.xvar, yvar=dynamicData.yvar)
    brush_points
  }, rownames = FALSE)

  ####End for dynamic output########


  output$brush_info_dl<-downloadHandler(
    filename=function(){paste0(input$study,"_",input$tumor,"_brushed_dynamicData.csv")},
    content=function(file){
      tmpout<-brushedPoints(dynamicData, input$dynamicPlot_brush,
                            xvar=dynamicData.xvar, yvar=dynamicData.yvar)
      write.csv(tmpout, file=file, row.names=FALSE, fileEncoding='UTF-8')
    }
  ) # Download clicked data



  ####Dynamic data table####
  output$outTbl_DT<-renderUI({
    return(DT::dataTableOutput('outTbl'))
  })
  output$outTbl<-DT::renderDataTable({
    if (all(!Vdic()$Type[AnalyN()] %in% c('Figure','Table'))||
        all(eval(parse(text=Vdic()$Condition[AnalyN()])))){
      return(NULL)
    }
    for (i in AnalyN()[1]){#only render the first table
      if(!is.na(Vdic()$Title[i])){
        title<-ifelse(substr(Vdic()$Title[i],1,5)=='paste',
                      eval(parse(text=Vdic()$Title[i])),Vdic()$Title[i])
        titlecode<-paste0('<h3><textarea name=\"titlebox\" rows=\"1\" style=\"width:80%\">',
                          title,'</textarea></h3>')}else{titlecode<-NULL}

      tflname<-ifelse(all(is.na(widgetOrd()$names)),               #Condition
                      paste0(tflfile,Vdic()$Num[i]),    #if TRUE
                      paste0(tflfile,Vdic()$Num[i],'x',        #if FALSE
                             paste0(#Paste all UIs together
                               sapply(widgetOrd()$names,function(y){
                                 y0<-eval(parse(text=paste0('input$',y)))
                                 if(!is.null(y0)){y0[is.na(y0)]<-''}
                                 y0<-paste0(y0[length(y0):1],collapse='_') #Paste all Params for each UI
                                 substring(y0, max(nchar(y0)-30,1))
                               }),collapse=''))
      )
      tflname<-gsub(' ', '',tflname)
      fig.name<-paste0(input$submitcode,gsub("[[:punct:]]", "",tflname),'.png')
      tab.name<-file.path(local.path3,paste0(input$submitcode,gsub("[[:punct:]]", "",tflname),'.rdata'))


      if(Vdic()$Type[i]=='Table'){
        if(!file.exists(tab.name)){
          if(class(try(tmptab<-eval(parse(text=input0.code))))[1]=='try-error'){
            tmptab<-''
          }
          save(tmptab, file=tab.name)
        }else{
          load(tab.name)
        }
        rd_tmptab <<- tmptab
        return(tmptab)
      }else{return(NULL)}
    }
  }, rownames = FALSE)


  output$getDataSelected <- renderUI({
    data_selected_col1 <<- unique(c(
      input$click_info_rows_selected,
      input$brush_info_rows_selected  ))

    if(is.null(input$outTbl_rows_selected)){
      data_selected <<- rbind(
        near_points[!is.na(near_points[,1]) & near_points[,1]%in%data_selected_col1,],
        brush_points[!is.na(brush_points[,1]) & brush_points[,1]%in%data_selected_col1,]
      )
    } else{
      #input$outTbl_rows_selected is shiny internal widget indicate row id(s)
      data_selected <<- rd_tmptab[!is.na(rd_tmptab[,1]) &
                                    rd_tmptab[,1] %in% input$outTbl_rows_selected,]
    }
    return(NULL)
  })

  output$pumpPlotOut<-renderPlot({
    if(is.null(input$outTbl_rows_selected)||input$outTbl_rows_selected==0){
      return(NULL)
    }
    isolate({
      if(is.null(click2plot) || !is.function(click2plot)){
        click2plot.o(input$outTbl_rows_selected)
      }else{
        click2plot();#input$outTbl_rows_selected needs inside
      }
    })
  })

  ##########################
}  #close Shiny server#


shinyServer(BeachServer)

#*****************************************************************************************************
#-- Function to produce table or plot to RTF file
#
#-- Author: Michael Man, Duytrac Nguyen, Danni Yu
#
#*****************************************************************************************************

#-----------------------------------------------------------------------------------------------
#
###--- These functions are used for produce a nice RTF file
#
#-----------------------------------------------------------------------------------------------
if(!exists('muliHead.split')){
  muliHead.split <<- ";"
}

if (TRUE) {

  #--- produce to rtf file that as SAS output. It can be used for single table or table with multiple pages  
  rtf.table.out <- function(
    rtf,          # RTF object that is just needed to be declared once before calling the function
    tb,           # table out
    cell1=2, 
    cell2=1, 
    nheader=1,
    nline.body=40, #number of lines per page
    height=8.5, 
    width=11, 
    omi=c(1,1,1,1),
    cw=NULL,      #column width
    colFormat=c(rep("L", 1), rep("C",3)), #alignment (left, center, or right) for each column
    varName=NULL,  #variable name that want to be repeated when go to the next page
    var.ul="",     #key string in table defining the bottom line on each page.
#    titles="", 
#    footns="",
#    prd.status='QA', 
    header=FALSE,
    footer=FALSE,
    addSpaceHeader=0, #expand the width of header or footnotes
    addSpaceFoot=0,   #expand the width of header or footnotes
    page.disp=FALSE,   #whether diplay page number
#    Done=TRUE,
    ...
  ){
    # rtf: RTF object that is just needed to be declared once before calling the function
    # tb: table out
    # cw: column width
    # colFormat: alignment (left, center, or right) for each column
    # varName: variable name that want to be repeated when go to the next page
    # nline.body: number of lines per page
    # addSpaceFoot, addSpaceHeader: expand the width of header or footnotes
    # page.disp: whether diplay page number
    
    #--- generate blank pape (break page) if the data is more than a page
    if(nrow(tb) > nline.body) {
      idx <- seq(1, nrow(tb), by = nline.body)
      idx.n <- c(seq(nline.body, nrow(tb), by = nline.body), nrow(tb))
    }else {
      idx <- 1
      idx.n <- nrow(tb)
    }
    
    npage <- length(idx)
    
    for(k in 1:length(idx)) {
      if(idx[k]==idx.n[k])
        subTable <- tb
      else
        subTable <- tb[idx[k]:idx.n[k], ]
      #--- if nrow < nline.body, need adding some spaces to move footnotes to bottom of the page
      if(nrow(subTable) < nline.body) {
        addData <- data.frame(matrix("",ncol=ncol(subTable), nrow=nline.body-nrow(subTable)-1))
        colnames(addData) <- colnames(subTable)
        subTable <- rbind(subTable, addData)
      }
      
      #-- get values that will be in the 1st row of next page
      rownames(subTable) <- 1:nrow(subTable)
      
      #-- check if the last row of previous page with varName not matched the 1st row of next page
      if(k==1)
        string.val <- NULL
      if(k!=1 & !all(unique(subTable[1,varName]) %in% "") & !all(unique(subTable[1,varName]) %in% string.val))
        string.val <- unique(subTable[1,varName])
      
      if(k==1 & all(tb[min(nrow(tb), nrow(subTable)+1), varName] %in% "")) {
        for(m in 1:nrow(subTable))
          if(all(!subTable[m,varName] %in% ""))
            string.val <- subTable[m, varName]
      } else if(!all(tb[min(nrow(tb),nrow(subTable)+1), varName] %in% "")) {
        string.val <- NULL
      } else {
        #-- add last row of previous page to 1st row of next page
        if(!is.null(string.val))
          subTable[1, varName] <- string.val
        
        for(m in 1:nrow(subTable))
          if(all(!subTable[m,varName] %in% ""))
            string.val <- subTable[m, varName]
      }
      
      hd <- sapply(colnames(subTable), function(x) strsplit(x, muliHead.split)[[1]])
      ret <- rbind(hd, as.matrix(subTable))
      colnames(ret) <- 1:ncol(ret)
      rownames(ret) <- 1:nrow(ret)
      
      ret2 <- ret
      
      colnames(ret2) <- 1:ncol(ret2)
      rownames(ret2) <- 1:nrow(ret2)
      attributes(ret2) <- list(dim = dim(ret2), dimnames = dimnames(ret2), `start cell` = c(cell1, cell2))
      
      col.just <- matrix(c(rep(colFormat, nrow(ret2) + nheader)), ncol=ncol(ret2), byrow=TRUE)
      
      dat <- ret2
      st <- attributes(dat)$'start cell'[1]
      hd <- 1:(st-1)
      if(is.null(cw)) cw <- c(1.5,rep(.7,ncol(dat)-1))
      x <- dat
      cw2 <- matrix(rep(cw, nrow(x)), ncol=ncol(x), byrow=TRUE)
      if (st > 2) {
        y <- adj.width(x=dat[hd,],cw=cw, space=1)
        x[hd,] <- y$x
        cw2[hd,] <- y$cw
      }
      
      rtf.add.row <- function(rows=1:nrow(x)){
        ret <- "{\\pard\n"
        for (i in rows) if (i <= nrow(x)){
          sel <- which(cw2[i,]>0)
          ret <- paste(ret,
                       .add.table.row(
                         col.data =     x[i,sel],
                         col.widths = cw2[i,sel],
                         col.justify = col.just[i,sel],
                         font.size = fs,
                         border.top = i %in% c(1),
                         border.bottom = if (i > st-2) i %in% c(st-1,nrow(x),max(rows)) else x[i,sel] %in% var.ul
                       ),
                       sep='')
          if (i < st) if (!all(cw2[i,] == cw2[i+1,])) ret <- paste(ret,'{\\pard\\par}','', sep='')
        }
        ret <- paste(ret, "}\n\n", sep = "")
        rtf$.rtf <- paste(rtf$.rtf, ret, sep='')
      }
      
      rtf <- rtf
      fs <- rtf$.font.size
      rtf$.rtf <- gsub('Times New Roman', 'Courier New', rtf$.rtf)	# make "Courier New" as default
      rtf$.rtf <- gsub('field{\\fldinst{page}}', '', rtf$.rtf, fixed=TRUE)	# delete page number
      
      for (i in 1:1){
        rtf.add.row(rows=c(1:(st-1), 1:nline.body-1+st+nline.body*(i-1)))
      }
      
    }

    
  }#end rtf.table.out
  
  
  
  #--- this funciton to be used for single plot output or
  # when there are different plots that would be saved in the same RTF file
  rtf.plot.out <- function(rtf, plotOut, page.disp=FALSE,
                           height=8.5, width=11, omi.marg=c(1, 1, 1, 1),
                           width.plot=8, height.plot=5,
                           fs=10,
                           titles,footns,
                           prd.status="",
                           widthHeader=7, widthFoot=9,
                           breakPage=TRUE,...) {

    # rtf: RTF object that is just needed to be declared once before calling the function
    # plotOut: plot function
    # page.disp: whether diplay page number
    # width.plot, height.plot: width and height of plot
    # fs: font size for header and footnotes
    # titles,footns: title and footnotes
    # withHeader, widthFoot: width of header and footnotes
    # omi.marg: margin of the page
    # breakPage: if there are more than 1 page of the RTF file, need breakPage=TRUE,
    #            otherwise (just a single page), set breakPage=FALSE

    rtf <- rtf

    rtf$.font.size <- fs
    rtf$.rtf <- gsub('Times New Roman', 'Courier New', rtf$.rtf)  # make "Courier New" as default


    npage <- 1
#    systems <- c(ifelse(page.disp==TRUE, paste('Page \\chpgn  of ', npage, sep=''), ""),
#                 format(Sys.time(), "%H:%M %d%b%Y"),
#                 prd.status)
#    hd.m <- c(paste(titles,  collapse='\\line '),
#              paste(systems, collapse='\\line '))  # main header

#    tmp <- .add.table.row(
#      col.data =  hd.m,
#      col.widths = c(widthHeader,2),
#      col.justify = c('L', 'R'),
#      font.size = fs)

#    tmp2 <- .add.table.row(
#      col.data =  paste(footns, collapse='\\line '),
#      col.widths = widthFoot,
#      col.justify = 'L',
#      font.size = fs)

    #-- add headers
    #rtf$.rtf <- paste(rtf$.rtf,  '{\\pard\\par}', tmp,  '{\\pard\\par}', sep='')

    #-- add plot
    addPlot(rtf, plot.fun=plotOut, width=width.plot, height=height.plot, res=300)   #add plot

    #-- add footnotes
    #addParagraph(rtf, paste(footns,  collapse='\\line '))
    #rtf$.rtf <- paste(rtf$.rtf,  '{\\pard\\par}', tmp2,  '{\\pard\\par}', sep='')

    if(breakPage)
      addPageBreak(rtf, width=width, height=height, omi=omi.marg)
  }#end rtf.plot.out


}#end RTF output functions


#-----------------------------------------------------------------------------------------------
#
###--- These functions are original developed/modified from Michael Man
# in which he used RTF syntax (from tables and etable packages) rather than the RTF package.
#
#-----------------------------------------------------------------------------------------------

if (TRUE) {

  .convert <- function (x)
  {
    x <- gsub("\\n", " \\\\line ", x)
    x <- gsub("<=", "\\\\u8804\\\\3", x)
    x <- gsub(">=", "\\\\u8805\\\\3", x)
    x <- gsub("&gt;", ">", x)
    x <- gsub("&lt;", "<", x)
    x <- gsub("&Alpha;", "\\\\u0913\\\\3", x)
    x <- gsub("&Beta;", "\\\\u0914\\\\3", x)
    x <- gsub("&Gamma;", "\\\\u0915\\\\3", x)
    x <- gsub("&Delta;", "\\\\u0916\\\\3", x)
    x <- gsub("&Epsilon;", "\\\\u0917\\\\3", x)
    x <- gsub("&Zeta;", "\\\\u0918\\\\3", x)
    x <- gsub("&Eta;", "\\\\u0919\\\\3", x)
    x <- gsub("&Theta;", "\\\\u0920\\\\3", x)
    x <- gsub("&Iota;", "\\\\u0921\\\\3", x)
    x <- gsub("&Kappa;", "\\\\u0922\\\\3", x)
    x <- gsub("&Lambda;", "\\\\u0923\\\\3", x)
    x <- gsub("&Mu;", "\\\\u0924\\\\3", x)
    x <- gsub("&Nu;", "\\\\u0925\\\\3", x)
    x <- gsub("&Xi;", "\\\\u0926\\\\3", x)
    x <- gsub("&Omicron;", "\\\\u0927\\\\3", x)
    x <- gsub("&Pi;", "\\\\u0928\\\\3", x)
    x <- gsub("&Rho;", "\\\\u0929\\\\3", x)
    x <- gsub("&Sigma;", "\\\\u0931\\\\3", x)
    x <- gsub("&Tau;", "\\\\u0932\\\\3", x)
    x <- gsub("&Upsilon;", "\\\\u0933\\\\3", x)
    x <- gsub("&Phi;", "\\\\u0934\\\\3", x)
    x <- gsub("&Chi;", "\\\\u0935\\\\3", x)
    x <- gsub("&Psi;", "\\\\u0936\\\\3", x)
    x <- gsub("&Omega;", "\\\\u0937\\\\3", x)
    x <- gsub("&alpha;", "\\\\u0945\\\\3", x)
    x <- gsub("&beta;", "\\\\u0946\\\\3", x)
    x <- gsub("&gamma;", "\\\\u0947\\\\3", x)
    x <- gsub("&delta;", "\\\\u0948\\\\3", x)
    x <- gsub("&epsilon;", "\\\\u0949\\\\3", x)
    x <- gsub("&zeta;", "\\\\u0950\\\\3", x)
    x <- gsub("&eta;", "\\\\u0951\\\\3", x)
    x <- gsub("&theta;", "\\\\u0952\\\\3", x)
    x <- gsub("&iota;", "\\\\u0953\\\\3", x)
    x <- gsub("&kappa;", "\\\\u0954\\\\3", x)
    x <- gsub("&lambda;", "\\\\u0955\\\\3", x)
    x <- gsub("&mu;", "\\\\u0956\\\\3", x)
    x <- gsub("&nu;", "\\\\u0957\\\\3", x)
    x <- gsub("&xi;", "\\\\u0958\\\\3", x)
    x <- gsub("&omicron;", "\\\\u0959\\\\3", x)
    x <- gsub("&pi;", "\\\\u0960\\\\3", x)
    x <- gsub("&rho;", "\\\\u0961\\\\3", x)
    x <- gsub("&sigmaf;", "\\\\u0962\\\\3", x)
    x <- gsub("&sigma;", "\\\\u0963\\\\3", x)
    x <- gsub("&tau;", "\\\\u0964\\\\3", x)
    x <- gsub("&upsilon;", "\\\\u0965\\\\3", x)
    x <- gsub("&phi;", "\\\\u0966\\\\3", x)
    x <- gsub("&chi;", "\\\\u0967\\\\3", x)
    x <- gsub("&psi;", "\\\\u0968\\\\3", x)
    x <- gsub("&omega;", "\\\\u0969\\\\3", x)
    x <- gsub("TRUE", "Yes", x)
    x <- gsub("FALSE", "No", x)
    x
  }


  .get.space.before.after <- function (space.before = NULL, space.after = NULL)
  {
    ret <- ""
    if (!is.null(space.before)) {
      ret <- paste(ret, "\\sb", (space.before * 1440), sep = "")
    }
    if (!is.null(space.after)) {
      ret <- paste(ret, "\\sa", (space.after * 1440), sep = "")
    }
    ret
  }
 

  .add.table <- function (dat, col.widths = NULL, col.justify = NULL, header.col.justify = NULL,
                          font.size = 10, row.names = FALSE, indent = 0, NA.string = "-",
                          bd.top=NULL, bd.bottom=NULL,  # MZM: border option, need row numbers
                          max.table.width = NULL, space.before = NULL, space.after = NULL)
  {
    ret <- "{\\pard\n"
    if (!is.null(bd.top) | !is.null(bd.bottom)) {  #MZM: for complex table
      dat <- as.data.frame(dat, stringsAsFactors = FALSE)
      nc <- ncol(dat)
      if (is.null(col.widths)) col.widths <- rep(6.5/nc, nc)
      for (i in 1:nrow(dat)) {
        ret <- paste(ret, .add.table.row(as.character(dat[i, ]),
                                         col.widths, col.justify, font.size = font.size,
                                         last.row = FALSE, indent = indent, space.before = space.before, # MZM: change last.row
                                         border.top = i %in% bd.top,  border.bottom = i %in% bd.bottom,  # MZM: add top/bottom option
                                         space.after = space.after), sep = "")
      }
    }
    else if ("table" %in% class(dat)) {
      if (length(dim(dat)) == 1) {
        varnames <- names(dimnames(dat))[1]
        nc <- 2
        nr <- length(dimnames(dat)[[1]])
        if (is.null(col.widths)) {
          col.widths <- rep(6.5/nc, nc)
        }
        ret <- paste(ret, .add.table.header.row(c(names(dimnames(dat))[1],
                                                  " "), col.widths, header.col.justify, font.size = font.size,
                                                repeat.header = TRUE, indent = indent), sep = "")
        if (nrow(dat) > 1) {
          for (i in 1:(nrow(dat) - 1)) {
            rn <- rownames(dat)[i]
            ret <- paste(ret, .add.table.row(c(rn, as.character(dat[i])),
                                             col.widths, col.justify, font.size = font.size,
                                             indent = indent, space.before = space.before,
                                             space.after = space.after), sep = "")
          }
        }
        rn <- rownames(dat)[nrow(dat)]
        ret <- paste(ret, .add.table.row(c(rn, as.character(dat[nrow(dat)])),
                                         col.widths, col.justify, font.size = font.size,
                                         indent = indent, border.bottom = TRUE, space.before = space.before,
                                         space.after = space.after), sep = "")
      }
      else if (length(dim(dat)) == 2) {
        varnames <- names(dimnames(dat))
        nc <- ncol(dat) + 1
        nr <- nrow(dat)
        if (is.null(col.widths)) {
          col.widths <- rep(6.5/nc, nc)
        }
        ret <- paste(ret, .add.merged.table.row(c(" ", paste("\\b ",
                                                             varnames[2], " \\b0", sep = ""), rep(" ", nc -
                                                                                                    2)), col.widths, font.size = font.size, indent = indent,
                                                border.top = TRUE), sep = "")
        ret <- paste(ret, .add.table.row(c(paste("\\b ",
                                                 varnames[1], " \\b0", sep = ""), colnames(dat)),
                                         col.widths, col.justify, font.size = font.size,
                                         indent = indent, border.bottom = TRUE), sep = "")
        if (nrow(dat) > 1) {
          for (i in 1:(nrow(dat) - 1)) {
            rn <- rownames(dat)[i]
            ret <- paste(ret, .add.table.row(c(rn, as.character(dat[i,
                                                                    ])), col.widths, col.justify, font.size = font.size,
                                             indent = indent, space.before = space.before,
                                             space.after = space.after), sep = "")
          }
        }
        rn <- rownames(dat)[nrow(dat)]
        ret <- paste(ret, .add.table.row(c(rn, as.character(dat[nrow(dat),
                                                                ])), col.widths, col.justify, font.size = font.size,
                                         indent = indent, border.bottom = TRUE, space.before = space.before,
                                         space.after = space.after), sep = "")
      }
      else {
        stop("Table dimensions can't be written")
      }
    }
    else if ("xtab" %in% class(dat)) {
      nc <- ncol(dat$counts) + 2
      nr <- nrow(dat$counts)
      if (is.null(col.widths)) {
        col.widths <- rep(6.5/nc, nc)
      }
      ret <- paste(ret, .add.merged.table.row(c(" ", paste("\\b ",
                                                           dat$varnames[2], " \\b0", sep = ""), rep(" ", nc -
                                                                                                      2)), col.widths, font.size = font.size, indent = indent,
                                              border.top = TRUE), sep = "")
      ret <- paste(ret, .add.table.row(c(paste("\\b ", dat$varnames[1],
                                               " \\b0", sep = ""), colnames(dat$counts), "Total"),
                                       col.widths, col.justify, font.size = font.size, indent = indent,
                                       border.bottom = TRUE), sep = "")
      grand.total <- sum(dat$col.margin)
      if (nrow(dat$counts) > 1) {
        for (i in 1:(nrow(dat$counts))) {
          rn <- rownames(dat$counts)[i]
          ret <- paste(ret, .add.table.row(c(rn, as.character(dat$counts[i,
                                                                         ]), paste(dat$row.margin[i], " (", sprintf("%0.1f",
                                                                                                                    dat$row.margin[i]/grand.total * 100), "%)",
                                                                                   sep = "")), col.widths, col.justify, font.size = font.size,
                                           indent = indent, space.before = space.before,
                                           space.after = space.after), sep = "")
          ret <- paste(ret, .add.table.row(c(" ", paste("(",
                                                        sprintf("%0.1f", dat$counts[i, ]/dat$row.margin[i] *
                                                                  100), "% R)", sep = ""), " "), col.widths,
                                           col.justify, font.size = font.size, indent = indent,
                                           space.before = space.before, space.after = space.after),
                       sep = "")
          ret <- paste(ret, .add.table.row(c(" ", paste("(",
                                                        sprintf("%0.1f", dat$counts[i, ]/dat$col.margin *
                                                                  100), "% C)", sep = ""), " "), col.widths,
                                           col.justify, font.size = font.size, indent = indent,
                                           space.before = space.before, space.after = space.after),
                       sep = "")
          ret <- paste(ret, .add.table.row(rep(" ", nc),
                                           col.widths, col.justify, font.size = font.size,
                                           indent = indent, space.before = space.before,
                                           space.after = space.after), sep = "")
        }
      }
      ret <- paste(ret, .add.table.row(c("Total", paste(as.character(dat$col.margin),
                                                        paste(" (", sprintf("%0.1f", dat$col.margin/grand.total *
                                                                              100), "%)", sep = "")), as.character(grand.total)),
                                       col.widths, font.size = font.size, last.row = TRUE,
                                       indent = indent, space.before = space.before, space.after = space.after),
                   sep = "")
    }
    else if ("matrix" %in% class(dat) & !is.null(attributes(dat)$"start cell")) {
      start.row <- attributes(dat)$"start cell"[1]
      dat <- as.data.frame(dat, stringsAsFactors = FALSE)
      if (is.null(col.widths) & !is.null(max.table.width)) {
        col.widths <- .optimize.col.widths(dat, include.row.names = row.names,
                                           max.table.width = max.table.width, font.size = font.size)
      }
      nc <- ncol(dat)
      if (is.null(col.widths)) {
        col.widths <- rep(6.5/nc, nc)
      }
      if (nrow(dat) > 1) {
        for (i in 1:(nrow(dat) - 1)) {
          if (i < start.row) {
            border.top = FALSE
            border.bottom = FALSE
            if (i == 1) {
              border.top = TRUE
            }
            if (i == (start.row - 1)) {
              border.bottom = TRUE
            }
            ret <- paste(ret, .add.table.row(paste("\\b ",
                                                   as.character(dat[i, ]), " \\b0", sep = ""),
                                             col.widths, col.justify, font.size = font.size,
                                             indent = indent, border.top = border.top,
                                             border.bottom = border.bottom, space.before = space.before,
                                             space.after = space.after), sep = "")
          }
          else {
            ret <- paste(ret, .add.table.row(as.character(dat[i,
                                                              ]), col.widths, col.justify, font.size = font.size,
                                             indent = indent, space.before = space.before,
                                             space.after = space.after), sep = "")
          }
        }
        ret <- paste(ret, .add.table.row(as.character(dat[nrow(dat),
                                                          ]), col.widths, col.justify, font.size = font.size,
                                         last.row = TRUE, indent = indent, space.before = space.before,
                                         space.after = space.after), sep = "")
      }
    }
    else if ("data.frame" %in% class(dat) || "matrix" %in% class(dat)) {
      if ("matrix" %in% class(dat)) {
        dat <- as.data.frame(dat)
      }
      rnames <- rownames(dat)
      is.na(dat) <- is.na(dat)
      dat <- data.frame(lapply(dat, as.character), stringsAsFactors = FALSE,
                        check.names = FALSE)
      dat[is.na(dat)] <- NA.string
      dat[dat == "NA"] <- NA.string
      rownames(dat) <- rnames
      if (is.null(col.widths) & !is.null(max.table.width)) {
        col.widths <- .optimize.col.widths(dat, include.row.names = row.names,
                                           max.table.width = max.table.width, font.size = font.size)
      }
      nc <- ncol(dat)
      if (row.names == TRUE) {
        nc <- nc + 1
      }
      if (is.null(col.widths)) {
        col.widths <- rep(6.5/nc, nc)
      }
      if (row.names == TRUE) {
        ret <- paste(ret, .add.table.header.row(c(" ", colnames(dat)),
                                                col.widths, header.col.justify, font.size = font.size,
                                                repeat.header = TRUE, indent = indent), sep = "")
      }
      else {
        ret <- paste(ret, .add.table.header.row(colnames(dat),
                                                col.widths, header.col.justify, font.size = font.size,
                                                repeat.header = TRUE, indent = indent), sep = "")
      }
      if (nrow(dat) > 1) {
        for (i in 1:(nrow(dat) - 1)) {
          if (row.names == TRUE) {
            rn <- rownames(dat)[i]
            ret <- paste(ret, .add.table.row(c(rn, as.character(dat[i,
                                                                    ])), col.widths, col.justify, font.size = font.size,
                                             indent = indent, space.before = space.before,
                                             space.after = space.after), sep = "")
          }
          else {
            ret <- paste(ret, .add.table.row(as.character(dat[i,
                                                              ]), col.widths, col.justify, font.size = font.size,
                                             indent = indent, space.before = space.before,
                                             space.after = space.after), sep = "")
          }
        }
      }
      if (row.names == TRUE) {
        rn <- rownames(dat)[nrow(dat)]
        ret <- paste(ret, .add.table.row(c(rn, as.character(dat[nrow(dat),
                                                                ])), col.widths, col.justify, font.size = font.size,
                                         last.row = TRUE, indent = indent, space.before = space.before,
                                         space.after = space.after), sep = "")
      }
      else {
        ret <- paste(ret, .add.table.row(as.character(dat[nrow(dat),
                                                          ]), col.widths, col.justify, font.size = font.size,
                                         last.row = TRUE, indent = indent, space.before = space.before,
                                         space.after = space.after), sep = "")
      }
    }
    else {
      warning("No suitable RTF converter for object class!")
    }
    ret <- paste(ret, "}\n\n", sep = "")
    ret
  }
 
  .add.table.row <- function (col.data = c("c1", "c2", "c3"), col.widths = c(1, 4.5,
                                                                             1), col.justify = NULL, font.size = 10, last.row = FALSE,
                              indent = 0, border.top = FALSE, border.bottom = FALSE, space.before = NULL,
                              space.after = NULL)
  {
    header <- paste("\\trowd\\trgaph100\\trleft", indent, sep = "")
    if (length(col.data) != length(col.widths)) {
      stop(paste("The number of data columns (", length(col.data),
                 ") doesn't match the column widths (", length(col.widths),
                 ")!  Input data: ", col.data, sep = ""))
    }
    justify <- vector()
    justify["L"] <- "\\ql"
    justify["R"] <- "\\qr"
    justify["C"] <- "\\qc"
    justify["J"] <- "\\qj"
    justify.v <- rep(justify["L"], length(col.data))
    numeric.cols <- which(!is.na(suppressWarnings(as.numeric(col.data))))
    if (length(numeric.cols) > 0) {
      justify.v[numeric.cols] <- justify["R"]
    }
    if (!is.null(col.justify)) {
      if (length(col.justify) == 1) {
        if (col.justify %in% names(justify)) {
          justify.v <- rep(justify[col.justify], length(col.data))
        }
        else {
          stop(paste("col.justify parameter not recognized: ",
                     col.justify, " (should be L, R, C, or J)",
                     sep = ""))
        }
      }
      else if (length(col.justify) == length(col.data)) {
        justify.v <- justify[col.justify]
      }
      else {
        stop(paste("The number of data columns (", length(col.data),
                   ") doesn't match the col.justify (", length(col.justify),
                   ") parameter!  Input data: ", paste(col.data,
                                                       sep = "", collapse = ", "), sep = ""))
      }
    }
    btop <- ""
    bbottom <- ""
    if (any(border.top))  # MZM
      btop <- sapply(border.top, ifelse, "\\clbrdrt\\brdrs\\brdrw15",'') #MZM: make border.top as a vector option
    if (last.row == TRUE | any(border.bottom))  #MZM
      bbottom <- sapply(border.bottom, ifelse, "\\clbrdrb\\brdrs\\brdrw15",'') #MZM: make border.bottom as a vector option
    cols.prefix <- paste("\\clvertalt\\clshdrawnil\\clwWidth",
                         round(col.widths * 1440, 0), "\\clftsWidth3\\clheight260\\clpadl100\\clpadr100\\gaph",
                         btop, bbottom, "\\cellx", c(1:length(col.widths)), "\n",
                         sep = "", collapse = "")
    cols <- paste("\\pard", justify.v, .get.space.before.after(space.before,
                                                               space.after), "\\widctlpar\\intbl\\fi0\\f2\\fs", font.size *
                    2, " ", .convert(col.data), "\\cell\n", sep = "", collapse = "")
    end.row <- "\\widctlpar\\intbl\\row\n"
    paste(header, cols.prefix, cols, end.row, sep = "")
  }
 

  # add width basing on duplication
  adj.width <- function(x, cw, space=1){
    ret <- array(0, dim=dim(x))
    x2 <- x
    dup <- t(apply(x,1, function(x) c(FALSE, unlist(x[-1])==unlist(x[-length(x)]))))
    for (i in 1:nrow(x)) {
      for (j in ncol(x):1) {
        if (i > 1 & j <= ncol(x)) if (!dup[i-1,j]) dup[i,j] <- FALSE
        if (dup[i,j]) {
          ret[i,j-1] <- ret[i,j]+space*cw[j]
          ret[i,j  ] <-         -space*cw[j]
          x2[i,j] <- ''
        }
      }
      ret[i,] <- ret[i,]+cw
    }
    list(x=x2, cw=ret)
  }#end

}#end mist functions


if (TRUE) {
  #-----------------------------------------------------------------------------------------------
  #
  ###--- These functions are used for formatting dataframe, before produce it to RTF file
  #
  #-----------------------------------------------------------------------------------------------
  # cat the expression and its result.
  cat.exp <- function(x, start='\n----', sep2=ifelse(Print, '\n', ': '), end='\n',
                      Print=is.na(match(class(eval(x)), c('integer', 'numeric', 'character')))) {
    cat(start, deparse(substitute(x)), sep2)
    if (!Print) cat(eval(x),end) else print(eval(x))
  }#end
  
  
  # Function to add blank line between item (record) from table output.
  add.blank.line.between <- function(dat, index_blank) {
    #--- adding blank lines between subjects
    dat2 <- NULL
    for(k in 1:length(index_blank)) {
      if(k==1) {
        if(index_blank[k]==index_blank[k+1]-1) {
          tmp <- rbind(dat[1:index_blank[k], ], "")
        } else {
          tmp <- rbind(dat[(index_blank[k]:(index_blank[k+1]-1)), ], "")
        }
      } else if(k==length(index_blank)) {
        tmp <- rbind(dat[(index_blank[k]:nrow(dat)), ], "")
      } else {
        tmp <- rbind(dat[(index_blank[k]:(index_blank[k+1]-1)), ], "")
      }
      if(is.null(dat2)) dat2 <- tmp else dat2 <- rbind(dat2, tmp)
    }
    dat_with_blank <- dat2
    
    return(dat_with_blank)
  }#end
  
  add_blank_line <- function(dat, index_blank) {
    #--- adding blank lines into data
    dat2 <- NULL
    for(k in 1:length(index_blank)) {
      if(k==1) {
        tmp <- rbind(dat[1:index_blank[k], ], "")
      } else {
        tmp <- rbind(dat[(index_blank[k-1]+1):index_blank[k], ], "")
      } 
      
      if(is.null(dat2)) dat2 <- tmp else dat2 <- rbind(dat2, tmp)
    }
    dat_with_blank <- rbind(dat2, dat[(index_blank[k]+1):nrow(dat), ])  # add the last part
    
    return(dat_with_blank)
  }#end
  
  # format numbers before outputing
  format.num <- function(x, num.sigf=2, width=1, num.space=1, trun=FALSE) {
    num <- formatC(format(round(x, num.sigf), nsmall=num.sigf), 
                   width=width, flag=paste(rep("", num.space), collapse=" "))
    if(trun==TRUE) {
      num <- gsub(" ", "", num)
    }
    return(num)
  }#end format_num
  
  
  sep.space <- function(n) {
    paste(rep(" ", times=n), collapse="")
  }#end
  
  
  #--- exclude col with all NA value
  ex.col <- function(dat, excluded=c(NA, "")) {
    for(i in colnames(dat))
      if(all(dat[,i] %in% excluded)) {
        print(i)
        dat <- dat[,-which(names(dat) %in% i)]
      }
    dat
  }
  
  
  #--- excluded row with all NA value
  ex.row <- function(dat, na.str=c(NA, "NA", "", " ", ".")) {
    ex.r <- NULL
    for(i in 1:nrow(dat)) {
      x <- dat[i,]
      if(all(x %in% na.str))
        ex.r <- c(ex.r, i)
    }
    if(!is.null(ex.r))
      ret <- dat[-ex.r,] else
        ret <- dat
      return(ret)
  }#end
  
  
  #--- function to make the 1st letter of a word to uppercase
  simpleCap <- function(x) {
    x2 <- tolower(x)
    gsub("(^|[[:space:]])([[:alpha:]])", "\\1\\U\\2", x2, perl=TRUE)
  }#end
  
  
  # reorder levels 
  level.order <- function(x, index=c(1,2,3)) {
    y <- factor(x)
    levels(y) <- index
    y <- as.numeric(as.character(y))
    return(y)
  }#end
  
  
  # remove duplcate. For example, a ID has multiple rows, just displaying
  # the ID in the 1st row, the rest is empty
  removed.dup <- function(dat, dupBy=NULL, varName=NULL) {
    id.dup <- which(duplicated(dat[,dupBy]))
    dat[id.dup, varName] <- ""
    return(dat)
  }#end
  
  
  #--- function to replace value
  replace.val <- function(x, replaceVal=NA, byVal=NULL) {
    id <- which(x %in% replaceVal)
    x[id] <- byVal
    x
  }#end replace_val
  
  
  # some cases needed to convert NA to zero
  convert.NA.to.zero <- function(dat) {
    check.NA <- function(x, width=2) {
      if(any(is.na(x)))
        x[x%in%NA] <- format(0, justify='right', width=width)
      x
    }
    
    tmp <- apply(dat, 2, check_NA)
    ret <- data.frame(tmp)
    return(ret)
  }#end
  
  
  # Function to Generate rtf table column widths
  col.width <- function(tb){  
    cws <- NULL
    for(i in 1:length(names(tb))) {
      ncName <- nchar(names(tb)[i])
      ncString <- max(nchar(tb[,i]))
      nc <- max(ncName, ncString)
      cw <- nc*0.89/10                 # assume 10 characters per an inch
      cws <- c(cws, cw)
    }
    return(cws)
  }#end
  
  
  # Fill missing/blank as NA
  fill.missing <- function(x) {
    x2 <- x
    if(any(x2 %in% c(NA, "", ".", " "))) {
      x2[which(x2 %in% c(NA, "", ".", " "))] <- NA
    }
    # make sure class of x would be the same as its original class
    class(x2) <- class(x)
    return(x2)
  }#end
  
  
  # make two data have the same class()
  # apply for original and derived data
  class.data <- function(dat1, dat2) {
    # dat1: original
    # dat2: derived
    if(ncol(dat1) != ncol(dat2))
      stop
    for(i in 1:ncol(dat1)) {
      class(dat2[,i]) <- class(dat1[,i])
    }
    return(dat2)
  }#end
  
  # function to map Lilly color with chart R color
  color.code <- function(str.color) {
    colz <- NULL
    for(i in 1:length(str.color)) {
      colz[i] <- str.color[i]
      if(str.color[i] %in% "red")     {colz[i] <- '#D52B1E'} 
      if(str.color[i] %in% "blue")    {colz[i] <- '#00A1DE'}  
      if(str.color[i] %in% "darkblue")    {colz[i] <- '#263F6A'} 
      if(str.color[i] %in% "green")   {colz[i] <- '#00AF3F'}  
      if(str.color[i] %in% "lightgreen")  {colz[i] <- '#C2EDCE'}
      if(str.color[i] %in% "darkgreen")   {colz[i] <- '#275E37'}
      if(str.color[i] %in% "yellow")  {colz[i] <- '#FED100'}
      if(str.color[i] %in% "orange")  {colz[i] <- '#FF6D22'}
      if(str.color[i] %in% c('grey', 'gray'))           {colz[i] <- '#A59D95'}
      if(str.color[i] %in% c('lightgrey', 'lightgray')) {colz[i] <- '#D5D2CA'}
      if(str.color[i] %in% c('darkgrey', 'darkgray')) {colz[i] <- '#82786F'}
      if(str.color[i] %in% "brown")    {colz[i] <- '#4E2E2D'}
      
    }#end
    return(colz)
  }#end
  
  stat_summary <- function(xval, quantile=FALSE) {  
    # xval: a numeric vector
    summ <- summary(xval)
    SD <- sd(xval, na.rm=T) 
    if(quantile) {
      result <- c(summ[names(summ)%in%'Mean'], 
                  SD, 
                  summ[names(summ)%in%'1st Qu.'],
                  summ[names(summ)%in%'Median'], 
                  summ[names(summ)%in%'3rd Qu.'],
                  summ[names(summ)%in%'Min.'], 
                  summ[names(summ)%in%'Max.'])
    } else {
      result <- c(summ[names(summ)%in%'Mean'], 
                  SD, 
                  summ[names(summ)%in%'Median'], 
                  summ[names(summ)%in%'Min.'], 
                  summ[names(summ)%in%'Max.'])
    }
    return(result)
  }#end stat_summary
  
}#end

#------------------------------------------------------------------------------------------------

if(TRUE){#header
  #*****************************************************************************
  #CODE NAME (required)                : nzi_source.r
  #PROJECT NAME (required)             : Near-Zero-Informed Bayesian (NZIB)
  #PLATFORM                            : x86_64-w64-mingw32 
  #SOFTWARE/VERSION# (required)        : R Version 4.2.1 (2022-06-23)
  #INFRASTRUCTURE                      : R studio server
  #-----------------------------------------------------------------------------
  #     #Author                 Code History Description             Date Change
  #---- ------------       ---------------------------------------  ---------
  #1.0  Danni Yu                Last Revision                        06/30/2022
  #*****************************************************************************
}
# rm(list=ls())

#program name, track_info
if(TRUE){
  progfile<-'nzi_source.r'
}

#source functions for NZI Bayesian
if(TRUE){
  library(ggplot2)
  library(gridExtra)
  library(ggrepel)
  library(extraDistr)
  library(cowplot)
  library(dplyr)
  library(scales)
  library(ggthemes)
  
  
  #----------------------------------------------------------------------------#
  #### given percentile return number of events under beta binomail #####
  qbbinom<-function(n=10, a1=2, b1=3, pcnt=c(0.025, 0.975)){
    qq<-NULL
    Xs<-0:n
    for(pc in pcnt){
      all.p<-extraDistr::pbbinom(Xs, n, a1, b1)
      wh0<-which(all.p<=pc)
      if(length(wh0)>0){qq<-c(qq, Xs[max(wh0)])}else{qq<-c(qq, 0)}
    }
    names(qq)<-pcnt
    return(qq)
  }
  
  
  #----------------------------------------------------------------------------#
  #### Recommend the maximum P_a is at least ... #####
  recPa <- function(n, dp=6){
    if(is.null(n)){return("0.2")}
    if(is.character(n)){n<-round(as.numeric(n))}
    if(is.na(n)){return("0.2")}
    rp<-1/n
    for(i in 2:dp){
      rPa<-round(rp, i)
      if(rPa>0) break
    }
    if(i==dp & rPa==0){
      rPa<-as.numeric(paste0('0.',paste(rep(0,dp-1), collapse=''),'1'))
    }
    rPa<-min(rPa,1)
    return(rPa)
  }
  
  
  #----------------------------------------------------------------------------#
  #### compute CI (Wilson method) for p in binomial distribution ####
  binomCI <-function(y, n, alpha=.05){ #event, sample size, significance level
    phat<-y/n
    z<-qnorm(p=1-alpha/2, lower.tail=TRUE)
    tm0 <- (phat+z^2/(2*n))/(1+z^2/n)
    tm2 <- z*sqrt(phat*(1-phat)/n + z^2/(4*n^2)) / ((1+z^2/n))
    pL <- max(tm0 - tm2, 0)
    pH <- min(tm0 + tm2, 1)
    return(c(pL, pH))
  } #  binomCI(1, 20)
  
  
  #----------------------------------------------------------------------------#
  #~~~ check and plot NZI Beta distribution
  fbet<-function(bet, B=5000, p0=0.01, alp=NULL, xlim1=c(0,0.1),
                 ylim1=NULL, is.plot=F, ... ){
    if(is.null(alp)){
      alp<-2; tm.p<-min(0.05, p0); bet<-2*(0.1-tm.p)/tm.p+1;
    }
    ss<-rbeta(B, shape1=alp, shape2=bet) 
    if(is.plot){
      hist(ss, freq=F, ylim=ylim1, 
           xlim=xlim1, 
           main=paste0('p=', p0, ', beta=', bet), ...)
    }
    print(c(mean(ss), alp/(alp+bet)))
    oo<-density(ss, from=0, to=1)
    oo$y[oo$y<=0]<-min(oo$y[oo$y>0])
    return(oo)
  }
  
  #~~~ function to generate density values from the prior Beta distribution
  s.dbeta<-function(p,a,b){
    d<-dbeta(p,a,b)
    return(d)
  }
  
  #~~~ function to generate density values from the beta binomial distribution
  s.dbb<-function(x, n, a,b){
    d<- extraDistr::dbbinom(x, n, a, b)
    return(d)
  }
  
  #~~~ function to generate beta-binomial upper tail probability P[X>=x]
  #=== prior predictive
  s.pbb<-function(x, n, a,b){
    pp<- extraDistr::pbbinom(x, n, a, b, FALSE) +
      extraDistr::dbbinom(x, n, a, b)
    return(pp)
  }

  #~~~ function to generate posterior (Beta) upper tail probability
  s.pb<-function(x,n,a,b, q.p, lowt=T){
    pb<-pbeta(q.p, a+x, b+n-x, lower.tail=lowt)
    return(pb)
  }
  
  #~~~ convert string to vector
  c2v<-function(xx){
    if(is.character(xx)){xx<-eval(parse(text=paste0('c(',xx,')')))}
    return(xx)
  }
  
  #----------------------------------------------------------------------------#
  #### Re-set the structure for table output #####
  laytab<-function(ttb, ttb.th=0.99){
    colnames(ttb) <- paste0('n=', 1:ncol(ttb)-1)#NULL
    rownames(ttb) <- c("Number of Events",  #x
                       "Event Rate",        #orr
                       "Posterior Prob(Po.LT)",       #csr or po.lt
                       "FPR (PrP.UT)",      #prob.fp or prp.ut 
                       "FNR (PoP.LT)",     #prob.fn or pop.lt
                       "phat", 
                       "phat low", 
                       "phat high" )
    if(all(!is.na(ttb[3,]))){
      return( ttb[,(ttb[3,]<=ttb.th)] )
    }else{return(ttb) }
  }
  
  
  #----------------------------------------------------------------------------#
  ### count number of decimals ###
  ndecim <- function(x) {
    ndec0<-0
    if (!is.na(x) && (x %% 1) != 0) {
      tnm<-as.character(x)
      if(grepl('.', tnm, fixed=TRUE)){
        ndec0<-nchar(strsplit(tnm, ".", fixed=TRUE)[[1]][[2]])
      }else if(grepl('-', tnm, fixed=TRUE)) {
        ndec0<-as.numeric(strsplit(tnm, "-", fixed=TRUE)[[1]][[2]])
      }
    } 
    return(ndec0)
  }
  
  
  #----------------------------------------------------------------------------#
  # Bayesian approach for estimation and probabilities 
  nzi_Bayes_sim<-function(
    N=45,              #sample size
    pa=0.02,           #a maximally acceptable rate
    bet=NULL, a1=NULL, #the parameters in the prior Beta distribution
    ndec=3             #number of decimals
  ){
    #set up prior values
    if(is.null(pa) & (is.null(a1)|is.null(bet))){return(NULL)}
    if(!is.null(pa) & (is.null(a1)|is.null(bet))){ #if choose NZIB
      a1<-pa^2/(1-pa^2); 
      #a1<-pa/(1-pa); 
      bet<-1
    }else if(!is.null(a1) & is.null(pa) & !is.null(bet)){
      pa<-sqrt(a1/(a1+bet))
    }
    
    #list for all numbers of events
    if(!is.null(pa)){
      tab <- sapply(0:N, function(x, n=N){
        #--- occurrence rate
        orr <- round(x/n, ndec) 
        #--- critical success factor: posterior lower tail probabilities (beta) 
        po.lt <- round(pbeta(pa, a1+x, bet+n-x), ndec) #csf
        #--- Bayesian prior predictive upper tail probability (beta binomial)
        prp.ut<-round(s.pbb(x,n,a1,bet), ndec) #prob.fp
        #--- Bayesian posterior predictive lower tail probability 
        pop.lt<-1-round(s.pbb(x,n,a1+x,bet+n-x), ndec) # prob.fn
        #--- estimate and 95%CI for the occurrence rate
        ph <- (a1+x)/(a1+x+bet+n-x)
        ph.L <- qbeta(0.025, a1+x, bet+n-x)
        ph.H <- qbeta(0.975, a1+x, bet+n-x)
        return(c(x, orr, po.lt, prp.ut, pop.lt, ph, ph.L, ph.H))
      })
      mtt<-laytab(tab, 1.1) 
    }else{mtt<-NULL}
    
    return(laytab=mtt)
  } # nzi_Bayes_sim()
  
  
  #----------------------------------------------------------------------------#
  # Under Binomial model, get estimation and probabilities
  binom_sim<-function( 
    N=45,     #sample size
    p1=NULL,  #a lower referral rate for the null hypothesis
    pa=0.02,   #maximally acceptable rate
    getPlot=FALSE, getPnt=FALSE, getPnt.col='black', getPnt.lty=1, ndec=3,
    out='pp'  #or 'laytab'
  ){
    if(is.null(pa))return(NULL)
    
    #list for all numbers of events
    o<-0:N #number of events
    if(!is.null(p1)){
      tab <- sapply(o, function(x, n=N){
        orr <- round(x/n,ndec)
        csf <- NA
        prob.fp <- round(1-pbinom(x-1, n, pa), ndec)
        if(p1>pa){
          prob.fn <- round(pbinom(x-1, n, p1), ndec) 
        }else{prob.fn<-NA}
        ph <- x/n
        return(c(x, orr, csf, prob.fp, prob.fn, ph))
      })
      pLH <- matrix(unlist(lapply(o, binomCI, n=N, alpha=0.05)), nrow=2)
      mtt<-laytab(rbind(tab, pLH)) 
    }else{mtt<-NULL}
    
    #probability of observing at least #events: P(X>=x)
    if(!is.null(p1) && is.numeric(p1) && p1>pa){
      prob0<-pbinom(o-1, N, pa, lower.tail=F) #P(Y>=y)
      proba<-pbinom(o-1, N, p1, lower.tail=F)
      pp<-rbind(prob0, proba)
      colnames(pp)<-o
      rownames(pp)<-paste0('p=', c(pa, p1))
      if(getPlot){
        plot(prob0~o, type='l', xlim=c(0,9), ylim=c(0,0.6),
             ylab='Chance observing >= #events', 
             xlab='#events')
        points(proba~o, type='l', col=getPnt.col, lty=getPnt.lty)
        legend('topright', bty='n', legend=paste0(c('p1=','pa='), c(p1, pa)),
               lty=c(1,2), col=c('black', 'blue'), text.col=c('black', 'blue'))
      }
    }else{
      proba<-pbinom(o-1, N, pa, lower.tail=F) #P(Y>=y)
      pp<-proba
      names(pp)<-o
      if(getPlot){
        plot(proba~o, type='l',  col='blue', lty=2)
      }
      if(getPnt){
        points(proba~o, type='l',  col='blue', lty=2)
      }
    }
    #to get a normalized value relative to the center of data for model risk
    return(laytab=mtt)
  } # binom_sim(p1=0.01)
  
  
  #----------------------------------------------------------------------------#
  #visualize the prior Beta distribution and the Beta-Binomial distribution
  bbin<-function(
    prior.a="0.5,1", #parameters in p~Beta(a=, b=) prior distribution
    prior.b="0.5,1",  #parameters in p~Beta(a=, b=) prior distribution
    N11=30,           #planned sample size
    pa=0.2,           #expected average for event rate p
    p.xL='',          #xlim for beta distribution
    x.xL='',          #xlim for beta-binomial distribution
    showBinom=F,      #whether show binomial distribution in the plot
    drawPlot=TRUE,    #if F, only return the ggplot object for predictive distb
    valLeg=FALSE      #whether show the original parameter formular or value
  ){
    if(is.character(prior.a)){
      a<-c2v(prior.a); 
      pra<-strsplit(prior.a, ',')[[1]]
    }else{a<-pra<-prior.a}
    if(is.character(prior.b)){
      b<-c2v(prior.b)
      prb<-strsplit(prior.b, ',')[[1]]
    }else{b<-prb<-prior.b}
    if(valLeg){lab.a<-a; lab.b<-b}else{lab.a<-pra; lab.b<-prb}
    print(lab.a)
    if(is.character(p.xL)){xL.p<-c2v(p.xL)}
    if(is.character(x.xL)){xL.x<-c2v(x.xL)}
    if(is.character(pa)){pa<-as.numeric(pa)}
    if(is.character(N11)){N11<-round(as.numeric(N11))}
    if(length(a)!=length(b)){
      num<-min(length(a), length(b))
      a<-a[1:num]; b<-b[1:num];
    }else{num<-length(a)}
    col2<-rep(c('red', 'purple','magenta','pink', 'brown','valet'), each=4)
    col3<-c('black','blue')
    lin2<-rep(3:6,len=length(col2))
    lin3<-1:2
    
    #function to set x-axis limit
    xyL0<-function(pp, xl){
      if(is.numeric(xl) & length(xl)==2) pp<-pp+ xlim(xl)
      return(pp)
    }
    
    #generate prior distribution
    x1<-0:N11  #use exact probability instead of simulations
    u1<-x1/N11
    ppL<-bp2<-list()
    uu2<-seq(0, 1, len=50) #for beta prior density
    
    legLab1<-legLab2<-NULL #used for math expression in legend
    if(num>0){
      for(i in 1:num){
        #get density values
        bp2[[i]]<- data.frame(p=uu2, d=s.dbeta(uu2, a[i],  b[i]),
                             model=paste0('Beta(a=',lab.a[i],', b=',lab.b[i],')'))
        ppL[[i]]<- data.frame(p=u1, x=x1,
                              d=s.dbeta(u1, a[i],  b[i]),
                              dx=s.dbb(x1, N11,a[i], b[i]),
                              px=s.pbb(x1, N11,a[i], b[i]),
                              model=paste0('Beta(a=',lab.a[i],', b=',lab.b[i],')'))
        #add math expression in legend
        legLab1<-c(legLab1, 
                   bquote(paste("Beta(", alpha, "=", .(lab.a[i]),
                                ", ", beta, "=", .(lab.b[i]),')')))
        legLab2<-c(legLab2, 
                   bquote(paste("BetaB(N=", .(N11), ", ", alpha, "=", .(lab.a[i]),
                                ", ", beta, "=", .(lab.b[i]),')')))
      }
      pp <- do.call(rbind, ppL)
      bb <- do.call(rbind, bp2)
    }else{pp<-NULL}
    col1<-rep(col2, len=num) 
    lin1<-rep(lin2, len=num)
    
    #set NZIB label
    model.nzi1<- bquote(paste("Beta(", #alpha, "=", 
                              {.(pa)}^2, #{.(pa)},
                              "/(1-", {.(pa)}^2, #{.(pa)},
                              "), ", #beta, "=",
                              "1",')'))
    model.nzi2<- bquote(paste("BetaB(", .(N11), ", ", #alpha, "=", 
                              {.(pa)}^2, #{.(pa)},
                              "/(1-", {.(pa)}^2, #{.(pa)},
                              "), ", #beta, "=",
                              "1",')'))
    
    #combine 3 model data 
    tit.s<-NULL
    if(is.numeric(pa) && !is.na(pa)){
      nzi.a<-pa^2/(1-pa^2);  #nzi.a<-pa/(1-pa);  
      nzi.b<-1
      nbp2 <- data.frame(p=uu2, d=s.dbeta(uu2, nzi.a,  nzi.b),
                        model=paste0("NZIB Beta pa=", pa))
      tm0<-data.frame(p=u1, x=x1,
                      d=s.dbeta(u1, nzi.a, nzi.b),
                      dx=s.dbb(x1, N11, nzi.a, nzi.b),
                      px=s.pbb(x1, N11, nzi.a, nzi.b),
                      model=paste0("NZIB Beta pa=", pa) )
      pp <- rbind(tm0, pp)
      bb <- rbind(nbp2, bb)
      legLab1<-c(model.nzi1, legLab1)
      legLab2<-c(model.nzi2, 
                 #bquote(paste("NZIB(N=", .(N11),", ", p[a],"=", .(pa), ")")),
                 legLab2)
      col1<-c(col3[1], col1)
      lin1<-c(lin3[1], lin1)
      if(showBinom){
        tm<-data.frame(p=rep(pa,length(x1)), x=x1, 
                       d=rep(1, length(x1)),
                       dx=dbinom(x1, N11, pa),
                       px=1-pbinom(x1-1, N11, pa),
                       model=paste0('Binomial(N=',N11,', p=',pa, ')'))
        pp2<-rbind(pp, tm)
        legLab2<-c(legLab2, 
                   bquote(paste('Binomial(N=',.(N11),', p=', .(pa), ')')))
        col1<-c(col1, col3[2])
        lin1<-c(lin1, lin3[2])
        tit.s<-'or P(Y=y) for Binomial'
      }else{pp2<-pp}
    }else{pp2<-pp}
    
    #generate beta-binomial distribution
    pp2$model[grepl('NZIB', pp2$model, fixed=TRUE)]<-
      paste0("NZIB(N=", N11, ', pa=', pa, ')')
    pp2$model<-gsub('Beta(', paste0('BetaB(N=',N11, ', '), pp2$model, fixed=T)
    pp2$model<-factor(pp2$model, levels=unique(pp2$model))
    #for beta prior distribution
    pp$model<-factor(pp$model, levels=unique(pp$model))
    bb$model<-factor(bb$model, levels=unique(bb$model))
    
    #clean data for predictive distribution
    pp2<-unique(pp2[,c('x','dx', 'px','model')])
    
    #generate distribution plot for prior Beta
    p1<-ggplot(bb, aes(x=p, y=d, group=model,color=model, linetype=model)) + 
      geom_line() + ylab('Density') + 
      theme_bw() + ggtitle('Prior distribution') +
      xlab('p') + 
      scale_color_manual(values=col1, labels=legLab1)+
      scale_linetype_manual(values=lin1, labels=legLab1)
    p1<-xyL0(p1, xL.p)
    
    if(drawPlot){
      #generate distribution plot for Beta-Binomial
      p2<-ggplot(pp2, 
                 aes(x=x, y=dx, group=model, color=model, linetype=model)) + 
        geom_line() + ylab('Density') + theme_bw() + 
        ggtitle('Prior Predictive Distribution', subtitle=tit.s) +
        xlab('y: number of events') + 
        scale_color_manual(values=col1, labels=legLab2)+
        scale_linetype_manual(values=lin1, labels=legLab2)
      p2<-xyL0(p2, xL.x)
      
      p3<-ggplot(pp2, 
                 aes(x=x, y=px, group=model, color=model, linetype=model)) + 
        geom_line() + ylab('Probability') + theme_bw() + 
        ggtitle('Prior Predictive Upper Tail') +
        xlab('n: number of events') + 
        scale_color_manual(values=col1, labels=legLab2)+
        scale_linetype_manual(values=lin1, labels=legLab2)
      p3<-xyL0(p3, xL.x)
      
      grid.arrange(grobs=list(p1, p2), nrow=1, widths=c(1, 1.1))
    }else{
      #generate distribution plot for Beta-Binomial
      p2<-ggplot(pp2, aes(x=x, y=dx, group=model,color=model, linetype=model)) + 
        geom_line() + 
        theme_bw() + ggtitle('Prior Predictive distribution', subtitle=tit.s) +
        scale_color_manual(values=col1, labels=legLab2)+
        scale_linetype_manual(values=lin1, labels=legLab2)
      p2<-xyL0(p2, xL.x) 
      return(list(data=pp2, plot=p2))
    }
  } # bbin()

  
  #----------------------------------------------------------------------------#
  #source functions for operating characteristics and calculate probstop
  if(TRUE){
    ######Generating Toxicity Monitory Rule#####
    #compare to online shiny App with minor revision for small p
    #https://www.trialdesign.org/one-page-shell.html#BTOX
    #rule based on Prob(theta>th0)<stPr
    BayTox <- function(
      betaPrior="1, 1", #Prior distribution "alpha, beta"
      N=10,        #maximum number of subjects
      n0=3,        #minimum number of subjects if early stop by enough ADRs
      th0=0.1,     #maximum ADR rate
      stPr=0.05,   #stopping criterion probability for excessive toxicity
      coh.size=1,  #number of patients in each cohort run
      ruleTp=1,    #stopping rule type: 1=posterior>0.95; 2=priorPred<0.5; 
      #3=binomial p-value
      adj.pv='BH'  #the p-value adjustment method
    ){
      pa<-c("holm", "hochberg", "hommel", "bonferroni", "BH", "BY", "fdr")
      #if adj.pv is NULL, then no adjustment
      
      #check input
      if(!is.null(n0) && !is.null(N) && n0>N-1){n0<-N}
      if(!is.null(n0) && !is.null(N) && n0<1){n0<-1}
      if(is.null(th0)|is.na(th0) | is.null(stPr)|is.na(stPr)){return(NULL)}
      if(n0<2){stop('minimum number of subject n0 must be >1!')}
      
      #If Beta Prior is NULL or '', set it for NZIB
      if(is.null(betaPrior)||gsub(' ', '', betaPrior)==''){
        ab<-c(th0^2/(1-th0^2), 1) ;# ab<-c(th0/(1-th0), 1)
        pltp<-1
      }else{ #get hyper prior parameters
        ab<-as.numeric(unlist(strsplit(betaPrior, split=',', fixed=T)))
        if(length(ab)<2){return(NULL)}
        pltp<-3
      }
      bpr<-paste0("c(alpha=", ab[1], ", beta=", ab[2], ")")
      
      #set label for 1st row in the stopping rule tables
      lb<-max(n0-1, 1, coh.size-1)
      row01<-ifelse(lb>1, paste0('1-', lb), '1')
      row02<-'Not Applicable'
      
      #set a contain for all probabilities
      p0_ij<-matrix(NA, nrow=N, ncol=N)
      
      #set number of patients, number of ADRs
      max.j<- min(n0, coh.size) - 1
      i <- 1      #---i: number of ADR events; j: number of patients---#
      #generate all the probabilities
      while(max.j<=N & i<=N){
        j <- ceiling(i/coh.size)*coh.size
        while(j>=i & j<=N){#fix i, increase j
          if(ruleTp==3){#binomial p-value
            p0_ij[i,j]<- 1-pbinom(i-1, j, th0)
          } else if(ruleTp==2){#prior predictive p-value
            p0_ij[i,j]<- s.pbb(i, j, ab[1], ab[2])
          }else{#posterior probability
            p0_ij[i,j]<- pbeta(th0, ab[1]+i, ab[2]+j-i) 
          }
          j <- j+coh.size
        }
        i <- i + 1
      }
      
      #p-value adjust method
      if(!is.null(adj.pv) && adj.pv%in%pa){
        p_ij<-matrix(p.adjust(p0_ij, method=adj.pv), nrow=N)
      }else{p_ij<-p0_ij}
      
      #set number of patients, number of ADRs
      ns <- ets <- NULL 
      i <- 1      #---i: number of ADR events; j: number of patients---#
      prior.j<-n0
      while(max.j<=N & i<=N){
        j <- ceiling(i/coh.size)*coh.size
        tm.j<- NULL
        #search largest j(=#patients) for smallest p_ij (>stPr)
        while(j>=i  && j<=N && p_ij[i,j]<stPr){
          if(j>max.j){tm.j <- c(tm.j, j)}
          j <- j+coh.size
        }
        tm.j <- tm.j[!is.na(tm.j)&!is.infinite(tm.j) & is.numeric(tm.j)]
        if(length(tm.j)>0){
          max.j <- max(tm.j)
          ns0 <- unique(c(min(min(tm.j),N), min(max.j, N)))
          ns0 <- ns0[ns0>=n0]
          if(length(ns0)>0){
            ets <- c(ets, i)
            if(length(ns0)==1){ns0<-c(prior.j, ns0); prior.j<-NULL}
            ns <- c(ns, paste(unique(ns0), collapse='-'))
          }
        }
        i <- i + 1
      }#get: ns and ets
      
      if(n0>0){
        oT <- data.frame(x=c(row01,ns), y=c(row02, ets))
      }else{
        oT <- data.frame(x=ns, y=ets)
      }
      xx <- unique(oT$x)
      oT.od <- data.frame(od=1:length(xx), x=xx)
      oT <- aggregate(y~x, data=oT, FUN=min)
      oT <- merge(oT.od, oT, by='x', sort=F)[,c('x','y')]
      colnames(oT)<-c('Total Number of Treated Subjects', 
                      'Suspending Accrual if >= Number of Subjects with the ADR')
      print(oT)
      return(oT)
    }
    
    ######Run Operating Characteristics based on BayTox result#####
    BayToxOp<-function(
      #true ADR rates:
      trueProb='0.0000001, 0.001, 0.01,0.02,0.05, 0.1', 
      #get the threshold: 
      th=BayTox(), 
      #percentiles for number of patients:
      spct='0.10, 0.25, 0.5, 0.75, 0.90',
      only.early=FALSE, #if TRUE, return ProbStop as stop prob before reaching N
      est.n=FALSE #if TURE, return estimated n values at spct percentiles
    ){
      th2x<-th2y<-NULL
      for(i in 1:nrow(th)){
        n.rg <- unlist(strsplit(th[i,1], split='-'))
        suppressWarnings( n.rg<-unique(as.numeric(n.rg)) )
        suppressWarnings( evt <-as.numeric(th[i,2]) )
        if(is.na(evt)|any(is.na(n.rg))){next}
        if(length(n.rg)>1){
          nn <- min(n.rg): max(n.rg)
        }else if(length(n.rg)==1){
          nn <- n.rg[1]
        }else{nn<-NULL}
        if(!is.null(nn)){
          th2x<-c(th2x, nn) #sample sizes
          th2y<-c(th2y, rep(th[i,2], length(nn))) #number of events
        }   
      }
      #a dataframe with sample sizes and number of events
      th2 <- unique(data.frame(x=as.numeric(th2x), y=as.numeric(th2y)))
      th2 <- th2[!is.na(th2$x)&!is.na(th2$y),]
      th2 <- th2[order(th2$x),]
      
      #sample size percentiles included in results for estimation on n
      n.pct <- unique(unlist(strsplit(spct, split=',', fixed=T)))
      n.header <- gsub('0.', 'n.pct.', as.character(n.pct), fixed=T)
      n.pct <-as.numeric(n.pct)
      n.sel <- !is.na(n.pct)
      n.pct <- n.pct[n.sel]
      n.header <- n.header[n.sel]
      
      #convert true rates into a vector
      tps <- as.numeric(unlist(strsplit(trueProb, split=',', fixed=T)))
      tps <- unique(tps[!is.na(tps)])
      
      #setup operating table
      oT <- data.frame(x=1:length(tps), y=tps)
      if(nrow(th2)==0){
        oT <- cbind(oT, z=0)
        oT[,2]<-format(oT[,2], scientific=F)
        colnames(oT)<-c('Scenario', 'TrueRate', 'ProbStop')
        return(oT)
      }
      z <- ths <- NULL
      nSS <- matrix(NA, nrow=length(tps), ncol=length(n.header)+2)
      nSS.id<-1
      for(tp in tps){
        #prob of stopping at 1st check
        p0 <- pbinom(th2$y[1]-1, th2$x[1], tp, F) #Prob(stop.at.th2$x[1])
        evG <- 0:(th2$y[1]-1) #all numbers of events if not stop at 1st check
        #prob for each number of events at 1st check if not stop
        pG <- dbinom(evG, th2$x[1], tp)
        #prob of not stop at 1st check
        p2 <- sum(pG) #Prob(n>th2$x[1])
        if(nrow(th2)>1){ #start ith check after 1st check
          for(i in 2:nrow(th2)){ 
            evS2 <- th2$y[i]-1 - evG #all numbers of new events at ith check
            #prob for each number of new events at ith check
            pS <- pbinom(evS2, th2$x[i]-th2$x[i-1], tp, F) 
            #update prob of stopping at ith check
            p0 <- c(p0, sum(pG*pS)) #Prob(n=th2$x[i]) stop at th2$x[i]
            if(i<nrow(th2)){
              evG2 <- 0:(th2$y[i]-1) #all numbers if not stop at ith check
              pG2 <- NULL
              #prob for each number of events if not stop at ith~1st checks
              for(k in evG2){
                pG2<-c(pG2, sum(dbinom(k-evG, th2$x[i]-th2$x[i-1], tp)*pG))
              }
              evG <- evG2 #will be used for next iteration
              pG <- pG2
            }
            #update prob of not stop at ith check
            p2 <- c(p2, sum(pG)) #Prob(n>th2$x[i])
          }
        }
        names(p0)<-th2$x #probabilities stopping at the ith checks.
        if(only.early){
          z <- c(z, sum(p0[-length(p0)])) #prob.early.stop before reaching n 
        }else{
          z <- c(z, sum(p0)) #prob.stop before reaching or at n
        }
        #get sample size percentiles
        th2$p.stop<-p0
        th2$p.go<-p2
        th2$n.pct<-1-th2$p.go
        thS <- rbind(ths, th2)
        for(k in 1:length(n.pct)){
          dst <- th2$n.pct-n.pct[k]
          dst2 <- abs(dst)
          #wh2 <- which(dst2<=n.pct.dist)#nearest method
          wh0 <- which(th2$n.pct < n.pct[k]) #step up method
          if(length(wh0)>0){wh0 <-min(max(wh0) +1, nrow(th2))}else{wh0<-1}
          wh3 <- wh0#[wh0%in%wh2]
          if(length(wh3)<1){wh3<- max(which(dst2==min(dst2)))}
          nSS[nSS.id, k] <- th2$x[wh3]
        }
        if(nrow(th2)>1){
          th2$p.stop[nrow(th2)]<-th2$p.go[nrow(th2)-1]
        }
        n.mu<-sum(th2$x*th2$p.stop)
        n.var<- sum( ((th2$x-n.mu)^2)*th2$p.stop )
        nSS[nSS.id, k+1] <-round(n.mu,4) #get the average mean
        nSS[nSS.id, k+2] <-round(sqrt(n.var),4) #get the SD
        nSS.id <- nSS.id+1
      }
      
      oT$z <- round(z,4) #Prob.Early.Stop
      oT <- cbind(oT, nSS)
      oT[,2]<-format(oT[,2], scientific=F)
      colnames(oT)<-c('Scenario', 'TrueRate', 'ProbStop', n.header, 
                      'n.Mean', 'n.SD')
      if(!est.n){oT<-oT[,1:3]}
      return(oT)
    }
    
    ##################################################
    #Check whether a rule is successfully created
    IsRuleSet<-function(md=mods[i], hh=hh1, th.hh=th2){
      if(nrow(hh)==1 & hh[1,2]=="Not Applicable"){
        print(su1<-paste(md, 'fails to create stopping rule for', th.hh))
        return(list(is.fail=TRUE, subtitle=su1))
      }else{return(list(is.fail=FALSE))}
    }
    
    ##################################################
    #generate 1 set of operating characteristics
    # OC1 <- function(ab='0.5,0.5', NN1=NN, th1=th2, tp1=tp ) {
    #   modc<-rep(c(paste0(ab) ), each=2)
    #   mods<-paste0('Bayesian ', NN1, ",", modc)
    #   mod0<-rep(paste0('NZIB(',NN1, ', ', th1,')'), each=2)
    #   modLv<-paste(c(mods,mod0), c('by Po.LT', 'by PrP.UT'))
    #   nLv<-length(modLv)
    #   sz <- (1:nLv)*1.1/nLv
    #   subtt<-NULL #used for subtitle
    #   
    #   btL<-list(); id<-1;
    #   for(i in 1:length(modc)){
    #     if((i%%2)==1){rtp<-1}else{rtp<-2}
    #     hh1<- BayTox(betaPrior=modc[i], N=NN1, th0=th1, ruleTp=rtp)
    #     irs1<-IsRuleSet(md=modLv[i], hh=hh1, th.hh=th1)
    #     if(irs1$is.fail){subtt<-c(subtt, irs1$subtitle)}else{
    #       btL[[i]]<-data.frame(model=modLv[i], BayToxOp(th=hh1,trueProb=tp1) )
    #     }
    #   }
    #   for(j in 1:2){
    #     hh01<-BayTox(betaPrior="", N=NN1, th0=th1, ruleTp=j) 
    #     irs01<-IsRuleSet(md=modLv[i+j], hh=hh01, th.hh=th2)
    #     if(irs01$is.fail){subtt<-c(subtt, irs01$subtitle)}else{
    #       btL[[i+j]]<-data.frame(model=modLv[i+j], BayToxOp(th=hh01,trueProb=tp1) )
    #     }
    #   }
    #   
    #   #integrate datasets
    #   intd<-rbind( bind_rows(btL))
    #   intd$N<-NN1; intd$pa<-th1;
    #   intd$model<-factor(intd$model, levels=modLv)
    #   intd$TrueRate<-as.numeric(intd$TrueRate)
    #   
    #   return(intd)
    # } 
    
  }#end probstop functions
  
  
  #----------------------------------------------------------------------------#
  #---generate probability coverage plot---#
  prob_cov<-function(
    sample_size = c(45),  #number of samples in one trial
    show_freq = 1,        #observed event frequency in a trial
    p_a = c("0.0001"), #max acceptable occurrence rate p
    ab = c(0.5, 0.5),  #the alpha and beta in the other Bayesian model
    a.seq=seq(0.05, 0.95, by=0.01), #sequence of statistic significance levels
    lenLab=5, #number of breaks at Y-axis
    lab=c('NZIB', 'Bayesian', 'Binomial'),
    tt0='Posterior Probability Coverage' #title
  ){
    l.bay<-grepl('baye', tolower(lab))
    l.bin<-tolower(lab)=='binomial'
    if(any(l.bay)){lab[l.bay]<-paste('Bayesian', paste(ab, collapse=','))}
    
    if(is.character(p_a)){p_a<-as.numeric(unlist(strsplit(p_a, split=',')))}
    
    #set vectors
    bb<-nn<-aa<-yy <-pp <-ci<-pL<-pH<- NULL
    for(i in sample_size){
      for(k in show_freq){
        for(m in a.seq){
          for(b0 in lab){
            if(b0=='NZIB'){
              for(j in p_a){
                lb0<-paste(b0, j)
                bb<- c(bb, rep(lb0, 2))
                nn<- c(nn, rep(i, 2))
                yy<- c(yy, rep(k, 2))
                a2t<-c(m/2, 1-m/2)
                aa<- c(aa, a2t[1], a2t[1])
                j<-as.numeric(j)
                #get the posterior prob cov for NZIB
                ptt<-qbeta(a2t, j^2/(1-j^2)+k, 1+i-k)
                # ptt<-qbeta(a2t, j/(1-j)+k, 1+i-k)
                pp<-c(pp, ptt)
                ci<-c(ci, rep((1-m)*100, 2))
                pL<-c(pL, rep(ptt[1], 2))
                pH<-c(pH, rep(ptt[2], 2))
              }
            }else{
              bb<- c(bb, rep(b0, 2))
              nn<- c(nn, rep(i, 2))
              yy<- c(yy, rep(k, 2))
              a2t<-c(m/2, 1-m/2)
              aa<- c(aa, a2t[1], a2t[1])
              j<-as.numeric(j)
              if(b0=='Binomial'){ ptt<-binomCI(k, i, m)
              }else{ptt<-qbeta(a2t, ab[1]+k, ab[2]+i-k) }
              #get the prob cov for Bay or Binomial
              pp<-c(pp, ptt)
              ci<-c(ci, rep((1-m)*100, 2))
              pL<-c(pL, rep(ptt[1], 2))
              pH<-c(pH, rep(ptt[2], 2))
            }
          }
        }
      }
    }
    lev<-c(paste(lab[1], p_a), lab[-1])
    pcd<-unique(data.frame(lab=bb, n=nn, alpha=aa, y=yy, phat=pp, ci=ci))
    pcd$lab<-factor(pcd$lab, levels=lev)
    pcd <- pcd[order(pcd$y, pcd$phat),]
    pcd <- pcd[order(pcd$lab, pcd$n),]
    pcd2<-unique(data.frame(lab=bb, n=nn, alpha=aa, y=yy, ci=ci, pL=pL, pH=pH))
    if(TRUE){
      col1 <- c(rep("black", length(p_a)), 
                ifelse(any(l.bay), 'red', NA),
                ifelse(any(l.bin), 'blue', NA))
      col1 <- col1[!is.na(col1)]
      #get Y-labels
      a0<-sort(unique(pcd$alpha))
      len.a<-length(a0)
      a.rg<-a0[seq(1, len.a, len=min(lenLab, len.a))]
      u.a <- unique(pcd[,c('alpha', 'ci')])
      u.a <- u.a[u.a$alpha%in%a.rg, ]
      a.lb<-paste0(round(u.a$ci), '% CI')
      names(a.lb)<-as.character(u.a$alpha)
      #generate the data to show the plot
      pcd$Y<-paste0('y=', pcd$y)
      pcd$n<-paste0('N=', pcd$n)
      p0<-ggplot(data=pcd, 
                 aes(x=phat, y=alpha, color=lab, linetype=lab, fill=lab)) + 
        geom_ribbon(aes(x=phat, ymax=alpha, fill=lab), 
                    ymin=min(a0), alpha=0.2)+
        geom_line() + theme_bw() + 
        theme(plot.title=element_text(size = 11), 
              legend.position="bottom", legend.key.width=unit(0.008, 'npc') )+
        ggtitle(tt0) + ylab('') + 
        xlab('Estimated Rate') + scale_linetype('') +  
        scale_colour_manual('', values=col1) +
        scale_fill_manual('', values=col1) +
        scale_y_continuous(breaks=u.a$alpha, labels=a.lb)
      if(length(sample_size)>1){
        p0 <- p0 + facet_grid(n~Y, switch='y')
      }else{
        p0 <- p0 + facet_grid(.~Y, switch='y')
      }
    }
    return(list(pcd, pcd2, plot=p0))
  }  # prob_cov()
  
  
  #----------------------------------------------------------------------------#
  #All-in-one function for NIZB analysis
  nzib <- function( stopAt=NULL, #number of ADR for stopping rule
                    N1=45,         #max number of samples
                    maxIDR=0.0051, #max expected acceptable occurrence rate
                    normIDR=NULL,  #normal occurrence rate, default maxIDR/2 
                    plot.type=4,   #1. NZIB; 2. NZIB, Binomial; 
                    #3.NZIB, Bayesian; 4.all 3 lines
                    bay.prior="c(alpha=0.05, beta=0.05)", #hyper parameter in beta-binomial
                    col1=c("black",'red', 'blue'),     #line colors in graph
                    rsk.xlim=NULL,    #x-axis range for risk plot
                    rsk.ylim=NULL,    #y-axis range for risk plot
                    errI.xlim=c(0,5), #x-axis range for type I error plot
                    errI.ylim=NULL,   #y-axis range for type I error plot
                    errII.xlim=NULL,  #x-axis range for type II error plot
                    errII.ylim=NULL,  #y-axis range for type II error plot
                    sup.xlim=NULL,    #x-axis range for superiority plot, default=errI.xlim
                    sup.ylim=NULL,    #y-axis range for superiority plot
                    plot4=FALSE,      #show 4 plots
                    goTh="0.05, 0.2", #go/no-go thresholds for type I and type II errors
                    noplot=F,         #don't create any plot if T
                    showNZIB=TRUE,    #if plot.type!=1, show NZIB or not
                    ajpm = NULL       #method for p-adjust 
  ){
    if(is.null(maxIDR)){maxIDR<-""}
    pdig<-ndecim(as.numeric(maxIDR))
    
    #set prior according to plot type
    if(plot.type%in%c(1,2)){bay.prior<-NULL}
    if(plot.type%in%c(2,4)){showbm<-T}else{showbm<-F}
    
    #clean up parameters
    if(is.null(goTh)){
      goTh<-c(0.05, 0.2)
    }else{
      goTh<-as.numeric(strsplit(as.character(goTh), split=',', fixed=T)[[1]])
    }
    if(length(goTh[!is.na(goTh)])==0){goTh<-c(0.05, 0.2)}
    if(length(goTh[!is.na(goTh)])==1){goTh<-c(goTh, 0.2)}
    if(is.character(N1)){N1<-max(3, round(as.numeric(N1)))}
    if(!is.null(stopAt) & !is.numeric(stopAt)){
      stopAt<-gsub(' ', '', stopAt, fixed=T)
      if(stopAt!=''){
        stopAt<-unlist(strsplit(as.character(stopAt), split=',', fixed=T))
        stopAt<-as.numeric(stopAt)
        stopAt<-stopAt[!is.na(stopAt)]
        if(length(stopAt)>0){
          stopAt<-pmin(pmax(0, round(stopAt)),N1) #lowest bound
        }
      }
    }
    if(is.character(maxIDR)){maxIDR<-max(min(as.numeric(maxIDR),1),0)}
    if(is.character(normIDR)){normIDR<-min(max(as.numeric(normIDR),maxIDR),1)}
    
    bay.prior<-c2v(bay.prior)
    rsk.xlim<-c2v(rsk.xlim)
    rsk.ylim<-c2v(rsk.ylim)
    errI.xlim<-c2v(errI.xlim)
    errI.ylim<-c2v(errI.ylim)
    errII.xlim<-c2v(errII.xlim)
    errII.ylim<-c2v(errII.ylim)
    sup.xlim<-c2v(sup.xlim)
    sup.ylim<-c2v(sup.ylim)
    
    #get stop reference relying number of ADR events
    if(!is.null(stopAt)&is.numeric(stopAt)&length(stopAt)>0){
      sa <- round(stopAt) #require an integer
      saLab<-paste(sort(sa), collapse=',')
    }else{sa<-NULL; saLab<-NULL}
    
    #set default normIDR
    if(is.null(normIDR)){normIDR <- maxIDR}
    
    #get normal expected rate 
    if(plot.type%in%c(1,3)){ tP1<-NULL }else{ tP1<-maxIDR }
    
    #order Bayesian hyper parameters
    bay.prior.nm<-c('alpha','beta')
    if(all(bay.prior.nm%in%names(bay.prior))){
      bay.prior<-bay.prior[bay.prior.nm]
    }
    
    #label the methods
    mNm<-c('NZIB', 'Bayesian', 'Binomial')
    
    #colors
    if(plot.type==2 & length(col1)>2){
      if(!showNZIB){
        lab2<-col1[c(3)]; lin2<-c(3)
      }else{
        lab2<-col1[c(1,3)]; lin2<-c(1,3)
      }
    }else{ lab2<-col1; lin2<-1:3 }
    
    #----get get estimates and probabilities----#
    b.eg<-eb.eg<-nzi.eg<-NULL
    #: classic binomial
    if(plot.type%in%c(2,4)){
      b.eg<-binom_sim(N=N1, p1=normIDR, pa=maxIDR)
    }
    #: Bayesian
    if(plot.type%in%c(3,4)){
      eb.eg<-nzi_Bayes_sim(N=N1,a1=bay.prior[1], bet=bay.prior[2], pa=maxIDR)
    }
    #: NZI Bayesian
    if(plot.type==1 | (showNZIB & plot.type!=1)){
      nzi.eg<-nzi_Bayes_sim(N=N1, pa=maxIDR)
    }
    
    #adjust by plot type
    if(plot.type==4){#show all 3 lines
      eg<-list(nzi.eg, eb.eg, b.eg)
      names(eg)<-mNm
    }else if(plot.type==3){#show lines for NZIB, Bayesian
      eg<-list(nzi.eg, eb.eg)
      names(eg)<-mNm[1:2]
    }else if(plot.type==2){#show lines for NZIB, binomial
      eg<-list(nzi.eg, b.eg)
      names(eg)<-mNm[c(1,3)]
    }else{#show line for NZIB only
      eg<-list(nzi.eg)
      names(eg)<-mNm[1]
    }
    if(!showNZIB & plot.type!=1){ eg<-eg[names(eg)!=mNm[1]] }
    mNM0<-names(eg)
    
    #compare prior predictive and post post predictive
    set.errs<-function(egL=eg){
      numEvts<-fpr<-fnr<-sup<-grp<-phat<-phat.L<-phat.H <-NULL
      for(i in 1:length(egL)){
        numEvts<-c(numEvts, egL[[i]][1,]) 
        fpr<-c(fpr, egL[[i]][4,]) 
        fnr<-c(fnr, egL[[i]][5,])
        sup<-c(sup, egL[[i]][3,])
        grp<-c(grp, rep(names(egL)[i], ncol(egL[[i]])))
        phat<-c(phat, egL[[i]][6,])
        phat.L<-c(phat.L, egL[[i]][7,])
        phat.H<-c(phat.H, egL[[i]][8,])
      }
      ors<- data.frame( numEvts, fpr, fnr, sup, grp, phat, phat.L, phat.H)
      ors$sen<-1-ors$fpr;  
      ors$pwr<-1-ors$fnr
      ors$grp <- factor(ors$grp, levels=names(egL))
      return(ors)
    }
    errs<-set.errs(eg)
    errs.2<-errs[order(errs$grp, errs$numEvts),]
    errs.3<-errs[!is.na(errs$sup),]
    
    #internal functions for adding stopping thresholds into plot
    xyL<-function(pp, xl, yl, ssa, myLabel, leg='yes', 
                  addref=TRUE, anno.pos=0
    ){
      if(is.numeric(xl) & length(xl)==2) pp<-pp+ xlim(xl)
      if(is.numeric(yl) & length(yl)==2) pp<-pp+ ylim(yl)
      if(!is.null(ssa)){
        if(addref){
          pp<-pp+ geom_vline(xintercept=ssa,colour='darkgreen', linetype=2)
        }
        pp<-pp+geom_text_repel( data=myLabel[myLabel$numEvts%in%ssa,],
                                aes(label = mylab), 
                                position=position_dodge(anno.pos),
                                box.padding = unit(0.35, "lines"),
                                point.padding = unit(0.3, "lines"),
                                show.legend = FALSE)
      }
      if(leg=='no'){pp<-pp+theme(legend.position='none')}else{
        pp<-pp+guides(linetype="none")
      }
      return(pp)
    }
    
    #get posterior lower tail-area probability estimation
    #Bayesian
    eb.pst <- eb.eg[grepl("Po.LT", row.names(eb.eg)),]
    #NZIB
    nzi.pst <- nzi.eg[grepl("Po.LT", row.names(nzi.eg)),]
    #integrate posterior results: nzib, bayesian
    getid<-function(n1){if(n1<=0){return(NULL)}else{1:n1}}
    psto<-cbind(nzi.pst, eb.pst)
    psto<-data.frame(observe_number=(1:nrow(psto))-1, psto)
    colnames(psto)[-1]<-paste('posterior prob', mNM0[mNM0!='Binomial'])
    pst<-data.frame(
      numEvts=c(getid(length(eb.pst)), getid(length(nzi.pst))) - 1,
      post=c(eb.pst, nzi.pst),
      grp=c(rep(mNm[2], length(eb.pst)), rep(mNm[1], length(nzi.pst)) ) )
    pst$grp <- factor(pst$grp, levels=mNM0[mNM0!='Binomial'])
    pst$mylab<-as.character(round(pst$post, 3))
    
    #setup label? double check the use case locations
    if(is.na(normIDR)|plot.type%in%c(2,4)){
      p0lab.s<-bquote(paste("P(Y">="y"," | p=", .(normIDR), ") for Binomial" ))
      ppd.y<-bquote(paste("P(Y=y)"))
    }else{
      p0lab.s<- NULL
      #ppd.y<-bquote(paste("P(",tilde(Y),"=y)"))
      ppd.y<-bquote('P('~Y^rep~'=y)')
    }
    
    #1. posterior predictive upper tail probability
    errs.2$mylab<-as.character(round(errs.2$pwr, 3))
    p1<-ggplot(data=errs.2, aes(x=numEvts, y=pwr, color=grp, linetype=grp)) + 
      geom_line() + theme_bw() + theme(plot.title = element_text(size = 11))+
      ggtitle('Posterior Preditive Upper Tail (PoP.UT)') + 
      # ylab(bquote(paste("P(",tilde(Y),"">="y)"))) + 
      ylab(bquote(paste("P(",Y^rep,"">="y|observing y)"))) + 
      xlab('Data: y') + scale_linetype('') + scale_colour_manual('', values=lab2)
    pp.poput<-xyL(pp=p1, xl=errII.xlim, yl=c(0,1), ssa=sa, myLabel=errs.2, 
                  leg='no') 
    
    #2 posterior prob plot
    pp.po <- ggplot(data=pst, aes(x=numEvts, y=post, color=grp, linetype=grp))+
      geom_hline(yintercept=goTh[1], color='tan3') + 
      geom_line() + theme_bw() + theme(plot.title = element_text(size = 11)) +
      ggtitle( bquote(paste("Posterior Lower Tail (Po.LT)")))+ 
      xlab("Data: y") + ylab(bquote(paste("P(p"<="", .(maxIDR), ~"|"~"observing y)"))) +
      scale_linetype('') + scale_colour_manual('', values=lab2) 
    pp.po<-xyL(pp=pp.po, xl=errI.xlim, yl=c(0,1), ssa=sa, 
               myLabel=pst, leg='no')
    
    #3. prior predictive probability
    p0lab<-"Priopr Predictive Upper Tail (PrP.UT)"
    errs.2$mylab<-as.character(round(errs.2$fpr, 3))
    p2<-ggplot(data=errs.2, aes(x=numEvts, y=fpr, color=grp, linetype=grp)) + 
      geom_hline(yintercept=goTh[1], color='tan3') +
      geom_line() + theme_bw() + theme(plot.title = element_text(size = 11))+
      ggtitle(p0lab, subtitle=p0lab.s) + xlab("Data: y") +
      scale_colour_manual('', values=lab2) +
      ylab(bquote(paste("P(Y">="y)")))  
    pp.prput<-xyL(pp=p2, xl=errI.xlim, yl=c(0,1), ssa=sa, myLabel=errs.2,
                  leg='yes')

    #graph
    if(plot4){
      #-------------------set up operating characteristics---------------------# 
      truep<-paste(seq(0.000001, min(1, maxIDR*2.5), len=10), collapse=',')
      mod0<-rep(paste0('NZIB(',N1, ', ', maxIDR,')'), each=2)
      subtt<-NULL #used for subtitle
      btL<-stop_rule<-list(); id<-1;
      if('Bayesian'%in%mNM0){
        modc<-rep( paste(bay.prior, collapse=','), each=2)
        mods<-paste0('BetaB(', N1, ",", modc, ")",  c(' by Po.LT', ' by PrP.UT'))
        for(i.m in 1:length(modc)){ #for Bayesian
          if((i.m%%2)==1){rtp<-1}else{rtp<-2}
          print(goTh) ######
          hh1<- BayTox(betaPrior=modc[i.m], N=N1, th0=maxIDR, ruleTp=rtp, 
                       stPr=goTh[1], adj.pv=ajpm)
          stop_rule<-c(stop_rule, list(data.frame(model=mods[i.m], hh1)))
          irs1<-IsRuleSet(md=mods[i.m], hh=hh1, th.hh=maxIDR)
          if(irs1$is.fail){subtt<-c(subtt, irs1$subtitle)}else{
            btL[[i.m]]<-data.frame(model=mods[i.m], 
                                   BayToxOp(th=hh1,trueProb=truep) )
          }
        }
      }else{mods<-modc<-NULL; i.m <- 0}
      modLv<- c(mods, paste(mod0, c('by Po.LT', 'by PrP.UT')))
      nLv<-length(modLv)
      sz <- (1:nLv)*1.1/nLv
      for(j in 1:2){ #for NZIB
        hh01<-BayTox(betaPrior="", N=N1, th0=maxIDR, ruleTp=j, 
                     stPr=goTh[1], adj.pv=ajpm) 
        stop_rule<-c(stop_rule, list(data.frame(model=modLv[i.m+j], hh01)))
        irs01<-IsRuleSet(md=modLv[i.m+j], hh=hh01, th.hh=maxIDR)
        if(irs01$is.fail){subtt<-c(subtt, irs01$subtitle)}else{
          btL[[i.m+j]]<-data.frame(model=modLv[i.m+j], 
                                   BayToxOp(th=hh01, trueProb=truep) )
        }
      }
      #integrate data set
      atd<-rbind( bind_rows(btL))
      atd$N<-N1; atd$pa<-maxIDR;
      atd$TrueRate<-as.numeric(atd$TrueRate)
      nzlab<-c('NZIB by Po.LT', 'NZIB by PrP.UT')
      atd$model[grepl('NZIB', atd$model)& grepl('Po.LT', atd$model)]<-nzlab[1]
      atd$model[grepl('NZIB', atd$model)&grepl('PrP.UT', atd$model)]<-nzlab[2]
      atd$TrueRate<-as.numeric(atd$TrueRate)
      atd$N<-paste0('N=',atd$N)
      atd$pa<-paste0('pa=',atd$pa)
      u.mod<-unique(atd$model) 
      n.nzib<-sum(grepl('NZIB', u.mod))
      nLv<-length(unique(atd$model))
      a.0<-nrow(unique(atd[,c('N','pa')]))
      a.col<- rep(c(rep('red', nLv-n.nzib), rep('black', n.nzib)), a.0)
      legt<-''
      oc_legp <- c(min(atd$TrueRate) + diff(range(atd$TrueRate))*.1, 1 )
      #####~~~~~graph~~~~####
      pp.oc<-ggplot(atd, size=5, alpha=0.5,
                    aes(x=TrueRate, y=ProbStop, color=model, shape=model,
                        linetype=model, group=model)) + 
        ggtitle('Operating Characteristics') + xlab("True Rate: p") +
        ylab(paste0('P[stop before or at N=', N1, ']')) + 
        geom_point()+ geom_line() + theme_bw() + ylim(c(0,1))+
        theme(legend.justification=c(0,0.9),
              legend.background=element_rect(fill=alpha("yellow", 0)),
              axis.text.x=element_text(angle=90, vjust=0.5, hjust=1),
              panel.grid = element_blank()) +
        scale_color_manual(legt, values=a.col)+
        scale_linetype_manual(legt, values=rep(nLv:1, a.0))+
        scale_shape_manual(legt, values=rep(1:nLv, a.0))+
        annotate("text", x=maxIDR, y=0, label=list('paste(p[a])'), parse=TRUE) +
        geom_hline(yintercept=0.5, color='darkgray') +  
        geom_hline(yintercept=goTh[1], color='tan3') +  
        geom_vline(xintercept=maxIDR, color='gray') +
        theme(legend.position=oc_legp)

      # pp.oc
      
      #----------------------plot for probability coverage----------------------#
      pp.cov<- prob_cov(sample_size=N1, p_a=maxIDR, ab=bay.prior,
                        show_freq=ifelse(is.null(stopAt), 1, stopAt[1]),
                        lab=mNM0)$plot 
      # pp.cov
            
      #----------------------Estimate +/- 95%CI---------------------------#
      #7. plot the estimated values for p vs y #ADR with 95%CI. 
      if( is.numeric(errII.xlim)&length(errII.xlim)==2 ){
        errs.02 <- errs.2[errs.2$numEvts>=min(errII.xlim) & 
                            errs.2$numEvts<=max(errII.xlim),]
      }else{errs.02 <- errs.2}
      Lb0<-round(errs.02[,c('phat','phat.L', 'phat.H')], pdig+2)
      errs.02$mylab<-paste0(Lb0[,1],'(',Lb0[,2], ', ', Lb0[,3], ')')
      p7<-ggplot(data=errs.02, 
                 aes(x=numEvts, y=phat, color=grp, linetype=grp, fill=grp)) + 
        geom_errorbar(aes(ymin=phat.L, ymax=phat.H), 
                      width = 0.3, colour='darkgray',
                      position = position_dodge(0.25)) +
        geom_line( position = position_dodge(0.25)) + 
        theme_bw() + theme(plot.title = element_text(size = 11), 
                           legend.position='bottom')+
        ggtitle("Estimates") + 
        ylab('Posterior 95% CIs') + 
        xlab('Data: y') +
        scale_linetype('') +  
        scale_colour_manual('', values=lab2) +
        scale_fill_manual('', values=lab2) +
        geom_hline(yintercept=maxIDR, linetype='dashed', color='darkgray') +
        geom_text(x=max(errs.02$numEvts, na.rm=T), y=maxIDR, 
                  label=as.character(maxIDR), hjust=0.75, color='darkgray')
      pp.est<-xyL(pp=p7, xl=NULL, yl=NULL, ssa=sa, myLabel=errs.02, 
                  leg='no', addref=FALSE, anno.pos=0.25) 
      
      #----------------------show graphs in layout---------------------------#
      if(!noplot){
        x3loc<-0.3; x4loc <- 0.6
        show(ggdraw() + 
               draw_plot(pp.prput, x=0,     y=.5, width=x3loc, height=.5) + 
               draw_plot(pp.po, x=x3loc, y=.5, width=x4loc-x3loc, height=.5) +
               draw_plot(pp.poput, x=x4loc, y=.5, width=1-x4loc, height=.5) + 
               draw_plot(pp.oc, x=0,     y=0,  width=x3loc, height=.5) + 
               draw_plot(pp.cov, x=x3loc, y=0,  width=x4loc-x3loc, height=.5) + 
               draw_plot(pp.est, x=x4loc, y=0,  width=1-x4loc, height=.5) + 
               draw_plot_label(c('A','B', 'C', 'D', 'E', 'F'), 
                               x=c(0, x3loc+0.01, x4loc+0.01, 0, 
                                   x3loc+0.01, x4loc+0.01), 
                               y=c(1,1,1, 0.5,0.5,0.5), 
                               size=15))
      }
    }else{
      #layout the 2 graphs
      if(!noplot){
        x3loc<-0.3; x4loc <- 0.6
        if(plot.type==2){
          show( ggdraw() + 
                  draw_plot(pp.poput, x=0,     y=.5, width=x3loc, height=.5) + 
                  draw_plot(pp.po, x=x3loc, y=.5, width=x4loc-x3loc, height=.5) +
                  draw_plot(pp.prput, x=x4loc, y=.5, width=1-x4loc, height=.5) +
                  draw_plot_label(c('A','B', 'C'), 
                                  x=c(0, x3loc+0.01, x4loc+0.01), y=c(1,1,1), 
                                  size=15))
        }else{
          show( ggdraw() + 
                  draw_plot(pp.poput, x=0,     y=.5, width=x3loc, height=.5) + 
                  draw_plot(pp.po, x=x3loc, y=.5, width=x4loc-x3loc, height=.5) +
                  draw_plot(pp.prput, x=x4loc, y=.5, width=1-x4loc, height=.5) +
                  draw_plot_label(c('A','B', 'C'), 
                                  x=c(0, x3loc+0.01, x4loc+0.01), y=c(1,1,1), 
                                  size=15)) 
        }
      }
    }
    oth<-errs.2[,!colnames(errs.2)%in%'mylab']
    sel<-oth[oth$numEvts%in%sa, c('grp','numEvts', 'fpr', 'fnr')]
    if(nrow(sel)>0){
      sel$note<-"n/a"
      sel$note[sel$fnr<=goTh[2]]<-'go'
      sel$note[sel$fn>goTh[2]&sel$fpr<goTh[1]]<-'stop'
    }
    if(exists("stop_rule")){
      rule<-rbind( bind_rows(stop_rule))
      r2<-rule[rule[,3]!='Not Applicable',]
      rule2<-NULL
      for(rr in unique(r2$model)){
        r3<-r2[r2$model==rr,]
        rule2<-c(rule2, paste0('Using ', rr, ': '), 
                 paste("    stop if >=", r3[,3], 
                       'events in ', r3[,2], 'subjects.'), '  ')
      }
      rule2<-paste(rule2, collapse = '\n')
    }else{rule<-rule2<-NULL}
    return(list(posterior=psto, oth=oth, sel=sel, stop_rule=rule, rule=rule2))
  }# nzib(plot4=T)$rule
  
  
  #-----------------------function: Print result in table----------------------#
  Dis<-function(x='0.025 (0.01, 0.09)'){
    xx<-unlist(strsplit(gsub(')','',x), split='(', fixed=TRUE))
    xx<-as.numeric(unlist(strsplit(xx, split=',', fixed=TRUE)))
    sum(abs(xx[1]-xx[2:3]))
  }
  Tsh<-function(rr=r1, rg=1:3, bay.lab='', shdig=pdig){ 
    #show estimates
    est<-rr$oth[rr$oth$numEvts%in%rg,]
    if(shdig==0){shdig=3}
    x <- paste0(round(est$phat, shdig), ' (', round(est$phat.L, shdig), 
                ', ', round(est$phat.H, shdig),')')
    #distance
    y <- sapply(x, Dis)
    
    #table out    
    ot<-data.frame(numEvts=est$numEvts, mod=est$grp, est=x, dist=y, pv=est$fpr, 
                   po.lt=est$sup, pop.ut=est$fnr)
    ot<-ot[order(ot$mod, ot$numEvts),]
    ot$mod<-as.character(ot$mod)
    ot$mod[ot$mod=='Bayesian']<-paste('Bayesian',bay.lab)
    return(ot)
  }  
} #end for all source functions


if(F){
  dev.off()

  # main analysis
  #input$text:  1. stopping threshold for number of Adverse Drug Reaction (#IADR)
  #input$text2: 2. max number of samples
  #input$text3: 3. max expected acceptable occurrence rate of ADR
  #input$text4: 4. expected occurrence rate of ADR considered as normal, 
  #               only useful for Binomial
  #input$text5: 5. Hyper parameters for traditional Bayesian
  #input$text6: 6. X-axis range in risk plot
  #input$text7: 7. Y-axis range in risk plot
  #input$text8: 8. X-axis range in type I error plot and Superiority plot
  #input$radio: 9. whether show all 4 available plots
  

  
  out.pdf<-'nzib_sim_n40_p03.pdf'
  out1<-gsub('.pdf', '_1.csv', out.pdf)
  out2<-gsub('.pdf', '_2.csv', out.pdf)
  
  #comparing the simulated results
  pdf(file=out.pdf, width=15, height=7)
  r1<- nzib(stopAt="1,2,3",   #1. stopping threshold
         N1=40,               #2. max number of samples
         maxIDR="0.03",       #3. max expected acceptable occurrence rate
         plot.type=1, 
         bay.prior=c(1, 1),   #5. hyper parameter in beta-binomial
         rsk.xlim="0,5",      #6. x-axis range for risk plot
         errII.xlim="0,5",    #8. x-axis range for type I error plot
         plot4=T,              #9. whether show all 4 available plots
         goTh="0.1",
         ajpm='BH'
    )
  #get the result for Bayesian model only  
  r2<-nzib(stopAt="1,2,3", N1=40, maxIDR="0.03",  plot.type=4, 
         bay.prior=c(alpha=0.03092784, beta=1), 
         rsk.xlim="0,3",  errII.xlim="0,3", plot4=T, ajpm='BH', goTh='0.05')
  r2<-nzib(stopAt="20", N1=40, maxIDR="0.05",  plot.type=4, 
           bay.prior=c(alpha=1, beta=0.5), 
           plot4=T, ajpm='BH', goTh='0.05')
  
  r2<-nzib(stopAt="3", N1=400, maxIDR="0.001",  plot.type=4, 
           bay.prior=c(alpha=0.5, beta=0.5), 
           rsk.xlim="0,3",  errII.xlim="0,3", plot4=T, ajpm='BH', goTh='0.05')
  dev.off()
  
  #print result
  t1<-Tsh(r1, 1:3, '1,1')
  t2<-Tsh(r2, 1:3, '0.5,0.5')
  write.csv(t1, file=out1, row.names=F)
  write.csv(t2, file=out2, row.names=F)
  
  
  #generate the density plot of prior distribution
  pdf(file='prior_density.pdf', width=10, height=6.1)
  bbin(
    prior.a="1,0.5, 0.0051", #1. parameters in p~Beta(a=, b=) prior distribution
    prior.b="1,0.5,1", #2. parameters in p~Beta(a=, b=) prior distribution
    N1=45,            #3. planned sample size
    pa='0.01',           #4. expected average for event rate p
    p.xL='',        #5. xlim for beta distribution
    x.xL=''         #6. xlim for beta-binomial distribution
  )

  
  bbin(
    prior.a="0.01/(1-0.01), 0.05", #1. parameters in p~Beta(a=, b=) prior distribution
    prior.b="1, 0.05", #2. parameters in p~Beta(a=, b=) prior distribution
    N1=45,            #3. planned sample size
    pa='0.01',           #4. expected average for event rate p
    p.xL='',        #5. xlim for beta distribution
    x.xL='',         #6. xlim for beta-binomial distribution
    valLeg=TRUE
  )  

  bbin(
    prior.a="0.01/(1-0.01), 0.05", #1. parameters in p~Beta(a=, b=) prior distribution
    prior.b="1, 0.05", #2. parameters in p~Beta(a=, b=) prior distribution
    N1=45,            #3. planned sample size
    pa='0.01',           #4. expected average for event rate p
    p.xL='',        #5. xlim for beta distribution
    x.xL=''         #6. xlim for beta-binomial distribution
  )
  
  #input$text:  1. parameters in p~Beta(a=, b=) prior distribution
  #input$text2: 2. parameters in p~Beta(a=, b=) prior distribution
  #input$text3: 3. planned sample size
  dev.off()
  
}
